Package: multiplex
Type: Package
Title: Algebraic Tools for the Analysis of Multiple Social Networks
Version: 4.0
Depends: R (>= 4.6.0)
Imports: methods
Suggests: multigraph, Rgraphviz, knitr
Description: Algebraic procedures for analyses of multiple social networks are provided with this 
    package as described in Ostoic (2020) <DOI:10.18637/jss.v092.i11>. 'multiplex' supports the 
    creation and analysis of multiplex, multimode, and multilevel network data in various formats. 
    It combines methods based on partially ordered semigroups, decomposition procedures, semiring 
    structures, and relational bundles for multivariate network analysis. It also provides an 
    algebraic approach to affiliation networks using Galois derivations, with visualization options.
Date: 2026-07-29
Authors@R: person(given = "Antonio", family = "Rivero Ostoic", role = c("aut", "cre"), email = "multiplex@post.com")
Author: Antonio Rivero Ostoic [aut, cre]
Maintainer: Antonio Rivero Ostoic <multiplex@post.com>
URL: https://github.com/mplex/multiplex/
BugReports: https://github.com/mplex/multiplex/issues/
Repository: CRAN
License: GPL-3
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-07-29 15:38:41 UTC; AOST
Date/Publication: 2026-07-30 09:30:02 UTC
Built: R 4.6.1; ; 2026-07-30 13:25:10 UTC; unix

# multiplex
View output of multiple processes, in parallel, in the console, with an interactive TUI

## Installation
```shell script
pip install multiplex
# or better yet
pipx install multiplex
```

Python 3.7 or greater is required.
## Examples

### Parallel Execution Of Commands

```shell script
mp \
    './some-long-running-process.py --zone z1' \
    './some-long-running-process.py --zone z2' \
    './some-long-running-process.py --zone z3'
```

![Par](http://multiplex-static-files.s3-website-us-east-1.amazonaws.com/o.par.gif)

You can achive the same effect using Python API like this:

```python
from multiplex import Multiplex

mp = Multiplex()
for zone in ['z1', 'z2', 'z3']:
    mp.add(f"./some-long-running-process.py --zone {zone}")
mp.run()
```

### Dynamically Add Commands

`my-script.sh`:
```shell script
#!/bin/bash -e
echo Hello There

export REPO='git@github.com:dankilman/multiplex.git'

mp 'git clone $REPO'
mp 'pyenv virtualenv 3.8.5 multiplex-demo && pyenv local multiplex-demo'
cd multiplex
mp 'poetry install'
mp 'pytest tests'

mp @ Goodbye -b 0
```

And then running: 
```shell script
mp ./my-script.sh -b 7
```

![Seq](http://multiplex-static-files.s3-website-us-east-1.amazonaws.com/o.seq.gif)

### Python Controller
An output similar to the first example can be achieved from a single process using
the Python Controller API.

```python
import random
import time
import threading

from multiplex import Multiplex, Controller

CSI = "\033["
RESET = CSI + "0m"
RED = CSI + "31m"
GREEN = CSI + "32m"
BLUE = CSI + "34m"
MAG = CSI + "35m"
CYAN = CSI + "36m"

mp = Multiplex()

controllers = [Controller(f"zone z{i+1}", thread_safe=True) for i in range(3)]

for controller in controllers:
    mp.add(controller)

def run(index, c):
    c.write(
        f"Starting long running process in zone {BLUE}z{index}{RESET}, "
        f"that is not really long for demo purposes\n"
    )
    count1 = count2 = 0
    while True:
        count1 += random.randint(0, 1000)
        count2 += random.randint(0, 1000)
        sleep = random.random() * 3
        time.sleep(sleep)
        c.write(
            f"Processed {RED}{count1}{RESET} orders, "
            f"total amount: {GREEN}${count2}{RESET}, "
            f"Time it took to process this batch: {MAG}{sleep:0.2f}s{RESET}, "
            f"Some more random data: {CYAN}{random.randint(500, 600)}{RESET}\n"
        )

for index, controller in enumerate(controllers):
    thread = threading.Thread(target=run, args=(index+1, controller))
    thread.daemon = True
    thread.start()

mp.run()
```

![Cont](http://multiplex-static-files.s3-website-us-east-1.amazonaws.com/o.cont.gif)

### Help Screen
Type `?` to toggle the help screen.

![help](http://multiplex-static-files.s3-website-us-east-1.amazonaws.com/help.png)

## Why Not Tmux? 
In short, they solve different problems.

`tmux` is a full blown terminal emulator multiplexer.
`multiplex` on the other hand, tries to optimize for a smooth experience in navigating output from several sources.

`tmux` doesn't have any notion of scrolling panes. That is to say, the layout contains all panes at any
given moment (unless maximized).
In `multiplex`, current view will display boxes that fit current view, but you can have many more, 
and move around boxes using `less` inspired keys such as `j`, `k`, `g`, `G`, etc...

Another aspect is that keybindigs for moving around are much more ergonomic (as they are in `less`) because
`multiplex` is not a full terminal emulator, so it can afford using single letter keyboard bindings (e.g. `g` for
go to beginning)

## ----setup, include=FALSE-----------------------------------------------------------------------------------
knitr::opts_chunk$set(size = "footnotesize", background = "#FFFFFF", prompt = TRUE, strip.white = FALSE, comment = NA)
options(width=110)
knitr::knit_hooks$set(small.mar = function(before, options, envir) {
    if (before) par(mar = c(4, 4, .1, .1)) 
})

## ----data, echo=-6------------------------------------------------------------------------------------------
# fruits data set with attributes
frt <- data.frame(yellow = c(0,1,0,0,1,0,0,0), green = c(0,0,1,0,0,0,0,1), red = c(1,0,0,1,0,0,0,0), 
                  orange = c(0,0,0,0,0,1,1,0), apple = c(1,1,1,1,0,0,0,0), citrus = c(0,0,0,0,1,1,1,1))
# fruit varieties as objects
rownames(frt) <- c("PinkLady","GrannySmith","GoldenDelicious","RedDelicious","Lemon","Orange","Mandarin","Lime")
frt

## ----loadmultiplex------------------------------------------------------------------------------------------
# load package
library("multiplex")

## ----galoisFull---------------------------------------------------------------------------------------------
# Galois derivations between fruits and their attributes
galois(frt)

## ----galoisReduc, echo=TRUE---------------------------------------------------------------------------------
# Galois derivation with a reduced labeling
frt |> galois(labeling = "reduced")

## ----strgaloisReduc, size="scriptsize"----------------------------------------------------------------------
# structure of Galois derivation with full labeling
frt |> 
  galois(labeling = "reduced") |> 
  getElement("gc") |> 
  getElement("full") |> 
  str()

## ----partialorder, echo=-5----------------------------------------------------------------------------------
# partial ordering of the formal concepts with established labels
pogdc <- frt |> 
  galois(labeling = "reduced") |> 
  partial.order(type = "galois", lbs = paste("c", seq_len(12), sep = ""))
pogdc

## ----diagrampogc, fig.pos="H", fig.width=4.5, fig.height=4.5, fig.align="center", fig.cap="Concept Lattice of fruits and color characteristics", echo=-1, small.mar=TRUE----
par(mar=c(0,0,0,0))
# plot concept lattice diagram
suppressPackageStartupMessages(require("Rgraphviz", quietly = TRUE))
frt |> galois(labeling = "reduced") |> 
  partial.order(type = "galois") |> 
  diagram(type = "concept", main = "Fruits & Colors", fsize = 17, fcol = "red", col.main = "blue")

## ----diaglevels, echo=TRUE----------------------------------------------------------------------------------
# diagram levels of partial order
require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)
frt |> 
  galois(labeling = "reduced") |> 
  partial.order(type = "galois") |> 
  diagram.levels() 

## ----diaglevelsperm, echo=TRUE, message=FALSE, warning=FALSE------------------------------------------------
# diagram levels with permutation
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc, perm = TRUE) }

## ----pogc, echo=TRUE----------------------------------------------------------------------------------------
# first assign the partial order of the reduced context
pogd <- frt |> galois(labeling = "reduced") |> 
  partial.order(type = "galois")

## ----princfltrlbs, echo=TRUE--------------------------------------------------------------------------------
# principal order filter of the third concept 
fltr(3, pogd)

## ----princfltrlbs2, echo=TRUE, eval=TRUE--------------------------------------------------------------------
# principal order filter of the concept with these labels
fltr(c("red", "RedDelicious"), pogd)

## ----filter, echo=TRUE--------------------------------------------------------------------------------------
# order filter of two concepts
fltr(c("Lemon", "Lime"), pogd)

## ----ideal, echo=TRUE---------------------------------------------------------------------------------------
# order ideal of two concepts
fltr(c(9, 11), pogd, ideal = TRUE)

## ----bipp, echo=TRUE, eval=TRUE, fig.pos="H", fig.width=3.5, fig.height=3.5, fig.align="center", fig.env="figure", fig.cap="Bipartite graph of fruits with attributes", small.mar=TRUE----
# load "multigraph" package and plot bipartite graph
suppressPackageStartupMessages(library("multigraph", quietly = TRUE))
multigraph::bmgraph(frt, pch = 16:15, lwd = 2, fsize = 6)

## ----binp2, echo=TRUE, eval=FALSE---------------------------------------------------------------------------
#  # plot proyection of bipartite graph
#  require(multigraph)
#  bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, lwd = 2, rot = 15)

## ----binp, fig.pos="H", fig.width=4.4, fig.height=4.4, fig.align="center", fig.env="figure", fig.cap="Bipartite graph of fruit attributes with a force-directed layout", echo=FALSE, small.mar=TRUE----
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, lwd = 2, rot = 15)

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
ti <-
function (net) 
{
    ifelse(isTRUE(is.data.frame(net) == TRUE) == TRUE, net <- as.matrix(net), 
        NA)
    ifelse(isTRUE(dim(net)[3] == 1) == TRUE, net <- net[, , 1], 
        NA)
    ifelse(isTRUE(is.na(dim(net)[3]) == TRUE) == TRUE, z <- 1L, 
        z <- dim(net)[3])
    if (isTRUE(z == 1) == TRUE) {
        x <- net
        cp <- unique(cpath(x, sep = ", ", lb2lb = FALSE))
        if (is.list(cp) == TRUE && isTRUE(sum(unlist(cp)) == 
            0) == TRUE) {
            NA
        }
        else {
            for (i in seq_len(length(cp))) {
                pck <- as.numeric(dhc(cp[i], sep = ", "))
                if (isTRUE(length(pck) > 2) == TRUE && isTRUE(x[pck, 
                  pck][1, 3] != 0) == TRUE) {
                  tri <- net[pck, pck]
                  if (isTRUE(sum(tri[1, 2] + tri[2, 3]) < tri[1, 
                    3]) == TRUE) {
                    x[pck[c(1, 3)][1], pck[c(1, 3)][2]] <- 0L
                  }
                  else {
                    NA
                  }
                }
                else {
                  NA
                }
            }
            rm(i)
        }
        Qq <- x
    }
    else {
        Qq <- net
        for (k in seq_len(z)) {
            x <- net[, , k]
            cp <- unique(cpath(x, sep = ", ", lb2lb = FALSE))
            for (i in seq_len(length(cp))) {
                pck <- as.numeric(dhc(cp[i], sep = ", "))
                if (isTRUE(length(pck) > 2) == TRUE && isTRUE(x[pck, 
                  pck][1, 3] != 0) == TRUE) {
                  tri <- x[pck, pck]
                  if (isTRUE(sum(tri[1, 2] + tri[2, 3]) < tri[1, 
                    3]) == TRUE) {
                    x[pck[c(1, 3)][1], pck[c(1, 3)][2]] <- 0L
                  }
                  else {
                    NA
                  }
                }
                else {
                  NA
                }
            }
            rm(i)
            Qq[, , k] <- x
        }
        rm(k)
    }
    Qq
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
transl <-
function (lt, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    llt <- levels(factor(lt))
    if (isTRUE(length(llt) == 1) == TRUE) {
        ifelse(isTRUE(length(jnt(llt)) == 1) == TRUE, return(jnt(llt)), 
            return(llt))
    }
    else {
        Ls <- as.list(llt)
        j <- 1L
        tmp0 <- strsplit(Ls[[1]], sep)[[1]]
        attr(Ls[[1]], "names") <- j
        for (i in 2:length(Ls)) {
            tmp2 <- strsplit(Ls[[i]], sep)[[1]]
            ifelse((any(tmp2 %in% tmp0)) | (any(tmp0 %in% tmp2)), 
                attr(Ls[[i]], "names") <- as.integer(attr(Ls[[j]], 
                  "names")), NA)
        }
        rm(i)
        uno <- unlist(dhc(jnt(unlist(Ls)[which(attr(unlist(Ls), 
            "names") == j)])))
        for (i in which(attr(unlist(Ls), "names") == "")) {
            tmp2 <- strsplit(Ls[[i]], sep)[[1]]
            ifelse((any(uno %in% tmp2)) | (any(tmp2 %in% uno)), 
                attr(Ls[[i]], "names") <- j, NA)
            uno <- unlist(dhc(jnt(unlist(Ls)[which(attr(unlist(Ls), 
                "names") == j)])))
        }
        rm(i)
        if (isTRUE(length(uno) > 1) == TRUE) {
            while (isTRUE(unlist(dhc(jnt(unlist(Ls)[which(attr(unlist(Ls), 
                "names") == j)]))) == uno) == TRUE) {
                for (i in which(attr(unlist(Ls), "names") == 
                  "")) {
                  tmp2 <- strsplit(Ls[[i]], sep)[[1]]
                  ifelse((any(uno %in% tmp2)) | (any(tmp2 %in% 
                    uno)), attr(Ls[[i]], "names") <- j, NA)
                }
                rm(i)
            }
        }
        kual <- which(attr(unlist(Ls), "names") == "")
        while (length(kual) != 0) {
            j <- (j + 1L)
            attr(Ls[[kual[1]]], "names") <- j
            kual <- which(attr(unlist(Ls), "names") == "")
            if (length(kual) != 0) {
                tmp0 <- unlist(dhc(jnt(unlist(Ls)[which(attr(unlist(Ls), 
                  "names") == j)])))
                for (i in kual) {
                  tmp2 <- strsplit(Ls[[i]], sep)[[1]]
                  ifelse((any(tmp2 %in% tmp0)) | (any(tmp0 %in% 
                    tmp2)), attr(Ls[[i]], "names") <- j, NA)
                }
                rm(i)
                tmp0 <- unlist(dhc(jnt(unlist(Ls)[which(attr(unlist(Ls), 
                  "names") == j)])))
                for (i in kual) {
                  tmp2 <- strsplit(Ls[[i]], sep)[[1]]
                  ifelse((any(tmp0 %in% tmp2)) | (any(tmp2 %in% 
                    tmp0)), attr(Ls[[i]], "names") <- j, NA)
                }
                rm(i)
            }
            kual <- which(attr(unlist(Ls), "names") == "")
        }
        clu <- vector()
        for (i in seq_len(length(Ls))) clu[i] <- as.numeric(attr(Ls[[i]], 
            "names")[1])
        tls <- vector()
        for (i in seq_len(nlevels(factor(clu)))) tls <- append(tls, 
            jnt(llt[clu == i]))
        return(levels(factor(tls)))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
cph <-
function (W, lbs) 
{
    if (isTRUE("Rel.Box" %in% attr(W, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(W))), " must be a ", 
            dQuote("Rel.Box"), " class object.", sep = ""))
    rls <- array(dim = c(dim(W$W)[3], dim(W$W)[1], dim(W$W)[1]))
    for (i in seq_len(dim(W$W)[3])) {
        for (j in seq_len(dim(W$W)[1])) {
            rls[i, , j] <- W$W[j, , i]
        }
    }
    phs <- array(0L, dim = c(dim(W$W)[1], dim(W$W)[1], dim(W$W)[1]))
    for (k in seq_len(dim(W$W)[1])) {
        for (j in seq_len(dim(W$W)[1])) {
            for (i in seq_len(dim(W$W)[1])) {
                if ((as.numeric(any(rls[, i, k] < rls[, j, k])) == 
                  1L && as.numeric(any(rls[, j, k] < rls[, i, 
                  k])) == 0L) | as.numeric(all(rls[, i, k] == 
                  rls[, j, k])) == 1L) 
                  phs[i, j, k] <- 1L
            }
        }
    }
    for (k in seq_len(dim(W$W)[1])) {
        for (i in seq_len(dim(W$W)[1])) {
            if (sum(rls[, i, k]) == 0L) 
                phs[i, , k] <- 0L
        }
    }
    dimnames(phs)[[1]] <- dimnames(phs)[[2]] <- dimnames(W$W)[[1]]
    tmp <- data.frame(matrix(ncol = (dim(phs)[1] * dim(phs)[2]), 
        nrow = 0))
    for (i in seq_len(dim(phs)[3])) {
        ifelse(dim(phs)[3] > 1L, tmp[i, ] <- as.vector(phs[, 
            , i]), tmp <- as.vector(phs))
    }
    rm(i)
    phu <- matrix(replace(sapply(tmp, sum), sapply(tmp, sum) >= 
        1, 1), nrow = dim(W$W)[1], ncol = dim(W$W)[1])
    diag(phu) <- 1L
    for (i in seq_len(ncol(phu))) {
        tmp <- outer(phu[, i], phu[i, ], pmin.int)
        phu <- pmax(phu, tmp)
    }
    if (missing(lbs) == FALSE && isTRUE(length(lbs) == dim(phu)[1]) == 
        TRUE) {
        dimnames(phu)[[1]] <- dimnames(phu)[[2]] <- lbs
    }
    else if (missing(lbs) == TRUE) {
        dimnames(phu)[[1]] <- dimnames(phu)[[2]] <- W$lbs
    }
    class(phu) <- c("Partial.Order", "CPH")
    phu
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
edgel <-
function (x, toarray = TRUE, header = TRUE, sep = "\t", valued = FALSE, 
    inc = FALSE, rownames = TRUE, add = NULL, na.rm) 
{
    if (is.array(x) != TRUE && is.data.frame(x) != TRUE && is.list(x) != 
        TRUE) {
        x <- utils::read.table(x, header = header, sep = sep)
        x0 <- "x"
    }
    else {
        x0 <- deparse(substitute(x))
        if (is.array(x) == TRUE && isTRUE(dim(x)[1] == dim(x)[2]) == 
            TRUE) {
            if (isTRUE(toarray == TRUE) == TRUE) {
                warning(paste("Array ", sQuote(x0), " to array.", 
                  sep = ""), call. = FALSE)
                return(x)
            }
            else if (isTRUE(inc == TRUE) == TRUE) {
                inc <- FALSE
                warning(paste(sQuote("inc"), " is set to FALSE since ", 
                  sQuote(x0), " is array.", sep = ""), call. = FALSE)
            }
        }
        else if ((is.list(x) == TRUE && is.data.frame(x) == FALSE) && 
            isTRUE(toarray == TRUE) == TRUE) {
            stop("Use a transformation function for a list to array.", 
                call. = FALSE)
        }
        else {
            NA
        }
    }
    if (isTRUE("edgelist" %in% class(x)) == TRUE) {
        inc <- FALSE
        warning(paste(sQuote(deparse(substitute(x))), " is an ", 
            dQuote("edgelist"), " class object.", sep = ""), 
            call. = FALSE)
    }
    if (isTRUE(inc == TRUE) == TRUE) {
        if (isTRUE(is.data.frame(x) == TRUE) == TRUE && is.character(x[, 
            1]) == TRUE) {
            if (isTRUE(toarray == FALSE) == TRUE && isTRUE(rownames == 
                TRUE) == TRUE) {
                x2 <- x[, 2:ncol(x)]
                rownames(x2) <- x[, 1]
                ifelse(isTRUE(valued == FALSE) == TRUE, x <- dichot(x2, 
                  c = 1L), x <- x2)
                rm(x2)
            }
            else {
                NA
            }
        }
        else {
            if (isTRUE(is.data.frame(x) == TRUE) == TRUE && isTRUE(toarray == 
                FALSE) == TRUE) {
                return(x)
            }
            else {
                if (any(duplicated(x[, 1])) == TRUE && isTRUE(rownames == 
                  FALSE) == TRUE) {
                  stop(paste("Duplicated objects/actors in incidence matrix: ", 
                    sQuote(x0), " not allowed.", sep = ""), call. = FALSE)
                }
                else {
                  NA
                }
            }
        }
        if (isTRUE(toarray == FALSE) == TRUE) {
            ifelse(isTRUE(rownames == TRUE) == TRUE, warning(paste("Objects/actors in incidence matrix ", 
                sQuote(x0), " are the ", dQuote("rownames"), 
                ".", sep = ""), call. = FALSE), warning(paste("Objects/actors in incidence matrix ", 
                sQuote(x0), " are in column: ", dQuote(colnames(x)[1]), 
                ".", sep = ""), call. = FALSE))
        }
    }
    else if (isTRUE(inc == FALSE) == TRUE) {
        if (isTRUE(is.data.frame(x) == TRUE) == TRUE || isTRUE(dim(x)[1] != 
            dim(x)[2]) == TRUE) {
            NA
        }
    }
    if (is.null(add) == FALSE) {
        levels(x[, 1]) <- c(levels(x[, 1]), add)
        levels(x[, 2]) <- c(levels(x[, 2]), add)
        for (i in seq_len(length(add))) {
            x <- rbind(x, c(add[i], add[i], NA))
        }
        rm(i)
    }
    if (isTRUE(toarray == TRUE) == TRUE) {
        if (missing(na.rm) == FALSE && isTRUE(na.rm == FALSE) == 
            TRUE) {
            if (any(is.na(x)) == TRUE) 
                warning(paste("Missing information in ", sQuote(x0), 
                  " recorded as ", sQuote("NA"), ".", sep = ""), 
                  call. = FALSE)
            ifelse(is.data.frame(x) == FALSE, NA, x[is.na(x)] <- "NA")
        }
        else {
            NA
        }
        if (isTRUE(inc == FALSE) == TRUE) {
            warning(paste("Edge-list ", deparse(substitute(x0)), 
                " to array.", sep = ""), call. = FALSE)
            if (isTRUE((ncol(x) - 2L) == 0L) == TRUE) {
                warning(paste("One type of relation assumed in ", 
                  sQuote(x0), ".", sep = ""), call. = FALSE)
                x <- cbind(x, t = rep(1L, nrow(x)))
            }
            else {
                warning(paste("In ", sQuote(x0), ", sender - receiver relations are: ", 
                  paste(dQuote(colnames(x)[1]), dQuote(colnames(x)[2]), 
                    sep = " - "), ".", sep = ""), call. = FALSE)
            }
            r <- (ncol(x) - 2L)
            x <- x[stats::complete.cases(x[, seq_len(2)]), ]
            lbs <- unique(c(as.vector(x[, 1]), as.vector(x[, 
                2])))
            if (isTRUE(lbs == "") == TRUE) {
                warning("Node labels in the input are empty!")
                lbs <- seq_len(nrow(x))
            }
            else {
                NA
            }
            n <- length(lbs)
        }
        else if (isTRUE(inc == TRUE) == TRUE) {
            warning(paste("Incidence matrix ", sQuote(x0), " to array.", 
                sep = ""), call. = FALSE)
            if (is.data.frame(x) == TRUE && any(is.na(suppressWarnings(as.numeric(rownames(x))))) == 
                FALSE && any(duplicated(x[, 1])) == FALSE) {
                lbs <- x[, 1]
                r <- ncol(x) - 1L
                rownames <- FALSE
            }
            else {
                lbs <- rownames(x)
                r <- ncol(x)
            }
            n <- nrow(x)
        }
        if (isTRUE(r == 1L) == TRUE) {
            MAT <- array(0L, dim = c(n, n))
        }
        else if (isTRUE(r > 1L) == TRUE) {
            MAT <- array(0L, dim = c(n, n, r))
            if (isTRUE(inc == TRUE) == TRUE) {
                if (isTRUE(rownames == TRUE) == TRUE || (isTRUE(rownames == 
                  FALSE) == TRUE && is.null(attr(x, "names")) == 
                  TRUE)) {
                  dimnames(MAT)[[3]] <- colnames(x)
                }
                else {
                  ifelse(is.null(attr(x, "names")) == FALSE, 
                    dimnames(MAT)[[3]] <- attr(x, "names")[2:ncol(x)], 
                    NA)
                }
            }
            else {
                ifelse(is.null(attr(x, "names")) == TRUE, dimnames(MAT)[[3]] <- colnames(x)[3:ncol(x)], 
                  dimnames(MAT)[[3]] <- attr(x, "names")[3:ncol(x)])
            }
        }
        dimnames(MAT)[[1]] <- dimnames(MAT)[[2]] <- lbs
        if (isTRUE(inc == TRUE) == TRUE) {
            if (isTRUE(r == 1L) == TRUE) {
                diag(MAT) <- as.numeric(x[, 2])
            }
            else if (isTRUE(r > 1L) == TRUE) {
                if (isTRUE(rownames == TRUE) == TRUE || (isTRUE(rownames == 
                  FALSE) == TRUE && is.null(attr(x, "names")) == 
                  TRUE)) {
                  for (k in seq_len(r)) {
                    diag(MAT[, , k]) <- x[, k]
                  }
                  rm(k)
                }
                else if (isTRUE(isTRUE(rownames == FALSE) == 
                  TRUE) == TRUE) {
                  for (k in seq_len(r)) {
                    diag(MAT[, , k]) <- x[, k + 1L]
                  }
                  rm(k)
                }
            }
        }
        else {
            if (isTRUE(ncol(x) > 3L) == TRUE) {
                for (k in seq_len(r)) {
                  rel <- which(x[, (k + 2L)] != 0L)
                  rrel <- x[rel, ]
                  if (isTRUE(length(rel) > 1L) == TRUE) {
                    X <- n
                    for (i in seq_len(n)) {
                      X[i] <- sum(as.numeric(rrel[, 1] == lbs[i]))
                    }
                    rm(i)
                    attr(X, "names") <- lbs
                    xx <- vector()
                    for (i in seq_len(n)) {
                      ifelse(X[i] != 0L, xx[i] <- i, xx[i] <- NA)
                    }
                    rm(i)
                    attr(xx, "names") <- lbs
                    xx <- (stats::na.omit(xx))
                    xx <- as.vector(attr(xx, "names"))
                    nX <- X[which(X > 0L)]
                    YY <- vector()
                    if (isTRUE(length(xx) > 1L) == TRUE) {
                      for (i in seq_len(length(xx))) {
                        YY <- rrel[, 2][which(rrel[, 1] == attr(nX, 
                          "names")[i])]
                        if (isTRUE(length(YY) > 1L) == TRUE) {
                          for (j in seq_len(length(YY))) {
                            tmp <- MAT[(which((as.vector(rownames(MAT)) == 
                              xx[i]), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                              YY[j]), arr.ind = TRUE)), (k)]
                            MAT[(which((as.vector(rownames(MAT)) == 
                              xx[i]), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                              YY[j]), arr.ind = TRUE)), (k)] <- tmp + 
                              as.numeric(as.vector(rrel[, (k + 
                                2L)][which(rrel[, 1] == attr(nX, 
                                "names")[i])]))[j]
                          }
                          rm(j)
                        }
                        else if (isTRUE(length(YY) == 1L) == 
                          TRUE) {
                          tmp <- MAT[(which((as.vector(rownames(MAT)) == 
                            xx[i]), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                            YY), arr.ind = TRUE)), (k)]
                          MAT[(which((as.vector(rownames(MAT)) == 
                            xx[i]), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                            YY), arr.ind = TRUE)), (k)] <- tmp + 
                            as.numeric(as.vector(rrel[, (k + 
                              2L)][which(rrel[, 1] == attr(nX, 
                              "names")[i])]))
                        }
                      }
                      rm(i)
                      rm(xx, YY)
                    }
                    else if (isTRUE(length(xx) == 1L) == TRUE) {
                      YY <- rrel[, 2][which(rrel[, 1] == attr(nX, 
                        "names"))]
                      if (isTRUE(length(YY) > 1L) == TRUE) {
                        for (j in seq_len(length(YY))) {
                          tmp <- MAT[(which((as.vector(rownames(MAT)) == 
                            xx), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                            YY[j]), arr.ind = TRUE)), (k)]
                          MAT[(which((as.vector(rownames(MAT)) == 
                            xx), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                            YY[j]), arr.ind = TRUE)), (k)] <- tmp + 
                            as.numeric(as.vector(rrel[, (k + 
                              2L)][which(rrel[, 1] == attr(nX, 
                              "names"))]))[j]
                        }
                        rm(j)
                      }
                      else if (isTRUE(length(YY) == 1L) == TRUE) {
                        tmp <- MAT[(which((as.vector(rownames(MAT)) == 
                          xx), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                          YY), arr.ind = TRUE)), (k)]
                        MAT[(which((as.vector(rownames(MAT)) == 
                          xx), arr.ind = TRUE)), (which(as.vector(colnames(MAT) == 
                          YY), arr.ind = TRUE)), (k)] <- tmp + 
                          as.numeric(as.vector(rrel[, (k + 2L)][which(rrel[, 
                            1] == attr(nX, "names"))]))
                      }
                      rm(xx, YY)
                    }
                  }
                  else if (isTRUE(length(rel) == 1L) == TRUE) {
                    tmp <- MAT[which(rownames(MAT) == x[rel, 
                      1]), which(colnames(MAT) == x[rel, 2]), 
                      (k)]
                    MAT[which(rownames(MAT) == x[rel, 1]), which(colnames(MAT) == 
                      x[rel, 2]), (k)] <- tmp + as.numeric(rel)
                  }
                }
                rm(k)
            }
            else if (isTRUE(ncol(x) == 3L) == TRUE) {
                rel <- which(x[, 3] != 0L)
                rrel <- x[rel, ]
                X <- integer(n)
                for (i in seq_len(n)) {
                  X[i] <- sum(as.numeric(rrel[, 1] == lbs[i]))
                }
                rm(i)
                attr(X, "names") <- lbs
                xx <- vector()
                for (i in seq_len(n)) {
                  ifelse(X[i] != 0L, xx[i] <- i, xx[i] <- NA)
                }
                rm(i)
                attr(xx, "names") <- lbs
                xx <- (stats::na.omit(xx))
                xx <- as.vector(attr(xx, "names"))
                nX <- X[which(X > 0L)]
                if (isTRUE(length(xx) > 1L) == TRUE) {
                  YY <- vector()
                  for (i in seq_len(length(xx))) {
                    kual0 <- which(rrel[, 1] == attr(nX, "names")[i])
                    kual1 <- which((as.vector(rownames(MAT)) == 
                      xx[i]), arr.ind = TRUE)
                    YY <- rrel[, 2][kual0]
                    if (isTRUE(length(YY) > 1L) == TRUE) {
                      for (j in seq_len(length(YY))) {
                        kual2 <- which(as.vector(colnames(MAT) == 
                          YY[j]), arr.ind = TRUE)
                        tmp <- MAT[kual1, kual2]
                        MAT[kual1, kual2] <- tmp + as.numeric(as.vector(factor(rrel[, 
                          3][kual0])))[j]
                      }
                      rm(j)
                    }
                    else if (isTRUE(length(YY) == 1L) == TRUE) {
                      kual3 <- which(as.vector(colnames(MAT) == 
                        YY), arr.ind = TRUE)
                      tmp <- MAT[kual1, kual3]
                      MAT[kual1, kual3] <- tmp + as.numeric(as.vector(factor(rrel[, 
                        3][kual0])))
                    }
                  }
                  rm(i)
                }
                else if (isTRUE(length(xx) == 1L) == TRUE) {
                  YY <- rrel[, 2][which(rrel[, 1] == attr(nX, 
                    "names"))]
                  if (isTRUE(length(YY) > 1L) == TRUE) {
                    kual4 <- which((as.vector(rownames(MAT)) == 
                      xx), arr.ind = TRUE)
                    kual5 <- which(rrel[, 1] == attr(nX, "names"))
                    for (j in seq_len(length(YY))) {
                      kual2 <- (which(as.vector(colnames(MAT) == 
                        YY[j]), arr.ind = TRUE))
                      MAT[kual4, kual2] <- as.numeric(as.vector(rrel[, 
                        3][kual5]))[j]
                    }
                    rm(j)
                  }
                  else if (isTRUE(length(YY) == 1L) == TRUE) {
                    MAT[which(dimnames(MAT)[1][[1]] == YY), which(dimnames(MAT)[2][[1]] == 
                      YY)] <- as.numeric(as.vector(rrel[, 3]))
                  }
                  rm(xx, YY)
                }
            }
        }
        if (isTRUE(valued == FALSE) == TRUE) {
            MAT <- dichot(MAT, c = 1)
        }
        if (isTRUE(inc == FALSE) == TRUE && isTRUE(r == 1L) == 
            TRUE) {
            return(MAT[, sort(colnames(MAT))][sort(rownames(MAT)), 
                ])
        }
        else {
            return(MAT)
        }
    }
    else if (isTRUE(toarray == FALSE) == TRUE) {
        if (is.array(x) == TRUE) {
            if (is.na(dim(x)[3]) == TRUE) {
                if (identical(dimnames(x)[[1]], dimnames(x)[[2]]) == 
                  TRUE) {
                  tmp <- trnf(x, tolist = TRUE, lb2lb = TRUE, 
                    lbs = dimnames(x)[[1]], sep = sep)
                }
                else {
                  if (isTRUE(ncol(x) > nrow(x)) == TRUE) {
                    x0 <- x
                    colnames(x0) <- seq_len(ncol(x0))
                    x0 <- rbind(x0, matrix(0, nrow = ncol(x) - 
                      nrow(x), ncol = ncol(x)))
                  }
                  else if (isTRUE(ncol(x) < nrow(x)) == TRUE) {
                    x0 <- x
                    rownames(x0) <- seq_len(nrow(x0))
                    x0 <- cbind(x0, matrix(0, nrow = nrow(x), 
                      ncol = nrow(x) - ncol(x)))
                  }
                  tmp <- trnf(x0, tolist = TRUE, lb2lb = FALSE, 
                    sep = sep)
                }
                tmp2 <- sapply(tmp, function(z) {
                  strsplit(z, sep)
                })
                rm(tmp)
                edgl <- data.frame(matrix(nrow = 0, ncol = 3))
                colnames(edgl) <- c("s", "r", "t")
                for (i in seq_len(length(tmp2))) {
                  edgl[nrow(edgl) + 1L, ] <- c(strsplit(tmp2[[i]], 
                    sep)[[1]], strsplit(tmp2[[i]], sep)[[2]], 
                    "1")
                }
                rm(i)
            }
            else {
                edgl <- data.frame(matrix(nrow = 0, ncol = (dim(x)[3]) + 
                  2L))
                colnames(edgl) <- c("s", "r", dimnames(x)[[3]])
                lb <- trnf(x[, , 1], tolist = TRUE, lb2lb = TRUE, 
                  lbs = dimnames(x)[[1]], sep = sep)
                nd <- trnf(x[, , 1], tolist = TRUE, lb2lb = FALSE, 
                  sep = sep)
                for (l in seq_len(length(lb))) {
                  edgl[nrow(edgl) + 1L, 3] <- 1L
                  edgl[nrow(edgl), 1:2] <- strsplit(lb[l], sep)[[1]]
                }
                rm(l)
                lb1 <- Map(as.vector, data.frame(t(edgl[, 1:2])))
                for (k in 2:dim(x)[3]) {
                  lbk <- trnf(x[, , k], tolist = TRUE, lb2lb = TRUE, 
                    lbs = dimnames(x)[[1]], sep = sep)
                  ndk <- trnf(x[, , k], tolist = TRUE, lb2lb = FALSE, 
                    sep = sep)
                  for (j in seq_len(length(ndk))) {
                    lbe <- strsplit(lbk[[j]], sep)[[1]]
                    if (any(unlist(lapply(lapply(jnt(lb1, uniq = TRUE), 
                      function(z) {
                        jnt(lbe, uniq = TRUE) %in% z
                      }), all), use.names = FALSE)) == TRUE) {
                      edgl[which(unlist(lapply(lapply(jnt(lb1, 
                        uniq = TRUE), function(z) {
                        jnt(lbe, uniq = TRUE) %in% z
                      }), all), use.names = FALSE)), (k + 2L)] <- 1L
                    }
                    else {
                      edgl[nrow(edgl) + 1L, (k + 2L)] <- 1L
                      edgl[nrow(edgl), 1:2] <- lbe
                    }
                    lb1 <- Map(as.vector, data.frame(t(edgl[, 
                      1:2])))
                  }
                  rm(j)
                }
                rm(k)
                edgl[sapply(edgl, is.na)] <- 0
            }
            return(edgl)
        }
        else {
            return(x)
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
rm.isol <-
function (x, diag, diag.incl) 
{
    if (isTRUE(sum(x) == 0L) == TRUE) 
        return(NULL)
    ifelse(missing(diag) == FALSE && isTRUE(diag == FALSE) == 
        TRUE, diag <- FALSE, diag <- TRUE)
    ifelse(is.na(dim(x)[3]) == TRUE | isTRUE(dim(x)[3] == 1) == 
        TRUE, px <- x, px <- mnplx(x))
    ifelse(isTRUE(diag == TRUE) == TRUE, NA, diag(px) <- 0L)
    out <- vector()
    for (i in seq_len(nrow(x))) {
        ifelse(isTRUE(sum(px[i, ] + px[, i]) == 0L) == TRUE, 
            out[length(out) + 1L] <- i, NA)
    }
    rm(i)
    inn <- which(!(seq_len(nrow(x)) %in% out))
    ifelse(missing(diag.incl) == FALSE && isTRUE(diag.incl == 
        FALSE) == TRUE, diag(x) <- 0, NA)
    if (is.na(dim(x)[3]) == TRUE) {
        x[inn, inn]
    }
    else {
        x[inn, inn, ]
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
semiring <-
function (x, type = c("balance", "cluster"), symclos = TRUE, 
    transclos = TRUE, k = 2, lbs) 
{
    if (isTRUE("Signed" %in% attr(x, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be a ", 
            dQuote("Signed"), " class object.", sep = ""))
    q <- x$s
    q[which(q == 1)] <- "p"
    q[which(q == 0)] <- "o"
    q[which(q == -1)] <- "n"
    if (isTRUE(all(levels(factor(as.matrix(q))) %in% c("a", "n", 
        "o", "p", "q")) == TRUE) == TRUE) {
        if (isTRUE(symclos == TRUE) == TRUE) {
            for (i in seq_len(nrow(q))) {
                for (j in seq_len(ncol(q))) {
                  if (isTRUE(q[i, j] != q[j, i]) == TRUE) {
                    if (isTRUE(q[i, j] == "o") == TRUE) {
                      q[i, j] <- q[j, i]
                    }
                    else if (isTRUE(q[j, i] == "o") == TRUE) {
                      q[j, i] <- q[i, j]
                    }
                  }
                }
                rm(j)
            }
            rm(i)
            for (i in seq_len(nrow(q))) {
                for (j in seq_len(ncol(q))) {
                  if (isTRUE(q[i, j] != q[j, i]) == TRUE) {
                    if (isTRUE(q[i, j] == "p") == TRUE) {
                      q[j, i] <- q[i, j]
                    }
                    else if (isTRUE(q[j, i] == "p") == TRUE) {
                      q[i, j] <- q[j, i]
                    }
                    else if (isTRUE(q[i, j] == "q") == TRUE || 
                      isTRUE(q[j, i] == "q") == TRUE) {
                      q[i, j] <- q[j, i] <- "p"
                    }
                    else {
                      q[i, j] <- "a"
                    }
                  }
                }
                rm(j)
            }
            rm(i)
        }
        ifelse(isTRUE(attr(q, "class") != "data.frame") == TRUE, 
            Q <- as.data.frame(unclass(q)), Q <- as.data.frame(q))
        if (k == 1) {
            lst <- list(val = x$val, s = x$s, Q = noquote(as.matrix(q)), 
                k = k)
            class(lst) <- c("Rel.Q", match.arg(type))
            return(lst)
        }
        else {
            for (z in 2:k) {
                chn <- list()
                for (h in seq_len(nrow(Q))) {
                  tmp2 <- list()
                  for (i in seq_len(nrow(Q))) {
                    tmp <- vector()
                    for (j in seq_len(ncol(Q))) {
                      tmp <- append(tmp, paste(Q[h, j], Q[j, 
                        i], sep = ", "))
                    }
                    rm(j)
                    tmp2[[i]] <- tmp
                  }
                  rm(i)
                  chn[[h]] <- tmp2
                }
                rm(h)
                rm(tmp, tmp2)
                mx <- list()
                for (i in seq_len(nrow(Q))) {
                  tmp2 <- list()
                  for (j in seq_len(nrow(Q))) {
                    tmp <- vector()
                    for (l in seq_len(ncol(Q))) {
                      ch <- strsplit(chn[[i]][[j]][l], ", ")[[1]]
                      switch(match.arg(type), balance = {
                        if ("o" %in% ch) {
                          tmp <- append(tmp, "o")
                        } else if ("a" %in% ch && is.na(match("o", 
                          ch)) == TRUE) {
                          tmp <- append(tmp, "a")
                        } else if (all(c("p", "n") %in% ch)) {
                          tmp <- append(tmp, "n")
                        } else tmp <- append(tmp, "p")
                      }, cluster = {
                        if ("o" %in% ch) {
                          tmp <- append(tmp, "o")
                        } else if ("q" %in% ch | all("n" == ch)) {
                          tmp <- append(tmp, "q")
                        } else if (all("p" == ch)) {
                          tmp <- append(tmp, "p")
                        } else if (all("a" == ch) | all(c("a", 
                          "p") %in% ch)) {
                          tmp <- append(tmp, "a")
                        } else tmp <- append(tmp, "n")
                      })
                      rm(ch)
                    }
                    rm(l)
                    tmp2[[j]] <- tmp
                  }
                  rm(j)
                  mx[[i]] <- tmp2
                }
                rm(i)
                rm(tmp, tmp2)
                switch(match.arg(type), balance = {
                  NA
                }, cluster = {
                  mxn <- mx
                  for (i in seq_len(ncol(Q))) {
                    for (j in seq_len(ncol(Q))) {
                      if (any("n" == strsplit(chn[[i]][[j]][i], 
                        ", ")[[1]])) {
                        mxn[[i]][[j]][i] <- "n"
                      } else if (any("p" == strsplit(chn[[i]][[j]][i], 
                        ", ")[[1]])) {
                        mxn[[i]][[j]][i] <- "p"
                      }
                    }
                    rm(j)
                  }
                  rm(i)
                  mx <- mxn
                  rm(mxn)
                })
                x2 <- data.frame(matrix(nrow = nrow(Q), ncol = ncol(Q)))
                for (i in seq_len(nrow(Q))) {
                  for (j in seq_len(nrow(Q))) {
                    ch <- mx[[i]][[j]]
                    switch(match.arg(type), balance = {
                      if (isTRUE(all("o" == ch)) == TRUE) {
                        x2[i, j] <- "o"
                      } else {
                        ch <- replace(ch, ch == "o", NA)
                        cch <- stats::na.omit(ch)
                        if ("a" %in% cch) {
                          x2[i, j] <- "a"
                        } else if (all("p" == cch)) {
                          x2[i, j] <- "p"
                        } else if (all("n" == cch)) {
                          x2[i, j] <- "n"
                        } else x2[i, j] <- "a"
                        rm(cch)
                      }
                    }, cluster = {
                      if (isTRUE(all("o" == ch)) == TRUE) {
                        x2[i, j] <- "o"
                      } else {
                        ch <- replace(ch, ch == "o", NA)
                        cch <- stats::na.omit(ch)
                        if (isTRUE(length(cch) == 0) == TRUE) {
                          x2[i, j] <- "o"
                        } else if (all("p" == cch)) {
                          x2[i, j] <- "p"
                        } else if (all("n" == cch)) {
                          x2[i, j] <- "n"
                        } else if (all("q" == cch)) {
                          x2[i, j] <- "q"
                        } else if (all("a" == cch)) {
                          x2[i, j] <- "a"
                        } else {
                          cch <- replace(cch, cch == "q", NA)
                          ccch <- stats::na.omit(cch)
                          if ("a" %in% ccch) {
                            x2[i, j] <- "a"
                          } else if (all("p" == ccch)) {
                            x2[i, j] <- "p"
                          } else if (all("n" == ccch)) {
                            x2[i, j] <- "n"
                          } else if (all("q" == ccch)) {
                            x2[i, j] <- "q"
                          } else x2[i, j] <- "a"
                          rm(ccch)
                        }
                        rm(cch)
                      }
                    })
                  }
                  rm(j)
                  rm(ch)
                }
                rm(i)
                switch(match.arg(type), balance = {
                  if (isTRUE(transclos == TRUE) == TRUE) {
                    y2 <- as.matrix(x2)
                    y2 <- replace(y2, y2 == "p", 1L)
                    y2 <- replace(y2, y2 != 1L, 0)
                    for (i in seq_len(ncol(y2))) {
                      y2 <- pmax(y2, outer(y2[, i], y2[i, ], 
                        pmin.int))
                    }
                    rm(i)
                    y2 <- replace(y2, y2 == 1L, "p")
                    y2 <- replace(y2, y2 != "p", "o")
                    nn <- which(x2 == "n", arr.ind = TRUE)
                    for (i in seq_len(nrow(nn))) y2[nn[, 1][i], 
                      nn[, 2][i]] <- "n"
                    rm(i, nn)
                    aa <- which(x2 == "a", arr.ind = TRUE)
                    for (i in seq_len(nrow(aa))) y2[aa[, 1][i], 
                      aa[, 2][i]] <- "a"
                    rm(i, aa)
                    qq <- which(x2 == "q", arr.ind = TRUE)
                    for (i in seq_len(nrow(qq))) y2[qq[, 1][i], 
                      qq[, 2][i]] <- "q"
                    rm(i, qq)
                    x2 <- data.frame(matrix(nrow = nrow(x2), 
                      ncol = ncol(x2)))
                    for (i in seq_len(nrow(y2))) x2[i, ] <- y2[i, 
                      ]
                    rm(i)
                  } else {
                    NA
                  }
                  Q <- x2
                }, cluster = {
                  chmx <- list()
                  for (h in seq_len(nrow(Q))) {
                    tmp2 <- list()
                    for (i in seq_len(nrow(Q))) {
                      tmp <- vector()
                      for (j in seq_len(ncol(Q))) {
                        tmp <- append(tmp, c(Q[h, j], Q[j, i]))
                      }
                      rm(j)
                      tmp2[[i]] <- tmp
                    }
                    rm(i)
                    chmx[[h]] <- tmp2
                  }
                  rm(h)
                  rm(tmp, tmp2)
                  if (isTRUE(transclos == TRUE) == TRUE) {
                    y2 <- as.matrix(x2)
                    y2 <- replace(y2, y2 == "p", 1L)
                    y2 <- replace(y2, y2 != 1L, 0)
                    for (i in seq_len(ncol(y2))) {
                      y2 <- pmax(y2, outer(y2[, i], y2[i, ], 
                        pmin.int))
                    }
                    rm(i)
                    y2 <- replace(y2, y2 == 1L, "p")
                    y2 <- replace(y2, y2 != "p", "o")
                    nn <- which(x2 == "n", arr.ind = TRUE)
                    for (i in seq_len(nrow(nn))) y2[nn[, 1][i], 
                      nn[, 2][i]] <- "n"
                    rm(i, nn)
                    aa <- which(x2 == "a", arr.ind = TRUE)
                    for (i in seq_len(nrow(aa))) y2[aa[, 1][i], 
                      aa[, 2][i]] <- "a"
                    rm(i, aa)
                    qq <- which(x2 == "q", arr.ind = TRUE)
                    for (i in seq_len(nrow(qq))) y2[qq[, 1][i], 
                      qq[, 2][i]] <- "q"
                    rm(i, qq)
                    x2 <- data.frame(matrix(nrow = nrow(x2), 
                      ncol = ncol(x2)))
                    for (i in seq_len(nrow(y2))) x2[i, ] <- y2[i, 
                      ]
                    rm(i)
                  } else {
                    NA
                  }
                  x3 <- x2
                  for (o in seq_along(which(x2 == "o"))) {
                    if (isTRUE(sum(as.numeric(chmx[[which(x2 == 
                      "o", arr.ind = TRUE)[, 2][1]]][[which(x2 == 
                      "o", arr.ind = TRUE)[, 1][1]]] == "n")) > 
                      0) == TRUE) {
                      x3[which(x2 == "o", arr.ind = TRUE)[, 1][o], 
                        which(x2 == "o", arr.ind = TRUE)[, 2][o]] <- "n"
                    }
                  }
                  rm(o)
                  Q <- x3
                  rm(chmx, x2, x3)
                })
            }
            rm(z)
            Q <- noquote(as.matrix(Q))
            if (isTRUE(is.null(dimnames(q)) == FALSE) == TRUE) 
                rownames(Q) <- colnames(Q) <- dimnames(q)[[1]]
            if (missing(lbs) == FALSE && isTRUE(length(lbs) == 
                dim(Q)[1]) == TRUE) 
                rownames(Q) <- colnames(Q) <- lbs
            lst <- list(val = x$val, s = x$s, Q = Q, k = k)
            class(lst) <- c("Rel.Q", match.arg(type))
            return(lst)
        }
    }
    else {
        stop(paste("Valences in ", sQuote(deparse(substitute(x))), 
            " must be ", dQuote(paste("a", "n", "o", "p", "q", 
                sep = ", ")), " only.", sep = ""))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
partial.order <-
function (x, type = c("strings", "galois", "pi.rels"), lbs, sel, 
    po.incl, valued) 
{
    if (match.arg(type) == "strings") {
        if (isTRUE(attr(x, "class")[1] == "Strings") == TRUE) {
            if (missing(valued) == FALSE && isTRUE(valued == 
                FALSE) == TRUE) {
                po <- strng(strings(dichot(x$wt, c = 1))$wt)
            }
            else {
                po <- strng(x$wt)
            }
        }
        else if (isTRUE(attr(x, "class")[1] == "Strings") == 
            FALSE) {
            stop(paste(sQuote("x"), " is not a ", dQuote("Strings"), 
                " class object.", sep = ""))
        }
    }
    if (match.arg(type) == "galois") {
        if (isTRUE(attr(x$gc, "class")[1] == "Galois") == TRUE) {
            ifelse(isTRUE(x$sep == ", ") == TRUE, sep2 <- "} {", 
                sep2 <- "}{")
            if (isTRUE(attr(x$gc, "class")[2] == "full") == TRUE) {
                po <- matrix(0L, nrow = length(x$gc), ncol = length(x$gc))
                for (j in seq_along(x$gc)) {
                  for (i in seq_along(x$gc)) {
                    ifelse(isTRUE(all(dhc(x$gc[[i]], sep = x$sep) %in% 
                      dhc(x$gc[[j]], sep = x$sep))) == TRUE, 
                      po[i, j] <- 1L, NA)
                  }
                }
                rm(i, j)
                lb <- list()
                length(lb) <- length(x$gc)
                for (i in seq_along(x$gc)) {
                  if (isTRUE(is.na(attr(x$gc, "names")[i])) == 
                    FALSE) {
                    lb[[i]] <- paste(paste("{", attr(x$gc, "names")[i], 
                      sep = ""), paste(x$gc[[i]], "}", sep = ""), 
                      sep = sep2)
                  }
                  else {
                    lb[[i]] <- paste(paste("{", x$gc[[i]], sep = ""), 
                      paste(" ", "}", sep = ""), sep = sep2)
                  }
                }
                rm(i)
                colnames(po) <- rownames(po) <- lb
            }
            else if (isTRUE(attr(x$gc, "class")[2] == "reduced") == 
                TRUE) {
                po <- matrix(0L, nrow = length(x$gc$reduc), ncol = length(x$gc$reduc))
                for (j in seq_along(x$gc$reduc)) {
                  for (i in seq_along(x$gc$reduc)) {
                    ifelse(isTRUE(all(dhc(x$gc$full[[i]], sep = x$sep) %in% 
                      dhc(x$gc$full[[j]], sep = x$sep))) == TRUE, 
                      po[i, j] <- 1L, NA)
                  }
                }
                rm(i, j)
                lb <- list()
                length(lb) <- length(x$gc$reduc)
                for (i in seq_along(x$gc$reduc)) {
                  if (isTRUE(is.na(attr(x$gc$reduc, "names")[i])) == 
                    FALSE) {
                    lb[[i]] <- paste(paste("{", attr(x$gc$reduc, 
                      "names")[i], sep = ""), paste(x$gc$reduc[[i]], 
                      "}", sep = ""), sep = sep2)
                  }
                  else {
                    lb[[i]] <- paste(paste("{", " ", sep = ""), 
                      paste(x$gc$reduc[[i]], "}", sep = ""), 
                      sep = sep2)
                  }
                }
                rm(i)
                colnames(po) <- rownames(po) <- lb
            }
            ifelse(isTRUE(x$sep == ", ") == TRUE, cp <- which(dimnames(po)[[1]] == 
                "{} {}"), cp <- which(dimnames(po)[[1]] == "{}{}"))
            dimnames(po)[[1]][cp] <- dimnames(po)[[2]][cp] <- cp
        }
        else if (isTRUE(attr(x$gc, "class")[1] == "Galois") == 
            FALSE) {
            stop(paste(sQuote("x"), " is not a ", dQuote("Galois"), 
                " class object.", sep = ""))
        }
    }
    if (match.arg(type) == "pi.rels") {
        if (isTRUE("Pi.rels" %in% attr(x, "class")) == TRUE) {
            if (missing(sel) == FALSE && isTRUE(is.vector(sel) == 
                TRUE) == TRUE) {
                if (isTRUE(sel <= 0) == TRUE) {
                  stop(paste("Value of ", sQuote("sel"), " should be a positive integer.", 
                    sep = ""))
                }
                else {
                  NA
                }
            }
            else {
                if (missing(sel) == FALSE && is.null(sel) == 
                  TRUE) {
                  stop(paste(sQuote("sel"), " is NULL.", sep = ""))
                }
                else {
                  sel <- FALSE
                }
            }
            if (isTRUE(sel == FALSE) == TRUE) {
                xpi <- x$pi
            }
            else {
                xpi <- x$pi[, , unique(sel)]
            }
            if (missing(po.incl) == FALSE && isTRUE(po.incl == 
                TRUE) == TRUE) {
                ifelse(is.null(x$po) == TRUE, po <- strng(xpi), 
                  po <- strng(suppressWarnings(zbind(xpi, x$po))))
                dimnames(po)[[2]][dim(po)[2]] <- dimnames(po)[[1]][dim(po)[1]] <- "PO"
            }
            else {
                po <- strng(xpi)
            }
        }
        else if (isTRUE(attr(x, "class")[1] == "Pi.rels") == 
            FALSE) {
            stop(paste(sQuote("x"), " is not a ", dQuote("Pi.rels"), 
                " class object.", sep = ""))
        }
    }
    ifelse(missing(lbs) == FALSE && isTRUE(length(lbs) == dim(po)[1]) == 
        TRUE, dimnames(po)[[2]] <- dimnames(po)[[1]] <- lbs, 
        NA)
    if (match.arg(type) == "galois") {
        class(po) <- c("Partial.Order", match.arg(type), x$sep)
    }
    else if (match.arg(type) == "pi.rels") {
        class(po) <- c("Partial.Order", "Pi.rels")
    }
    else {
        class(po) <- c("Partial.Order", match.arg(type))
    }
    po
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
bundles <-
function (x, loops = FALSE, smpl = FALSE, lb2lb = TRUE, collapse = FALSE, 
    sep) 
{
    if (isTRUE(is.array(x)) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be an array of square matrices.", 
            sep = ""))
    if (isTRUE(dim(x)[1] == dim(x)[2]) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be square.", 
            sep = ""))
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    if (any(grepl(",", dimnames(x)[[1]])) == TRUE && isTRUE(sep %in% 
        c(",", ", ")) == TRUE) {
        warning(paste("Labels in ", sQuote(deparse(substitute(x))), 
            " contain comma like default separator.", sep = ""), 
            call. = FALSE)
    }
    else {
        NA
    }
    if (isTRUE(sum(x) == 0) == TRUE) {
        ifelse(isTRUE(loops == FALSE) == TRUE, lst <- list(asym = character(0), 
            recp = character(0), tent = character(0), txch = character(0), 
            mixd = character(0), full = character(0)), lst <- list(asym = character(0), 
            recp = character(0), tent = character(0), txch = character(0), 
            mixd = character(0), full = character(0), loop = character(0)))
        class(lst) <- c("Rel.Bundles", paste0("sep: ", sep))
        return(lst)
    }
    else {
        NA
    }
    ifelse(isTRUE(is.null(dimnames(x)[1]) == TRUE | is.null(dimnames(x)[1][[1]]) == 
        TRUE) == TRUE, LBS <- seq_len(nrow(x)), LBS <- dimnames(x)[[1]])
    lbs <- seq(LBS)
    if (is.null(dimnames(x)) == TRUE) {
        dimnames(x)[[1]] <- dimnames(x)[[2]] <- lbs
    }
    ifelse(isTRUE(dim(x)[3] == 1) == TRUE, x <- x[, , 1], NA)
    xd <- dichot(x, c = 1L, diag = TRUE)
    if (is.na(dim(xd)[3]) == FALSE) {
        TRD <- TRUE
        r <- dim(x)[3]
        if (isTRUE(is.null(dimnames(x)[[3]]) == TRUE) | isTRUE(any(duplicated(dimnames(x)[[3]]))) == 
            TRUE) {
            dimnames(x)[[3]] <- seq_len(dim(x)[3])
        }
        mlt <- list()
        for (i in seq_len(dim(x)[3])) {
            mlt[[i]] <- trnl(xd[, , i], lbs = lbs, sep = sep, 
                lb2lb = lb2lb)
        }
        rm(i)
        m <- unlist(mlt)
    }
    else {
        TRD <- FALSE
        r <- 1
        m <- trnl(xd, lbs = lbs, sep = sep, lb2lb = lb2lb)
    }
    if (smpl) {
        if (isTRUE(TRD == TRUE) == TRUE) {
            tmp <- list()
            tt <- vector()
            if (isTRUE(is.null(dimnames(x)[[3]])) == FALSE) {
                for (i in seq_len(length(dimnames(x)[[3]]))) tmp[i] <- dimnames(x)[[3]][i]
                rm(i)
                for (i in seq_len(length(tmp))) tt[i] <- (strsplit(tmp[[i]], 
                  "")[[1]][1])
                rm(i)
            }
            else {
                for (i in seq_len(dim(x)[3])) tt[i] <- tmp[i] <- i
                rm(i)
            }
            for (k in seq_len(r)) {
                allr <- paste("all", tt[k], sep = "_")
                assign(allr, trnl(xd[, , k], lbs = lbs, sep = sep, 
                  lb2lb = lb2lb))
                tmp <- trnl(xd[, , k], lbs = lbs, sep = sep, 
                  lb2lb = lb2lb)
                tDF <- data.frame(matrix(ncol = 2L, nrow = 0L))
                for (i in seq_len(length(tmp))) {
                  tDF[i, 1] <- strsplit(tmp[i], sep)[[1]][1]
                  tDF[i, 2] <- strsplit(tmp[i], sep)[[1]][2]
                }
                rm(i)
                rm(tmp)
                oud <- list()
                ind <- list()
                ald <- list()
                for (i in seq_len(length(lbs))) {
                  oud[[i]] <- as.numeric(tDF[which(tDF[, 1] == 
                    as.numeric(lbs[i])), 2])
                  ind[[i]] <- as.numeric(tDF[which(tDF[, 2] == 
                    as.numeric(lbs[i])), 1])
                  ald[[i]] <- c(oud[[i]], ind[[i]])
                }
                rm(i)
                assign(allr, ald)
                rm(oud, ind, ald, allr)
                rm(tDF)
            }
            rm(k)
        }
        else if (isTRUE(TRD == FALSE) == TRUE) {
            tt <- "R"
            tmp <- x
        }
    }
    else if (!(smpl)) {
        ifelse(isTRUE(TRD == TRUE) == TRUE, tt <- dimnames(x)[[3]], 
            NA)
    }
    bd <- bnd(x, xd, lbs, TRD, r, m, mlt, sep)
    As <- vector()
    for (i in seq_len(length(bd$asym))) {
        for (j in seq_len(length(bd$asym[[i]]))) {
            if (isTRUE(length(bd$asym[[i]]) != 0L) == TRUE) {
                if (isTRUE(is.na(dim(x)[3])) == FALSE) {
                  As <- append(As, paste(lbs[i], bd$asym[[i]][j], 
                    sep = sep))
                }
                else {
                  ifelse(isTRUE(bd$asym[[i]][j] %in% bd$out[[i]]) == 
                    TRUE, As <- append(As, paste(lbs[i], bd$asym[[i]][j], 
                    sep = sep)), NA)
                }
            }
        }
        rm(j)
    }
    rm(i)
    if (isTRUE(TRD == TRUE) == TRUE) {
        AS <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            for (i in which(As %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, As[i])
            }
            rm(i)
            AS[[k]] <- as.character(tmp)
        }
        rm(k)
    }
    else {
        AS <- as.character(As)
    }
    Rp <- vector()
    for (i in seq_len(length(bd$recp))) {
        for (j in seq_len(length(bd$recp[[i]]))) {
            if (isTRUE(length(bd$recp[[i]]) != 0L) == TRUE) {
                Rp <- append(Rp, paste(lbs[i], bd$recp[[i]][j], 
                  sep = sep))
            }
        }
        rm(j)
    }
    rm(i)
    if (isTRUE(TRD == TRUE) == TRUE) {
        RP <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            for (i in which(Rp %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, Rp[i])
            }
            rm(i)
            RP[[k]] <- as.character(tmp)
        }
        rm(k)
    }
    else {
        RP <- as.character(Rp)
    }
    Xc <- vector()
    if (isTRUE(TRD == TRUE) == TRUE) {
        for (i in seq_len(length(bd$xchg))) {
            for (j in seq_len(length(bd$xchg[[i]]))) {
                if (isTRUE(length(bd$xchg[[i]]) != 0L) == TRUE) {
                  if (isTRUE(lbs[i] < bd$xchg[[i]][j]) == TRUE) 
                    Xc <- append(Xc, paste(lbs[i], bd$xchg[[i]][j], 
                      sep = sep))
                }
            }
            rm(j)
        }
        rm(i)
        XC <- list()
        XCt <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            tmpt <- vector()
            for (i in which(Xc %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, Xc[i])
            }
            rm(i)
            for (i in which(Xc %in% trnl(t(xd[, , k]), lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmpt <- append(tmpt, paste(strsplit(Xc[i], sep)[[1]][2], 
                  strsplit(Xc[i], sep)[[1]][1], sep = sep))
            }
            rm(i)
            XC[[k]] <- tmp
            XCt[[k]] <- tmpt
        }
        rm(k)
        XCH <- list()
        for (i in seq_len(length(XC))) {
            XCH[[i]] <- as.character(c(XC[[i]], XCt[[i]]))
        }
        rm(i)
    }
    else {
        XCH <- as.character(Xc)
    }
    Et <- vector()
    if (isTRUE(TRD == TRUE) == TRUE) {
        for (i in seq_len(length(bd$Eout))) {
            for (j in seq_len(length(bd$Eout[[i]]))) {
                if (isTRUE(length(bd$Eout[[i]]) != 0L) == TRUE) {
                  Et <- append(Et, paste(lbs[i], bd$Eout[[i]][j], 
                    sep = sep))
                }
            }
            rm(j)
        }
        rm(i)
        ENT <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            for (i in which(Et %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, Et[i])
            }
            rm(i)
            ENT[[k]] <- as.character(tmp)
        }
        rm(k)
    }
    else {
        ENT <- as.character(Et)
    }
    Mx <- vector()
    if (isTRUE(TRD == TRUE) == TRUE) {
        for (i in seq_len(length(bd$mixe))) {
            for (j in seq_len(length(bd$mixe[[i]]))) {
                if (isTRUE(length(bd$mixe[[i]]) != 0L) == TRUE) {
                  if (isTRUE(lbs[i] < bd$mixe[[i]][j]) == TRUE) 
                    Mx <- append(Mx, paste(lbs[i], bd$mixe[[i]][j], 
                      sep = sep))
                }
            }
            rm(j)
        }
        rm(i)
        MX <- list()
        MXt <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            tmpt <- vector()
            for (i in which(Mx %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, Mx[i])
            }
            rm(i)
            for (i in which(Mx %in% trnl(t(xd[, , k]), lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmpt <- append(tmpt, paste(strsplit(Mx[i], sep)[[1]][2], 
                  strsplit(Mx[i], sep)[[1]][1], sep = sep))
            }
            rm(i)
            MX[[k]] <- tmp
            MXt[[k]] <- tmpt
        }
        rm(k)
        MIX <- list()
        for (i in seq_len(length(MX))) {
            MIX[[i]] <- as.character(c(MX[[i]], MXt[[i]]))
        }
        rm(i)
    }
    else {
        MIX <- as.character(Mx)
    }
    Fl <- vector()
    if (isTRUE(TRD == TRUE) == TRUE) {
        for (i in seq_len(length(bd$full))) {
            for (j in seq_len(length(bd$full[[i]]))) {
                if (isTRUE(length(bd$full[[i]]) != 0L) == TRUE) {
                  if (isTRUE(lbs[i] < bd$full[[i]][j]) == TRUE) 
                    Fl <- append(Fl, paste(lbs[i], bd$full[[i]][j], 
                      sep = sep))
                }
            }
            rm(j)
        }
        rm(i)
        FL <- list()
        FLt <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            tmpt <- vector()
            for (i in which(Fl %in% trnl(xd[, , k], lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmp <- append(tmp, Fl[i])
            }
            rm(i)
            for (i in which(Fl %in% trnl(t(xd[, , k]), lbs = lbs, 
                sep = sep, lb2lb = lb2lb))) {
                tmpt <- append(tmpt, paste(strsplit(Fl[i], sep)[[1]][2], 
                  strsplit(Fl[i], sep)[[1]][1], sep = sep))
            }
            rm(i)
            FL[[k]] <- tmp
            FLt[[k]] <- tmpt
        }
        rm(k)
        FUL <- list()
        for (i in seq_len(length(FL))) {
            FUL[[i]] <- as.character(c(FL[[i]], FLt[[i]]))
        }
        rm(i)
    }
    else {
        FUL <- as.character(Fl)
    }
    if (lb2lb) {
        if (isTRUE(is.null(dimnames(x)[[1]]) == TRUE) == FALSE) {
            if (length(AS) > 0L) {
                for (k in seq_len(length(AS))) {
                  for (i in seq_len(length(AS[[k]]))) {
                    if (length(AS[[k]]) > 0L) {
                      AS[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(AS[[k]][i], 
                        sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(AS[[k]][i], 
                        sep)[[1]][2])], sep = sep)
                    }
                  }
                  rm(i)
                }
                rm(k)
            }
            if (length(RP) > 0L) {
                for (k in seq_len(length(RP))) {
                  for (i in seq_len(length(RP[[k]]))) {
                    if (length(RP[[k]]) > 0L) {
                      RP[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(RP[[k]][i], 
                        sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(RP[[k]][i], 
                        sep)[[1]][2])], sep = sep)
                    }
                  }
                  rm(i)
                }
                rm(k)
            }
            if (isTRUE(is.na(dim(x)[3])) == FALSE) {
                if (length(XCH) > 0L) {
                  for (k in seq_len(length(XCH))) {
                    for (i in seq_len(length(XCH[[k]]))) {
                      if (length(XCH[[k]]) > 0L) {
                        XCH[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(XCH[[k]][i], 
                          sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(XCH[[k]][i], 
                          sep)[[1]][2])], sep = sep)
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
                if (length(ENT) > 0L) {
                  for (k in seq_len(length(ENT))) {
                    for (i in seq_len(length(ENT[[k]]))) {
                      if (length(ENT[[k]]) > 0L) {
                        ENT[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(ENT[[k]][i], 
                          sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(ENT[[k]][i], 
                          sep)[[1]][2])], sep = sep)
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
                if (length(MIX) > 0L) {
                  for (k in seq_len(length(MIX))) {
                    for (i in seq_len(length(MIX[[k]]))) {
                      if (length(MIX[[k]]) > 0L) {
                        MIX[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(MIX[[k]][i], 
                          sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(MIX[[k]][i], 
                          sep)[[1]][2])], sep = sep)
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
                if (length(FUL) > 0L) {
                  for (k in seq_len(length(FUL))) {
                    for (i in seq_len(length(FUL[[k]]))) {
                      if (length(FUL[[k]]) > 0L) {
                        FUL[[k]][i] <- paste(dimnames(x)[[1]][as.numeric(strsplit(FUL[[k]][i], 
                          sep)[[1]][1])], dimnames(x)[[1]][as.numeric(strsplit(FUL[[k]][i], 
                          sep)[[1]][2])], sep = sep)
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
            }
        }
    }
    if (loops) {
        if (isTRUE(TRD == TRUE) == TRUE) {
            LOP <- list()
            length(LOP) <- dim(x)[3]
            for (i in seq_len(dim(x)[3])) {
                lp <- which(diag(xd[, , i]) != 0L)
                if (isTRUE(length(lp) > 0L) == TRUE) {
                  for (j in seq_len(length(lp))) {
                    if (lb2lb) {
                      if (isTRUE(is.null(dimnames(x)[[1]])) == 
                        FALSE) {
                        LOP[[i]] <- append(LOP[[i]], paste(dimnames(x)[[1]][lp][j], 
                          dimnames(x)[[1]][lp][j], sep = sep))
                      }
                      else if (isTRUE(is.null(dimnames(x)[[1]])) == 
                        TRUE) {
                        LOP[[i]] <- append(LOP[[i]], paste(lp[j], 
                          lp[j], sep = sep))
                      }
                    }
                    else {
                      LOP[[i]] <- append(LOP[[i]], paste(lp[j], 
                        lp[j], sep = sep))
                    }
                  }
                  rm(j)
                }
                else {
                  LOP[[i]] <- character(0)
                }
            }
            rm(i)
            attr(LOP, "names") <- dimnames(x)[[3]]
        }
        else {
            LOP <- vector()
            lp <- which(diag(xd) != 0L)
            for (j in seq_len(length(lp))) {
                LOP <- append(LOP, paste(LBS[lp][j], LBS[lp][j], 
                  sep = sep))
            }
            rm(j)
        }
        if (isTRUE(smpl == FALSE) == TRUE) {
            ifelse(isTRUE(TRD == TRUE) == TRUE, attr(LOP, "names") <- dimnames(x)[[3]], 
                NA)
        }
        else {
            ifelse(isTRUE(TRD == TRUE) == TRUE, attr(LOP, "names") <- tt, 
                NA)
        }
    }
    if (isTRUE(TRD == TRUE) == TRUE) {
        ifelse(isTRUE(smpl == FALSE) == TRUE, attr(FUL, "names") <- attr(MIX, 
            "names") <- attr(ENT, "names") <- attr(XCH, "names") <- attr(RP, 
            "names") <- attr(AS, "names") <- dimnames(x)[[3]], 
            attr(FUL, "names") <- attr(MIX, "names") <- attr(ENT, 
                "names") <- attr(XCH, "names") <- attr(RP, "names") <- attr(AS, 
                "names") <- tt)
    }
    if (collapse) {
        ifelse(isTRUE(loops == FALSE) == TRUE, lst <- list(asym = as.vector(unlist(AS)), 
            recp = as.vector(unlist(RP)), tent = as.vector(unlist(ENT)), 
            txch = as.vector(unlist(XCH)), mixd = as.vector(unlist(MIX)), 
            full = as.vector(unlist(FUL))), lst <- list(asym = as.vector(unlist(AS)), 
            recp = as.vector(unlist(RP)), tent = as.vector(unlist(ENT)), 
            txch = as.vector(unlist(XCH)), mixd = as.vector(unlist(MIX)), 
            full = as.vector(unlist(FUL)), loop = as.vector(unlist(LOP))))
    }
    else {
        ifelse(isTRUE(loops == FALSE) == TRUE, lst <- list(asym = AS, 
            recp = RP, tent = ENT, txch = XCH, mixd = MIX, full = FUL), 
            lst <- list(asym = AS, recp = RP, tent = ENT, txch = XCH, 
                mixd = MIX, full = FUL, loop = LOP))
    }
    class(lst) <- c("Rel.Bundles", paste0("sep: ", sep))
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
swp <-
function (y, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    sy <- vector(length = length(y))
    for (i in seq_len(length(y))) {
        sy[i] <- paste(strsplit(y[i], sep)[[1]][2], strsplit(y[i], 
            sep)[[1]][1], sep = sep)
    }
    rm(i)
    return(sy)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
edgS <-
function (E, semigroupClass = FALSE) 
{
    if (isTRUE("EdgeTable" %in% attr(E, "class")) == TRUE) {
        gens <- E$gens
        E <- E$E
    }
    else {
        gens <- seq_len(ncol(E))
    }
    if (isTRUE(ncol(E) > 2) == TRUE) 
        stop("Two generators only are yet accepted.")
    n <- nrow(E)
    m <- ncol(E)
    S <- cbind(E, data.frame(matrix(ncol = (n - m), nrow = n)))
    colnames(S) <- seq_len(n)
    for (r in seq_len(n)) {
        for (s in (m + 1):n) {
            ws <- which(E == s)
            i <- ws%%n
            i <- replace(i, i == 0, n)
            j <- vector(length = length(i))
            j[which(ws <= n)] <- 1
            j[which(ws > n)] <- 2
            if (all(i > m) == TRUE) {
                tmp <- c(r, i[1], j[1])
                if (isTRUE(length(which(tmp > m)) == 1) == TRUE) {
                  chg <- which(tmp > m)
                }
                else {
                  chg <- which(tmp > m)[which(tmp > m)[length(which(tmp > 
                    m))]]
                }
                while (any(tmp > m) == TRUE) {
                  ifelse(isTRUE(length(which(tmp > m)) == 1) == 
                    TRUE, chg <- which(tmp > m), chg <- which(tmp > 
                    m)[which(tmp > m)[length(which(tmp > m))]])
                  ss <- tmp[chg]
                  wss <- which(E == ss)
                  ii <- wss%%n
                  ii <- replace(ii, ii == 0, n)
                  jj <- vector(length = length(ii))
                  jj[which(wss <= n)] <- 1L
                  jj[which(wss > n)] <- 2L
                  ifelse(isTRUE(chg > 1) == TRUE, tmp <- c(tmp[1:(chg - 
                    1)], c(ii[which(ii == min(ii))], jj[which(ii == 
                    min(ii))]), tmp[(chg + 1):length(tmp)]), 
                    tmp <- c(c(ii[which(ii == min(ii))], jj[which(ii == 
                      min(ii))]), tmp[(chg + 1):length(tmp)]))
                }
                if (any(tmp > m) == TRUE) {
                  for (k in seq_len(length(tmp) - 2)) {
                    tmp0 <- E[tmp[1], tmp[2]]
                    ifelse(isTRUE(length(tmp) > k) == TRUE, tmp <- c(tmp0, 
                      tmp[(k + 2):length(tmp)]), tmp <- c(E[tmp[1], 
                      tmp[2]], tmp[3]))
                  }
                  rm(k)
                }
                else {
                  ifelse(E[tmp[1], tmp[2]] > m, tmp1 <- E[tmp[1], 
                    tmp[2]], tmp1 <- c(tmp[1], tmp[2]))
                  tmp <- c(tmp1, tmp[3], tmp[4])
                  tmp <- c(E[tmp[1], tmp[2]], tmp[3])
                }
            }
            else {
                tmp <- c(r, i[which(i <= m)][1], j[which(i <= 
                  m)][1])
                if (E[tmp[2], tmp[3]] > m) {
                  tmp <- c(E[tmp[1], tmp[2]], tmp[3])
                }
                else {
                  tmp <- c(tmp[1], E[tmp[2], tmp[3]])
                }
            }
            S[r, s] <- S[tmp[1], tmp[2]]
        }
    }
    if (isTRUE(semigroupClass == FALSE) == TRUE) {
        S
    }
    else {
        lst <- list(ord = n, st = rownames(E), gens = gens, S = S)
        class(lst) <- "Semigroup"
        return(lst)
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
summaryBundles <-
function (x, file = NULL, latex = FALSE, byties) 
{
    if (isTRUE("Rel.Bundles" %in% attr(x, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be a ", 
            dQuote("Rel.Bundles"), " class object.", sep = ""))
    sep <- dhc(attr(x, "class")[2], ": ")[2]
    ifelse(isTRUE(sep == " -- ") == TRUE, sep2 <- ", ", sep2 <- " -- ")
    ifelse(missing(byties) == FALSE && isTRUE(byties == TRUE) == 
        TRUE, byties <- TRUE, byties <- FALSE)
    if (latex) {
        if (isTRUE(is.null(file)) == TRUE) 
            stop("No connection provided.")
    }
    else {
        if (isTRUE(is.null(file)) == FALSE) 
            file = NULL
    }
    ulx <- unlist(x)
    if (isTRUE(length(ulx) != 0) == TRUE) {
        lb <- vector()
        for (i in seq_len(length(ulx))) {
            lb <- append(lb, strsplit(ulx[i], sep)[[1]])
        }
        rm(i)
        lb <- levels(factor(lb))
    }
    asym <- list()
    k <- 1L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        for (i in seq_len(length(x[[k]]))) {
            for (j in seq_len(length(x[[k]][[i]]))) {
                if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                  if (latex) {
                    if (isTRUE(is.null(attr(x[[k]], "names")) == 
                      FALSE)) {
                      asym[[q]] <- noquote(paste("\\stackrel{\\rightarrow}{\\sf ", 
                        attr(x[[k]][i], "names"), "} (", x[[k]][[i]][j], 
                        ")", sep = ""))
                    }
                    else {
                      asym[[q]] <- noquote(paste("\\stackrel{\\rightarrow}{", 
                        "R", "} (", x[[k]][[i]][j], ")", sep = ""))
                    }
                  }
                  else if (isTRUE(byties == TRUE) == TRUE) {
                    asym[[q]] <- x[[k]][[i]][j]
                  }
                  else {
                    if (isTRUE(is.null(attr(x[[k]], "names")) == 
                      FALSE)) {
                      asym[[q]] <- noquote(paste("->", "{", attr(x[[k]][i], 
                        "names"), "} (", x[[k]][[i]][j], ")", 
                        sep = ""))
                    }
                    else {
                      asym[[q]] <- noquote(paste("->", "{", "R", 
                        "} (", x[[k]][[i]][j], ")", sep = ""))
                    }
                  }
                  q <- q + 1L
                }
            }
            rm(j)
        }
        rm(i)
    }
    recp <- list()
    k <- 2L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        if (isTRUE(is.list(x[[k]])) == TRUE) {
            for (i in seq_len(length(x[[k]]))) {
                if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                  tmp <- transf(x[[k]][[i]], type = "toarray", 
                    lb2lb = TRUE, lbs = lb, ord = length(lb), 
                    sep = sep)
                  tmp[lower.tri(tmp)] <- NA
                  tmp[is.na(tmp)] <- 0
                  if (isTRUE(sum(tmp) == 0) == FALSE) {
                    tmp <- trnf(tmp, tolist = TRUE, lb2lb = TRUE, 
                      lbs = lb, sep = sep)
                    for (j in seq_len(length(tmp))) {
                      if (latex) {
                        if (isTRUE(is.null(attr(x[[k]], "names")) == 
                          FALSE)) {
                          recp[[q]] <- noquote(paste("\\stackrel{\\leftrightarrow}{\\sf ", 
                            attr(x[[k]][i], "names"), "} (", 
                            tmp[j], ")", sep = ""))
                        }
                        else {
                          recp[[q]] <- noquote(paste("\\stackrel{\\leftrightarrow}{", 
                            "R", "} (", tmp[j], ")", sep = ""))
                        }
                      }
                      else if (isTRUE(byties == TRUE) == TRUE) {
                        recp[[q]] <- (paste0(c(tmp[j], swp(tmp[j], 
                          sep = sep)), collapse = sep2))
                      }
                      else {
                        if (isTRUE(is.null(attr(x[[k]], "names")) == 
                          FALSE)) {
                          recp[[q]] <- noquote(paste("<->", "{", 
                            attr(x[[k]][i], "names"), "} (", 
                            tmp[j], ")", sep = ""))
                        }
                        else {
                          recp[[q]] <- noquote(paste("<->", "{", 
                            "R", "} (", tmp[j], ")", sep = ""))
                        }
                      }
                      q <- q + 1L
                    }
                    rm(j)
                  }
                }
            }
            rm(i)
        }
        else if (isTRUE(is.list(x[[k]])) == FALSE) {
            tmp <- men(x[[k]], sep = sep)
            for (j in seq_len(length(tmp))) {
                if (latex) {
                  recp[[q]] <- noquote(paste("\\stackrel{\\leftrightarrow}{", 
                    "R", "} (", tmp[j], ")", sep = ""))
                }
                else if (isTRUE(byties == TRUE) == TRUE) {
                  recp[[q]] <- (paste0(c(tmp[j], swp(tmp[j], 
                    sep = sep)), collapse = sep2))
                }
                else {
                  recp[[q]] <- noquote(paste("<->", "{", "R", 
                    "} (", tmp[j], ")", sep = ""))
                }
                q <- q + 1L
            }
            rm(j)
        }
    }
    tent <- list()
    k <- 3L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        tmp <- vector()
        for (l in seq_len(length(levels(factor(unlist(x[[k]])))))) {
            for (i in seq_len(length(x[[k]]))) {
                if (isTRUE(levels(factor(unlist(x[[k]])))[l] %in% 
                  x[[k]][[i]]) == TRUE) {
                  if (latex) {
                    tmp <- append(tmp, paste("\\stackrel{\\rightarrow}{\\sf ", 
                      attr(x[[k]][i], "names"), "}", sep = ""))
                  }
                  else {
                    ifelse(isTRUE(byties == TRUE) == TRUE, tmp <- append(tmp, 
                      levels(factor(unlist(x[[k]])))[l]), tmp <- append(tmp, 
                      paste("->", "{", attr(x[[k]][i], "names"), 
                        "}", sep = "")))
                  }
                }
            }
            rm(i)
            if (isTRUE(byties == TRUE) == FALSE) {
                tmp <- append(tmp, paste(" (", levels(factor(unlist(x[[k]])))[l], 
                  ")", sep = ""))
                tent[[q]] <- noquote(paste(tmp, collapse = " "))
            }
            else if (isTRUE(byties == TRUE) == TRUE) {
                tent[[q]] <- (paste0(tmp, collapse = sep2))
            }
            q <- q + 1L
            tmp <- vector()
        }
        rm(l)
    }
    txch <- list()
    k <- 4L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        temp <- men(levels(factor(unlist(x[[k]]))), sep = sep)
        tmp <- vector()
        for (l in seq_len(length(temp))) {
            for (i in seq_len(length(x[[k]]))) {
                if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                  if (isTRUE(temp[l] %in% x[[k]][[i]]) == TRUE) {
                    if (latex) {
                      tmp <- append(tmp, paste("\\stackrel{\\rightarrow}{\\sf ", 
                        attr(x[[k]][i], "names"), "}", sep = ""))
                    }
                    else {
                      ifelse(isTRUE(byties == TRUE) == TRUE, 
                        tmp <- append(tmp, temp[l]), tmp <- append(tmp, 
                          paste("->", "{", attr(x[[k]][i], "names"), 
                            "}", sep = "")))
                    }
                  }
                  if (isTRUE(swp(temp[l], sep = sep) %in% x[[k]][[i]]) == 
                    TRUE) {
                    if (latex) {
                      tmp <- append(tmp, paste("\\stackrel{\\leftarrow}{\\sf ", 
                        attr(x[[k]][i], "names"), "}", sep = ""))
                    }
                    else {
                      ifelse(isTRUE(byties == TRUE) == TRUE, 
                        tmp <- append(tmp, swp(temp[l], sep = sep)), 
                        tmp <- append(tmp, paste("<-", "{", attr(x[[k]][i], 
                          "names"), "}", sep = "")))
                    }
                  }
                }
            }
            rm(i)
            if (isTRUE(byties == TRUE) == FALSE) {
                tmp <- append(tmp, paste("(", temp[l], ")", sep = ""))
                txch[[q]] <- noquote(paste(tmp, collapse = " "))
            }
            else if (isTRUE(byties == TRUE) == TRUE) {
                txch[[q]] <- (paste0(tmp, collapse = sep2))
            }
            q <- q + 1L
            tmp <- vector()
        }
        rm(l)
    }
    mixd <- list()
    k <- 5L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        temp <- men(levels(factor(unlist(x[[k]]))), sep = sep)
        tmp <- vector()
        for (l in seq_len(length(temp))) {
            for (i in seq_len(length(x[[k]]))) {
                if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                  if (isTRUE(temp[l] %in% x[[k]][[i]]) == TRUE && 
                    isTRUE(swp(temp[l], sep = sep) %in% x[[k]][[i]]) == 
                      TRUE) {
                    if (latex) {
                      tmp <- append(tmp, paste("\\stackrel{\\leftrightarrow}{\\sf ", 
                        attr(x[[k]][i], "names"), "}", sep = ""))
                    }
                    else {
                      ifelse(isTRUE(byties == TRUE) == TRUE, 
                        tmp <- append(tmp, c(temp[l], swp(temp[l], 
                          sep = sep))), tmp <- append(tmp, paste("<->", 
                          "{", attr(x[[k]][i], "names"), "}", 
                          sep = "")))
                    }
                  }
                  else {
                    if (isTRUE(temp[l] %in% x[[k]][[i]]) == TRUE) {
                      if (latex) {
                        tmp <- append(tmp, paste("\\stackrel{\\rightarrow}{\\sf ", 
                          attr(x[[k]][i], "names"), "}", sep = ""))
                      }
                      else {
                        ifelse(isTRUE(byties == TRUE) == TRUE, 
                          tmp <- append(tmp, temp[l]), tmp <- append(tmp, 
                            paste("->", "{", attr(x[[k]][i], 
                              "names"), "}", sep = "")))
                      }
                    }
                    if (isTRUE(swp(temp[l], sep = sep) %in% x[[k]][[i]]) == 
                      TRUE) {
                      if (latex) {
                        tmp <- append(tmp, paste("\\stackrel{\\leftarrow}{\\sf ", 
                          attr(x[[k]][i], "names"), "}", sep = ""))
                      }
                      else {
                        ifelse(isTRUE(byties == TRUE) == TRUE, 
                          tmp <- append(tmp, swp(temp[l], sep = sep)), 
                          tmp <- append(tmp, paste("<-", "{", 
                            attr(x[[k]][i], "names"), "}", sep = "")))
                      }
                    }
                  }
                }
            }
            rm(i)
            if (isTRUE(byties == TRUE) == FALSE) {
                tmp <- append(tmp, paste(" (", temp[l], ")", 
                  sep = ""))
                mixd[[q]] <- noquote(paste(tmp, collapse = " "))
            }
            else if (isTRUE(byties == TRUE) == TRUE) {
                mixd[[q]] <- (paste0(tmp, collapse = sep2))
            }
            q <- q + 1L
            tmp <- vector()
        }
        rm(l)
    }
    full <- list()
    k <- 6L
    if (length(unlist(x[[k]])) > 0) {
        q <- 1L
        temp <- men(levels(factor(unlist(x[[k]]))), sep = sep)
        tmp <- vector()
        for (l in seq_len(length(temp))) {
            for (i in seq_len(length(x[[k]]))) {
                if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                  if (isTRUE(temp[l] %in% x[[k]][[i]]) == TRUE) {
                    if (latex) {
                      tmp <- append(tmp, paste("\\stackrel{", 
                        "\\leftrightarrow}{\\sf ", attr(x[[k]][i], 
                          "names"), "}", sep = ""))
                    }
                    else {
                      ifelse(isTRUE(byties == TRUE) == TRUE, 
                        tmp <- append(tmp, c(temp[l], swp(temp[l], 
                          sep = sep))), tmp <- append(tmp, paste("<->", 
                          "{", attr(x[[k]][i], "names"), "}", 
                          sep = "")))
                    }
                  }
                }
            }
            rm(i)
            if (isTRUE(byties == TRUE) == FALSE) {
                tmp <- append(tmp, paste(" (", temp[l], ")", 
                  sep = ""))
                full[[q]] <- noquote(paste(tmp, collapse = " "))
            }
            else if (isTRUE(byties == TRUE) == TRUE) {
                full[[q]] <- (paste0(tmp, collapse = sep2))
            }
            q <- q + 1L
            tmp <- vector()
        }
        rm(l)
    }
    if (isTRUE(length(x) == 7L) == TRUE) {
        loop <- list()
        k <- 7L
        if (length(unlist(x[[k]])) > 0) {
            q <- 1L
            for (i in seq_len(length(x[[k]]))) {
                for (j in seq_len(length(x[[k]][[i]]))) {
                  if (isTRUE(length(x[[k]][[i]]) != 0) == TRUE) {
                    if (latex) {
                      if (isTRUE(is.null(attr(x[[k]], "names")) == 
                        FALSE)) {
                        loop[[q]] <- noquote(paste("\\stackrel{\\curvearrowright}{\\sf ", 
                          attr(x[[k]][i], "names"), "} (", x[[k]][[i]][j], 
                          ")", sep = ""))
                      }
                      else {
                        loop[[q]] <- noquote(paste("\\stackrel{\\curvearrowright}{", 
                          "R", "} (", x[[k]][[i]][j], ")", sep = ""))
                      }
                    }
                    else if (isTRUE(byties == TRUE) == TRUE) {
                      loop[[q]] <- x[[k]][[i]][j]
                    }
                    else {
                      if (isTRUE(is.null(attr(x[[k]], "names")) == 
                        FALSE)) {
                        loop[[q]] <- noquote(paste("o", "{", 
                          attr(x[[k]][i], "names"), "} (", x[[k]][[i]][j], 
                          ")", sep = ""))
                      }
                      else {
                        loop[[q]] <- noquote(paste("o", "{", 
                          "R", "} (", x[[k]][[i]][j], ")", sep = ""))
                      }
                    }
                    q <- q + 1L
                  }
                }
                rm(j)
            }
            rm(i)
        }
    }
    ifelse(isTRUE(length(x) == 7L) == TRUE, bndl <- list(Asym = asym, 
        Recp = recp, Tent = tent, Txch = txch, Mixd = mixd, Full = full, 
        Loop = loop), bndl <- list(Asym = asym, Recp = recp, 
        Tent = tent, Txch = txch, Mixd = mixd, Full = full))
    Bundles <- unlist(bndl)
    if (latex) {
        cat(paste("%% Produced by", dQuote("multiplex"), paste("v.", 
            sQuote(utils::packageDescription("multiplex")["Version"]$Version), 
            sep = ""), collapse = "  \\\\\n"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\\documentclass{article}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\usepackage[landscape,a4paper]{geometry}", 
            collapse = "\n"), file = file, sep = "\n", append = TRUE)
        if (isTRUE(length(bndl) == 7L) == TRUE) {
            cat(paste("\\usepackage{amssymb}", collapse = "\n"), 
                file = file, sep = "\n", append = TRUE)
        }
        cat(paste("\\begin{document}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat(paste("\\pagestyle{empty}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("\\setlength{\\tabcolsep}{5pt}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{lllllll}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Asymmetric}:", length(bndl[[1]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[1]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("&", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Reciprocal}:", length(bndl[[2]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[2]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("&", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Tie Entrainment}:", length(bndl[[3]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[3]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("&", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Tie Exchange}:", length(bndl[[4]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[4]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("&", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Mixed}:", length(bndl[[5]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[5]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("&", file = file, sep = "\n", append = TRUE)
        cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\\normalsize{\\bf Full}:", length(bndl[[6]]), 
            sep = " "), file = file, append = TRUE)
        cat("\\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("$", bndl[[6]], "$", sep = "", collapse = "  \\\\\n"), 
            file = file, append = TRUE)
        cat("  \\\\", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        if (isTRUE(length(bndl) == 7) == TRUE) {
            cat("&", file = file, sep = "\n", append = TRUE)
            cat(paste("\\begin{tabular}[t]{l}", collapse = "\n"), 
                file = file, sep = "\n", append = TRUE)
            cat(paste("\\normalsize{\\bf Loops}:", length(bndl[[7]]), 
                sep = " "), file = file, append = TRUE)
            cat("\\\\", file = file, sep = "\n", append = TRUE)
            cat(paste("$", bndl[[7]], "$", sep = "", collapse = "  \\\\\n"), 
                file = file, append = TRUE)
            cat("  \\\\", file = file, sep = "\n", append = TRUE)
            cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
                sep = "\n", append = TRUE)
        }
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{tabular}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("\\end{document}", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
    }
    else {
        if (isTRUE(byties == TRUE) == TRUE && isTRUE(length(ulx) != 
            0) == TRUE) {
            dfbndl <- as.data.frame(Bundles)
            ltbndl <- list()
            length(ltbndl) <- nrow(dfbndl)
            for (i in seq_len(nrow(dfbndl))) {
                ltbndl[[i]] <- dhc(as.vector(dfbndl[i, ]), sep = sep2)
            }
            rm(i)
            attr(ltbndl, "names") <- attr(Bundles, "names")
            return(ltbndl)
        }
        else {
            return(as.data.frame(Bundles))
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
ngbs <-
function (x, rs, type = c("und", "inn", "out"), num = FALSE) 
{
    if (isTRUE("Rel.System" %in% attr(rs, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(rs))), " must be a ", 
            dQuote("Rel.System"), " class object.", sep = ""))
    ifelse(isTRUE(is.numeric(x)) == TRUE, x <- rs$nodes[x], NA)
    if (isTRUE(all(x %in% unique(unlist(dhc(as.character(rs$nodes)))))) == 
        TRUE) {
        rst <- as.list(unlist(rs$Ties))
        srs <- list()
        for (i in seq_len(length(rst))) {
            tmp <- vector()
            if (length(rst[[i]]) > 0) {
                for (n in seq_len(length(x))) {
                  for (j in seq_len(length(rst[[i]]))) {
                    if (x[n] %in% c(c(strsplit(rst[[i]][j], rs$sep)[[1]][1], 
                      strsplit(rst[[i]][j], rs$sep)[[1]][2]))) {
                      tmp <- append(tmp, rst[[i]][j])
                    }
                  }
                  rm(j)
                }
                rm(n)
            }
            srs[[i]] <- as.vector(unlist(tmp))
        }
        rm(i)
        attr(srs, "names") <- attr(rst, "names")
        nrs <- vector()
        for (i in seq_len(length(srs))) {
            if (isTRUE(length(srs[[i]]) > 0) == TRUE) {
                for (j in seq_len(length(srs[[i]]))) {
                  switch(match.arg(type), und = nrs <- append(nrs, 
                    strsplit(srs[[i]][j], rs$sep)[[1]][1]), inn = nrs <- append(nrs, 
                    strsplit(srs[[i]][j], rs$sep)[[1]][1]), out = nrs <- append(nrs, 
                    (strsplit(srs[[i]][j], rs$sep)[[1]][2])))
                  switch(match.arg(type), und = nrs <- append(nrs, 
                    strsplit(srs[[i]][j], rs$sep)[[1]][2]), inn = NA, 
                    out = NA)
                }
                rm(j)
            }
        }
        rm(i)
        nb <- levels(factor(nrs))
        if (num) {
            return(which(rs$nodes %in% nb[which(!(nb %in% x))]))
        }
        else {
            return(nb[which(!(nb %in% x))])
        }
    }
    else {
        warning(paste(sQuote(deparse(substitute(x))), " is not part of ", 
            sQuote(deparse(substitute(rs))), ".", sep = ""), 
            call. = FALSE)
        x
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
bundle.census <-
function (x, loops = FALSE) 
{
    if (isTRUE(is.array(x)) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be an array of square matrices.", 
            sep = ""))
    if (isTRUE(dim(x)[1] == dim(x)[2]) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be square.", 
            sep = ""))
    sep <- ", "
    if (any(grepl(",", dimnames(x)[[1]])) == TRUE) {
        lb2lb <- FALSE
    }
    else {
        lb2lb <- TRUE
    }
    ifelse(isTRUE(is.null(dimnames(x)[1]) == TRUE | is.null(dimnames(x)[1][[1]]) == 
        TRUE) == TRUE, LBS <- seq_len(nrow(x)), LBS <- dimnames(x)[[1]])
    lbs <- seq(LBS)
    xd <- dichot(x, c = 1L, diag = TRUE)
    ifelse(isTRUE(dim(xd)[3] == 1) == TRUE, xd <- xd[, , 1], 
        NA)
    if (is.na(dim(xd)[3]) == FALSE) {
        TRD <- TRUE
        r <- dim(x)[3]
        if (isTRUE(is.null(dimnames(x)[[3]]) == TRUE) | isTRUE(any(duplicated(dimnames(x)[[3]]))) == 
            TRUE) {
            dimnames(x)[[3]] <- seq_len(dim(x)[3])
        }
        mlt <- list()
        for (i in seq_len(dim(x)[3])) {
            mlt[[i]] <- trnl(xd[, , i], lbs = lbs, lb2lb = lb2lb, 
                sep = sep)
        }
        rm(i)
        m <- unlist(mlt)
    }
    else {
        TRD <- FALSE
        r <- 1L
        m <- trnl(xd, lbs = lbs, lb2lb = lb2lb, sep = sep)
    }
    bd <- bnd(x, xd, lbs, TRD, r, m, mlt, sep)
    Et <- vector()
    if (isTRUE(TRD == TRUE) == TRUE) {
        for (i in seq_len(length(bd$Eout))) {
            for (j in seq_len(length(bd$Eout[[i]]))) {
                if (isTRUE(length(bd$Eout[[i]]) != 0L) == TRUE) {
                  Et <- append(Et, paste(lbs[i], bd$Eout[[i]][j], 
                    sep = sep))
                }
            }
            rm(j)
        }
        rm(i)
        ENT <- list()
        for (k in seq_len(r)) {
            tmp <- vector()
            for (i in which(Et %in% trnl(xd[, , k], lbs = lbs, 
                lb2lb = lb2lb, sep = sep))) {
                tmp <- append(tmp, Et[i])
            }
            rm(i)
            ENT[[k]] <- as.character(tmp)
        }
        rm(k)
    }
    else {
        ENT <- as.character(Et)
    }
    if (loops) {
        if (isTRUE(is.na(dim(xd)[3])) == FALSE) {
            vec <- vector()
            for (i in seq_len(dim(xd)[3])) {
                vec <- append(vec, sum(diag(xd[, , i])))
            }
            rm(i)
            lop <- sum(vec)
        }
        else {
            lop <- sum(diag(xd))
        }
    }
    tbnd <- (length(unlist(bd$full))/2L + length(unlist(bd$asym))/2L + 
        length(unlist(bd$recp))/2L + length(unlist(bd$xchg))/2L + 
        length(unlist(bd$Eout))/1L + (length(unlist(bd$tripfl))/2L) - 
        (length(which(table(unlist(ENT)) > 2L))))
    ifelse(isTRUE(loops == FALSE) == TRUE, {
        bc <- cbind(abs(choose(nrow(xd), 2) - (choose(nrow(xd), 
            2)) - tbnd), (choose(nrow(xd), 2)) - tbnd, length(unlist(bd$asym))/2L, 
            length(unlist(bd$recp))/2L, length(unlist(bd$Eout))/1L, 
            length(unlist(bd$xchg))/2L, (length(unlist(bd$tripfl))/2L) - 
                (length(which(table(unlist(ENT)) > 2L))), length(unlist(bd$full))/2L)
        colnames(bc) <- c("BUNDLES", "NULL", "ASYMM", "RECIP", 
            "T.ENTR", "T.EXCH", "MIXED", "FULL")
        rownames(bc) <- "TOTAL"
    }, {
        bc <- cbind(abs(choose(nrow(xd), 2) - (choose(nrow(xd), 
            2)) - tbnd), (choose(nrow(xd), 2)) - tbnd, length(unlist(bd$asym))/2L, 
            length(unlist(bd$recp))/2L, length(unlist(bd$Eout))/1L, 
            length(unlist(bd$xchg))/2L, (length(unlist(bd$tripfl))/2L) - 
                (length(which(table(unlist(ENT)) > 2L))), length(unlist(bd$full))/2L, 
            lop)
        colnames(bc) <- c("BUNDLES", "NULL", "ASYMM", "RECIP", 
            "T.ENTR", "T.EXCH", "MIXED", "FULL", "LOOP")
        rownames(bc) <- "TOTAL"
    })
    return(bc)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
rbox <-
function (w, transp = FALSE, smpl = FALSE, k = 3, tlbs) 
{
    if (is.array(w) == FALSE) 
        stop(paste(sQuote(deparse(substitute(w))), " must be at least a stacked array of square matrices.", 
            sep = ""))
    if (is.na(dim(w)[3]) == TRUE) 
        stop("Data must have at least 2 dimensions.")
    if (k > 9L) {
        warning("Only compounds until length 9 are supported.", 
            call. = FALSE)
        k <- 9
    }
    x <- w
    ifelse(is.null(dimnames(w)[[3]]) == FALSE, lbs <- dimnames(w)[[3]], 
        lbs <- seq_len(dim(w)[3]))
    if (smpl == TRUE) {
        olbs <- dimnames(w)[[3]]
        if (is.null(dimnames(w)[[3]]) == FALSE) {
            nlb <- list()
            for (i in seq_len(length(lbs))) nlb[i] <- lbs[i]
            for (i in seq_len(length(nlb))) lbs[i] <- (strsplit(nlb[[i]], 
                "")[[1]][1])
            dimnames(w)[[3]] <- lbs
        }
        nlbs <- dimnames(w)[[3]]
    }
    if (transp == TRUE) {
        if (missing(tlbs) == TRUE) {
            LBS <- chartr("a-zA-Z", "A-Za-z", lbs)
        }
        else {
            if (isTRUE(length(tlbs) == dim(w)[3]) == TRUE) {
                LBS <- tlbs
            }
            else {
                warning(paste("Use toggle case for transpose relations in ", 
                  sQuote("tlbs"), " since length is not equal to number of relation-types in ", 
                  sQuote(deparse(substitute(w))), ".", sep = ""), 
                  call. = FALSE)
                LBS <- chartr("a-zA-Z", "A-Za-z", lbs)
            }
        }
        Lbs <- as.vector(stats::na.exclude(LBS))
        tw <- array(dim = c(dim(w)[1], dim(w)[2], length(Lbs)))
        for (i in seq_len(length(Lbs))) {
            if (isTRUE(is.na(LBS)[i]) == FALSE) {
                tw[, , i] <- t(w[, , i])
            }
            else {
                NA
            }
        }
        rm(i)
        dimnames(tw)[3] <- list(Lbs)
        tmp <- zbnd(w, tw)
        lbs <- c(dimnames(w)[[3]], dimnames(tw)[[3]])
        w <- tmp
        dimnames(w)[[3]] <- lbs
        rm(tmp, tw)
    }
    w1 <- w
    if (isTRUE(k > 1L) == TRUE) {
        tmp2 <- data.frame(matrix(ncol = (dim(w)[1] * dim(w)[2]), 
            nrow = (dim(w)[3]^2)))
        lb2 <- vector()
        h <- 1L
        for (i in seq_len(dim(w)[3])) {
            for (j in seq_len(dim(w)[3])) {
                tmp2[h, ] <- replace(as.numeric(as.vector(w[, 
                  , i] %*% w[, , j])), as.numeric(as.vector(w[, 
                  , i] %*% w[, , j])) >= 1L, 1L)
                lb2[h] <- paste(dimnames(w)[[3]][i], dimnames(w)[[3]][j], 
                  sep = "")
                h <- h + 1L
            }
        }
        w2 <- array(dim = c(dim(w)[1], dim(w)[2], nrow(tmp2)))
        for (i in seq_len(nrow(tmp2))) {
            w2[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp2[i, 
                ])
        }
        if (isTRUE(k > 2L) == TRUE) {
            tmp3 <- data.frame(matrix(ncol = (dim(w)[1] * dim(w)[2]), 
                nrow = (dim(w)[3]^3)))
            lb3 <- vector()
            h <- 1L
            for (i in seq_len(dim(w)[3])) {
                for (j in seq_len(dim(w)[3])) {
                  for (l in seq_len(dim(w)[3])) {
                    tmp3[h, ] <- replace(as.numeric(as.vector(w[, 
                      , i] %*% w[, , j] %*% w[, , l])), as.numeric(as.vector(w[, 
                      , i] %*% w[, , j] %*% w[, , l])) >= 1L, 
                      1L)
                    lb3[h] <- paste(dimnames(w)[[3]][i], dimnames(w)[[3]][j], 
                      dimnames(w)[[3]][l], sep = "")
                    h <- h + 1L
                  }
                }
            }
            w3 <- array(dim = c(dim(w)[1], dim(w)[2], nrow(tmp3)))
            for (i in seq_len(nrow(tmp3))) {
                w3[, , i][1:(dim(w)[1] * dim(w)[2])] <- as.numeric(tmp3[i, 
                  ])
            }
            if (isTRUE(k > 3L) == TRUE) {
                tmp4 <- data.frame(matrix(ncol = (dim(w)[1] * 
                  dim(w)[2]), nrow = (dim(w)[3]^4)))
                lb4 <- vector()
                h <- 1L
                for (i in seq_len(dim(w)[3])) {
                  for (j in seq_len(dim(w)[3])) {
                    for (l in seq_len(dim(w)[3])) {
                      for (m in seq_len(dim(w)[3])) {
                        tmp4[h, ] <- replace(as.numeric(as.vector(w[, 
                          , i] %*% w[, , j] %*% w[, , l] %*% 
                          w[, , m])), as.numeric(as.vector(w[, 
                          , i] %*% w[, , j] %*% w[, , l] %*% 
                          w[, , m])) >= 1L, 1L)
                        lb4[h] <- paste(dimnames(w)[[3]][i], 
                          dimnames(w)[[3]][j], dimnames(w)[[3]][l], 
                          dimnames(w)[[3]][m], sep = "")
                        h <- h + 1L
                      }
                    }
                  }
                }
                w4 <- array(dim = c(dim(w)[1], dim(w)[2], nrow(tmp4)))
                for (i in seq_len(nrow(tmp4))) {
                  w4[, , i][1:(dim(w)[1] * dim(w)[2])] <- as.numeric(tmp4[i, 
                    ])
                }
                if (isTRUE(k > 4L) == TRUE) {
                  tmp5 <- data.frame(matrix(ncol = (dim(w)[1] * 
                    dim(w)[2]), nrow = (dim(w)[3]^5)))
                  lb5 <- vector()
                  h <- 1L
                  for (i in seq_len(dim(w)[3])) {
                    for (j in seq_len(dim(w)[3])) {
                      for (l in seq_len(dim(w)[3])) {
                        for (m in seq_len(dim(w)[3])) {
                          for (n in seq_len(dim(w)[3])) {
                            tmp5[h, ] <- replace(as.numeric(as.vector(w[, 
                              , i] %*% w[, , j] %*% w[, , l] %*% 
                              w[, , m] %*% w[, , n])), as.numeric(as.vector(w[, 
                              , i] %*% w[, , j] %*% w[, , l] %*% 
                              w[, , m] %*% w[, , n])) >= 1L, 
                              1L)
                            lb5[h] <- paste(dimnames(w)[[3]][i], 
                              dimnames(w)[[3]][j], dimnames(w)[[3]][l], 
                              dimnames(w)[[3]][m], dimnames(w)[[3]][n], 
                              sep = "")
                            h <- h + 1L
                          }
                        }
                      }
                    }
                  }
                  w5 <- array(dim = c(dim(w)[1], dim(w)[2], nrow(tmp5)))
                  for (i in seq_len(nrow(tmp5))) {
                    w5[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp5[i, 
                      ])
                  }
                  if (isTRUE(k > 5L) == TRUE) {
                    tmp6 <- data.frame(matrix(ncol = (dim(w)[1] * 
                      dim(w)[2]), nrow = (dim(w)[3]^6)))
                    lb6 <- vector()
                    h <- 1L
                    for (i in seq_len(dim(w)[3])) {
                      for (j in seq_len(dim(w)[3])) {
                        for (l in seq_len(dim(w)[3])) {
                          for (m in seq_len(dim(w)[3])) {
                            for (n in seq_len(dim(w)[3])) {
                              for (o in seq_len(dim(w)[3])) {
                                tmp6[h, ] <- replace(as.numeric(as.vector(w[, 
                                  , i] %*% w[, , j] %*% w[, , 
                                  l] %*% w[, , m] %*% w[, , n] %*% 
                                  w[, , o])), as.numeric(as.vector(w[, 
                                  , i] %*% w[, , j] %*% w[, , 
                                  l] %*% w[, , m] %*% w[, , n] %*% 
                                  w[, , o])) >= 1L, 1L)
                                lb6[h] <- paste(dimnames(w)[[3]][i], 
                                  dimnames(w)[[3]][j], dimnames(w)[[3]][l], 
                                  dimnames(w)[[3]][m], dimnames(w)[[3]][n], 
                                  dimnames(w)[[3]][o], sep = "")
                                h <- h + 1L
                              }
                            }
                          }
                        }
                      }
                    }
                    w6 <- array(dim = c(dim(w)[1], dim(w)[2], 
                      nrow(tmp6)))
                    for (i in seq_len(nrow(tmp6))) {
                      w6[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp6[i, 
                        ])
                    }
                    if (isTRUE(k > 6L) == TRUE) {
                      tmp7 <- data.frame(matrix(ncol = (dim(w)[1] * 
                        dim(w)[2]), nrow = (dim(w)[3]^7)))
                      lb7 <- vector()
                      h <- 1L
                      for (i in seq_len(dim(w)[3])) {
                        for (j in seq_len(dim(w)[3])) {
                          for (l in seq_len(dim(w)[3])) {
                            for (m in seq_len(dim(w)[3])) {
                              for (n in seq_len(dim(w)[3])) {
                                for (o in seq_len(dim(w)[3])) {
                                  for (q in seq_len(dim(w)[3])) {
                                    tmp7[h, ] <- replace(as.numeric(as.vector(w[, 
                                      , i] %*% w[, , j] %*% w[, 
                                      , l] %*% w[, , m] %*% w[, 
                                      , n] %*% w[, , o] %*% w[, 
                                      , q])), as.numeric(as.vector(w[, 
                                      , i] %*% w[, , j] %*% w[, 
                                      , l] %*% w[, , m] %*% w[, 
                                      , n] %*% w[, , o] %*% w[, 
                                      , q])) >= 1L, 1L)
                                    lb7[h] <- paste(dimnames(w)[[3]][i], 
                                      dimnames(w)[[3]][j], dimnames(w)[[3]][l], 
                                      dimnames(w)[[3]][m], dimnames(w)[[3]][n], 
                                      dimnames(w)[[3]][o], dimnames(w)[[3]][q], 
                                      sep = "")
                                    h <- h + 1L
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                      w7 <- array(dim = c(dim(w)[1], dim(w)[2], 
                        nrow(tmp7)))
                      for (i in seq_len(nrow(tmp7))) {
                        w7[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp7[i, 
                          ])
                      }
                      if (isTRUE(k > 7L) == TRUE) {
                        tmp8 <- data.frame(matrix(ncol = (dim(w)[1] * 
                          dim(w)[2]), nrow = (dim(w)[3]^8)))
                        lb8 <- vector()
                        h <- 1L
                        for (i in seq_len(dim(w)[3])) {
                          for (j in seq_len(dim(w)[3])) {
                            for (l in seq_len(dim(w)[3])) {
                              for (m in seq_len(dim(w)[3])) {
                                for (n in seq_len(dim(w)[3])) {
                                  for (o in seq_len(dim(w)[3])) {
                                    for (q in seq_len(dim(w)[3])) {
                                      for (r in seq_len(dim(w)[3])) {
                                        tmp8[h, ] <- replace(as.numeric(as.vector(w[, 
                                          , i] %*% w[, , j] %*% 
                                          w[, , l] %*% w[, , 
                                          m] %*% w[, , n] %*% 
                                          w[, , o] %*% w[, , 
                                          q] %*% w[, , r])), 
                                          as.numeric(as.vector(w[, 
                                            , i] %*% w[, , j] %*% 
                                            w[, , l] %*% w[, 
                                            , m] %*% w[, , n] %*% 
                                            w[, , o] %*% w[, 
                                            , q] %*% w[, , r])) >= 
                                            1L, 1L)
                                        lb8[h] <- paste(dimnames(w)[[3]][i], 
                                          dimnames(w)[[3]][j], 
                                          dimnames(w)[[3]][l], 
                                          dimnames(w)[[3]][m], 
                                          dimnames(w)[[3]][n], 
                                          dimnames(w)[[3]][o], 
                                          dimnames(w)[[3]][q], 
                                          dimnames(w)[[3]][r], 
                                          sep = "")
                                        h <- h + 1L
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                        w8 <- array(dim = c(dim(w)[1], dim(w)[2], 
                          nrow(tmp8)))
                        for (i in seq_len(nrow(tmp8))) {
                          w8[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp8[i, 
                            ])
                        }
                        if (isTRUE(k > 8L) == TRUE) {
                          tmp9 <- data.frame(matrix(ncol = (dim(w)[1] * 
                            dim(w)[2]), nrow = (dim(w)[3]^9)))
                          lb9 <- vector()
                          h <- 1L
                          for (i in seq_len(dim(w)[3])) {
                            for (j in seq_len(dim(w)[3])) {
                              for (l in seq_len(dim(w)[3])) {
                                for (m in seq_len(dim(w)[3])) {
                                  for (n in seq_len(dim(w)[3])) {
                                    for (o in seq_len(dim(w)[3])) {
                                      for (q in seq_len(dim(w)[3])) {
                                        for (r in seq_len(dim(w)[3])) {
                                          for (s in seq_len(dim(w)[3])) {
                                            tmp9[h, ] <- replace(as.numeric(as.vector(w[, 
                                              , i] %*% w[, , 
                                              j] %*% w[, , l] %*% 
                                              w[, , m] %*% w[, 
                                              , n] %*% w[, , 
                                              o] %*% w[, , q] %*% 
                                              w[, , r] %*% w[, 
                                              , s])), as.numeric(as.vector(w[, 
                                              , i] %*% w[, , 
                                              j] %*% w[, , l] %*% 
                                              w[, , m] %*% w[, 
                                              , n] %*% w[, , 
                                              o] %*% w[, , q] %*% 
                                              w[, , r] %*% w[, 
                                              , s])) >= 1L, 1L)
                                            lb9[h] <- paste(dimnames(w)[[3]][i], 
                                              dimnames(w)[[3]][j], 
                                              dimnames(w)[[3]][l], 
                                              dimnames(w)[[3]][m], 
                                              dimnames(w)[[3]][n], 
                                              dimnames(w)[[3]][o], 
                                              dimnames(w)[[3]][q], 
                                              dimnames(w)[[3]][r], 
                                              dimnames(w)[[3]][s], 
                                              sep = "")
                                            h <- h + 1L
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                          w9 <- array(dim = c(dim(w)[1], dim(w)[2], 
                            nrow(tmp9)))
                          for (i in seq_len(nrow(tmp9))) {
                            w9[, , i][seq_len((dim(w)[1] * dim(w)[2]))] <- as.numeric(tmp9[i, 
                              ])
                          }
                        }
                      }
                    }
                  }
                }
            }
        }
    }
    {
        if (k == 9L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, zbnd(w4, zbnd(w5, 
                zbnd(w6, zbnd(w7, zbnd(w8, w9))))))))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4, lb5, 
                  lb6, lb7, lb8, lb9)
        }
        else if (k == 8L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, zbnd(w4, zbnd(w5, 
                zbnd(w6, zbnd(w7, w8)))))))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4, lb5, 
                  lb6, lb7, lb8)
        }
        else if (k == 7L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, zbnd(w4, zbnd(w5, 
                zbnd(w6, w7))))))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4, lb5, 
                  lb6, lb7)
        }
        else if (k == 6L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, zbnd(w4, zbnd(w5, 
                w6)))))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4, lb5, 
                  lb6)
        }
        else if (k == 5L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, zbnd(w4, w5))))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4, lb5)
        }
        else if (k == 4L) {
            W <- zbnd(w1, zbnd(w2, zbnd(w3, w4)))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3, lb4)
        }
        else if (k == 3L) {
            W <- zbnd(w1, zbnd(w2, w3))
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2, lb3)
        }
        else if (k == 2L) {
            W <- zbnd(w1, w2)
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- c(lbs, lb2)
        }
        else {
            W <- w1
            if (is.null(dimnames(w)[[3]]) == FALSE) 
                dimnames(W)[[3]] <- lbs
        }
    }
    if (transp == TRUE) {
        if (smpl == TRUE) {
            warning(paste("Relation labels in", sQuote("w"), 
                " have been simplified and their transpose relations are included.", 
                sep = ""), call. = FALSE)
            lst <- list(w = w, W = W, lbs = dimnames(x)[[1]], 
                Orels = olbs, Srels = nlbs, Trels = Lbs, k = k, 
                z = dim(W)[3])
        }
        else {
            warning(paste("Transpose relations of ", sQuote("w"), 
                " are included.", sep = ""), call. = FALSE)
            lst <- list(w = w, W = W, lbs = dimnames(x)[[1]], 
                Trels = Lbs, k = k, z = dim(W)[3])
        }
    }
    else if (transp == FALSE) {
        if (smpl == TRUE) {
            warning(paste("Relation labels in", sQuote("w"), 
                " have been simplified.", sep = ""), call. = FALSE)
            lst <- list(w = w, W = W, lbs = dimnames(x)[[1]], 
                Orels = olbs, Srels = nlbs, k = k, z = dim(W)[3])
        }
        else if (smpl == FALSE) {
            lst <- list(w = w, W = W, lbs = dimnames(x)[[1]], 
                k = k, z = dim(W)[3])
        }
    }
    class(lst) <- "Rel.Box"
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
hierar <-
function (W, x, type = c("person", "relation")) 
{
    if (isTRUE("Rel.Box" %in% attr(W, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(W))), " must be a ", 
            dQuote("Rel.Box"), " class object.", sep = ""))
    if (isTRUE(is.null(W$lbs) == TRUE) == FALSE) {
        if (isTRUE(is.numeric(x) == TRUE) == TRUE) {
            if (isTRUE(length(W$lbs) < x) == TRUE) 
                stop(paste(sQuote(deparse(substitute(x))), " exceeds the order of ", 
                  sQuote(deparse(substitute(W))), ".", sep = ""))
        }
        if (isTRUE(is.character(x) == TRUE) == TRUE) {
            if (isTRUE(x %in% W$lbs) == FALSE) 
                stop(paste(sQuote(deparse(substitute(x))), " is not part of ", 
                  sQuote(deparse(substitute(W))), ".", sep = ""))
        }
    }
    else if (isTRUE(is.null(W$lbs) == TRUE) == TRUE) {
        if (isTRUE(dim(W$W)[1] < x) == TRUE) 
            stop(paste(sQuote(deparse(substitute(x))), " exceeds the order of ", 
                sQuote(deparse(substitute(W))), ".", sep = ""))
    }
    ifelse(isTRUE(is.numeric(x) == TRUE), X <- x, X <- which(W$lbs == 
        x))
    rele <- unique(t(W$W[X, , ]))
    switch(match.arg(type), person = {
        Ph <- as.data.frame(array(0, dim = c(nrow(t(rele)), nrow(t(rele)))))
    }, relation = {
        Rh <- as.data.frame(array(0, dim = c(nrow(rele), nrow(rele))))
    })
    switch(match.arg(type), person = {
        for (j in seq_len(nrow(t(rele)))) {
            for (i in seq_len(nrow(t(rele)))) {
                if ((as.numeric(any(rele[, i] < rele[, j])) == 
                  1 && as.numeric(any(rele[, j] < rele[, i])) == 
                  0) | as.numeric(all(rele[, i] == rele[, j])) == 
                  1) Ph[i, j] <- 1
            }
        }
        rm(j)
        for (i in 1:nrow(t(rele))) {
            if (sum(rele[, i]) == 0) Ph[i, ] <- 0
        }
        rm(i)
        ph <- as.matrix(Ph)
        if (isTRUE(is.null(W$lbs) == FALSE)) dimnames(ph)[[1]] <- dimnames(ph)[[2]] <- W$lbs
        ph <- list(ph = ph, pers = x)
        class(ph) <- c("Person.Hierarchy")
        return(ph)
    }, relation = {
        for (j in seq_len(nrow(rele))) {
            for (i in seq_len(nrow(rele))) {
                if ((as.numeric(any(rele[i, ] < rele[j, ])) == 
                  1 && as.numeric(any(rele[j, ] < rele[i, ])) == 
                  0) | as.numeric(all(rele[i, ] == rele[j, ])) == 
                  1) Rh[i, j] <- 1
            }
        }
        rm(j)
        rh <- as.matrix(Rh)
        if (isTRUE(is.null(dimnames(W$W)[[3]]) == FALSE)) attributes(rh)$dimnames[[2]] <- attributes(rh)$dimnames[[1]] <- dimnames(rele)[[1]]
        rh <- list(rh = rh, pers = x)
        class(rh) <- c("Relation.Hierarchy")
        return(rh)
    })
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
trnl <-
function (x, lbs = NULL, lb2lb = FALSE, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    if (isTRUE(is.matrix(x) == TRUE) == FALSE) 
        x <- as.matrix(x)
    if (is.null(lbs) == FALSE | isTRUE(lb2lb == TRUE) == FALSE) {
        lbsr <- lbsc <- lbs
    }
    else {
        lbsr <- dimnames(x)[[1]]
        lbsc <- dimnames(x)[[2]]
    }
    rws <- vector()
    cls <- vector()
    inc <- list()
    for (l in seq_len(max(x))) {
        xd <- dichot(x, c = l)
        for (i in seq_len(length(which((xd) == 1L)))) {
            cls[i] <- (ceiling(which((xd) == 1L)/dim(x)[1]))[i]
            ifelse((which((xd) == 1L)%%dim(x)[1])[i] == 0L, rws[i] <- (which((xd) == 
                1L)%%dim(x)[1])[i] + dim(x)[1], rws[i] <- (which((xd) == 
                1L)%%dim(x)[1])[i])
            ifelse(isTRUE(lb2lb == TRUE) == TRUE, inc[[length(inc) + 
                1L]] <- paste(lbsr[rws[i]], lbsc[cls[i]], sep = sep), 
                inc[[length(inc) + 1L]] <- paste(rws[i], cls[i], 
                  sep = sep))
        }
        rm(i)
    }
    rm(l)
    return(sort(unlist(inc)))
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
rel.sys <-
function (x, type = c("tolist", "toarray"), bonds = c("entire", 
    "strong", "weak", "asym", "recp", "txch", "tent", "mixd", 
    "full"), loops = FALSE, sel = NULL, att = NULL, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    ifelse(missing(bonds) == TRUE, bonds <- "entire", NA)
    if (isTRUE(att == 0L) == TRUE) {
        att <- NULL
    }
    else {
        NA
    }
    if (isTRUE(any(c("entire", "strong", "weak", "asym", "recp", 
        "txch", "tent", "mixd", "full") %in% bonds)) == FALSE) 
        stop(paste(sQuote("bonds"), " type should be ", dQuote("entire"), 
            ", ", dQuote("strong"), ", ", dQuote("weak"), ", ", 
            dQuote("asym"), ", ", dQuote("recp"), ", ", dQuote("txch"), 
            ", ", dQuote("tent"), ", ", dQuote("mixd"), " or ", 
            dQuote("full"), ".", sep = ""))
    if (all(c("strong", "weak") %in% bonds) == TRUE | isTRUE("entire" %in% 
        bonds) == TRUE) {
        bnds <- "entire"
    }
    else if (any(c("entire", "weak", "strong") %in% bonds) == 
        TRUE | isTRUE(length(bonds) > 1L) == TRUE) {
        bnds <- "Mixed"
    }
    else {
        bnds <- bonds
    }
    if (isTRUE("Rel.System" %in% attr(x, "class")) == FALSE) {
        if (is.array(x) == TRUE && is.null(dimnames(x)) == TRUE) {
            dimnames(x)[[1]] <- dimnames(x)[[2]] <- seq_len(dim(x)[1])
        }
        else {
            NA
        }
        if (is.null(att) == FALSE) {
            if (is.numeric(att) == FALSE) 
                stop(paste("Attribute(s) in ", sQuote(deparse(substitute(att))), 
                  " must be numeric pointing the array(s) representing it(them).", 
                  sep = ""))
            if (is.na(dim(x)[3]) == FALSE) {
                if (isTRUE(max(att) > dim(x)[3]) == TRUE) 
                  stop(paste("Value of ", sQuote(deparse(substitute(att))), 
                    " greater than third dimension in ", sQuote(deparse(substitute(x))), 
                    ".", sep = ""))
            }
            else if (is.na(dim(x)[3]) == TRUE) {
                if (isTRUE(max(att) > 1L) == TRUE) 
                  stop(paste("Value of ", sQuote(deparse(substitute(att))), 
                    " greater than third dimension in ", sQuote(deparse(substitute(x))), 
                    ".", sep = ""))
            }
            ats <- bundles(x, collapse = FALSE, loops = TRUE, 
                sep = sep)[[7]][att]
        }
        else if (is.null(att) == TRUE) {
            ats <- logical(0)
        }
    }
    if (match.arg(type) == "tolist") {
        if (is.array(x) == FALSE) {
            if (isTRUE("Rel.System" %in% attr(x, "class")) == 
                FALSE) {
                stop(paste("For ", sQuote("tolist"), " type, ", 
                  sQuote(deparse(substitute(x))), " must be a square array or a ", 
                  dQuote("Rel.System"), " class object.", sep = ""))
            }
            else if (isTRUE("Rel.System" %in% attr(x, "class")) == 
                TRUE) {
                message(paste(dQuote("Rel.System"), " class input is yet to implement.", 
                  sep = ""))
                return(x)
            }
        }
        else {
            if (isTRUE(dim(x)[1] == dim(x)[2]) == FALSE) 
                stop(paste("Arrays in ", sQuote(deparse(substitute(x))), 
                  " must be square.", sep = ""))
        }
        if (is.na(dim(x)[3]) == FALSE && isTRUE(length(ats) == 
            0) == TRUE) {
            if (isTRUE(all(seq(dim(x)[3]) %in% att)) == FALSE) {
                x3D <- x[, , which(!(seq(dim(x)[3]) %in% att))]
                bd <- bundles(x3D, collapse = FALSE, loops = loops, 
                  sep = sep)
            }
            else if (isTRUE(all(seq(dim(x)[3]) %in% att)) == 
                TRUE) {
                bd <- NULL
            }
        }
        else {
            bd <- bundles(x, collapse = FALSE, loops = loops, 
                sep = sep)
        }
        if (isTRUE(length(unlist(bd)) == 0L) == TRUE) 
            stop("Relational system chosen is empty.")
        if ((bnds) == "entire") {
            lbd <- bd
        }
        else if ((bnds) == "strong") {
            lbd <- list(bd$recp, bd$txch, bd$mixd, bd$full)
        }
        else if ((bnds) == "weak") {
            lbd <- list(bd$asym, bd$tent)
        }
        else {
            if ((bnds) == "Mixed") {
                ifelse(isTRUE("weak" %in% bonds) == TRUE, bonds <- unique(c(bonds, 
                  c("asym", "tent"))), NA)
                ifelse(isTRUE("strong" %in% bonds) == TRUE, bonds <- unique(c(bonds, 
                  c("txch", "mixd", "full"))), NA)
            }
            else {
                NA
            }
            lbd <- bd[which(attr(bd, "names") %in% bonds)]
        }
        if (is.null(sel) == FALSE) {
            if (isTRUE(length(sel) == 1) == TRUE) {
                if (isTRUE(sel %in% dimnames(x)[[1]]) == FALSE) {
                  return(NULL)
                }
                else {
                  if (is.na(dim(x)[3]) == TRUE) {
                    stb <- unlist(jnt(Filter(function(z) sel %in% 
                      z, strsplit(trnf(x, tolist = TRUE, lb2lb = TRUE, 
                      sep = sep), split = sep)), sep = sep))
                    if (is.null(stb) == TRUE) {
                      stb <- c(paste(sel, names(which(lapply(x[which(dimnames(x)[[1]] == 
                        sel), ], sum) > 0)), sep = sep), paste(names(which(lapply(x[, 
                        which(dimnames(x)[[1]] == sel)], sum) > 
                        0)), sel, sep = sep))
                    }
                    else {
                      NA
                    }
                  }
                  else {
                    stb <- vector()
                    for (k in seq_len(dim(x)[3])) {
                      tmpstb <- unlist(jnt(Filter(function(z) sel %in% 
                        z, strsplit(trnf(x[, , k], tolist = TRUE, 
                        lb2lb = TRUE, sep = sep), split = sep)), 
                        sep = sep))
                      if (is.null(tmpstb) == TRUE) {
                        stb <- c(paste(sel, names(which(lapply(x[which(dimnames(x)[[1]] == 
                          sel), , k], sum) > 0)), sep = sep), 
                          paste(names(which(lapply(x[, which(dimnames(x)[[1]] == 
                            sel), k], sum) > 0)), sel, sep = sep))
                      }
                      else {
                        NA
                      }
                      stb <- append(stb, tmpstb)
                    }
                    rm(k)
                    stb <- unique(stb)
                  }
                  ties <- unique(dhc(stb))
                }
            }
            else if (isTRUE(length(sel) > 1) == TRUE) {
                inn <- vector()
                out <- vector()
                if (is.na(dim(x)[3]) == TRUE) {
                  for (i in sel) {
                    if (any(dimnames(x)[[1]] == i) == TRUE) {
                      inn <- append(inn, paste(i, names(which(lapply(x[which(dimnames(x)[[1]] == 
                        i), ], sum) > 0)), sep = sep))
                      out <- append(out, paste(names(which(lapply(x[, 
                        which(dimnames(x)[[1]] == i)], sum) > 
                        0)), i, sep = sep))
                    }
                    else {
                      NA
                    }
                  }
                  rm(i)
                }
                else if (is.na(dim(x)[3]) == FALSE) {
                  for (k in seq_len(dim(x)[3])) {
                    for (i in sel) {
                      if (any(dimnames(x)[[1]] == i) == TRUE) {
                        inn <- append(inn, paste(i, names(which(lapply(x[which(dimnames(x)[[1]] == 
                          i), , k], sum) > 0)), sep = sep))
                        out <- append(out, paste(names(which(lapply(x[, 
                          which(dimnames(x)[[1]] == i), k], sum) > 
                          0)), i, sep = sep))
                      }
                      else {
                        NA
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
                inn <- inn[which(unlist(lapply(lapply(as.list(inn), 
                  dhc), length)) == 2L)]
                out <- out[which(unlist(lapply(lapply(as.list(swp(out)), 
                  dhc), length)) == 2L)]
                stb <- unique(c(inn, out))
                ties <- unique(dhc(stb))
            }
            else {
                NA
            }
            if (is.null(att) == FALSE) {
                if (is.na(dim(x)[3]) == FALSE && isTRUE((dim(x)[3] - 
                  length(att)) == 0L) == FALSE) {
                  stb <- list()
                  for (k in seq_len(dim(x)[3] - length(att))) {
                    tmp <- vector()
                    for (i in seq_len(length(lbd))) {
                      if (isTRUE(length(lbd[[i]]) > 0L) == TRUE) {
                        ifelse(is.na(dim(x[, , which(!(seq(dim(x)[3]) %in% 
                          att))])[3]) == TRUE, tmp <- append(tmp, 
                          lbd[[i]]), tmp <- append(tmp, lbd[[i]][k]))
                      }
                    }
                    rm(i)
                    stb[[k]] <- as.vector(unlist(tmp))
                  }
                  rm(k)
                }
                else {
                  stb <- vector()
                  for (i in seq_len(length(lbd))) {
                    stb <- append(stb, lbd[[i]])
                  }
                  rm(i)
                }
                if (is.array(sel) == TRUE) {
                  ifelse(is.na(dim(sel)[3]) == TRUE | isTRUE(dim(sel)[3] == 
                    1L) == TRUE, sel <- diag(sel), sel <- diag(mnplx(sel)))
                  sel <- as.vector(attr(which(!(sel == 0)), "names"))
                }
                if (is.null(dimnames(x)) == FALSE) {
                  ifelse(isTRUE(is.numeric(sel) == TRUE) == TRUE, 
                    sel <- as.character(sel), NA)
                }
                else {
                  NA
                }
                ntsel <- list()
                length(ntsel) <- length(stb)
                for (k in seq_len(length(stb))) {
                  tss <- which(dhc(stb[[k]], sep = sep) %in% 
                    sel)
                  if (isTRUE(length(tss) > 0) == TRUE) {
                    tmpsel <- vector()
                    for (i in seq_len(length(tss))) {
                      if (isTRUE((tss[i]%%2L) == 1L) == TRUE) {
                        tmpsel <- append(tmpsel, stb[[k]][ceiling(tss[i]/2L)])
                      }
                      else if (isTRUE((tss[i]%%2L) == 1L) == 
                        FALSE) {
                        tmpsel <- append(tmpsel, stb[[k]][floor(tss[i]/2L)])
                      }
                    }
                    rm(i)
                    ntsel[[k]] <- unique(as.vector(unlist(tmpsel)))
                  }
                }
                rm(k)
                rm(tss)
                stb <- ntsel
            }
            else {
                NA
            }
        }
        else if (is.null(sel) == TRUE) {
            if (is.null(att) == FALSE) {
                stb <- transf(x[, , which(!(seq_len(dim(x)[3]) %in% 
                  att))], type = "tolist", lb2lb = TRUE, sep = sep)
            }
            else {
                ifelse(is.na(dim(x)[3]) == TRUE, stb <- trnf(x, 
                  tolist = TRUE, lb2lb = TRUE, sep = sep), stb <- transf(x, 
                  type = "tolist", lb2lb = TRUE, sep = sep, valued = TRUE))
            }
        }
        if (length(stb) > 0L && is.null(unlist(stb)) == FALSE) {
            ties <- vector()
            for (k in seq_len(length(stb))) {
                for (i in seq_len(length(stb[[k]]))) {
                  if (isTRUE(length(stb[[k]]) > 0L) == TRUE) {
                    ties <- append(ties, dhc(stb[[k]][i], sep = sep))
                  }
                }
                rm(i)
            }
            rm(k)
        }
        else {
            ties <- stb <- character(0)
        }
        ifelse(is.na(dim(x)[3]) == TRUE, stb <- unlist(stb), 
            NA)
        if (is.na(dim(x)[3]) == FALSE) {
            if (is.null(att) == TRUE) {
                ifelse(is.null(dimnames(x)[[3]]) == TRUE, attr(stb, 
                  "names") <- seq_len(dim(x)[3] - length(att)), 
                  attr(stb, "names") <- dimnames(x)[[3]])
            }
            else if (is.null(att) == FALSE) {
                ifelse(is.null(dimnames(x)[[3]]) == TRUE, attr(stb, 
                  "names") <- which(!(seq(dim(x)[3]) %in% att)), 
                  attr(stb, "names") <- dimnames(x)[[3]][which(!(seq(dim(x)[3]) %in% 
                    att))])
            }
        }
        if (is.null(dimnames(x)[[1]]) == TRUE) {
            warning(paste("Input labels in ", sQuote(deparse(substitute(x))), 
                " are NULL.", sep = ""), call. = FALSE)
            lbs <- seq_len(dim(x)[1])
        }
        else {
            lbs <- dimnames(x)[[1]]
        }
        if (isTRUE(length(ats) > 0L) == TRUE) {
            rs <- (list(ord = dim(x)[1], nodes = lbs, sel = sel, 
                sys.ord = nlevels(factor(ties)), incl = lbs[which(lbs %in% 
                  levels(factor(ties)))], excl = lbs[which(!(lbs %in% 
                  levels(factor(ties))))], bond.type = bonds, 
                size = length(unlist(stb)), sep = sep, Ties = as.vector(stb), 
                Attrs.ord = length(unlist(ats)), Attrs = jnt(dhc(ats, 
                  sep = sep), sep = sep)))
        }
        else {
            rs <- (list(ord = dim(x)[1], nodes = lbs, sel = sel, 
                sys.ord = nlevels(factor(ties)), incl = lbs[which(lbs %in% 
                  levels(factor(ties)))], excl = lbs[which(!(lbs %in% 
                  levels(factor(ties))))], bond.type = bonds, 
                size = length(unlist(stb)), sep = sep, Ties = as.vector(stb)))
        }
        if (is.null(sel) == TRUE) {
            rs$sel <- NULL
        }
        else {
            NA
        }
        class(rs) <- "Rel.System"
        return(rs)
    }
    else if (match.arg(type) == "toarray") {
        if (is.null(att) == FALSE && isTRUE(length(ats) > 0L) == 
            TRUE) {
            return(transf(ats$a, type = "toarray", sort = TRUE))
        }
        else {
            NA
        }
        if (isTRUE("Rel.System" %in% attr(x, "class")) == FALSE) {
            ifelse(isTRUE(is.array(x) == TRUE) == TRUE, arr <- x, 
                arr <- transf(x, type = "toarray", sort = TRUE))
            if (is.null(sel) == FALSE) {
                if (isTRUE(length(sel) == 1) == TRUE || any(sel %in% 
                  dimnames(arr)[[1]]) == FALSE) {
                  return(NULL)
                }
                else {
                  kual <- which(dimnames(arr)[[1]] %in% sel)
                  ifelse(is.na(dim(arr)[3]) == TRUE, arr <- arr[kual, 
                    kual], arr <- arr[kual, kual, ])
                }
            }
            else {
                NA
            }
            if (isTRUE(bnds == "entire") == TRUE) {
                return(arr)
            }
            else {
                bd <- bundles(arr, collapse = FALSE, loops = loops, 
                  sep = sep)
                if ((bnds) == "strong") {
                  lbd <- list(bd$recp, bd$txch, bd$mixd, bd$full)
                }
                else if ((bnds) == "weak") {
                  lbd <- list(bd$asym, bd$tent)
                }
                else {
                  if ((bnds) == "Mixed") {
                    ifelse(isTRUE("weak" %in% bonds) == TRUE, 
                      bonds <- unique(c(bonds, c("asym", "tent"))), 
                      NA)
                    ifelse(isTRUE("strong" %in% bonds) == TRUE, 
                      bonds <- unique(c(bonds, c("txch", "mixd", 
                        "full"))), NA)
                  }
                  else {
                    NA
                  }
                  lbd <- bd[which(attr(bd, "names") %in% bonds)]
                }
                ifelse(is.na(dim(arr)[3]) == FALSE, tmp <- vector(mode = "list", 
                  length = dim(arr)[3]), tmp <- vector(mode = "list", 
                  length = 1))
                for (k in seq_len(length(tmp))) {
                  tmpp <- lapply(lbd, function(z) {
                    z[[k]]
                  })
                  tmp[[k]] <- unlist(tmpp)
                }
                rm(k, tmpp)
                attr(tmp, "names") <- dimnames(arr)[[3]]
                return(transf(tmp, type = "toarray", sort = TRUE))
            }
        }
        else if (isTRUE("Rel.System" %in% attr(x, "class")) == 
            TRUE) {
            if (isTRUE(x$sys.ord == 0L) == TRUE) 
                stop("Relational system chosen is empty.")
            if (is.null(sel) == TRUE) {
                n <- x$sys.ord
                r <- length(x$Ties)
                lbs <- x$incl
                lbst <- attr(x$Ties, "names")
            }
            else if (is.null(sel) == FALSE) {
                if (isTRUE(sel == "att") == TRUE) {
                  sel <- x$nodes[which(x$nodes %in% unlist(dhc(x$Attrs, 
                    sep = sep)))]
                }
                else if (isTRUE(sel == "noatt") == TRUE) {
                  sel <- x$nodes[which(!(x$nodes %in% unlist(dhc(x$Attrs, 
                    sep = sep))))]
                }
                else if (isTRUE(any(sel %in% x$nodes)) == FALSE) {
                  warning(paste("Selection is not part of ", 
                    sQuote("x"), ".", sep = ""), call. = FALSE)
                  return(tmp)
                }
                else {
                  NA
                }
                lbst <- vector()
                ntsel <- list()
                for (k in seq_len(length(x$Ties))) {
                  tss <- which(dhc(x$Ties[[k]], sep = sep) %in% 
                    sel)
                  if (isTRUE(length(tss) > 0L) == TRUE) {
                    tmpsel <- vector()
                    for (i in seq_len(length(tss))) {
                      if (isTRUE((tss[i]%%2L) == 1L) == TRUE) {
                        tmpsel <- append(tmpsel, x$Ties[[k]][ceiling(tss[i]/2L)])
                      }
                      else {
                        tmpsel <- append(tmpsel, x$Ties[[k]][floor(tss[i]/2L)])
                      }
                    }
                    rm(i)
                    ntsel[[k]] <- as.vector(unlist(tmpsel))
                    lbst <- append(lbst, attr(x$Ties, "names")[k])
                  }
                  else {
                    NA
                  }
                }
                rm(k)
                ntsel <- ntsel[unlist(lapply(ntsel, length) != 
                  0L)]
                attr(ntsel, "names") <- lbst
                x$Ties <- ntsel
                lbs <- unique(dhc(unlist(ntsel), sep = sep))
                n <- length(lbs)
                r <- length(lbst)
            }
            else if (is.null(sel) == FALSE && isTRUE(attr(x, 
                "class")[1] == "array") == TRUE) {
            }
            else {
                n <- length(x$sel)
                r <- 1L
                lbs <- x$sel
                lbst <- NULL
            }
            arr <- array(0L, dim = c(n, n, r))
            dimnames(arr)[[1]] <- dimnames(arr)[[2]] <- lbs
            if (isTRUE(n > 0L) == TRUE) 
                dimnames(arr)[[3]] <- lbst
            for (i in seq_len(r)) {
                if (isTRUE(length(x$Ties[[i]]) > 0L) == TRUE && 
                  isTRUE(n > 0L) == TRUE) {
                  arr[, , i] <- transf(x$Ties[[i]], type = "toarray", 
                    ord = n, lbs = lbs, lb2lb = TRUE)
                }
                else {
                  NA
                }
            }
            rm(i)
            if (is.null(x$Attrs) == FALSE) {
                arra <- array(0L, dim = c(n, n, length(x$Attrs)))
                dimnames(arra)[[1]] <- dimnames(arra)[[2]] <- lbs
                if (isTRUE(n > 0L) == TRUE) 
                  dimnames(arra)[[3]] <- attr(x$Attrs, "names")
                for (i in seq_len(length(x$Attrs))) {
                  act <- dhc(x$Attrs[[i]], sep = sep)
                  if (isTRUE(length(act) > 0L) == TRUE) {
                    diag(arra[, , i])[which(lbs %in% dhc(x$Attrs[[i]], 
                      sep = sep))] <- 1L
                  }
                }
                rm(i)
                attrs <- dim(arr)[3]
                arr <- zbind(arr, arra)
                if (isTRUE(dim(arra)[3] > 1L) == TRUE) {
                  class(arr) <- c("array", paste("Attrs.", paste(attrs + 
                    1L, dim(arr)[3], sep = ","), sep = " : "))
                }
                else {
                  class(arr) <- c("array", paste("Attrs.", dim(arr)[3], 
                    sep = " : "))
                }
            }
            return(arr)
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
comps <-
function (x, bonds = c("entire", "strong", "weak"), sort) 
{
    ifelse(isTRUE(is.null(dimnames(x)[1]) == TRUE | is.null(dimnames(x)[1][[1]]) == 
        TRUE) == TRUE, lbs <- seq_len(nrow(x)), lbs <- dimnames(x)[[1]])
    if (isTRUE(sum(mnplx(x, diag = FALSE)) > 0) == TRUE) {
        bd <- bundles(x, lb2lb = FALSE, collapse = TRUE)
        switch(match.arg(bonds), entire = lbd <- bd, strong = lbd <- list(bd$recp, 
            bd$txch, bd$mixd, bd$full), weak = lbd <- list(bd$asym, 
            bd$tent))
        if (isTRUE(length(unlist(lbd)) == 0) == TRUE) {
            com <- dimnames(rm.isol(x))[[1]]
        }
        else {
            tx <- transl(unlist(lbd))
            while (length(tx) > length(transl(tx))) {
                tx <- transl(tx)
            }
            if (missing(sort) == FALSE && isTRUE(sort == TRUE) == 
                TRUE) {
                tx <- tx[order(unlist(lapply(as.list(tx), function(z) {
                  length(dhc(z))
                })))]
            }
            else {
                NA
            }
            com <- vector(mode = "list", length = length(tx))
            for (i in seq_len(length(tx))) {
                com[[i]] <- lbs[as.numeric(dhc(tx[i]))]
            }
            rm(i)
        }
        lst <- list(com = com, isol = lbs[which(!(lbs %in% unlist(com)))])
    }
    else {
        lst <- list(com = character(0), isol = lbs)
    }
    class(lst) <- c(class(lst), match.arg(bonds))
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
expos <-
function (rs, classes = FALSE, allClasses = FALSE, allNodes = TRUE) 
{
    if (isTRUE(attr(rs, "class") == "Rel.System") == FALSE) 
        stop("Relational system must be a \"Rel.System\" class.")
    if (isTRUE(rs$sys.ord == 0L) == TRUE) 
        stop("Relational system chosen is empty!")
    if (isTRUE(rs$Attrs.ord == 0L) == TRUE | is.null(rs$Attrs.ord) == 
        TRUE) 
        return("There are no attributes in the relational system.")
    if (isTRUE(any(duplicated(attr(rs$Attrs, "names")))) == TRUE) {
        rs$attrs <- rs$Attrs[which(!(duplicated(attr(rs$Attrs, 
            "names"))))]
        dpl <- which(duplicated(attr(rs$Attrs, "names")))
        for (i in 1:length(dpl)) {
            rs$attrs[which(attr(rs$attrs, "names") == attr(rs$Attrs, 
                "names")[dpl[i]])] <- jnt(dhc(unlist(rs$attrs[which(attr(rs$attrs, 
                "names") == attr(rs$Attrs, "names")[dpl[i]])], 
                rs$Attrs[dpl[i]]), sep = rs$sep), sep = rs$sep)
        }
        rm(i)
    }
    else {
        rs$attrs <- rs$Attrs
    }
    rs$attrs2 <- list()
    attrs2 <- vector()
    for (i in 1:length(rs$attrs)) {
        if (isTRUE(is.null(rs$attrs[[i]])) == FALSE) {
            rs$attrs2[[length(rs$attrs2) + 1L]] <- rs$attrs[[i]]
            attrs2 <- append(attrs2, attr(rs$attrs, "names")[i])
        }
        else {
            NA
        }
    }
    rm(i)
    attr(rs$attrs2, "names") <- attrs2
    if (isTRUE(length(rs$attrs2) == 0L) == TRUE) 
        stop("There are no attributes in the relational system.")
    natt <- length(unique(attr(rs$attrs2, "names")))
    At <- data.frame(matrix(0L, ncol = rs$ord, nrow = natt))
    colnames(At) <- rs$nodes
    rownames(At) <- unique(attr(rs$attrs2, "names"))
    for (i in 1:natt) {
        At[i, which(colnames(At) %in% dhc(rs$attrs2[[i]], sep = rs$sep))] <- 1L
    }
    rm(i)
    if (is.null(rs$incl) == FALSE) {
        ifelse(isTRUE(is.null(nrow(At)) == TRUE) == TRUE, at <- At[which(attr(At, 
            "names") %in% rs$incl)], at <- as.data.frame(At)[, 
            which(colnames(At) %in% rs$incl)])
    }
    if (isTRUE(nrow(at) > 0L) == TRUE) {
        Adpt <- list()
        Adpt[[1]] <- colnames(at)[which(apply(at, 2, sum) == 
            0L)]
        Adpt[[2]] <- colnames(at)[which(apply(at, 2, sum) == 
            nrow(at))]
        if (isTRUE(nrow(at) > 1L) == TRUE) {
            rst <- which(!(colnames(at) %in% unlist(Adpt)))
            if (isTRUE(length(rst) >= 1L) == TRUE) {
                aat <- at[, rst]
                bnch <- as.data.frame(t(expand.grid(rep(list(0L:1L), 
                  natt))))
                rownames(bnch) <- unique(attr(rs$attrs2, "names"))
                colnames(bnch)[1] <- "Null"
                for (i in 2:ncol(bnch)) colnames(bnch)[i] <- jnt(rownames(bnch)[which(bnch[, 
                  i] == 1L)], sep = ", ")
                rm(i)
                bn <- bnch[, 2:(ncol(bnch) - 1L)]
                tmp <- vector()
                for (k in 1:ncol(bn)) {
                  if (isTRUE(is.null(ncol(aat)) == FALSE) == 
                    TRUE) {
                    for (i in 1:ncol(aat)) {
                      if (isTRUE(all(bn[, k] == aat[, i])) == 
                        TRUE) {
                        tmp <- append(tmp, colnames(aat)[i])
                      }
                      else {
                        NA
                      }
                    }
                    rm(i)
                  }
                  else {
                    ifelse(isTRUE(all(as.vector(bn[, k]) == aat)) == 
                      TRUE, tmp <- append(tmp, colnames(aat)[rst]), 
                      NA)
                  }
                  Adpt[[k + 2L]] <- as.character(tmp)
                  tmp <- vector()
                }
                rm(k)
                attr(Adpt, "names") <- c("NONE", "ALL", colnames(bn))
            }
            else {
                NA
            }
            adpt <- Adpt[c(1, 3:length(Adpt))]
        }
        else if (isTRUE(nrow(at) == 1L) == TRUE) {
            attr(Adpt, "names") <- c("NONE", "ALL")
            adpt <- Adpt[1]
        }
    }
    else if (isTRUE(nrow(at) > 0L) == FALSE) {
        Adpt <- NULL
    }
    if (isTRUE(length(unlist(adpt)) > 0L) == TRUE) {
        ladpt <- list()
        for (l in 1:length(adpt)) {
            if (isTRUE(length(adpt[[l]]) != 0L) == TRUE) {
                ex <- list()
                for (i in 1:length(adpt[[l]])) {
                  ngbsadpt <- ngbs(adpt[[l]][i], rs, type = "und")
                  if (isTRUE(length(ngbsadpt) == 1L) == TRUE) {
                    ex <- at[, which(colnames(at) %in% ngbsadpt)]
                    ex <- dichot(ex - at[, which(adpt[[l]][i] == 
                      colnames(at))])
                    attr(ex, "names") <- rownames(at)
                  }
                  else {
                    tmp <- at[, which(colnames(at) %in% ngbsadpt)]
                    tmp <- dichot(tmp - at[, which(adpt[[l]][i] == 
                      colnames(at))])
                    ex <- apply(tmp, 1, sum)/ncol(tmp)
                  }
                  ladpt[[length(ladpt) + 1L]] <- ex
                }
                rm(i)
            }
            else {
                NA
            }
        }
        rm(l)
        attr(ladpt, "names") <- as.vector(unlist(adpt))
        uladpt <- unlist(ladpt)
        slct <- (1:length(uladpt))%%nrow(at)
        slct <- replace(slct, slct == 0L, nrow(at))
        Exps <- list()
        for (i in 1:nrow(at)) {
            temp <- uladpt[slct == i]
            Exps[[i]] <- round(temp[which(temp > 0L)], 2)
        }
        rm(i)
        exx <- list()
        exx2 <- list()
        for (i in 1:length(Exps)) {
            if (isTRUE(length(Exps[[i]]) > 0L) == TRUE) {
                exx[[i]] <- dhc(names(Exps[[i]]), "[.]")[which(1:(length(Exps[[i]]) * 
                  2L)%%2L == 1L)]
                exx2[[i]] <- noquote(as.vector(Exps[[i]]))
            }
            else {
                exx2[[i]] <- exx[[i]] <- NULL
            }
        }
        rm(i)
        exps <- list()
        for (i in 1:length(Exps)) {
            if (isTRUE(length(Exps[[i]]) > 0L) == TRUE) {
                exps[[i]] <- paste(exx[[i]], paste0(exx2[[i]] * 
                  100L, "%"), sep = "=")
            }
        }
        rm(i)
        attr(exps, "names") <- paste0("to_", rownames(at))
        exps <- noquote(exps)
    }
    else {
        exps <- NULL
    }
    if (classes) {
        if (allNodes) {
            Adpt[[1]] <- colnames(At)[which(apply(At, 2, sum) == 
                0L)]
            Adpt[[2]] <- colnames(At)[which(apply(At, 2, sum) == 
                nrow(At))]
            rst <- which(!(colnames(At) %in% unlist(Adpt)))
            if (isTRUE(length(rst) >= 1L) == TRUE) {
                Aat <- At[, rst]
                tmp <- vector()
                for (k in 1:ncol(bn)) {
                  if (isTRUE(is.null(ncol(Aat)) == FALSE) == 
                    TRUE) {
                    for (i in 1:ncol(Aat)) {
                      if (isTRUE(all(bn[, k] == Aat[, i])) == 
                        TRUE) {
                        tmp <- append(tmp, colnames(Aat)[i])
                      }
                      else {
                        NA
                      }
                    }
                    rm(i)
                  }
                  else {
                    ifelse(isTRUE(all(as.vector(bn[, k]) == Aat)) == 
                      TRUE, tmp <- append(tmp, colnames(At)[rst]), 
                      NA)
                  }
                  Adpt[[k + 2L]] <- as.vector(c(Adpt[[k + 2L]], 
                    tmp))
                  tmp <- vector()
                }
                rm(k)
            }
            else {
                NA
            }
        }
        if (allClasses) {
            clss <- Adpt
        }
        else {
            clss <- list()
            ncls <- vector()
            for (i in 1:length(Adpt)) {
                if (isTRUE(length(Adpt[[i]]) > 0L) == TRUE) {
                  clss[[length(clss) + 1L]] <- Adpt[[i]]
                  ncls <- append(ncls, attr(Adpt, "names")[i])
                }
                else {
                  NA
                }
            }
            rm(i)
            attr(clss, "names") <- ncls
        }
        return(list(Classes = noquote(clss), Bonds = rs$bond.type, 
            Exposure = exps))
    }
    else {
        return(list(Bonds = rs$bond.type, Exposure = exps))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
pfvn <-
function (x, r, q) 
{
    ifelse(isTRUE("Multilevel" %in% attr(x, "class")) == TRUE, 
        x <- x$mlnet, NA)
    mx <- norm(as.matrix(x), type = "F")
    note <- NULL
    n <- dim(x)[1]
    if (missing(q) == TRUE) {
        q <- (n - 1)
    }
    else {
        if (isTRUE(q < 2) == TRUE) {
            q <- 2
            warning("'q' is set to the minimum possible value of 2.")
        }
    }
    ifelse(missing(r) == TRUE, r <- Inf, NA)
    ifelse(isTRUE(is.data.frame(x) == TRUE) == TRUE, x <- as.matrix(x), 
        NA)
    if (isTRUE(is.array(x) == TRUE) == FALSE) 
        stop("Input data must be data frame, matrix or array type.")
    if (isTRUE(is.na(dim(x)[3]) == TRUE) == TRUE) {
        Q <- x
        D <- x
        if (isTRUE(isSymmetric(x) == TRUE) == TRUE) {
            sim <- "Symmetric"
            for (k in seq(2, q)) {
                QO <- Q
                for (i in seq_len(n)) {
                  for (j in seq_len(n)) {
                    if (r == Inf) {
                      Q[i, j] <- min(pmax(x[i, ], QO[, j]))
                    }
                    else {
                      Q[i, j] <- min(x[i, ]^r + QO[, j]^r)^(1/r)
                    }
                    if (D[i, j] > Q[i, j]) {
                      D[i, j] <- Q[i, j]
                    }
                  }
                  rm(j)
                }
                rm(i)
            }
            rm(k)
            for (i in seq_len(n)) {
                for (j in seq_len(n)) {
                  if (D[i, j] < x[i, j]) {
                    Q[i, j] <- Inf
                  }
                }
                rm(j)
            }
            rm(i)
            QQ <- Q
        }
        else {
            sim <- "NonSymmetric"
            note <- paste("For non-symmetyric arrays, triangle inequality only for r=", 
                r, "and q=", q, "(?) is supported")
            QQ <- ti(x)
        }
    }
    else if (isTRUE(is.na(dim(x)[3]) == FALSE) == TRUE) {
        sim <- NULL
        QQ <- array(NA, dim = c(dim(x)[1], dim(x)[2], dim(x)[3]), 
            dimnames = list(dimnames(x)[[1]], dimnames(x)[[2]], 
                dimnames(x)[[3]]))
        for (K in seq_len(dim(x)[3])) {
            X <- x[, , K]
            Q <- x[, , K]
            D <- x[, , K]
            if (isTRUE(isSymmetric(X) == TRUE) == TRUE) {
                ifelse(isTRUE(length(sim) == 0) == TRUE, sim <- "Symmetric", 
                  NA)
                for (k in seq(2, q)) {
                  QO <- Q
                  for (i in seq_len(n)) {
                    for (j in seq_len(n)) {
                      if (r == Inf) {
                        Q[i, j] <- min(pmax(X[i, ], QO[, j]))
                      }
                      else {
                        Q[i, j] <- min(X[i, ]^r + QO[, j]^r)^(1/r)
                      }
                      if (D[i, j] > Q[i, j]) {
                        D[i, j] <- Q[i, j]
                      }
                    }
                    rm(j)
                  }
                  rm(i)
                }
                rm(k)
                for (i in seq_len(n)) {
                  for (j in seq_len(n)) {
                    if (D[i, j] < X[i, j]) {
                      Q[i, j] <- Inf
                    }
                  }
                  rm(j)
                }
                rm(i)
            }
            else {
                sim <- "NonSymmetric"
                Q <- ti(X)
            }
            QQ[, , K] <- Q
        }
        rm(K)
    }
    ifelse(isTRUE(length(note) > 0L) == TRUE, lst <- list(max = mx, 
        r = r, q = q, Q = QQ, Note = note), lst <- list(max = mx, 
        r = r, q = q, Q = QQ))
    class(lst) <- c("pathfinder", sim)
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
write.dl <-
function (x, file = NULL, type = c("nodelist", "fullmat")) 
{
    if (isTRUE(is.na(dim(x)[3]) == TRUE) == FALSE) {
        if (isTRUE(is.null(dimnames(x)[[3]])) == TRUE) 
            dimnames(x)[[3]] <- seq_len(dim(x)[3])
    }
    if (isTRUE(is.null(dimnames(x)[[1]])) == TRUE) 
        dimnames(x)[[1]] <- dimnames(x)[[2]] <- seq_len(dim(x)[1])
    switch(match.arg(type), fullmat = {
        cat(paste("DL", collapse = "\n"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("N=", dim(x)[1], sep = ""), file = file, append = TRUE)
        cat(paste(" NM=", dim(x)[3], sep = ""), file = file, 
            append = TRUE)
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("FORMAT = FULLMATRIX DIAGONAL PRESENT", collapse = "\n"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("ROW LABELS:", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        for (i in seq_len(dim(x)[1])) {
            cat(paste("\"", dimnames(x)[[1]][i], "\"", sep = "", 
                collapse = "\n"), file = file, sep = "\n", append = TRUE)
        }
        cat(paste("COLUMN LABELS:", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        for (i in seq_len(dim(x)[2])) {
            cat(paste("\"", dimnames(x)[[2]][i], "\"", sep = "", 
                collapse = "\n"), file = file, sep = "\n", append = TRUE)
        }
        cat(paste("LEVEL LABELS:", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        for (i in seq_len(dim(x)[3])) {
            cat(paste("\"", dimnames(x)[[3]][i], "\"", sep = "", 
                collapse = "\n"), file = file, sep = "\n", append = TRUE)
        }
        cat(paste("DATA:", collapse = "\n"), file = file, sep = "\n", 
            append = TRUE)
        for (i in seq_len(dim(x)[3])) {
            for (j in seq_len(dim(x)[1])) {
                cat(paste(x[j, , i]), file = file, collapse = "\n", 
                  append = TRUE)
            }
        }
        rm(i, j)
    }, nodelist = {
        tmp <- x
        dimnames(tmp)[[1]] <- dimnames(tmp)[[2]] <- seq_len(dim(x)[1])
        rs <- rel.sys(tmp)
        rm(tmp)
        vec <- vector()
        for (i in seq_len(length(rs$ties))) vec <- append(vec, 
            rs$ties[[i]])
        rm(rs)
        vec <- sort(vec)
        lst <- list()
        for (i in seq_len(dim(x)[1])) lst[[i]] <- i
        for (j in seq_len(length(vec))) lst[[as.numeric(strsplit(vec[[j]][1], 
            ", ")[[1]][1])]] <- append(lst[[as.numeric(strsplit(vec[[j]][1], 
            ", ")[[1]][1])]], as.numeric(strsplit(vec[[j]][1], 
            ", ")[[1]][2]))
        rm(vec)
        cat(paste("dl", " n=", dim(x)[1], " format=nodelist1", 
            sep = "", collapse = "\n"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("labels: ", collapse = "\n"), file = file, 
            sep = "\n", append = TRUE)
        for (i in seq_len(dim(x)[1])) {
            cat(paste("\"", dimnames(x)[[1]][i], "\" ", sep = ""), 
                file = file, sep = " ", append = TRUE)
        }
        cat("", file = file, sep = "\n", append = TRUE)
        cat(paste("data:", collapse = "\n"), file = file, sep = "\n", 
            append = TRUE)
        for (i in seq_len(dim(x)[1])) {
            cat(paste(lst[[i]]), file = file, collapse = "\n", 
                append = TRUE)
        }
        rm(i, j)
    })
}

## ----setup, include=FALSE-----------------------------------------------------------------------------------
knitr::opts_chunk$set(size = 'footnotesize', background = '#FFFFFF', prompt = TRUE, strip.white = FALSE, comment = NA)
options(width=110)
knitr::knit_hooks$set(small.mar = function(before, options, envir) {
    if (before) par(mar = c(4, 4, .1, .1))  # smaller margin on top and right
})

## ----data, echo=-6------------------------------------------------------------------------------------------
# Fruits data set with attributes
frt <- data.frame(yellow = c(0,1,0,0,1,0,0,0), green = c(0,0,1,0,0,0,0,1), red = c(1,0,0,1,0,0,0,0), 
                  orange = c(0,0,0,0,0,1,1,0), apple = c(1,1,1,1,0,0,0,0), citrus = c(0,0,0,0,1,1,1,1))
# Label the objects
rownames(frt) <- c("PinkLady","GrannySmith","GoldenDelicious","RedDelicious","Lemon","Orange","Mandarin","Lime")
frt

## ----loadmultiplex------------------------------------------------------------------------------------------
# load package
library("multiplex")

## ----galoisFull---------------------------------------------------------------------------------------------
# Galois representation between objects and attributes
galois(frt)

## ----galoisReduc, echo=-2-----------------------------------------------------------------------------------
# Galois derivation with a reduced labeling
gd <- galois(frt, labeling = "reduced")
galois(frt, labeling = "reduced")

## ----strgaloisReduc, size='scriptsize'----------------------------------------------------------------------
str(gd$gc$full)

## ----partialorder, echo=-3----------------------------------------------------------------------------------
# Partial ordering of the formal concepts with established labels
pogdc <- partial.order(gd, type = "galois", lbs = paste("c", seq_len(length(gd$gc$full)), sep = ""))
pogdc

## ----pogc---------------------------------------------------------------------------------------------------
# Assign partial order of reduced context to 'pogd'
pogd <- partial.order(gd, type = "galois")

## ----diagrampogc, fig.pos='H', fig.width=4.5, fig.height=4.5, fig.align='center', fig.cap='Concept Lattice of fruits and color characteristics', echo=-1, small.mar=TRUE----
par(mar=c(0,0,0,0))
# Plot the lattice diagram
suppressPackageStartupMessages(library("Rgraphviz", quietly = TRUE))
diagram(pogd, type = "concept", main = "Fruits & Colors", fcol = "red", col.main = "blue")

## ----diaglevels, echo=TRUE----------------------------------------------------------------------------------
# Diagram levels
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc) }

## ----diaglevelsperm, echo=TRUE, message=FALSE, warning=FALSE------------------------------------------------
# Diagram levels with permutation
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc, perm = TRUE) }

## ----princfltrlbs, echo=TRUE--------------------------------------------------------------------------------
# Principal order filter of the third concept 
fltr(3, pogd)

## ----princfltrlbs2, echo=TRUE, eval=FALSE-------------------------------------------------------------------
# # Principal order filter of the concept with these labels
# fltr(c("red", "RedDelicious"), pogd)

## ----filter, echo=TRUE--------------------------------------------------------------------------------------
# Order filter of two concepts
fltr(c("Lemon", "Lime"), pogd)

## ----ideal, echo=TRUE---------------------------------------------------------------------------------------
# Order ideal of two concepts
fltr(c(9, 11), pogd, ideal = TRUE)

## ----bipp, echo=TRUE, eval=TRUE, fig.pos='H', fig.width=3.0, fig.height=3.0, fig.align='center', fig.env='figure', fig.cap='Bipartite graph', small.mar=TRUE----
# Load the "multigraph" package and plot bipartite graph
suppressPackageStartupMessages(library("multigraph", quietly = TRUE))
bmgraph(frt, pch = 16:15, fsize = 6)

## ----binp2, echo=TRUE, eval=FALSE---------------------------------------------------------------------------
# # Plot proyection of bipartite network
# bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, rot = 25)

## ----binp, fig.pos='H', fig.width=4.5, fig.height=4.5, fig.align='center', fig.env='figure', fig.cap='Bipartite graph with a force-directed layout', echo=FALSE, small.mar=TRUE----
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, rot = 25)

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
reducs <-
function (s, cl) 
{
    if (isTRUE("Semigroup" %in% attr(s, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(s))), " must be a ", 
            dQuote("Semigroup"), " class object.", sep = ""))
    ifelse(isTRUE("symbolic" %in% attr(s, "class")) == TRUE, 
        sx <- suppressWarnings(as.semigroup(s, numerical = TRUE)), 
        sx <- s)
    n <- nlevels(factor(cl))
    cls <- list()
    for (i in seq_len(n)) {
        cls[[i]] <- which(cl == i)
    }
    rm(i)
    bm <- array(dim = c(n, n))
    for (i in seq_len(n)) {
        k <- seq_along(cls[[i]])
        for (j in seq_len(n)) {
            for (q in seq_along(cls)) {
                if (all(unique(as.vector(unlist(sx$S[which(cl == 
                  i), which(cl == j)]))) %in% cls[[q]]) == TRUE) {
                  ifelse(isTRUE("symbolic" %in% attr(s, "class")) == 
                    TRUE, bm[i, j] <- bm[i, j] <- s$st[min(cls[[q]])], 
                    bm[i, j] <- bm[i, j] <- as.numeric(dimnames(sx$S)[[1]])[min(cls[[q]])])
                  break
                }
                else {
                  NA
                }
            }
            rm(q)
        }
        rm(j)
    }
    rm(i)
    lbs <- vector()
    for (i in seq_along(tabulate(cl))) {
        ifelse(isTRUE("symbolic" %in% attr(s, "class")) == TRUE, 
            lbs <- append(lbs, s$st[which(cl == i)[1]]), lbs <- append(lbs, 
                as.numeric(dimnames(sx$S)[[1]])[which(cl == i)[1]]))
    }
    rm(i)
    dimnames(bm)[[1]] <- dimnames(bm)[[2]] <- as.list(lbs)
    return(as.data.frame(bm))
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
diagram <-
function (x, type = c("hasse", "concept", "egg-box"), attrs = NULL, 
    main = NULL, incmp, shape = c("rectangle", "circle", "box", 
        "ellipse"), col, col0, fcol, ecol, lty, lbs, ffamily, 
    fstyle, fsize, cex.main, col.main, bg, mar, sep, ...) 
{
    if (match.arg(type) == "concept" && isTRUE("galois" %in% 
        class(x)) == FALSE) {
        warning(paste(sQuote(deparse(substitute(x))), " is not a ", 
            dQuote("Galois"), " class object.", sep = ""), call. = FALSE)
    }
    else {
        invisible(NA)
    }
    if (match.arg(type) == "hasse" || match.arg(type) == "concept") {
        if (isTRUE("partial.order" %in% tolower(class(x))) == 
            FALSE) {
            warning(paste(sQuote(deparse(substitute(x))), " is not a ", 
                dQuote("Partial.Order"), " class object.", sep = ""), 
                call. = FALSE)
            if (is.matrix(x[[1]]) == TRUE) {
                x <- x[[1]]
            }
            else {
                if (is.array(x) == FALSE | is.matrix(x) == FALSE) 
                  stop(paste(sQuote(deparse(substitute(x))), 
                    " must be matrix, array, or a ", dQuote("Partial.Order"), 
                    " class object.", sep = ""))
            }
        }
        else {
            NA
        }
        if (requireNamespace("Rgraphviz", quietly = TRUE)) {
            switch(match.arg(type), concept = {
                concept <- TRUE
            }, hasse = {
                ifelse(isTRUE("galois" %in% class(x)) == TRUE, 
                  concept <- TRUE, concept <- FALSE)
            })
            hasse(x, concept = concept, attrs = attrs, main = main, 
                incmp, shape, col, col0, fcol, ecol, lty, lbs, 
                ffamily, fstyle, fsize, cex.main, col.main, bg, 
                mar, sep, ...)
        }
        else {
            stop(paste("Package ", sQuote("Rgraphviz"), " not found.", 
                sep = ""))
        }
    }
    else if (match.arg(type) == "egg-box") {
        ifelse(isTRUE(tolower(class(x)[1]) != "semigroup") == 
            TRUE, S <- suppressWarnings(as.semigroup(x)), S <- x)
        Sclass <- class(S)[2]
        gs <- green.rel(S)
        if (isTRUE(length(unique(unlist(gs$clu))) > 1) == TRUE) {
            dcl <- gs$D
            class(dcl) <- c("Semigroup", Sclass, "Green.Rels", 
                "D-class")
            return(noquote(dcl))
        }
        else {
            warning("Single L- and R-class found in semigroup and Green relations returned.", 
                call. = FALSE)
            lrdcl <- vector(mode = "list", length = 3)
            lrdcl[1:3] <- gs[7:9]
            names(lrdcl) <- c("R", "L", "D")
            class(lrdcl) <- attr(gs, "class")
            return(lrdcl)
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
galois <-
function (x, labeling = c("full", "reduced"), sep) 
{
    if (missing(sep) == TRUE) {
        if (all(c("conceptual.scaling", ", ") %in% class(x)) == 
            TRUE) {
            warning(paste("A comma-space separator found in conceptual scaling ", 
                sQuote("x"), " and use hyphen among extents/intents.", 
                sep = ""), call. = FALSE)
            sep <- "-"
        }
        else {
            sep <- ", "
        }
    }
    else {
        if (isTRUE(sep %in% c(".", "", "[.]", "(", "[", "{", 
            "+", "*", "?")) == TRUE) {
            warning(paste("Special characters, openers, dot, and empty separators are not allowed in ", 
                sQuote("sep"), " and use a comma among extents/intents.", 
                sep = ""), call. = FALSE)
            sep <- ","
        }
        else if (isTRUE("conceptual.scaling" %in% class(x)) == 
            TRUE && isTRUE(sep %in% class(x)) == TRUE) {
            warning(paste("Chosen separator equals to conceptual scaling separator in ", 
                sQuote("x"), ".", sep = ""), call. = FALSE)
        }
        else {
            NA
        }
    }
    if (is.data.frame(x) == FALSE) {
        if (is.vector(x) == TRUE) {
            x <- t(as.data.frame(x))
        }
        else if (is.array(x) == TRUE) {
            x <- as.data.frame(x)
        }
        else {
            stop(paste(sQuote(deparse(substitute(x))), " must be an array or a vector.", 
                sep = ""))
        }
    }
    if ("f" %in% colnames(x) == TRUE) {
        cnx <- colnames(x)
        xtmp <- x
        colnames(xtmp)[which(colnames(xtmp) == "f")] <- ""
        wdx <- which(duplicated(xtmp))
        rm(xtmp)
        flgf <- TRUE
    }
    else {
        wdx <- which(duplicated(x))
        flgf <- FALSE
    }
    eq0 <- list()
    if (isTRUE(length(wdx) > 1L) == TRUE) {
        for (i in wdx) {
            tmp <- vector()
            for (j in seq_len(nrow(x))) {
                if (isTRUE(all(x[i, ] == x[j, ]) == TRUE) == 
                  TRUE) {
                  tmp <- append(tmp, rownames(x)[j])
                }
                else {
                  NA
                }
            }
            rm(j)
            eq0[[length(eq0) + 1L]] <- paste(rownames(x)[i], 
                jnt(tmp, sep = sep), sep = sep)
        }
        rm(i)
    }
    else if (isTRUE(length(wdx) == 1L) == TRUE) {
        tmp <- vector()
        for (j in seq_len(nrow(x))) {
            ifelse(isTRUE(all(x[wdx, ] == x[j, ]) == TRUE) == 
                TRUE, tmp <- append(tmp, rownames(x)[j]), NA)
        }
        rm(j)
        eq0[[length(eq0) + 1L]] <- paste(rownames(x)[wdx], jnt(tmp, 
            sep = sep), sep = sep)
    }
    else {
        NA
    }
    ifelse(isTRUE(flgf == TRUE) == TRUE, colnames(x) <- cnx, 
        NA)
    if (isTRUE(length(eq0) > 0L) == TRUE) {
        for (i in seq_len(length(eq0))) {
            eq0[[i]] <- jnt(dhc(eq0[[i]], sep = sep), sep = sep)
        }
        rm(i)
        eq0 <- unique(eq0)
        x <- unique(x)
    }
    else {
        NA
    }
    eq1 <- list()
    for (i in which(duplicated(t(x)))) {
        tmp <- vector()
        for (j in seq_len(ncol(x))) {
            if (isTRUE(all(x[, i] == x[, j]) == TRUE) == TRUE) {
                tmp <- append(tmp, colnames(x)[j])
            }
            else {
                NA
            }
        }
        rm(j)
        eq1[[length(eq1) + 1L]] <- paste(colnames(x)[i], jnt(tmp, 
            sep = sep), sep = sep)
    }
    rm(i)
    if (isTRUE(length(eq1) > 0L) == TRUE) {
        for (i in seq_len(length(eq1))) {
            eq1[[i]] <- jnt(dhc(eq1[[i]], sep = sep), sep = sep)
        }
        rm(i)
        eq1 <- unique(eq1)
        x <- t(unique(t(x)))
        for (k in seq_len(length(eq1))) {
            colnames(x)[which(colnames(x) %in% dhc(eq1[[k]], 
                sep = sep))] <- eq1[[k]]
        }
        rm(k)
    }
    else {
        NA
    }
    conj <- vector(mode = "list", length = ncol(x))
    for (i in seq_len(ncol(x))) {
        conj[[i]] <- jnt(rownames(x)[which(x[, i] != 0L)], sep = sep)
    }
    rm(i)
    attr(conj, "names") <- colnames(x)
    conj1 <- vector(mode = "list", length = nrow(x))
    for (i in seq_len(nrow(x))) {
        conj1[[i]] <- jnt(colnames(x)[which(x[i, ] != 0L)], sep = sep)
    }
    rm(i)
    attr(conj1, "names") <- rownames(x)
    conj2 <- list()
    conj2n <- vector()
    if (isTRUE(length(conj) > 1L) == TRUE) {
        for (k in 2:length(conj)) {
            for (i in k:length(conj)) {
                if (isTRUE(length(intersect(dhc(conj[[k - 1L]], 
                  sep = sep), dhc(conj[[i]], sep = sep))) > 1L) == 
                  TRUE) {
                  conj2[[length(conj2) + 1L]] <- jnt(intersect(dhc(conj[[k - 
                    1]], sep = sep), dhc(conj[[i]], sep = sep)), 
                    sep = sep)
                }
                else if (isTRUE(length(intersect(dhc(conj[[k - 
                  1L]], sep = sep), dhc(conj[[i]], sep = sep))) > 
                  1L) == FALSE) {
                  conj2[[length(conj2) + 1L]] <- intersect(dhc(conj[[k - 
                    1L]], sep = sep), dhc(conj[[i]], sep = sep))
                }
                conj2n[length(conj2n) + 1L] <- paste(attr(conj, 
                  "names")[k - 1L], attr(conj, "names")[i], sep = sep)
            }
            rm(i)
        }
        rm(k)
        attr(conj2, "names") <- conj2n
    }
    else {
        conj2 <- conj
    }
    if (isTRUE(length(which(conj2 %in% conj == FALSE)) != 0L) == 
        TRUE) {
        if (isTRUE(jnt(rownames(x), sep = sep) %in% c(conj, conj2)) == 
            TRUE) {
            conj3 <- list(conj, unique(conj2[which(conj2 %in% 
                conj == FALSE)]))
        }
        else if (isTRUE(jnt(rownames(x), sep = sep) %in% c(conj, 
            conj2)) == FALSE) {
            conj3 <- list(conj, unique(conj2[which(conj2 %in% 
                conj == FALSE)]), jnt(rownames(x), sep = sep))
        }
    }
    else if (isTRUE(length(which(conj2 %in% conj == FALSE)) != 
        0L) == FALSE) {
        conj3 <- list(conj, jnt(rownames(x), sep = sep))
    }
    for (i in seq_len(length(conj))) {
        if (isTRUE(length(which(conj2 %in% conj[[i]] == TRUE)) != 
            0L) == TRUE) {
            attr(conj3[[1]], "names")[i] <- jnt(attr(conj2, "names")[which(conj2 %in% 
                conj[[i]])], sep = sep)
        }
        else {
            NA
        }
    }
    rm(i)
    for (i in seq_len(length(conj3[[2]]))) {
        if (isTRUE(length(attr(conj2, "names")[which(conj3[[2]][[i]] == 
            conj2)]) != 0L) == TRUE) {
            if (isTRUE(length(dhc(conj3[[2]][[i]], sep = sep)) == 
                1L) == TRUE) {
                attr(conj3[[2]], "names")[i] <- conj1[[which(conj3[[2]][[i]] == 
                  attr(conj1, "names"))]]
            }
            else if (isTRUE(length(dhc(conj3[[2]][[i]], sep = sep)) == 
                1L) == FALSE) {
                attr(conj3[[2]], "names")[i] <- jnt(attr(conj2, 
                  "names")[which(conj3[[2]][[i]] == conj2)], 
                  sep = sep)
            }
        }
        else {
            attr(conj3[[2]], "names")[i] <- jnt(attr(conj2, "names")[which(conj2 %in% 
                levels(factor(unlist(conj2))))], sep = sep)
        }
    }
    rm(i)
    if (isTRUE(jnt(rownames(x), sep = sep) %in% c(conj, conj2)) == 
        FALSE) {
        ifelse(isTRUE(length(conj3) > 2L) == TRUE, con <- c(conj3[[1]], 
            conj3[[2]], conj3[[3]]), con <- c(conj3[[1]], conj3[[2]]))
    }
    else {
        ifelse(isTRUE(conj3[[2]] %in% conj3[[1]]) == TRUE, con <- conj3[[1]], 
            con <- c(conj3[[1]], conj3[[2]]))
    }
    attr(con, "names")[which(attr(con, "names") == "")] <- NA
    der <- unique(con)
    attr(der, "names") <- unique(stats::na.omit(attr(con, "names")))
    po <- matrix(0L, nrow = length(der), ncol = length(der))
    for (j in seq_len(length(der))) {
        for (i in seq_len(length(der))) {
            ifelse(isTRUE(all(dhc(der[[i]], sep = sep) %in% dhc(der[[j]], 
                sep = sep))) == TRUE, po[i, j] <- 1L, NA)
        }
    }
    rm(i, j)
    ints <- attr(der, "names")
    exts <- der
    rownames(po) <- colnames(po) <- ints
    for (i in (length(conj3[[1]]) + 1L):length(der)) {
        if (isTRUE(length(der) > length(conj3[[1]])) == TRUE) {
            ifelse(isTRUE(length(flt(i, po, rclos = FALSE)) > 
                0L) == TRUE, ints[i] <- jnt(dhc(ints[flt(i, po, 
                rclos = FALSE)], sep = sep), sep = sep), NA)
        }
        else {
            NA
        }
    }
    rm(i)
    attr(der, "names") <- attr(exts, "names") <- ints
    ints[which(is.na(ints))] <- ""
    if (isTRUE(length(der) > 2L) == TRUE) {
        for (k in 2:length(der)) {
            for (i in k:length(der)) {
                if (isTRUE((k - 1L) == i) == FALSE) {
                  if (isTRUE(any(isTRUE(all(po[, i] - po[, (k - 
                    1L)] != -1)) == TRUE || isTRUE(all(po[, (k - 
                    1L)] - po[, i] != -1)) == TRUE)) == TRUE) {
                    if (isTRUE(all(po[, i] - po[, (k - 1L)] != 
                      -1)) == TRUE) {
                      if (isTRUE(ints[(k - 1L)] == "") == FALSE | 
                        isTRUE(which(!(dhc(ints[(k - 1L)], sep = sep) %in% 
                          dhc(ints[i], sep = sep))) > 0) == TRUE) {
                        ifelse(all(dhc(ints[(k - 1L)], sep = sep) %in% 
                          dhc(ints[i], sep = sep)) == TRUE, NA, 
                          ints[(k - 1L)] <- jnt(dhc(ints[(k - 
                            1L)], sep = sep)[which(!(dhc(ints[(k - 
                            1L)], sep = sep) %in% dhc(ints[i], 
                            sep = sep)))], sep = sep))
                      }
                      else {
                        NA
                      }
                      if (isTRUE(length(exts[[i]]) == 0L) == 
                        FALSE) {
                        exts[[i]] <- jnt(dhc(exts[[i]], sep = sep)[which(!(dhc(exts[[i]], 
                          sep = sep) %in% dhc(exts[[(k - 1L)]], 
                          sep = sep)))], sep = sep)
                      }
                      else {
                        NA
                      }
                    }
                    else if (isTRUE(all(po[, i] - po[, (k - 1L)] != 
                      -1)) == FALSE) {
                      if (isTRUE(all.equal(dhc(ints[i], sep = sep), 
                        dhc(ints[(k - 1L)], sep = sep))) == TRUE) {
                        ints[i] <- ""
                      }
                      else if (isTRUE(all.equal(dhc(ints[i], 
                        sep = sep), dhc(ints[(k - 1L)], sep = sep))) == 
                        FALSE) {
                        ifelse(isTRUE(length(jnt(dhc(ints[i], 
                          sep = sep)[which(!(dhc(ints[i], sep = sep) %in% 
                          dhc(ints[(k - 1L)], sep = sep)))], 
                          sep = sep)) == 0L) == TRUE, NA, ints[i] <- jnt(dhc(ints[i], 
                          sep = sep)[which(!(dhc(ints[i], sep = sep) %in% 
                          dhc(ints[(k - 1L)], sep = sep)))], 
                          sep = sep))
                      }
                      if (isTRUE(all.equal(dhc(exts[[(k - 1L)]], 
                        sep = sep), dhc(exts[[i]], sep = sep))) == 
                        TRUE) {
                        exts[[(k - 1L)]] <- ""
                      }
                      else if (isTRUE(all.equal(dhc(exts[[(k - 
                        1L)]], sep = sep), dhc(exts[[i]], sep = sep))) == 
                        FALSE) {
                        exts[[(k - 1L)]] <- jnt(dhc(exts[[(k - 
                          1L)]], sep = sep)[which(!(dhc(exts[[(k - 
                          1L)]], sep = sep) %in% dhc(exts[[i]], 
                          sep = sep)))], sep = sep)
                      }
                    }
                  }
                  else {
                    NA
                  }
                }
                else {
                  NA
                }
            }
            rm(i)
        }
        rm(k)
    }
    else if (isTRUE(length(der) == 2L) == TRUE) {
        if (isTRUE(any(isTRUE(all(po[, 2] - po[, 1] != -1)) == 
            TRUE | isTRUE(all(po[, 1] - po[, 2] != -1)) == TRUE)) == 
            TRUE) {
            if (isTRUE(all(po[, 1] - po[, 2] != -1)) == TRUE) {
                if (isTRUE(is.na(ints[2])) == FALSE) {
                  ints[2] <- jnt(dhc(ints[1], sep = sep)[which(!(dhc(ints[1], 
                    sep = sep) %in% dhc(ints[2], sep = sep)))], 
                    sep = sep)
                }
                else {
                  NA
                }
                if (isTRUE(length(exts[[2]]) == 0L) == FALSE) {
                  exts[[2]] <- jnt(dhc(exts[[2]], sep = sep)[which(!(dhc(exts[[2]], 
                    sep = sep) %in% dhc(exts[[1]], sep = sep)))], 
                    sep = sep)
                }
                else {
                  NA
                }
            }
            else if (isTRUE(any(po[, 2] - po[, 1] != -1)) == 
                TRUE) {
                if (isTRUE(all.equal(dhc(ints[2], sep = sep), 
                  dhc(ints[1], sep = sep))) == TRUE) {
                  ints[2] <- ""
                }
                else if (isTRUE(all.equal(dhc(ints[2], sep = sep), 
                  dhc(ints[1], sep = sep))) == FALSE) {
                  ifelse(isTRUE(length(jnt(dhc(ints[2], sep = sep)[which(!(dhc(ints[2], 
                    sep = sep) %in% dhc(ints[1], sep = sep)))], 
                    sep = sep)) == 0L) == TRUE, NA, ints[2] <- jnt(dhc(ints[2], 
                    sep = sep)[which(!(dhc(ints[2], sep = sep) %in% 
                    dhc(ints[1], sep = sep)))], sep = sep))
                }
                if (isTRUE(all.equal(dhc(exts[[1]], sep = sep), 
                  dhc(exts[[2]], sep = sep))) == TRUE) {
                  exts[[2]] <- ""
                }
                else if (isTRUE(all.equal(dhc(exts[[1]], sep = sep), 
                  dhc(exts[[2]], sep = sep))) == FALSE) {
                  exts[[2]] <- jnt(dhc(exts, sep = sep)[[2]][which(!(dhc(exts[[2]], 
                    sep = sep) %in% dhc(exts[[1]], sep = sep)))], 
                    sep = sep)
                }
            }
        }
        else {
            NA
        }
    }
    else {
        NA
    }
    dupl <- levels(factor(unlist(dhc(exts, sep = sep))[which(duplicated(unlist(dhc(exts, 
        sep = sep))) == TRUE)]))
    dder <- der
    if (isTRUE(length(dupl) > 0L) == TRUE) {
        for (i in seq_len(length(dupl))) dder[[(length(dder) + 
            1L)]] <- dupl[i]
        for (i in seq_len(length(dupl))) {
            for (j in seq_len(nrow(x))) {
                if (isTRUE(any(isTRUE(all(x[j, ] - x[which(rownames(x) == 
                  dupl[i]), ] != -1)) == TRUE & isTRUE(all(x[which(rownames(x) == 
                  dupl[i]), ] - x[j, ] != -1)) == FALSE)) == 
                  TRUE) {
                  dder[[(length(der) + i)]] <- jnt(append(dder[[(length(der) + 
                    i)]], rownames(x)[j]), sep = sep)
                }
                else {
                  NA
                }
            }
            rm(j)
        }
        rm(i)
        dpo <- matrix(0L, nrow = length(dder), ncol = length(dder))
        for (j in seq_len(length(dder))) {
            for (i in seq_len(length(dder))) {
                ifelse(isTRUE(all(dhc(dder[[i]], sep = sep) %in% 
                  dhc(dder[[j]], sep = sep))) == TRUE, dpo[i, 
                  j] <- 1L, NA)
            }
        }
        rm(i, j)
        attr(dder, "names")[which(is.na(attr(dder, "names")) == 
            TRUE)] <- ""
        ints <- attr(dder, "names")
        exts <- dder
        rownames(dpo) <- colnames(dpo) <- ints
        PO <- dpo
        if (isTRUE(length(dder) > length(der)) == TRUE) {
            for (i in (length(der) + 1L):length(dder)) {
                ifelse(isTRUE(length(flt(i, dpo, rclos = FALSE)) > 
                  0L) == TRUE, ints[i] <- jnt(dhc(ints[flt(i, 
                  dpo, rclos = FALSE)], sep = sep), sep = sep), 
                  NA)
            }
            rm(i)
        }
        else {
            NA
        }
        attr(dder, "names") <- ints
        for (k in 2:length(dder)) {
            for (i in k:length(dder)) {
                if (isTRUE((k - 1L) == i) == FALSE) {
                  if (isTRUE(any(isTRUE(all(dpo[, i] - dpo[, 
                    (k - 1L)] != -1)) == TRUE | isTRUE(all(dpo[, 
                    (k - 1L)] - dpo[, i] != -1)) == TRUE)) == 
                    TRUE) {
                    if (isTRUE(all(dpo[, i] - dpo[, (k - 1L)] != 
                      -1)) == TRUE) {
                      if (isTRUE(ints[(k - 1L)] == "") == FALSE) {
                        ifelse(all(dhc(ints[(k - 1L)], sep = sep) %in% 
                          dhc(ints[i], sep = sep)) == TRUE, NA, 
                          ints[(k - 1L)] <- jnt(dhc(ints[(k - 
                            1L)], sep = sep)[which(!(dhc(ints[(k - 
                            1L)], sep = sep) %in% dhc(ints[i], 
                            sep = sep)))], sep = sep))
                      }
                      else {
                        NA
                      }
                      if (isTRUE(length(exts[[i]]) == 0L) == 
                        FALSE) {
                        exts[[i]] <- jnt(dhc(exts[[i]], sep = sep)[which(!(dhc(exts[[i]], 
                          sep = sep) %in% dhc(exts[[(k - 1L)]], 
                          sep = sep)))], sep = sep)
                      }
                      else {
                        NA
                      }
                    }
                    else if (isTRUE(all(dpo[, i] - dpo[, (k - 
                      1L)] != -1)) == FALSE) {
                      if (isTRUE(all.equal(dhc(ints[i], sep = sep), 
                        dhc(ints[(k - 1L)], sep = sep))) == TRUE) {
                        ints[i] <- ""
                      }
                      else if (isTRUE(all.equal(dhc(ints[i], 
                        sep = sep), dhc(ints[(k - 1L)], sep = sep))) == 
                        FALSE) {
                        ifelse(isTRUE(length(jnt(dhc(ints[i], 
                          sep = sep)[which(!(dhc(ints[i], sep = sep) %in% 
                          dhc(ints[(k - 1L)], sep = sep)))], 
                          sep = sep)) == 0L) == TRUE, NA, ints[i] <- jnt(dhc(ints[i], 
                          sep = sep)[which(!(dhc(ints[i], sep = sep) %in% 
                          dhc(ints[(k - 1L)], sep = sep)))], 
                          sep = sep))
                      }
                      if (isTRUE(all.equal(dhc(exts[[(k - 1L)]], 
                        sep = sep), dhc(exts[[i]], sep = sep))) == 
                        TRUE) {
                        exts[[(k - 1L)]] <- ""
                      }
                      else if (isTRUE(all.equal(dhc(exts[[(k - 
                        1L)]], sep = sep), dhc(exts[[i]], sep = sep))) == 
                        FALSE) {
                        exts[[(k - 1L)]] <- jnt(dhc(exts[[(k - 
                          1L)]], sep = sep)[which(!(dhc(exts[[(k - 
                          1L)]], sep = sep) %in% dhc(exts[[i]], 
                          sep = sep)))], sep = sep)
                      }
                    }
                  }
                  else {
                    NA
                  }
                }
                else {
                  NA
                }
            }
            rm(i)
        }
        rm(k)
    }
    else if (isTRUE(length(dupl) > 0L) == FALSE) {
        PO <- po
    }
    if (isTRUE(length(dder) > 1L) == TRUE) {
        ifelse(isTRUE(length(jnt(dhc(ints[length(dder)], sep = sep)[which(!(dhc(ints[length(dder)], 
            sep = sep) %in% dhc(ints[1:(length(dder) - 1L)], 
            sep = sep)))], sep = sep)) == 0) == TRUE, ints[length(dder)] <- "", 
            NA)
    }
    if (isTRUE(length(eq0) > 0L) == TRUE) {
        for (k in seq_len(length(eq0))) {
            cmb <- which(exts %in% dhc(eq0, sep = sep)[[k]])
            if (isTRUE(length(cmb) == 0) == TRUE) {
                cmb <- which(unlist(dhc(exts, sep = sep)) %in% 
                  dhc(eq0, sep = sep)[[k]])
                ifelse(isTRUE(length(cmb) > 0) == TRUE, exts[[cmb]] <- jnt(unique(c(dhc(exts[[cmb]], 
                  sep = sep), dhc(eq0[[k]], sep = sep))), sep = sep), 
                  NA)
            }
            else {
                ifelse(isTRUE(length(cmb) > 0) == TRUE, exts[[cmb]] <- eq0[[k]], 
                  NA)
            }
            for (i in seq_len(length(dder))) {
                ifelse(isTRUE(any(dhc(dder, sep = sep)[[i]] %in% 
                  dhc(eq0, sep = sep)[[k]]) == TRUE) == TRUE, 
                  dder[[i]] <- jnt(c(dhc(dder, sep = sep)[[i]], 
                    dhc(eq0, sep = sep)[[k]]), sep = sep), NA)
            }
            rm(i)
        }
        rm(k, cmb)
    }
    mi <- NULL
    for (i in seq_len(dim(PO)[1])) {
        flt <- flt(i, PO, rclos = TRUE)
        ifelse(isTRUE(length(flt) == dim(PO)[1]) == TRUE, mi <- i, 
            NA)
    }
    rm(i)
    if (isTRUE(jnt(colnames(x), sep = sep) %in% attr(dder, "names")) == 
        FALSE) {
        if (isTRUE(length(mi) == 0L) == TRUE) {
            dder[[length(dder) + 1L]] <- exts[[length(exts) + 
                1L]] <- ints[length(ints) + 1L] <- ""
            attr(dder, "names")[length(dder)] <- jnt(colnames(x), 
                sep = sep)
        }
        else {
            attr(dder, "names")[mi] <- jnt(colnames(x), sep = sep)
        }
    }
    else {
        NA
    }
    attr(dder, "names")[which(is.na(attr(dder, "names")) == TRUE)] <- ""
    class(dder) <- c("Galois", "full")
    derr <- exts
    attr(derr, "names") <- ints
    attr(derr, "names")[which(is.na(attr(derr, "names")) == TRUE)] <- ""
    for (i in which(derr == "")) {
        derr[[i]] <- character(0)
    }
    rm(i)
    switch(match.arg(labeling), full = {
        Lst <- list(sep = sep, gc = dder)
    }, reduced = {
        Lst <- list(sep = sep, gc = (red = redl(dder, derr)))
    })
    Lst
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
strng <-
function (x) 
{
    if (is.list(x) == TRUE && isTRUE(length(x) > 1L) == TRUE) {
        xl <- x
        x <- array(dim = c(dim(xl[[1]]), length(xl)))
        for (k in seq_len(length(xl))) {
            x[, , k] <- xl[[k]]
        }
        rm(k)
        dimnames(x)[[1]] <- dimnames(x)[[2]] <- dimnames(xl[[1]])[[1]]
        dimnames(x)[[3]] <- names(xl)
    }
    else {
        if (is.array(x) == FALSE) 
            stop("Data must be a stacked array of square matrices of a product of 'strings' or a list of of square matrices.")
    }
    if (is.array(x) == TRUE && (is.na(dim(x)[3]) == FALSE)) {
        tmp <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
            nrow = 0))
        for (i in seq_len(dim(x)[3])) {
            tmp[i, ] <- as.vector(x[, , i])
        }
        rm(i)
        po <- as.matrix(array(0L, dim = c(dim(x)[3], dim(x)[3])))
        for (j in seq_len(dim(x)[3])) {
            for (i in seq_len(dim(x)[3])) {
                if ((as.numeric(any(tmp[i, ] < tmp[j, ])) == 
                  1 && as.numeric(any(tmp[j, ] < tmp[i, ])) == 
                  0) | as.numeric(all(tmp[i, ] == tmp[j, ])) == 
                  1) 
                  po[i, j] <- 1L
            }
        }
        rm(j)
        rownames(po) <- colnames(po) <- dimnames(x)[[3]]
    }
    else if (is.array(x) == TRUE && is.na(dim(x)[3]) == TRUE || 
        (is.list(x) == TRUE && isTRUE(length(x) == 1L) == TRUE)) {
        po <- 1L
    }
    po
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
dhc <-
function (xd, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    if (isTRUE(length(xd) != 0L) == TRUE && isTRUE(is.na(xd)) == 
        FALSE) {
        Ltd <- FALSE
        ifelse(isTRUE(is.list(xd)) == TRUE, Ltd <- TRUE, xd <- as.list(xd))
        Xd <- list()
        length(Xd) <- length(xd)
        for (i in 1:length(xd)) {
            if (isTRUE(length(xd[[i]]) != 0L) == TRUE) {
                tmpd <- as.list(xd[[i]])
                for (j in 1:length(xd[[i]])) Xd[[i]] <- append(Xd[[i]], 
                  strsplit(tmpd[[j]], sep)[[1]])
            }
        }
        attr(Xd, "names") <- attr(xd, "names")
        ifelse(isTRUE(Ltd) == TRUE, return(Xd), return(unlist(Xd)))
    }
    else {
        xd
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
bnd <-
function (x, xd, lbs, TRD, r, m, mlt, sep) 
{
    DF <- data.frame(matrix(ncol = 2L, nrow = length(m)))
    DF[, 1] <- dhc(m, sep = sep)[which(1:(length(m) * 2L)%%2L == 
        1L)]
    DF[, 2] <- dhc(m, sep = sep)[which(1:(length(m) * 2L)%%2L == 
        0L)]
    DF <- DF[which(DF[, 1] != DF[, 2]), ]
    out <- list()
    inn <- list()
    All <- list()
    for (i in seq(lbs)) {
        out[[i]] <- as.numeric(DF[which(DF[, 1] == as.numeric(lbs[i])), 
            2])
        inn[[i]] <- as.numeric(DF[which(DF[, 2] == as.numeric(lbs[i])), 
            1])
        All[[i]] <- c(out[[i]], inn[[i]])
    }
    rm(i)
    finn <- list()
    fout <- list()
    for (i in seq(lbs)) {
        finn[[i]] <- which(tabulate(inn[[i]]) == dim(x)[3])
        fout[[i]] <- which(tabulate(out[[i]]) == dim(x)[3])
    }
    rm(i)
    full <- list()
    for (i in seq(lbs)) {
        full[[i]] <- intersect(fout[[i]], finn[[i]])
    }
    rm(i)
    rm(finn, fout)
    asym <- list()
    for (i in seq(lbs)) {
        asym[[i]] <- which(tabulate(All[[i]]) == 1L)
    }
    rm(i)
    sout <- list()
    sinn <- list()
    for (i in seq(lbs)) {
        sout[[i]] <- which(tabulate(out[[i]]) == 1L)[which(!(which(tabulate(out[[i]]) == 
            1L) %in% asym[[i]]))]
        sinn[[i]] <- which(tabulate(inn[[i]]) == 1L)[which(!(which(tabulate(inn[[i]]) == 
            1L) %in% asym[[i]]))]
    }
    rm(i)
    dobl <- list()
    dout <- list()
    dinn <- list()
    for (i in seq(lbs)) {
        dobl[[i]] <- which(tabulate(All[[i]]) == 2L)
        dout[[i]] <- which(tabulate(out[[i]]) == 2L)
        dinn[[i]] <- which(tabulate(inn[[i]]) == 2L)
    }
    rm(i)
    if ((is.na(dim(x)[3]) == FALSE | isTRUE(dim(x)[3] == 1) == 
        TRUE)) {
        Eout <- list()
        length(Eout) <- length(lbs)
        Einn <- list()
        length(Einn) <- length(lbs)
        TEnt <- list()
        length(TEnt) <- length(lbs)
        for (i in seq(length(dobl))) {
            tmpout <- vector()
            tmpinn <- vector()
            for (j in seq(length(dobl[[i]]))) {
                if (isTRUE(dobl[[i]][j] %in% dout[[i]]) == TRUE) 
                  tmpout[length(tmpout) + 1L] <- dobl[[i]][j]
                if (isTRUE(dobl[[i]][j] %in% dinn[[i]]) == TRUE) 
                  tmpinn[length(tmpinn) + 1L] <- dobl[[i]][j]
            }
            rm(j)
            Eout[[i]] <- as.integer(tmpout)
            Einn[[i]] <- tmpinn
            TEnt[[i]] <- c(tmpout, tmpinn)
        }
        rm(i)
    }
    else {
        TEnt <- Eout <- Einn <- character(0)
    }
    trip <- list()
    trin <- list()
    trou <- list()
    for (i in seq(lbs)) {
        trip[[i]] <- which(tabulate(All[[i]]) > 2L)
        trin[[i]] <- which(tabulate(inn[[i]]) > 2L)
        trou[[i]] <- which(tabulate(out[[i]]) > 2L)
    }
    rm(i)
    tripfl <- list()
    trinfl <- list()
    troufl <- list()
    for (i in seq(lbs)) {
        tripfl[[i]] <- trip[[i]][which(!(trip[[i]] %in% full[[i]]))]
        trinfl[[i]] <- trin[[i]][which(!(trin[[i]] %in% full[[i]]))]
        troufl[[i]] <- trou[[i]][which(!(trou[[i]] %in% full[[i]]))]
    }
    rm(i)
    sngl <- list()
    for (i in seq(lbs)) {
        sngl[[i]] <- sout[[i]][which(!(sout[[i]] %in% tripfl[[i]]))]
    }
    rm(i)
    recp <- list()
    for (i in seq(lbs)) {
        tmprcp <- vector()
        for (j in seq(length(sngl[[i]]))) {
            chk <- paste(sngl[[i]][j], i, sep = sep)
            if (isTRUE(TRD == TRUE) == TRUE) {
                for (k in 1:dim(x)[3]) {
                  ifelse(isTRUE(all(c(chk, swp(chk, sep = sep)) %in% 
                    mlt[[k]])) == TRUE, tmprcp <- append(tmprcp, 
                    sngl[[i]][j]), NA)
                }
                rm(k)
            }
            else {
                ifelse(isTRUE(all(c(chk, swp(chk, sep = sep)) %in% 
                  m)) == TRUE, tmprcp <- append(tmprcp, sngl[[i]][j]), 
                  NA)
            }
        }
        rm(j)
        recp[[i]] <- as.integer(tmprcp)
    }
    rm(i)
    if (isTRUE(TRD == TRUE) == TRUE) {
        xchg <- list()
        for (i in seq(lbs)) {
            xchg[[i]] <- sngl[[i]][which(!(sngl[[i]] %in% recp[[i]]))]
        }
        rm(i)
    }
    else {
        xchg <- character(0)
    }
    if (isTRUE(TRD == TRUE) == TRUE) {
        Eout3p <- list()
        Einn3p <- list()
        TEnt3p <- list()
        for (i in seq(length(tripfl))) {
            tmpout <- vector()
            tmpinn <- vector()
            for (j in seq(length(tripfl[[i]]))) {
                if (isTRUE(tripfl[[i]][j] %in% trou[[i]]) == 
                  TRUE) 
                  tmpout[length(tmpout) + 1L] <- tripfl[[i]][j]
                if (isTRUE(tripfl[[i]][j] %in% trin[[i]]) == 
                  TRUE) 
                  tmpinn[length(tmpinn) + 1L] <- tripfl[[i]][j]
            }
            rm(j)
            Eout3p[[i]] <- tmpout
            Einn3p[[i]] <- tmpinn
            TEnt3p[[i]] <- as.integer(c(tmpout, tmpinn))
        }
        TEinn <- list()
        TEout <- list()
        for (i in seq(length(TEnt3p))) {
            tmpinn <- vector()
            tmpout <- vector()
            for (j in seq(length(TEnt3p[[i]]))) {
                if (isTRUE(length(Eout3p[[i]]) > 0) == TRUE) {
                  if (isTRUE(!(Eout3p[[i]][j] %in% inn[[i]])) == 
                    TRUE) 
                    tmpout <- append(tmpout, Eout3p[[i]][j])
                }
                if (isTRUE(length(Einn3p[[i]]) > 0) == TRUE) {
                  if (isTRUE(!(Einn3p[[i]][j] %in% out[[i]])) == 
                    TRUE) 
                    tmpinn <- append(tmpinn, Einn3p[[i]][j])
                }
            }
            rm(j)
            TEinn[[i]] <- tmpinn
            TEout[[i]] <- tmpout
        }
        rm(i)
        if (isTRUE(all.equal(TEnt3p, tripfl) == TRUE) == TRUE && 
            isTRUE(length(unlist(tripfl)) > 0) == TRUE) {
            mixe <- as.list(integer(length = length(lbs)))
        }
        else {
            mixe <- list()
            for (i in seq(lbs)) {
                mixe[[i]] <- tripfl[[i]][which(!(tripfl[[i]] %in% 
                  c(TEinn[[i]], TEout[[i]])))]
            }
            rm(i)
        }
        Eoutnp <- list()
        for (i in seq(lbs)) {
            Eoutnp[[i]] <- unique(c(Eout[[i]], Eout3p[[i]]))
            Eout[[i]] <- Eoutnp[[i]][which(!(Eoutnp[[i]] %in% 
                mixe[[i]]))]
        }
        rm(i)
    }
    else {
        mixe <- TEinn <- TEout <- character(0)
    }
    return(list(asym = asym, recp = recp, Eout = Eout, xchg = xchg, 
        mixe = mixe, full = full, out = out, tripfl = tripfl))
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
decomp <-
function (S, pr, type = c("mca", "pi", "at", "cc"), reduc, fac) 
{
    if (isTRUE("Pi.rels" %in% attr(pr, "class") || "Congruence" %in% 
        attr(pr, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(pr))), " must be either a ", 
            dQuote("Pi.rels"), " or a ", dQuote("Congruence"), 
            " class object.", sep = ""))
    if (missing(fac) == FALSE && isTRUE("Pi.rels" %in% attr(pr, 
        "class")) == FALSE) 
        warning(paste(sQuote(deparse(substitute(fac))), " is ignored since it requires as input a ", 
            dQuote("Pi.rels"), " class object.", sep = ""), call. = FALSE)
    if (isTRUE("Pi.rels" %in% attr(pr, "class")) == TRUE) {
        if (missing(fac) == FALSE && isTRUE("Decomp" %in% attr(S, 
            "class")) == TRUE) {
            if (is.numeric(fac) == FALSE || isTRUE(fac > length(S$IM)) == 
                TRUE) {
                warning(paste("First factor is taken since ", 
                  dQuote("fac"), " must be an integer smaller than the number of factors in ", 
                  sQuote(deparse(substitute(S))), ".", sep = ""), 
                  call. = FALSE)
                S <- S$IM[[1]]
            }
            else {
                S <- S$IM[[fac]]
            }
        }
        else {
            NA
        }
        switch(match.arg(type), mca = poi <- pr$mca, pi = poi <- pr$pi, 
            at = poi <- pr$at, cc = stop(paste("Type options for a ", 
                dQuote("Pi.rels"), " class object must be either ", 
                sQuote("pi"), ", ", sQuote("at"), " or ", sQuote("mc"), 
                ".", sep = "")))
    }
    else if (isTRUE(attr(pr, "class")[1] == "Congruence") == 
        TRUE) {
        if (match.arg(type) != "cc") {
            warning(paste("Only ", dQuote("cc"), " type is suitable for a ", 
                dQuote("Congruence"), " class object.", sep = ""), 
                call. = FALSE)
        }
        ifelse(isTRUE(attr(pr, "class")[2] == "PO.Semigroup") == 
            TRUE, poi <- pr$PO, NA)
    }
    if (isTRUE("symbolic" %in% attr(S, "class")) == TRUE || isTRUE("Semigroup" %in% 
        attr(S, "class")) == FALSE) {
        s <- suppressWarnings(as.semigroup(S, numerical = TRUE))
    }
    else {
        s <- S
    }
    if (isTRUE("Pi.rels" %in% attr(pr, "class")) == TRUE) {
        if (isTRUE(s$ord == dim(pr$pi)[1]) == FALSE) 
            stop("Semigroup order and partial order dimension differ.", 
                call. = FALSE)
        if (is.list(poi) == TRUE) {
            tmp <- poi
            poi <- array(NA, dim = c(dim(tmp[[1]]), length(tmp)), 
                dimnames = dimnames(tmp[[1]]))
            for (k in seq_along(tmp)) {
                poi[, , k] <- tmp[[k]]
            }
            rm(k)
            rm(tmp)
        }
        else {
            NA
        }
        if (is.na(dim(poi)[3]) == FALSE) {
            clu <- list()
            lb <- list()
            length(lb) <- length(clu) <- dim(poi)[3]
            for (i in seq_len(dim(poi)[3])) {
                ifelse(isTRUE(all(as.vector(poi[, , i]) == 1L) == 
                  TRUE) == TRUE, clu[[i]] <- rep(1, s$ord), clu[[i]] <- stats::cutree(stats::hclust(stats::dist(poi[, 
                  , i])), k = length(cut(stats::as.dendrogram(stats::hclust(stats::dist(poi[, 
                  , i]))), h = 0L)$lower)))
                ifelse(isTRUE("symbolic" %in% attr(S, "class")) == 
                  TRUE, attr(clu[[i]], "names") <- S$st, attr(clu[[i]], 
                  "names") <- s$st)
                lb[[i]] <- list()
                for (j in seq_along(tabulate(clu[[i]]))) {
                  lb[[i]][[j]] <- noquote(attr(which(clu[[i]] == 
                    j), "names"))
                }
                rm(j)
            }
            rm(i)
        }
        else {
            clu <- seq_len(S$ord)
            lb <- S$st
        }
    }
    else {
        clu <- pr$clu
        if (is.list(clu) == FALSE && isTRUE(nlevels(factor(clu)) == 
            1) == TRUE) {
            lb <- S$st
        }
        else {
            lb <- list()
            length(lb) <- length(clu)
            for (i in seq_along(clu)) {
                attr(clu[[i]], "names") <- S$st
                lb[[i]] <- list()
                for (j in seq_along(tabulate(clu[[i]]))) {
                  lb[[i]][[j]] <- noquote(attr(which(clu[[i]] == 
                    j), "names"))
                }
                rm(j)
            }
            rm(i)
        }
    }
    if (missing(reduc) == FALSE && isTRUE(reduc == TRUE) == TRUE) {
        if (isTRUE(nlevels(factor(as.matrix(s$S))) == 1) == TRUE) {
            im <- S$S
            ord <- S$ord
        }
        else {
            ord <- vector()
            po <- vector(mode = "list", length = length(clu))
            im <- vector(mode = "list", length = length(clu))
            for (k in seq_along(clu)) {
                tmpimk <- reducs(S, cl = as.vector(clu[[k]]))
                notek <- vector()
                if (isTRUE(length(which(is.na(tmpimk))) > 0) == 
                  TRUE) {
                  notek <- append(notek, k)
                  n <- nlevels(factor(clu[[k]]))
                  cls <- list()
                  for (i in seq_len(n)) {
                    cls[[i]] <- which(clu[[k]] == i)
                  }
                  rm(i)
                  jcc <- unique(unlist(S$S[which(clu[[k]] == 
                    which(is.na(tmpimk))[1]%%nrow(tmpimk)), which(clu[[k]] == 
                    ceiling(which(is.na(tmpimk))[1]/ncol(tmpimk)))]))
                  ifelse(isTRUE(attr(S, "class")[2] == "symbolic") == 
                    TRUE, Sst <- S$st, Sst <- s$st)
                  clsna <- vector()
                  for (q in seq_along(jcc)) {
                    for (i in seq_len(length(cls))) {
                      if (isTRUE(jcc[q] %in% Sst[cls[[i]]]) == 
                        TRUE) {
                        clsna <- append(clsna, i)
                        break
                      }
                      else {
                        NA
                      }
                    }
                    rm(i)
                  }
                  rm(q)
                  tmpcl <- clu[[k]]
                  tmpcl[which(tmpcl %in% unique(clsna))] <- min(clsna)
                  for (i in seq_len(nlevels(factor(tmpcl)))) {
                    tmpcl <- replace(tmpcl, tmpcl == as.numeric(levels(factor(tmpcl))[i]), 
                      i)
                  }
                  rm(i)
                  clu[[k]] <- tmpcl
                  lb[[k]] <- list()
                  for (j in seq_along(tabulate(clu[[k]]))) {
                    lb[[k]][[j]] <- noquote(attr(which(clu[[k]] == 
                      j), "names"))
                  }
                  rm(j)
                  im[[k]] <- reducs(S, cl = as.vector(clu[[k]]))
                }
                else {
                  im[[k]] <- tmpimk
                }
                rm(tmpimk)
                if (isTRUE(length(notek) == 1L) == TRUE) {
                  warning(paste0("Image ", notek, " has been forced to produce additional equations."), 
                    call. = FALSE)
                }
                else if (isTRUE(length(notek) > 1L) == TRUE) {
                  warning(paste0("Images in ", notek, " have been forced to produce additional equations."), 
                    call. = FALSE)
                }
                else {
                  NA
                }
                if (isTRUE("Pi.rels" %in% attr(pr, "class")) == 
                  TRUE) {
                  po[[k]] <- reduc(poi[, , k], clu = as.vector(clu[[k]]), 
                    lbs = dimnames(im[[k]])[[1]])
                }
                else if (isTRUE(attr(pr, "class")[2] == "PO.Semigroup") == 
                  TRUE) {
                  po[[k]] <- reduc(poi, clu = as.vector(clu[[k]]), 
                    lbs = dimnames(im[[k]])[[1]])
                }
                else {
                  NA
                }
                ord <- append(ord, dim(im[[k]])[1])
            }
            rm(k)
        }
        ifelse(isTRUE("Pi.rels" %in% attr(pr, "class")) == TRUE || 
            isTRUE("PO.Semigroup" %in% attr(pr, "class")) == 
                TRUE, lst <- list(clu = clu, eq = lb, IM = im, 
            PO = po, ord = ord), lst <- list(clu = clu, eq = lb, 
            IM = im, ord = ord))
    }
    else {
        lst <- list(clu = clu, eq = lb)
    }
    ifelse(isTRUE(attr(pr, "class")[1] == "Congruence") == TRUE, 
        class(lst) <- c("Decomp", attr(pr, "class")[1], "cc"), 
        class(lst) <- c("Decomp", attr(pr, "class")[1], match.arg(type)))
    class(lst) <- unique(c(class(lst), class(pr)))
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
write.edgel <-
function (x, file = NULL, sep = "\t", header = TRUE) 
{
    if (isTRUE(is.na(dim(x)[3]) == TRUE) == FALSE) {
        if (isTRUE(is.null(dimnames(x)[[3]])) == TRUE) 
            dimnames(x)[[3]] <- seq_len(dim(x)[3])
    }
    if (isTRUE(is.null(dimnames(x)[[1]])) == TRUE) 
        dimnames(x)[[1]] <- dimnames(x)[[2]] <- seq_len(dim(x)[1])
    if (isTRUE(dim(x)[3] == 1) == TRUE) 
        x <- x[, , 1]
    if (isTRUE(is.na(dim(x)[3]) == TRUE) == TRUE) {
        if (header) {
            cat(paste("Sender", "Receiver", "Ties", sep = sep), 
                file = file, sep = "\n", append = TRUE)
        }
        tmp <- trnf(x, tolist = TRUE, lb2lb = TRUE, lbs = dimnames(x)[[1]])
        for (i in seq_len(length(tmp))) {
            cat(paste(strsplit(tmp[i], ", ")[[1]][1], strsplit(tmp[i], 
                ", ")[[1]][2], "1", sep = sep), file = file, 
                sep = "\n", append = TRUE)
        }
        rm(i)
    }
    else if (isTRUE(is.na(dim(x)[3]) == TRUE) == FALSE) {
        ts <- rep(0L, dim(x)[3])
        DF <- data.frame(matrix(ncol = (dim(x)[3] + 2L), nrow = 0L))
        for (k in seq_len(dim(x)[3])) {
            tmp <- trnf(x[, , k], tolist = TRUE, lb2lb = TRUE, 
                lbs = dimnames(x)[[1]])
            for (i in seq_len(length(tmp))) {
                ts[k] <- 1L
                DF[(nrow(DF) + 1L), ] <- c(strsplit(tmp[i], ", ")[[1]][1], 
                  strsplit(tmp[i], ", ")[[1]][2], ts)
                ts <- rep(0L, dim(x)[3])
            }
            rm(i)
        }
        rm(k)
        isol <- dimnames(x)[[1]][which(!(dimnames(x)[[1]] %in% 
            dimnames(rm.isol(x))[[1]]))]
        if (isTRUE(length(isol) > 0L) == TRUE) {
            for (i in seq_len(length(isol))) {
                DF[(nrow(DF) + 1L), ] <- c(isol[i], isol[i], 
                  ts)
            }
            rm(i)
        }
        colnames(DF) <- c("Sender", "Receiver", dimnames(x)[[3]])
        if (header) {
            utils::write.table(DF, file = file, quote = FALSE, 
                sep = sep, row.names = FALSE, col.names = TRUE)
        }
        else if (!header) {
            utils::write.table(DF, file = file, quote = FALSE, 
                sep = sep, row.names = FALSE, col.names = FALSE)
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
hasse <-
function (x, concept, attrs = NULL, main = NULL, incmp, shape = c("rectangle", 
    "circle", "box", "ellipse"), col, col0, fcol, ecol, lty, 
    lbs, ffamily, fstyle, fsize, cex.main, col.main, bg, mar, 
    sep, ...) 
{
    if (requireNamespace("Rgraphviz", quietly = TRUE)) {
        if (isTRUE(shape %in% c("rectangle", "rect", "circle", 
            "box", "ellipse") == FALSE) == TRUE) {
            ifelse(isTRUE(shape == "rectangle") == TRUE, NA, 
                warning(paste("Unknown shape for ", dQuote(deparse(substitute(x))), 
                  ", assume ", sQuote("rectangle"), ".", sep = ""), 
                  call. = FALSE))
            shape <- "rectangle"
        }
        else {
            NA
        }
        ifelse(missing(col) == TRUE, fillcol <- "transparent", 
            fillcol <- col)
        ifelse(missing(col0) == TRUE, col0 <- "transparent", 
            NA)
        ifelse(missing(ecol) == TRUE, ecol <- "#000000", NA)
        ifelse(missing(lty) == TRUE, lty <- "solid", NA)
        if (missing(concept) == TRUE) {
            ifelse(isTRUE("galois" %in% class(x)) == TRUE, concept <- TRUE, 
                concept <- FALSE)
        }
        else {
            ifelse(isTRUE(class(concept) != "logical") == TRUE, 
                warning(paste("Value in ", sQuote("concept"), 
                  " should be TRUE/FALSE.", sep = ""), call. = FALSE), 
                NA)
        }
        po <- x & (1L - t(x))
        diag(po) <- 0L
        if (missing(lbs) == TRUE) {
            if (is.null(dimnames(x)[[1]]) == TRUE) {
                rownames(po) <- colnames(po) <- as.character(utils::as.roman(c(seq_len(dim(x)[1]))))
                lbs <- attr(po, "dimnames")[[1]]
            }
            else {
                lbs <- attr(x, "dimnames")[[1]]
            }
        }
        else {
            ifelse(isTRUE(length(lbs) != dim(po)[1]) == TRUE, 
                lbs <- lbs[seq_len(nrow(po))], NA)
        }
        if (isTRUE(length(lbs) == 1L) == TRUE && isTRUE(dim(x)[1] > 
            1L) == TRUE) {
            tlbs <- vector(mode = "list", length = dim(x)[1])
            for (i in seq_len(dim(x)[1])) tlbs[[i]] <- lbs[[1]][[i]]
            lbs <- tlbs
            rm(tlbs)
        }
        else {
            NA
        }
        ifelse(missing(sep) == TRUE, sep <- ",", NA)
        ifelse(is.list(lbs) == TRUE, lbs <- unlist(jnt(lbs, sep = sep)), 
            NA)
        if (missing(fsize) == TRUE) {
            if (isTRUE(concept == TRUE) == TRUE) {
                fsize <- 20L/max(nchar(lbs))
            }
            else {
                fsize <- 20L/dim(x)[1]
                ifelse(isTRUE(fsize < 1L) == TRUE, fsize <- 1L * 
                  ((1L/dim(x)[1] * dim(x)[1])), NA)
            }
        }
        else {
            if (isTRUE(concept == TRUE) == TRUE) {
                fsize <- fsize/6L
            }
            else {
                NA
            }
        }
        if (is.null(attrs) == TRUE) {
            attrs = list(graph = list(rankdir = "BT"), edge = list(arrowsize = "0", 
                style = "lty", minlen = "1", color = ecol), node = list(shape = shape, 
                color = col0, fixedsize = FALSE, fontsize = fsize, 
                fillcolor = fillcol, fontcolor = "transparent", 
                label = ""))
        }
        rownames(po) <- colnames(po) <- NULL
        if (isTRUE(ncol(x) == nrow(x)) == TRUE) {
            for (i in seq_len(ncol(po))) {
                tmp <- outer(po[, i], po[i, ], pmin.int)
                po <- pmin(po, (1L - tmp))
            }
            rm(tmp)
        }
        else {
            stop("Binary operation on non-conformable arrays.")
        }
        if (missing(incmp) == FALSE && isTRUE(incmp == FALSE) == 
            TRUE) {
            px <- po
            out <- vector()
            for (i in seq_len(nrow(po))) {
                ifelse(isTRUE(sum(px[i, ] + px[, i]) == 0L) == 
                  TRUE, out[length(out) + 1L] <- i, NA)
            }
            rm(i)
            inn <- which(!(seq_len(nrow(po)) %in% out))
            po <- as.matrix(po[inn, inn])
        }
        else {
            NA
        }
        ifelse(missing(cex.main) == TRUE, cex.main <- graphics::par()$cex.main, 
            NA)
        ifelse(missing(col.main) == TRUE, col.main <- graphics::par()$col.main, 
            NA)
        omr <- graphics::par()$mar
        omi <- graphics::par()$mai
        if (missing(mar) == TRUE) {
            mar <- c(0, 0, 0, 0)
        }
        else {
            mar <- omr
        }
        obg <- graphics::par()$bg
        ifelse(missing(bg) == TRUE, bg <- graphics::par()$bg, 
            NA)
        graphics::par(bg = bg)
        ifelse(is.null(main) == TRUE, graphics::par(mar = mar), 
            graphics::par(mar = mar + c(0, 0, cex.main, 0)))
        ifelse(missing(ffamily) == FALSE && isTRUE(ffamily %in% 
            names(grDevices::postscriptFonts())) == TRUE, graphics::par(family = ffamily), 
            NA)
        options(warn = -1)
        X <- invisible(Rgraphviz::plot(methods::as(po, Class = "graphNEL"), 
            attrs = attrs, main = main, cex.main = cex.main, 
            col.main = col.main, ...))
        yp <- vector()
        xp <- vector()
        for (i in seq_along(X@AgNode)) {
            xp[length(xp) + 1L] <- X@AgNode[[i]]@center@x
            yp[length(yp) + 1L] <- X@AgNode[[i]]@center@y
        }
        rm(i)
        if (missing(fcol) == TRUE) {
            if (missing(fstyle) == TRUE || (missing(fstyle) == 
                FALSE && isTRUE(fstyle %in% c("italic", "bold", 
                "bolditalic") == FALSE))) {
                graphics::text(cbind(xp, yp), labels = lbs, cex = fsize, 
                  ...)
            }
            else if (missing(fstyle) == FALSE) {
                if (isTRUE(fstyle == "italic") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(italic(.(z))))), cex = fsize, 
                    ...)
                }
                else if (isTRUE(fstyle == "bold") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(bold(.(z))))), cex = fsize, 
                    ...)
                }
                else if (isTRUE(fstyle == "bolditalic") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(bolditalic(.(z))))), cex = fsize, 
                    ...)
                }
            }
        }
        else {
            if (missing(fstyle) == TRUE || (missing(fstyle) == 
                FALSE && isTRUE(fstyle %in% c("italic", "bold", 
                "bolditalic") == FALSE))) {
                graphics::text(cbind(xp, yp), labels = lbs, col = fcol, 
                  cex = fsize, ...)
            }
            else if (missing(fstyle) == FALSE) {
                if (isTRUE(fstyle == "italic") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(italic(.(z))))), col = fcol, 
                    cex = fsize, ...)
                }
                else if (isTRUE(fstyle == "bold") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(bold(.(z))))), col = fcol, 
                    cex = fsize, ...)
                }
                else if (isTRUE(fstyle == "bolditalic") == TRUE) {
                  graphics::text(cbind(xp, yp), labels = as.expression(lapply(lbs, 
                    function(z) bquote(bolditalic(.(z))))), col = fcol, 
                    cex = fsize, ...)
                }
            }
        }
        options(warn = 0)
        graphics::par(new = FALSE)
        graphics::par(mar = omr)
        graphics::par(bg = obg)
        graphics::par(lend = 0)
        graphics::par(mai = omi)
    }
    else {
        stop(paste("Package ", dQuote("Rgraphviz"), " not found.", 
            sep = ""))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
fact <-
function (S, P, uniq = TRUE, fac, atoms, mca, atmc, patm, k) 
{
    if (isTRUE("Decomp" %in% attr(S, "class")) == TRUE) {
        if (missing(fac) == TRUE || missing(fac) == FALSE && 
            (is.numeric(fac) == FALSE || isTRUE(fac > length(S$IM)) == 
                TRUE)) {
            warning(paste("First factor is taken since ", sQuote(deparse(substitute(fac))), 
                " should be an integer no larger than the number of factors in ", 
                sQuote(deparse(substitute(S))), " image.", sep = ""), 
                call. = FALSE)
            s <- S$IM[[1]]
            po <- S$PO[[1]]
        }
        else if (missing(fac) == FALSE) {
            s <- S$IM[[fac]]
            po <- S$PO[[fac]]
        }
        S <- s
        P <- po
        rm(s, po)
    }
    else {
        NA
    }
    if (isTRUE("symbolic" %in% attr(S, "class")) == TRUE || isTRUE("Semigroup" %in% 
        attr(S, "class")) == FALSE) {
        ifelse(is.list(S) == TRUE && isTRUE(length(S) == 1L) == 
            TRUE, S <- S[[1]], NA)
        S <- suppressWarnings(as.semigroup(S, numerical = TRUE))
        ifelse(is.list(P) == TRUE && isTRUE(length(P) == 1L) == 
            TRUE, P <- P[[1]], NA)
        rownames(P) <- colnames(P) <- S$st
    }
    else {
        NA
    }
    NS <- S$ord
    TAB <- as.matrix(S$S)
    if (isTRUE(length(unique(as.vector(TAB))) == 1L) == TRUE) {
        warning(paste("1-element semigroup found in ", sQuote(deparse(substitute(S))), 
            ".", sep = ""), call. = FALSE)
        return(list(po = P[1:NS, 1:NS], iin = trnf(1 - P, tolist = TRUE, 
            lb2lb = TRUE)))
    }
    ifelse(missing(atoms) == FALSE && isTRUE(atoms == FALSE) == 
        TRUE, atoms <- FALSE, atoms <- TRUE)
    ifelse(missing(mca) == FALSE && isTRUE(mca == FALSE) == TRUE, 
        mca <- FALSE, mca <- TRUE)
    ifelse(missing(atmc) == FALSE && isTRUE(atmc == TRUE) == 
        TRUE, atmc <- TRUE, atmc <- FALSE)
    ifelse(missing(patm) == FALSE && isTRUE(patm == TRUE) == 
        TRUE, patm <- TRUE, patm <- FALSE)
    gi <- trnf(1 - P, tolist = TRUE, sep = ", ", lb2lb = FALSE)
    iin <- vector(mode = "list", length = length(gi))
    attr(iin, "names") <- gi
    ncomp <- vector()
    znote <- vector()
    for (z in seq_along(gi)) {
        Q <- P[1:NS, 1:NS]
        rownames(Q) <- colnames(Q) <- seq_len(NS)
        K <- as.numeric(dhc(gi[z], sep = ", ")[1])
        l <- as.numeric(dhc(gi[z], sep = ", ")[2])
        NCOMP <- 0
        COMP <- data.frame(matrix(nrow = 0L, ncol = 2L))
        ifelse(all(Q == dichot(Q %*% Q)) == TRUE, NA, Q <- dichot(Q %*% 
            Q))
        for (m in seq_len(NS)) {
            if (isTRUE(Q[TAB[K, m], TAB[l, m]] == 1L) == TRUE) {
                NA
            }
            else {
                Q[TAB[K, m], TAB[l, m]] <- 1L
                NCOMP <- NCOMP + 1L
                COMP[NCOMP, 1] <- TAB[K, m]
                COMP[NCOMP, 2] <- TAB[l, m]
            }
            if (isTRUE(Q[TAB[m, K], TAB[m, l]] == 1L) == TRUE) {
                NA
            }
            else {
                Q[TAB[m, K], TAB[m, l]] <- 1L
                NCOMP <- NCOMP + 1L
                COMP[NCOMP, 1] <- TAB[m, K]
                COMP[NCOMP, 2] <- TAB[m, l]
            }
        }
        rm(m)
        if (isTRUE(NCOMP != 0) == TRUE) {
            NMIN <- 1L
            NMAX <- NCOMP
            for (m in NMIN:NMAX) {
                for (n in seq_len(NS)) {
                  if (isTRUE(Q[TAB[COMP[m, 1], n], TAB[COMP[m, 
                    2], n]] == 1L) == TRUE) {
                    NA
                  }
                  else {
                    Q[TAB[COMP[m, 1], n], TAB[COMP[m, 2], n]] <- 1L
                    NCOMP <- NCOMP + 1L
                    COMP[NCOMP, 1] <- TAB[COMP[m, 1], n]
                    COMP[NCOMP, 2] <- TAB[COMP[m, 2], n]
                  }
                  if (isTRUE(Q[TAB[n, COMP[m, 1]], TAB[n, COMP[m, 
                    2]]] == 1L) == TRUE) {
                    NA
                  }
                  else {
                    Q[TAB[n, COMP[m, 1]], TAB[n, COMP[m, 2]]] <- 1L
                    NCOMP <- NCOMP + 1L
                    COMP[NCOMP, 1] <- TAB[n, COMP[m, 1]]
                    COMP[NCOMP, 2] <- TAB[n, COMP[m, 2]]
                  }
                  if (isTRUE(NCOMP == NMAX) == TRUE) {
                    if (all(Q == dichot(Q %*% Q)) == TRUE) {
                      NA
                    }
                    else if (all(Q == dichot(Q %*% Q)) == FALSE) {
                      Q <- dichot(Q %*% Q)
                    }
                  }
                  else {
                    NMIN <- NMIN + 1L
                    NMAX <- NCOMP
                  }
                }
                rm(n)
            }
            rm(m)
        }
        else {
            znote <- append(znote, z)
        }
        if (isTRUE(nrow(COMP) != 0) == TRUE) {
            vec <- vector()
            for (i in seq_len(nrow(COMP))) {
                vec <- append(vec, jnt(as.character(COMP[i, ]), 
                  uniq = TRUE))
            }
            rm(i)
            PQ <- replace(P + Q, P + Q == 2, 0)
            diag(PQ) <- 0
            iin[[z]] <- sort(unique(c(vec, trnf(PQ, tolist = TRUE, 
                sep = ", ", lb2lb = FALSE))))
        }
        else {
            NA
        }
        ncomp <- append(ncomp, length(iin[[z]]))
    }
    rm(z)
    Iin <- iin[lengths(iin) != 0]
    Ncomp <- ncomp[ncomp != 0]
    iin <- unique(Iin)
    attr(iin, "names") <- attr(Iin, "names")[which(duplicated(Iin) == 
        FALSE)]
    ncomp <- Ncomp[which(duplicated(Iin) == FALSE)]
    if (isTRUE(atoms == TRUE) == TRUE) {
        ifelse(missing(k) == TRUE, k <- 3, NA)
        patms <- list()
        for (i in seq_len(k)) {
            patms[[length(patms) + 1]] <- iin[which(ncomp == 
                which(tabulate(ncomp) != 0)[i])]
        }
        rm(i)
        vecn <- vector()
        for (i in seq_along(patms)) {
            vecn <- append(vecn, attr(patms[[i]], "names"))
        }
        rm(i)
        patoms <- which(as.character(attr(iin, "names")) %in% 
            vecn)
        pii <- array(dim = c(nrow(P), ncol(P), length(patoms)))
        for (i in seq_along(iin[patoms])) {
            pii[, , i] <- transf(iin[patoms][[i]], type = "toarray", 
                ord = nrow(P), lbs = seq_len(nrow(P))) + P
        }
        rm(i)
        dimnames(pii)[[1]] <- dimnames(pii)[[2]] <- seq_len(nrow(P))
        dimnames(pii)[[3]] <- patoms
        popatoms <- strng(pii)
        atm <- iin[patoms[which(apply(popatoms, 2, sum) == 1L)]]
    }
    if (isTRUE(mca == TRUE) == TRUE) {
        vatm <- patoms[which(apply(popatoms, 2, sum) == 1L)]
        mcl <- vector(mode = "list", length = length(vatm))
        iimc <- vector(mode = "list", length = length(vatm))
        for (K in seq_along(vatm)) {
            vec <- vector()
            for (i in seq_along(iin)) {
                ifelse(all(iin[[vatm[K]]] %in% iin[[i]]) == FALSE, 
                  vec <- append(vec, i), NA)
            }
            rm(i)
            mcl[[K]] <- vec
            iimc[[K]] <- iin[mcl[[K]]]
        }
        rm(K)
        attr(mcl, "names") <- attr(atm, "names")
        pomcl <- vector(mode = "list", length = length(iimc))
        for (K in seq_along(iimc)) {
            potmp <- matrix(0L, nrow = length(iimc[[K]]), ncol = length(iimc[[K]]), 
                dimnames = list(mcl[[K]], mcl[[K]]))
            for (j in seq_along(iimc[[K]])) {
                for (i in seq_along(iimc[[K]])) {
                  ifelse(isTRUE(all(iimc[[K]][[i]] %in% iimc[[K]][[j]])) == 
                    TRUE, potmp[i, j] <- 1L, NA)
                }
                rm(i)
            }
            rm(j)
            pomcl[[K]] <- potmp
        }
        rm(K)
        pmcl <- vector(mode = "list", length = length(pomcl))
        for (K in seq_along(pomcl)) {
            pmcl[[K]] <- which(apply(pomcl[[K]], 1, sum) == 1L)
            mcl[[K]][which(apply(pomcl[[K]], 1, sum) == 1L)]
        }
        rm(K)
        niin <- length(iin)
        mmcs <- vector(mode = "list", length = length(pmcl))
        for (K in seq_along(pmcl)) {
            if (isTRUE(length(pmcl[[K]]) == 1L) == TRUE) {
                mmcs[[K]] <- transf(iin[[as.numeric(attr(pmcl[[K]], 
                  "names"))]], type = "toarray", ord = NS, lbs = 1:NS) + 
                  P[1:NS, 1:NS]
            }
            else if (isTRUE(length(pmcl[[K]]) == 0) == TRUE) {
                niin <- niin + 1L
                mcl[[K]] <- append(mcl[[K]], (niin))
            }
            else {
                mmcs[[K]] <- transf(unique(unlist(iin[as.numeric(attr(pmcl[[K]], 
                  "names"))])), type = "toarray", ord = NS, lbs = 1:NS) + 
                  P[1:NS, 1:NS]
                niin <- niin + 1L
                mcl[[K]] <- append(mcl[[K]], (niin))
            }
        }
        rm(K)
    }
    if (isTRUE(length(znote) > 0) == TRUE) {
        warning(paste(sQuote("Q"), " has no substitution property in induced inclusions: `", 
            paste(znote, collapse = "`,`"), "`.", sep = ""), 
            call. = FALSE)
    }
    else {
        NA
    }
    if (isTRUE(uniq == TRUE) == TRUE) {
        ifelse(is.null(unlist(mmcs)) == TRUE, lst <- list(po = P[1:NS, 
            1:NS], iin = iin, niin = ncomp, patm = patoms, atm = atm, 
            atmc = mcl), lst <- list(po = P[1:NS, 1:NS], iin = iin, 
            niin = ncomp, patm = patoms, atm = atm, atmc = mcl, 
            mca = mmcs))
    }
    else {
        ifelse(is.null(unlist(mmcs)) == TRUE, lst <- list(po = P[1:NS, 
            1:NS], iin = Iin, niin = Ncomp, patm = patoms, atm = atm, 
            atmc = mcl), lst <- list(po = P[1:NS, 1:NS], iin = Iin, 
            niin = Ncomp, patm = patoms, atm = atm, atmc = mcl, 
            mca = mmcs))
    }
    class(lst) <- c("Factorization", "Induced.inclusions")
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
edgeT <-
function (x, semigroupClass) 
{
    if (missing(semigroupClass) == FALSE && isTRUE(semigroupClass == 
        TRUE) == TRUE) {
        if (isTRUE(attr(x, "class") == "EdgeTable") == TRUE) {
            if (is.null(dimnames(x$ET)) == TRUE) 
                stop(paste("Dimnames in ", sQuote(deparse(substitute(x))), 
                  " not found.", sep = ""))
            return(edgS(x$ET, semigroupClass = TRUE))
        }
        else {
            if (is.null(dimnames(x)) == TRUE) 
                warning(paste("Dimnames in ", sQuote(deparse(substitute(x))), 
                  " not found.", sep = ""), call. = FALSE)
            return(edgS(x, semigroupClass = TRUE))
        }
    }
    else {
        if (is.array(x) == FALSE) 
            stop(paste("Data should be a stacked array of square matrices or an ", 
                dQuote("EdgeTable"), " class object.", sep = ""))
    }
    if (is.na(dim(x)[3]) == TRUE) {
        if (is.null(dimnames(x)) == TRUE) 
            stop(paste("Dimnames in ", sQuote(deparse(substitute(x))), 
                " not found.", sep = ""))
        if (isTRUE(dim(x)[1] != dim(x)[2]) == TRUE) 
            stop(paste(sQuote(deparse(substitute(x))), " is not square. Try as ", 
                dQuote("semigroupClass"), " option.", sep = ""))
        s0 <- data.frame(matrix(ncol = 1, nrow = 1))
        if (isTRUE(all.equal(replace(x %*% x, x %*% x >= 1, 1), 
            x) == TRUE)) 
            s0[1, 1] <- 1
        Bx <- array(dim = c(dim(x)[1], dim(x)[2], 2))
        Bx[, , 1] <- as.matrix(x)
        Bx[, , 2] <- replace(x %*% x, x %*% x >= 1, 1)
    }
    if (is.na(dim(x)[3]) == FALSE) {
        tmp0 <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
            nrow = 0))
        for (i in seq_len(dim(x)[3])) {
            ifelse(isTRUE(dim(x)[3] > 1) == TRUE, tmp0[i, ] <- as.vector(x[, 
                , i]), tmp0 <- as.vector(x))
        }
        rm(i)
        if (isTRUE(is.null(dim(tmp0)) == FALSE) == TRUE) 
            rownames(tmp0) <- dimnames(x)[[3]]
        if (isTRUE(dim(x)[3] < 2) == TRUE) 
            x <- array(tmp0, c(dim(x)[1], dim(x)[2]))
        if (isTRUE(dim(x)[3] > 1) == TRUE) {
            tmp <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp0))))
            for (i in seq_len(nrow(unique(tmp0)))) {
                tmp[, , i][seq_len(dim(x)[1] * dim(x)[2])] <- as.numeric(unique(tmp0)[i, 
                  ])
            }
            rm(i)
            if (is.null(dimnames(tmp)[[1]]) == FALSE) 
                dimnames(tmp)[[3]] <- rownames(unique(tmp0))
            if (is.null(dimnames(x)[[1]]) == FALSE) 
                dimnames(tmp)[[1]] <- dimnames(tmp)[[2]] <- dimnames(x)[[1]]
            x <- tmp
            dimnames(x)[[3]] <- as.list(rownames(unique(tmp0)))
        }
        s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(x)[3]))
        for (k in seq_len(dim(x)[3])) {
            for (j in seq_len(dim(x)[3])) {
                for (i in rev(seq_len(dim(x)[3]))) {
                  if (isTRUE(all.equal(replace(x[, , j] %*% x[, 
                    , k], x[, , j] %*% x[, , k] >= 1, 1), x[, 
                    , i]) == TRUE)) 
                    s0[j, k] <- i
                }
            }
        }
        rm(i, j, k)
        rm(tmp0, tmp)
        dimnames(s0)[[1]] <- seq_len(dim(x)[3])
        dimnames(s0)[[2]] <- seq_len(dim(x)[3])
        if (sum(as.numeric(is.na(s0))) == 0) 
            Bx <- x
        if (sum(as.numeric(is.na(s0))) > 0) {
            Bx <- array(dim = c(dim(x)[1], dim(x)[2], 0))
            for (i in seq_len(nrow(s0))) {
                for (j in seq_len(length(which(is.na(s0[i, ]))))) {
                  if (length(which(is.na(s0[i, ]))) > 0) 
                    Bx <- zbnd(Bx, (replace(x[, , i] %*% x[, 
                      , which(is.na(s0[i, ]))[j]], x[, , i] %*% 
                      x[, , which(is.na(s0[i, ]))[j]] >= 1, 1)))
                }
            }
            rm(i, j)
            tmp <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
                nrow = 0))
            for (i in seq_len(dim(Bx)[3])) {
                tmp[i, ] <- as.vector(Bx[, , i])
            }
            rm(i)
            xBx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
            for (i in seq_len(nrow(unique(tmp)))) {
                xBx[, , i][seq_len(dim(Bx)[1] * dim(Bx)[2])] <- as.numeric(unique(tmp)[i, 
                  ])
            }
            rm(i)
            if (is.null(dimnames(xBx)) == FALSE) 
                dimnames(xBx)[[3]] <- (dim(x)[3] + 1):(dim(xBx)[3] + 
                  dim(x)[3])
            Bx <- zbnd(x, xBx)
            rm(xBx, tmp)
        }
    }
    while (sum(as.numeric(is.na(s0))) > 0) {
        BBx <- Bx
        for (i in seq_len(nrow(s0))) {
            for (j in seq_len(length(which(is.na(s0[i, ]))))) {
                if (length(which(is.na(s0[i, ]))) > 0) 
                  BBx <- zbnd(BBx, (replace(Bx[, , i] %*% Bx[, 
                    , which(is.na(s0[i, ]))[j]], Bx[, , i] %*% 
                    Bx[, , which(is.na(s0[i, ]))[j]] >= 1, 1)))
            }
        }
        rm(i, j)
        tmp <- data.frame(matrix(ncol = (dim(Bx)[1] * dim(Bx)[2]), 
            nrow = 0))
        for (i in seq_len(dim(BBx)[3])) {
            tmp[i, ] <- as.vector(BBx[, , i])
        }
        rm(i)
        Bx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
        for (i in seq_len(nrow(unique(tmp)))) {
            Bx[, , i][seq_len(dim(BBx)[1] * dim(BBx)[2])] <- as.numeric(unique(tmp)[i, 
                ])
        }
        rm(i)
        rm(tmp, BBx)
        if (is.na(dim(x)[3]) == TRUE) {
            s0 <- data.frame(matrix(ncol = 1, nrow = dim(Bx)[3]))
            for (j in seq_len(dim(Bx)[3])) {
                for (i in rev(seq_len(dim(Bx)[3]))) {
                  if (isTRUE(all.equal(replace(Bx[, , j] %*% 
                    Bx[, , 1], Bx[, , j] %*% Bx[, , 1] >= 1, 
                    1), Bx[, , i]) == TRUE)) 
                    s0[j, 1] <- i
                }
            }
            rm(i, j)
        }
        if (is.na(dim(x)[3]) == FALSE) {
            s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(Bx)[3]))
            for (k in seq_len(dim(x)[3])) {
                for (j in seq_len(dim(Bx)[3])) {
                  for (i in rev(seq_len(dim(Bx)[3]))) {
                    if (isTRUE(all.equal(replace(Bx[, , j] %*% 
                      Bx[, , k], Bx[, , j] %*% Bx[, , k] >= 1, 
                      1), Bx[, , i]) == TRUE)) 
                      s0[j, k] <- i
                  }
                }
            }
            rm(i, j, k)
        }
    }
    ifelse(isTRUE(is.na(dim(x)[3])) == TRUE, dimnames(s0)[[2]] <- 1, 
        dimnames(s0)[[2]] <- seq_len(dim(x)[3]))
    et <- list(gens = x, ET = s0)
    class(et) <- "EdgeTable"
    return(et)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
read.gml <-
function (file, as = c("edgel", "array"), directed = TRUE, coords = FALSE) 
{
    arx <- scan(file, what = "character", nlines = -1, quiet = TRUE)
    nod <- arx[which(("node" == arx) == TRUE)[1]:which(("edge" == 
        arx) == TRUE)[1] - 1L]
    n <- length(which(("node" == arx) == TRUE))
    lb <- vector()
    id <- vector()
    for (i in seq_len(n)) {
        id[length(id) + 1L] <- nod[which(("id" == nod) == TRUE)[i] + 
            1L]
        if (isTRUE("label" %in% nod) == TRUE) {
            lb[length(lb) + 1L] <- nod[which(("id" == nod) == 
                TRUE)[i] + 3L]
        }
    }
    rm(i)
    if (isTRUE("label" %in% nod) == FALSE) {
        lb <- id
    }
    atts <- vector()
    if (isTRUE(n > 1L) == TRUE) {
        for (i in seq_len((n - 1L))) {
            tmpat <- nod[which(("node" == nod) == TRUE)[i]:which(("node" == 
                nod) == TRUE)[i + 1L]]
            if (isTRUE(length(which(("LabelGraphics" == tmpat) == 
                TRUE)) > 1) == TRUE) {
                atts <- append(atts, tmpat[which(("LabelGraphics" == 
                  tmpat) == TRUE)[2] + 3L])
            }
            else if (isTRUE(length(which(("LabelGraphics" == 
                tmpat) == TRUE)) < 2L) == TRUE) {
                atts <- append(atts, NA)
            }
        }
        rm(i)
    }
    if (isTRUE(n > 0) == TRUE) {
        tmpat <- nod[which(("node" == nod) == TRUE)[n]:length(nod)]
        if (isTRUE(length(which(("LabelGraphics" == tmpat) == 
            TRUE)) > 1) == TRUE) {
            atts <- append(atts, tmpat[which(("LabelGraphics" == 
                tmpat) == TRUE)[2] + 3L])
        }
        else if (isTRUE(length(which(("LabelGraphics" == tmpat) == 
            TRUE)) < 2L) == TRUE) {
            atts <- append(atts, NA)
        }
    }
    if (isTRUE(coords == TRUE) == TRUE) {
        xv <- vector()
        yv <- vector()
        for (i in seq_len(n)) {
            xv[length(xv) + 1L] <- nod[which(("x" == nod) == 
                TRUE)[i] + 1L]
            yv[length(yv) + 1L] <- nod[which(("y" == nod) == 
                TRUE)[i] + 1L]
        }
        rm(i)
        ifelse(isTRUE(length(atts) > 0L) == TRUE, cds <- data.frame(X = 1L * 
            as.numeric(xv), Y = -1L * as.numeric(yv), L1 = lb, 
            L2 = atts), cds <- data.frame(X = 1L * as.numeric(xv), 
            Y = -1L * as.numeric(yv), L = lb))
    }
    else {
        NA
    }
    edg <- arx[which(("edge" == arx) == TRUE)[1]:length(arx)]
    ed <- length(which(("edge" == edg) == TRUE))
    sr <- vector()
    tg <- vector()
    for (i in seq_len(ed)) {
        sr[length(sr) + 1L] <- edg[which(("source" == edg) == 
            TRUE)[i] + 1L]
        tg[length(tg) + 1L] <- edg[which(("target" == edg) == 
            TRUE)[i] + 1L]
    }
    rm(i)
    if (isTRUE("0" %in% id) == TRUE & isTRUE(all(as.numeric(id) + 
        1L == seq_along(id))) == TRUE) {
        sr <- as.numeric(sr) + 1L
        tg <- as.numeric(tg) + 1L
    }
    pr <- vector()
    for (i in seq_len(length(sr))) pr[length(pr) + 1L] <- paste(sr[i], 
        tg[i], sep = ", ")
    z <- max(tabulate(factor(pr)))
    ledg <- length(grep("graphics", edg, fixed = TRUE, value = TRUE))
    nls <- nlevels(factor(edg[grep("style", edg, fixed = TRUE) + 
        1L]))
    nlf <- nlevels(factor(edg[grep("fill", edg, fixed = TRUE) + 
        1L]))
    st <- vector()
    if (isTRUE(ledg == 0) == FALSE) {
        for (i in 2:ledg) {
            tmp <- edg[(grep("graphics", edg, fixed = TRUE)[(i - 
                1)] + 2L):(grep("graphics", edg, fixed = TRUE)[i] - 
                7L)]
            if (isTRUE(nls > 1) == TRUE) {
                ifelse(isTRUE(length(tmp[grep("style", tmp, fixed = TRUE) + 
                  1L]) == 0) == FALSE, st[length(st) + 1L] <- tmp[grep("style", 
                  tmp, fixed = TRUE) + 1L], st[length(st) + 1L] <- "default")
            }
            else if (isTRUE(nlf > 1) == TRUE) {
                ifelse(isTRUE(length(tmp[grep("fill", tmp, fixed = TRUE) + 
                  1L]) == 0) == FALSE, st[length(st) + 1L] <- tmp[grep("fill", 
                  tmp, fixed = TRUE) + 1L], st[length(st) + 1L] <- "#000000")
            }
        }
        rm(i)
        tmp <- edg[utils::tail(grep("graphics", edg, fixed = TRUE), 
            1):length(edg)]
        if (isTRUE(nls > 1L) == TRUE) {
            ifelse(isTRUE(length(tmp[grep("style", tmp, fixed = TRUE) + 
                1L]) == 0) == FALSE, st[length(st) + 1L] <- tmp[grep("style", 
                tmp, fixed = TRUE) + 1L], st[length(st) + 1L] <- "default")
        }
        else if (isTRUE(nlf > 1) == TRUE) {
            ifelse(isTRUE(length(tmp[grep("fill", tmp, fixed = TRUE) + 
                1L]) == 0) == FALSE, st[length(st) + 1L] <- tmp[grep("fill", 
                tmp, fixed = TRUE) + 1L], st[length(st) + 1L] <- "#000000")
        }
        ndf <- cbind(sr, tg, st)
    }
    else {
        ndf <- cbind(sr, tg)
    }
    if (isTRUE(length(st) == 0L) == TRUE) {
        st <- rep("1", nrow(ndf))
        ifelse(isTRUE(z == 2L) == TRUE, st[which(duplicated(ndf))] <- "2", 
            NA)
        ndf <- cbind(ndf, st)
    }
    nlst <- nlevels(factor(st))
    if (match.arg(as) == "array") {
        if (isTRUE(z > 1L) == TRUE) {
            mat <- array(0L, dim = c(n, n, z))
            if (isTRUE(nlst > 1) == TRUE) {
                for (k in seq_len(nlst)) {
                  mdf <- subset(ndf, ndf[, 3] == levels(factor(st))[k])
                  pr <- vector()
                  for (i in seq_len(nrow(mdf))) {
                    if (isTRUE("0" %in% id) == FALSE) {
                      pr[length(pr) + 1L] <- paste(match(mdf[i, 
                        1], id), match(mdf[i, 2], id), sep = ", ")
                    }
                    else if (isTRUE("0" %in% id) == TRUE && isTRUE(all(as.numeric(id) + 
                      1L == seq_along(id))) == TRUE) {
                      pr[length(pr) + 1L] <- paste(match(as.numeric(mdf[i, 
                        1]), as.numeric(id) + 1L), match(as.numeric(mdf[i, 
                        2]), as.numeric(id) + 1L), sep = ", ")
                    }
                    else if (isTRUE("0" %in% id) == TRUE) {
                      pr[length(pr) + 1L] <- paste(match(as.numeric(mdf[i, 
                        1]), as.numeric(id)), match(as.numeric(mdf[i, 
                        2]), as.numeric(id)), sep = ", ")
                    }
                  }
                  rm(i)
                  mat[, , k] <- trnf(pr, tolist = FALSE, ord = n, 
                    lbs = c(1:n))
                }
                rm(k)
            }
        }
        if (isTRUE(ncol(ndf) == 2L) == TRUE | isTRUE(nlst == 
            1L) == TRUE) {
            mat <- array(0L, dim = c(n, n, 1))
            mat[, , 1] <- dichot(trnf(pr, tolist = FALSE, ord = n, 
                lbs = c(1:n)), c = 1L)
        }
        if (isTRUE(directed == FALSE) == TRUE) {
            for (i in seq_len(z)) {
                mat[, , i] <- (mat[, , i] + t(mat[, , i]))
            }
            rm(i)
        }
        dimnames(mat)[[1]] <- dimnames(mat)[[2]] <- lb
        if (isTRUE(coords == TRUE) == TRUE) {
            lst <- (out = coor(mat, cds))
            class(lst) <- c("gml")
            return(lst)
        }
        else {
            return(mat)
        }
    }
    else if (match.arg(as) == "edgel") {
        if (isTRUE("0" %in% id) == FALSE) {
            srt <- as.data.frame(cbind(lb[match(ndf[, 1], id)], 
                lb[match(ndf[, 2], id)]), stringsAsFactors = FALSE)
        }
        else if (isTRUE("0" %in% id) == TRUE && isTRUE(all(as.numeric(id) + 
            1L == seq_along(id))) == TRUE) {
            srt <- as.data.frame(cbind(lb[match(as.numeric(ndf[, 
                1]), as.numeric(id) + 1L)], lb[match(as.numeric(ndf[, 
                2]), as.numeric(id) + 1L)]), stringsAsFactors = FALSE)
        }
        else if (isTRUE("0" %in% id) == TRUE) {
            srt <- as.data.frame(cbind(lb[match(as.numeric(ndf[, 
                1]), as.numeric(id))], lb[match(as.numeric(ndf[, 
                2]), as.numeric(id))]), stringsAsFactors = FALSE)
        }
        if (isTRUE(all(lb %in% lb[as.numeric(unique(as.vector(ndf[, 
            1:2])))])) == FALSE) {
            isol <- lb[which(!(lb %in% unique(c(levels(lapply(srt, 
                factor)$V1), levels(lapply(srt, factor)$V2)))))]
            for (i in seq_len(length(isol))) {
                srt[nrow(srt) + 1L, ] <- c((isol[i]), (isol[i]))
            }
            rm(i)
        }
        else {
            NA
        }
        if (isTRUE(z > 1L) == TRUE | isTRUE(nlst > 1L) == TRUE) {
            DF <- as.data.frame(cbind(srt, data.frame(matrix(0L, 
                ncol = z, nrow = nrow(srt)))))
            for (k in seq_len(nlevels(factor(st)))) {
                DF[which(st == levels(factor(st))[k]), (k + 2L)] <- 1L
            }
            rm(k)
            ties <- vector()
            for (i in seq_len(z)) {
                ties <- append(ties, paste("t", i, sep = ""))
            }
            rm(i)
            colnames(DF) <- c("s", "r", ties)
        }
        else if (isTRUE(z == 1L) == TRUE) {
            DF <- as.data.frame(cbind(srt, rep(1, nrow(srt))), 
                row.names = NULL)
            colnames(DF) <- c("s", "r", "t")
        }
        if (isTRUE(directed == FALSE) == TRUE) {
            DF2 <- data.frame(DF[, 2], DF[, 1], DF[, 3:ncol(DF)])
            ifelse(isTRUE(z == 1L) == TRUE, colnames(DF2) <- c("s", 
                "r", "t"), colnames(DF2)[1:2] <- c("s", "r"))
            DF <- unique(as.data.frame(rbind(DF, DF2)))
        }
        else {
            NA
        }
        if (isTRUE(coords == TRUE) == TRUE) {
            lst <- (out = coor(DF, cds))
            class(lst) <- c("gml")
            return(lst)
        }
        else {
            return(DF)
        }
    }
    else {
        stop(paste("Argument ", sQuote("as"), " must be either ", 
            dQuote("array"), " or ", dQuote("edgel"), ".", sep = ""))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
write.dat <-
function (x, path) 
{
    if (is.na(dim(x)[3]) == FALSE) {
        ifelse(is.null(dimnames(x)[[3]]) == TRUE, lb <- 1:dim(x)[3], 
            lb <- dimnames(x)[[3]])
    }
    dir.create(path, showWarnings = FALSE)
    if (is.na(dim(x)[3]) == FALSE) {
        for (i in 1:dim(x)[3]) {
            filename <- sprintf(paste(substitute(x), "_", lb[i], 
                ".dat", sep = ""), i)
            pathname <- file.path(path, filename)
            obj <- x[, , i]
            utils::write.table(obj, file = pathname, row.names = FALSE, 
                col.names = FALSE)
        }
        rm(i)
    }
    else if (is.na(dim(x)[3]) == TRUE) {
        pathname <- file.path(path, paste(deparse(substitute(x)), 
            "dat", sep = "."))
        utils::write.table(x, file = pathname, row.names = FALSE, col.names = FALSE)
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
pacnet <-
function (file, toarray = FALSE, uniq = FALSE, transp = FALSE, 
    sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    arx <- scan(file, what = "character", nlines = -1, quiet = TRUE)
    if (isTRUE(length(grep("ALPHA", arx, fixed = TRUE)) == 0L) == 
        TRUE) {
        if (isTRUE(length(grep("ATOM", arx, fixed = TRUE)) == 
            0L) == TRUE) 
            stop("Input data does not have 'Generating and Induced Inclusions'")
    }
    ifelse(isTRUE(arx[1] == "FACTORIZATION") == TRUE, X <- arx[(utils::head(grep("Inclusions", 
        arx, fixed = TRUE), 1) + 1L):(utils::tail(grep("THERE", 
        arx, fixed = TRUE), 1) - 1L)], X <- arx[(utils::tail(grep("ALPHA", 
        arx, fixed = TRUE), 1) + 5L):(utils::tail(grep("THERE", 
        arx, fixed = TRUE), 1) - 1L)])
    x <- arx[utils::tail(grep("THERE", arx, fixed = TRUE), 1):length(arx)]
    v <- vector()
    for (i in seq_len(length(X))) {
        ifelse((isTRUE(as.logical(grep("(", X[i], fixed = TRUE))) == 
            FALSE & isTRUE(as.logical(grep(")", X[i], fixed = TRUE))) == 
            FALSE), v[length(v) + 1L] <- i, NA)
    }
    rm(i)
    m <- v[which(v%%2L == 0L)]
    n <- v[which(v%%2L != 0L)]
    n <- n[2:length(n)]
    rm(v)
    lt <- list()
    for (i in seq_len(length(m))) {
        if (is.na((n[i] - 1L)) == FALSE) 
            lt[[i]] <- X[(m[i] + 1):(n[i] - 1L)]
    }
    rm(i)
    rm(X)
    rm(n, m)
    ifelse(isTRUE(arx[1] == "FACTORIZATION") == TRUE, n <- as.numeric(arx[(utils::head(grep("Order", 
        arx, fixed = TRUE), 1) + 4L)]), n <- as.numeric(arx[(grep("(Semigroup", 
        arx, fixed = TRUE) - 1L)]))
    a <- grep("Inclusions:", x, fixed = TRUE)
    z <- grep("Atom", x, fixed = TRUE)
    lt2 <- list()
    for (i in seq_len(length(z))) {
        lt2[[i]] <- x[(a[i] + 1L):(z[i] - 1L)]
    }
    rm(i)
    for (i in seq_len(length(lt))) {
        lt[[i]] <- gsub("[[:punct:]]", "", lt[[i]])
    }
    rm(i)
    for (i in seq_len(length(lt2))) {
        lt2[[i]] <- gsub("[[:punct:]]", "", lt2[[i]])
    }
    rm(i)
    ii <- list()
    length(ii) <- length(lt)
    for (i in seq_len(length(lt))) {
        for (j in seq_len(length(lt[[i]])/2L)) {
            ii[[i]] <- append(ii[[i]], paste(lt[[i]][seq(1, length(lt[[i]]), 
                by = 2)[j]], lt[[i]][seq(2, length(lt[[i]]), 
                by = 2)[j]], sep = sep))
        }
        rm(j)
    }
    rm(i)
    ifelse(isTRUE(uniq == TRUE) == FALSE, NA, ii <- unique(ii))
    at <- list()
    length(at) <- length(lt2)
    for (i in seq_len(length(lt2))) {
        for (j in seq_len(length(lt2[[i]])/2L)) {
            at[[i]] <- append(at[[i]], paste(lt2[[i]][seq(1, 
                length(lt2[[i]]), by = 2)[j]], lt2[[i]][seq(2, 
                length(lt2[[i]]), by = 2)[j]], sep = sep))
        }
        rm(j)
    }
    rm(i)
    f <- utils::tail(grep("-|-", arx, fixed = TRUE), length(lt2))
    if (isTRUE(as.numeric(x[grep("-|-", x, fixed = TRUE)[1] - 
        1L]) != n) == TRUE) {
        g <- utils::tail(grep("-|-", x, fixed = TRUE))
        p <- as.numeric(x[grep("-|-", x, fixed = TRUE)[1] - 1L])
        q <- n - p
        arr1 <- array(NA, dim = c(n, p))
        arr2 <- array(NA, dim = c(n, q))
        for (i in seq_len(length(g))) {
            for (j in seq_len(n)) {
                if (isTRUE((i%%2L) == 1L) == TRUE) 
                  arr1[j, ] <- as.numeric(x[(g[i] + 3L + ((j - 
                    1) * p + ((j - 1) * 2L))):(g[i] + (j * p) + 
                    (j * 2L))])
            }
            rm(j)
            for (j in seq_len(n)) {
                if (isTRUE((i%%2L) == 0L) == TRUE) 
                  arr2[j, ] <- as.numeric(x[(g[i] + 3L + ((j - 
                    1) * q + ((j - 1) * 2L))):(g[i] + (j * q) + 
                    (j * 2L))])
            }
            rm(j)
            if (isTRUE((i%%2L) == 0L) == TRUE && isTRUE(i > 1) == 
                TRUE) {
                if (isTRUE(i == 2L) == TRUE) {
                  arr <- data.frame(arr1, arr2)
                }
                else if (isTRUE(i > 2) == TRUE) {
                  arr <- zbind(as.array(as.matrix(arr)), as.array(as.matrix(data.frame(arr1, 
                    arr2))))
                }
            }
        }
        rm(i)
    }
    else if (isTRUE(as.numeric(x[grep("-|-", x, fixed = TRUE)[1] - 
        1L]) == n) == TRUE) {
        arr <- array(NA, dim = c(n, n, length(f)))
        for (i in seq_len(length(f))) {
            for (j in seq_len(n)) {
                arr[j, , i] <- as.numeric(arx[(f[i] + 3L + ((j - 
                  1) * n + ((j - 1) * 2L))):(f[i] + (j * n) + 
                  (j * 2L))])
            }
            rm(j)
        }
        rm(i)
    }
    if (isTRUE(toarray == FALSE) == TRUE) {
        if (transp) {
            for (i in seq_len(length(ii))) {
                ii[[i]] <- swp(ii[[i]], sep = sep)
            }
            rm(i)
            for (i in seq_len(length(at))) {
                at[[i]] <- swp(at[[i]], sep = sep)
            }
            rm(i)
            tmp <- arr
            if (is.na(dim(arr)[3]) == FALSE) {
                for (i in seq_len(dim(arr)[3])) {
                  arr[, , i] <- t(tmp[, , i])
                }
                rm(i)
            }
            else if (is.na(dim(arr)[3]) == TRUE) {
                arr <- t(tmp)
            }
        }
    }
    if (toarray) {
        iiarrs <- array(dim = c(n, n, length(ii)), dimnames = list(seq_len(n), 
            seq_len(n), seq_len(length(ii))))
        for (i in seq_len(length(ii))) {
            ifelse(isTRUE(transp == TRUE) == TRUE, iiarrs[, , 
                i] <- trnf(t(ii[[i]]), tolist = FALSE, ord = n, 
                sep = sep), iiarrs[, , i] <- trnf(ii[[i]], tolist = FALSE, 
                ord = n, sep = sep))
        }
        rm(i)
        tmp <- data.frame(matrix(ncol = dim(iiarrs)[1] * dim(iiarrs)[2], 
            nrow = 0L))
        for (i in seq_len(dim(iiarrs)[3])) {
            tmp[i, ] <- as.vector(iiarrs[, , i])
        }
        rm(i)
        iiarr <- array(dim = c(n, n, nrow(unique(tmp))))
        for (i in seq_len(nrow(unique(tmp)))) {
            iiarr[, , i][seq_len(n * n)] <- as.numeric(unique(tmp)[i, 
                ])
        }
        rm(i)
        dimnames(iiarr)[[1]] <- dimnames(iiarr)[[2]] <- seq_len(n)
        rm(tmp)
        atarrs <- array(dim = c(n, n, length(at)), dimnames = list(seq_len(n), 
            seq_len(n), seq_len(length(at))))
        for (i in seq_len(length(at))) {
            ifelse(isTRUE(transp == TRUE) == TRUE, atarrs[, , 
                i] <- trnf(t(at[[i]]), tolist = FALSE, ord = n, 
                sep = sep), atarrs[, , i] <- trnf(at[[i]], tolist = FALSE, 
                ord = n, sep = sep))
        }
        rm(i)
        tmp <- data.frame(matrix(ncol = dim(atarrs)[1] * dim(atarrs)[2], 
            nrow = 0))
        for (i in seq_len(dim(atarrs)[3])) {
            tmp[i, ] <- as.vector(atarrs[, , i])
        }
        rm(i)
        atarr <- array(dim = c(n, n, nrow(unique(tmp))))
        for (i in seq_len(nrow(unique(tmp)))) {
            atarr[, , i][seq_len(n * n)] <- as.numeric(unique(tmp)[i, 
                ])
        }
        rm(i)
        dimnames(atarr)[[1]] <- dimnames(atarr)[[2]] <- seq_len(n)
        rm(tmp)
        if (transp) {
            tmp <- arr
            if (is.na(dim(arr)[3]) == FALSE) {
                for (i in seq_len(dim(arr)[3])) {
                  arr[, , i] <- t(tmp[, , i])
                }
                rm(i)
            }
            else if (is.na(dim(arr)[3]) == TRUE) {
                arr <- t(tmp)
            }
            tmp <- iiarr
            for (i in seq_len(dim(iiarr)[3])) {
                iiarr[, , i] <- t(tmp[, , i])
            }
            rm(i)
            tmp <- iiarrs
            for (i in seq_len(dim(iiarrs)[3])) {
                iiarrs[, , i] <- t(tmp[, , i])
            }
            rm(i)
            tmp <- atarr
            for (i in seq_len(dim(atarr)[3])) {
                atarr[, , i] <- t(tmp[, , i])
            }
            rm(i)
            tmp <- atarrs
            for (i in seq_len(dim(atarrs)[3])) {
                atarrs[, , i] <- t(tmp[, , i])
            }
            rm(i)
        }
    }
    dimnames(arr)[[1]] <- dimnames(arr)[[2]] <- seq_len(n)
    if (toarray) {
        ifelse(isTRUE(uniq == TRUE) == TRUE, lst <- list(ii = iiarr, 
            at = atarr, mc = arr), lst <- list(ii = iiarrs, at = atarrs, 
            mc = arr))
        class(lst) <- c("Pacnet", "toarray")
    }
    else {
        lst <- list(ii = ii, at = at, mc = arr)
        class(lst) <- "Pacnet"
    }
    if (uniq) 
        class(lst) <- append(class(lst), "uniq")
    if (transp) 
        class(lst) <- append(class(lst), "transp")
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
green.rel <-
function (x) 
{
    ifelse(isTRUE(tolower(class(x)[1]) != "semigroup") == TRUE, 
        S <- suppressWarnings(as.semigroup(x)), S <- x)
    oS <- S$S
    odim <- S$dim
    ogens <- S$gens
    Sclass <- class(S)[2]
    if (isTRUE(S$ord == 1L) == TRUE) {
        return(list(S = oS, dim = odim, gens = ogens, ord = S$ord, 
            st = S$st, clu = list(R = 1, L = 1), R = noquote(S$st), 
            L = noquote(S$st), D = oS))
    }
    else {
        if (isTRUE(Sclass == "numerical") == TRUE) {
            flgn <- TRUE
            S <- suppressWarnings(as.semigroup(S, numerical = FALSE))
        }
        else {
            flgn <- FALSE
        }
    }
    xs <- S$S
    st <- S$st
    rrel <- vector("list", length = nrow(xs))
    names(rrel) <- dimnames(xs)[[1]]
    for (i in seq_len(nrow(xs))) {
        rrel[[i]] <- as.character(sort(unique(as.vector(unlist(xs[i, 
            ])))))
    }
    rm(i)
    urrel <- unique(rrel)
    clur <- vector("list", length = length(urrel))
    names(clur) <- urrel
    for (i in seq_len(length(urrel))) {
        clur[[i]] <- which(rrel %in% list(urrel[[i]]))
    }
    rm(i)
    lrel <- vector("list", length = ncol(xs))
    names(lrel) <- dimnames(xs)[[2]]
    for (i in seq_len(ncol(xs))) {
        lrel[[i]] <- as.character(sort(unique(as.vector(unlist(xs[, 
            i])))))
    }
    rm(i)
    ulrel <- unique(lrel)
    clul <- vector("list", length = length(ulrel))
    names(clul) <- ulrel
    for (i in seq_len(length(ulrel))) {
        clul[[i]] <- which(lrel %in% list(ulrel[[i]]))
    }
    rm(i)
    xe <- xs[unlist(clur, use.names = FALSE), unlist(clul, use.names = FALSE)]
    lstr <- vector("list", length = length(clur))
    for (i in seq_len(length(lstr))) {
        lstr[[i]] <- xe[which(rownames(xe) %in% st[clur[[i]]]), 
            ]
    }
    rm(i)
    lstl <- vector("list", length = length(clul))
    for (i in seq_len(length(lstl))) {
        lstl[[i]] <- xe[, which(colnames(xe) %in% st[clul[[i]]])]
    }
    rm(i)
    lstrl <- vector("list", length = length(clur) * length(clul))
    k <- 1
    for (i in seq_len(length(lstr))) {
        for (j in seq_len(length(lstl))) {
            if (is.null(colnames(lstl[[j]])) == TRUE) {
                tmp <- lstr[[i]][which(colnames(lstr[[i]]) %in% 
                  st[clul[[j]]])]
                lstrl[[k]] <- tmp
            }
            else {
                tmp <- lstr[[i]][which(colnames(lstr[[i]]) %in% 
                  colnames(lstl[[j]]))]
                lstrl[[k]] <- tmp
            }
            k <- k + 1
        }
        rm(j)
    }
    rm(i)
    clurs <- clur
    for (i in seq_len(length(clur))) {
        clurs[[i]] <- c(st[clur[[i]]], "|")
    }
    rm(i)
    cluls <- clul
    for (i in seq_len(length(clul))) {
        cluls[[i]] <- c(st[clul[[i]]], "|")
    }
    rm(i)
    clr <- lapply(clur, length)
    cll <- lapply(clul, length)
    taqs <- which(seq_len(length(lstrl))%%length(lstl) == 1)
    tpqs <- which(seq_len(length(lstrl))%%length(lstl) == 0)
    xep <- data.frame(matrix(nrow = 0, ncol = (dim(xe)[2] + length(cll) - 
        1)))
    coln <- unlist(cluls, use.names = FALSE)
    colnames(xep) <- gsub("[|]", " ", coln)[seq_len(length(coln) - 
        1)]
    if (isTRUE(length(taqs) == 0) == TRUE) {
        xep <- xe
    }
    else {
        for (i in seq_len(length(taqs))) {
            temp <- lapply(lstrl[taqs[i]:tpqs[i]], function(z) {
                cbind(z, "|")
            })
            if (isTRUE(nrow(temp[[1]]) == 1) == TRUE) {
                utemp <- unlist(temp, use.names = FALSE)
                utemp[which(names(lapply(unlist(temp, recursive = FALSE), 
                  c)) == "\"|\"")] <- "|"
            }
            else {
                utemp <- Reduce(cbind, temp)
            }
            if (isTRUE(nrow(xep) == 0) == TRUE) {
                if (is.data.frame(utemp) == FALSE) {
                  xep[1:2, ] <- rbind(rep(" ", ncol(xep)), noquote(utemp[-length(utemp)]))
                  rownames(xep)[1:2] <- c("", coln[1])
                }
                else {
                  xep[seq_len(as.numeric(clr[1]) + 1), ] <- rbind(rep(" ", 
                    ncol(xep)), as.matrix(unname(utemp[-length(utemp)])))
                  rownames(xep)[seq_len(as.numeric(clr[1]) + 
                    1)] <- c("", rownames(xe)[seq_len(as.numeric(clr[1]))])
                }
            }
            else {
                if (is.vector(utemp) == TRUE) {
                  xep <- rbind(xep, utemp[-length(utemp)])
                  rownames(xep)[nrow(xep)] <- rownames(temp[[1]])
                }
                else {
                  if (is.data.frame(unname(utemp[-length(utemp)])) == 
                    FALSE) {
                    xep <- noquote(rbind(as.matrix(xep), as.vector(unname(utemp[-length(utemp)]))))
                    rownames(xep)[nrow(xep)] <- clurs[[i]][-length(clurs[[i]])]
                  }
                  else {
                    xep <- noquote(rbind(as.matrix(xep), as.matrix(unname(utemp[-length(utemp)]))))
                  }
                }
            }
            ifelse(isTRUE(i == length(taqs)) == TRUE, NA, xep <- rbind(as.matrix(xep), 
                rep("-", ncol(xep))))
        }
        rm(i)
    }
    clrs <- vector(length = S$ord)
    for (i in seq_len(length(clurs))) clrs[which(st %in% clurs[[i]])] <- i
    clls <- vector(length = S$ord)
    for (i in seq_len(length(cluls))) clls[which(st %in% cluls[[i]])] <- i
    rcls <- unlist(clurs, use.names = FALSE)[-length(unlist(clurs))]
    lcls <- unlist(cluls, use.names = FALSE)[-length(unlist(cluls))]
    if (isTRUE(flgn == TRUE) == TRUE) {
        for (k in seq_len(S$ord)) {
            xep[xep == st[k]] <- k
            colnames(xep)[which(colnames(xep) == st[k])] <- k
            rownames(xep)[which(rownames(xep) == st[k])] <- k
            rcls[which(rcls == st[k])] <- k
            lcls[which(lcls == st[k])] <- k
        }
        rm(k)
    }
    else {
        NA
    }
    lst <- list(S = oS, gens = ogens, dim = odim, ord = S$ord, 
        st = st, clu = list(R = clrs, L = clls), R = noquote(rcls), 
        L = noquote(lcls), D = noquote(xep))
    class(lst) <- c("Semigroup", Sclass, "Green.Rels")
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
strings <-
function (x, equat = FALSE, k = 2, smpl, valued) 
{
    if (is.array(x) == FALSE) 
        stop("Data must be a stacked array of square matrices.")
    if (k > 4) 
        warning("Only equations until k = 4 will be considered.", 
            call. = FALSE)
    ifelse(missing(valued) == FALSE && isTRUE(valued == TRUE) == 
        TRUE, valued <- TRUE, valued <- FALSE)
    ifelse(missing(smpl) == FALSE && isTRUE(smpl == TRUE) == 
        TRUE, smpl <- TRUE, smpl <- FALSE)
    if (is.na(dim(x)[3]) == TRUE) 
        stop("Labels in array are needed.")
    if (isTRUE(any(duplicated(dimnames(x)[[3]]))) == TRUE) 
        stop("Duplicated labels found in the input data")
    if (is.null(dimnames(x)[[3]]) == TRUE) 
        dimnames(x)[[3]] <- seq_len(dim(x)[3])
    if (smpl == TRUE | equat == TRUE) {
        ifelse(is.null(dimnames(x)[[3]]) == FALSE, lbs <- dimnames(x)[[3]], 
            lbs <- seq_len(dim(x)[3]))
        if (is.null(dimnames(x)[[3]]) == FALSE) {
            nlb <- list()
            for (i in seq_len(length(lbs))) {
                nlb[i] <- lbs[i]
            }
            rm(i)
            for (i in seq_len(length(nlb))) {
                lbs[i] <- (strsplit(nlb[[i]], "")[[1]][1])
            }
            dimnames(x)[[3]] <- lbs
        }
    }
    if (isTRUE(valued == TRUE) == FALSE) {
        xo <- x
        x <- dichot(x, c = 1L)
        gener <- dimnames(x)[[3]]
        if (is.na(dim(x)[3]) == TRUE) {
            s0 <- data.frame(matrix(ncol = 1L, nrow = 1L))
            if (isTRUE(all.equal(replace(x %*% x, x %*% x >= 
                1L, 1L), x) == TRUE)) 
                s0[1, 1] <- 1L
            Bx <- array(dim = c(dim(x)[1], dim(x)[2], 2))
            Bx[, , 1] <- as.matrix(x)
            Bx[, , 2] <- replace(x %*% x, x %*% x >= 1L, 1L)
        }
        if (is.na(dim(x)[3]) == FALSE) {
            tmpo <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
                nrow = 0L))
            for (i in seq_len(dim(x)[3])) {
                ifelse(isTRUE(dim(x)[3] > 1L) == TRUE, tmpo[i, 
                  ] <- as.vector(x[, , i]), tmpo <- as.vector(x))
            }
            rm(i)
            if (isTRUE(is.character(dimnames(x)[[3]]) == TRUE) == 
                TRUE) 
                dimnames(x)[[3]][which(duplicated(dimnames(x)[[3]]))] <- seq_len(length(which(duplicated(dimnames(x)[[3]]))))
            if (isTRUE(is.null(dim(tmpo)) == FALSE) == TRUE) 
                rownames(tmpo) <- dimnames(x)[[3]]
            tmpu <- unique(tmpo)
            dpl <- duplicated(tmpo)
            if (isTRUE(nrow(tmpo) != nrow(tmpu)) == TRUE) {
                if (isTRUE((nrow(tmpo) - nrow(tmpu)) == 1L) == 
                  TRUE) {
                  warning("There is 1 repeated generator that has been equated.", 
                    call. = FALSE)
                }
                else {
                  warning(paste("There are ", nrow(tmpo) - nrow(tmpu), 
                    " repeated generators that have been equated in ", 
                    sQuote("x"), ".", sep = ""), call. = FALSE)
                }
            }
            if (isTRUE(dim(x)[3] < 2L) == TRUE) 
                x <- array(tmpo, c(dim(x)[1], dim(x)[2]))
            if (isTRUE(dim(x)[3] > 1L) == TRUE) {
                tmp <- array(dim = c(dim(x)[1], dim(x)[2], nrow(tmpu)))
                for (i in seq_len(nrow(tmpu))) {
                  tmp[, , i][seq_len((dim(x)[1] * dim(x)[2]))] <- as.numeric(tmpu[i, 
                    ])
                }
                rm(i)
                if (is.null(dimnames(tmp)[[1]]) == FALSE) 
                  dimnames(tmp)[[3]] <- rownames(tmpu)
                if (is.null(dimnames(x)[[1]]) == FALSE) 
                  dimnames(tmp)[[1]] <- dimnames(tmp)[[2]] <- dimnames(x)[[1]]
                x <- tmp
                dimnames(x)[[3]] <- as.list(rownames(tmpu))
            }
            rm(tmp)
            s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(x)[3]))
            for (q in seq_len(dim(x)[3])) {
                for (j in seq_len(dim(x)[3])) {
                  tmp <- x[, , j] %*% x[, , q]
                  tmp <- replace(tmp, tmp >= 1L, 1L)
                  for (i in dim(x)[3]:1) {
                    if (isTRUE(all.equal(tmp, x[, , i]) == TRUE)) 
                      s0[j, q] <- i
                  }
                }
            }
            rm(i, j, q)
            dimnames(s0)[[1]] <- seq_len(dim(x)[3])
            dimnames(s0)[[2]] <- seq_len(dim(x)[3])
            if (sum(as.numeric(is.na(s0))) == 0L) 
                Bx <- x
            if (sum(as.numeric(is.na(s0))) > 0L) {
                Bx <- array(dim = c(dim(x)[1], dim(x)[2], 0L))
                for (i in seq_len(nrow(s0))) {
                  for (j in seq_len(length(which(is.na(s0[i, 
                    ]))))) {
                    if (length(which(is.na(s0[i, ]))) > 0L) 
                      Bx <- zbnd(Bx, (replace(x[, , i] %*% x[, 
                        , which(is.na(s0[i, ]))[j]], x[, , i] %*% 
                        x[, , which(is.na(s0[i, ]))[j]] >= 1L, 
                        1L)))
                  }
                }
                rm(i, j)
                tmp <- data.frame(matrix(ncol = (dim(x)[1] * 
                  dim(x)[2]), nrow = 0L))
                for (i in seq_len(dim(Bx)[3])) {
                  tmp[i, ] <- as.vector(Bx[, , i])
                }
                rm(i)
                xBx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
                for (i in seq_len(nrow(unique(tmp)))) {
                  xBx[, , i][seq_len((dim(Bx)[1] * dim(Bx)[2]))] <- as.numeric(unique(tmp)[i, 
                    ])
                }
                rm(i)
                if (is.null(dimnames(xBx)) == FALSE) 
                  dimnames(xBx)[[3]] <- (dim(x)[3] + 1L):(dim(xBx)[3] + 
                    dim(x)[3])
                Bx <- zbnd(x, xBx)
                rm(xBx, tmp)
            }
        }
        while (any(is.na(s0)) == TRUE) {
            BBx <- Bx
            for (i in seq_len(nrow(s0))) {
                for (j in seq_len(length(which(is.na(s0[i, ]))))) {
                  if (length(which(is.na(s0[i, ]))) > 0L) 
                    BBx <- zbnd(BBx, (replace(Bx[, , i] %*% Bx[, 
                      , which(is.na(s0[i, ]))[j]], Bx[, , i] %*% 
                      Bx[, , which(is.na(s0[i, ]))[j]] >= 1L, 
                      1L)))
                }
            }
            rm(i, j)
            tmp <- data.frame(matrix(ncol = (dim(Bx)[1] * dim(Bx)[2]), 
                nrow = 0L))
            for (i in seq_len(dim(BBx)[3])) {
                tmp[i, ] <- as.vector(BBx[, , i])
            }
            rm(i)
            Bx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
            for (i in seq_len(nrow(unique(tmp)))) {
                Bx[, , i][seq_len(dim(BBx)[1] * dim(BBx)[2])] <- as.numeric(unique(tmp)[i, 
                  ])
            }
            rm(i)
            rm(tmp, BBx)
            if (is.na(dim(x)[3]) == TRUE) {
                s0 <- data.frame(matrix(ncol = 1L, nrow = dim(Bx)[3]))
                for (j in seq_len(dim(Bx)[3])) {
                  tmp <- Bx[, , j] %*% Bx[, , 1]
                  tmp <- replace(tmp, tmp >= 1L, 1L)
                  for (i in dim(Bx)[3]:1) {
                    if (isTRUE(all.equal(tmp, Bx[, , i]) == TRUE)) 
                      s0[j, 1] <- i
                  }
                }
                rm(i, j)
            }
            if (is.na(dim(x)[3]) == FALSE) {
                s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(Bx)[3]))
                for (q in seq_len(dim(x)[3])) {
                  for (j in seq_len(dim(Bx)[3])) {
                    tmp <- Bx[, , j] %*% Bx[, , q]
                    tmp <- replace(tmp, tmp >= 1L, 1L)
                    for (i in dim(Bx)[3]:1) {
                      if (isTRUE(all.equal(tmp, Bx[, , i]) == 
                        TRUE)) 
                        s0[j, q] <- i
                    }
                  }
                }
                rm(i, j, q)
            }
        }
        ifelse(isTRUE(is.na(dim(x)[3])) == TRUE, dimnames(s0)[[2]] <- 1L, 
            dimnames(s0)[[2]] <- seq_len(dim(x)[3]))
        tmpO <- data.frame(matrix(ncol = (dim(Bx)[1] * dim(Bx)[2]), 
            nrow = 0L))
        for (i in seq_len(dim(Bx)[3])) {
            tmpO[i, ] <- as.vector(Bx[, , i])
        }
        rm(i)
        rownames(tmpO) <- dimnames(Bx)[[3]]
        tmpU <- unique(tmpO)
        tmp <- array(dim = c(dim(Bx)[1], dim(Bx)[2], nrow(tmpU)))
        for (i in seq_len(nrow(tmpU))) {
            tmp[, , i][seq_len((dim(Bx)[1] * dim(Bx)[2]))] <- as.numeric(tmpU[i, 
                ])
        }
        rm(i)
        Bx <- tmp
        dimnames(Bx)[[3]] <- as.list(rownames(tmpU))
        E <- s0
        rm(s0)
        if (dim(Bx)[3] == ncol(E)) {
            W <- rbind(cbind(1:ncol(E), NA, NA))
            colnames(W) <- c("", "n", "g")
        }
        if (dim(Bx)[3] > ncol(E)) {
            tmp <- (ncol(E) + 1L):dim(Bx)[3]
            z <- vector()
            for (i in seq_len(length(tmp))) {
                z[i] <- which(t(E) == tmp[i])[1]
            }
            rm(i)
            g <- vector()
            for (i in seq_len(length(tmp))) {
                ifelse(z[i]%%ncol(E) == 0L, g[i] <- ncol(E), 
                  g[i] <- z[i]%%ncol(E))
            }
            rm(i)
            n <- vector()
            for (i in seq_len(length(tmp))) {
                ifelse(z[i]%%ncol(E) == 0L, n[i] <- (z[i]%/%ncol(E)), 
                  n[i] <- ((z[i]%/%ncol(E)) + 1L))
            }
            rm(i)
            W <- rbind(cbind(1:ncol(E), NA, NA), cbind(((ncol(E) + 
                1L):nrow(E)), n, g))
            rm(z, n, g)
        }
        rm(tmp)
        if (is.na(dim(x)[3]) == TRUE) {
            ifelse(is.null(dimnames(Bx)[[3]]) == TRUE, lbl <- seq_len(dim(Bx)[3]), 
                lbl <- dimnames(Bx)[[3]])
        }
        if (is.na(dim(x)[3]) == FALSE) {
            if (is.null(dimnames(x)[[3]]) == TRUE) 
                lbl <- seq_len(dim(Bx)[3])
            if (is.null(dimnames(x)[[3]]) == FALSE) {
                if (isTRUE(dim(Bx)[3] == dim(x)[3]) == TRUE) 
                  lbl <- dimnames(x)[[3]]
                if (isTRUE(dim(Bx)[3] < dim(x)[3]) == TRUE) 
                  lbl <- rownames(tmpO)
                if (isTRUE(dim(Bx)[3] > dim(x)[3]) == TRUE) 
                  lbl <- c(dimnames(x)[[3]], (dim(x)[3] + 1L):dim(Bx)[3])
            }
            dimnames(Bx)[[3]] <- lbl
            for (i in which(W[, 2] < (ncol(E) + 1L))) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[, 2][i]], 
                  dimnames(Bx)[[3]][W[, 3][i]], sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] > ncol(E))[1]))[(length(which(W[, 
                2] < (ncol(E) + 1L))) + 1L):length(which(W[, 
                2] < (which(W[, 2] > ncol(E))[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[, 2][i], 
                  ][2]], dimnames(Bx)[[3]][W[W[, 2][i], ][3]], 
                  dimnames(Bx)[[3]][W[, 3][i]], sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] > ncol(E)))[1])[1]))[(length(which(W[, 2] < 
                (which(W[, 2] > ncol(E))[1]))) + 1L):length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] > ncol(E)))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2]], dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                  2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1])))[1])[1]))[(length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] > ncol(E)))[1])[1]))) + 
                1L):length(which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1])))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2]], dimnames(Bx)[[3]][W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                  2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] > ncol(E))[1]))[1])))[1])[1]))[(length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] > ncol(E))[1])))[1])[1]))) + 1L):length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1]))[1])))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2]], dimnames(Bx)[[3]][W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                  2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] > ncol(E))[1]))[1]))[1])))[1])[1]))[(length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1]))[1])))[1])[1]))) + 
                1L):length(which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] > ncol(E))[1]))[1]))[1])))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2]], 
                  dimnames(Bx)[[3]][W[W[W[W[W[W[W[, 2][i], ], 
                    ][1, ][2], ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[, 
                    2][i], ], ][1, ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[, 
                    2][i], ], ][1, ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[, 
                    2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                    2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1]))[1]))[1]))[1])))[1])[1]))[(length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] > ncol(E))[1]))[1]))[1])))[1])[1]))) + 
                1L):length(which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] > ncol(E))[1]))[1]))[1]))[1])))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2], 
                  ][2]], dimnames(Bx)[[3]][W[W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2], 
                  ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[W[, 2][i], 
                  ], ][1, ][2], ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                  2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            for (i in which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] > ncol(E))[1]))[1]))[1]))[1]))[1])))[1])[1]))[(length(which(W[, 
                2] < (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] > ncol(E))[1]))[1]))[1]))[1])))[1])[1]))) + 
                1):length(which(W[, 2] < (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] >= (which(W[, 
                2] >= (which(W[, 2] >= (which(W[, 2] > ncol(E))[1]))[1]))[1]))[1]))[1])))[1])[1])))]) {
                lbl[(i)] <- paste(dimnames(Bx)[[3]][W[W[W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2], 
                  ][2], ][2]], dimnames(Bx)[[3]][W[W[W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2], 
                  ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][2], ][2], 
                  ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[W[, 2][i], 
                  ], ][1, ][2], ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[W[, 
                  2][i], ], ][1, ][2], ][2], ][3]], dimnames(Bx)[[3]][W[W[W[W[, 
                  2][i], ], ][1, ][2], ][3]], dimnames(Bx)[[3]][W[W[, 
                  2][i], ][3]], dimnames(Bx)[[3]][W[, 3][i]], 
                  sep = "")
            }
            rm(i)
            dimnames(Bx)[[3]] <- lbl
        }
        if (is.null(dimnames(x)[[1]]) == FALSE) 
            dimnames(Bx)[[1]] <- dimnames(Bx)[[2]] <- dimnames(x)[[1]]
        if (equat == TRUE) {
            gn <- lbl
            w <- Bx
            luq <- vector(mode = "list", length = length(lbl))
            names(luq) <- lbl
            lid <- vector(mode = "list", length = 1)
            lid[[1]] <- names(lid) <- "e"
            mte <- matrix(0, nrow = dim(x)[1], ncol = dim(x)[2])
            diag(mte) <- 1L
            vce <- as.vector(mte)
            if (isTRUE(dim(w)[3] < 2) == TRUE) {
                lst0 <- list(wt = Bx, ord = dim(Bx)[3], st = lbl, 
                  equat = as.character(seq_len(dim(xo)[3])))
                class(lst0) <- "Strings"
                return(lst0)
            }
            else {
                NA
            }
            unq <- data.frame(matrix(ncol = (dim(w)[1] * dim(w)[2]), 
                nrow = 0))
            for (i in seq_len(dim(w)[3])) {
                ifelse(isTRUE(dim(w)[3] > 1) == TRUE, unq[i, 
                  ] <- as.vector(w[, , i]), unq <- as.vector(w))
            }
            rm(i)
            rownames(unq) <- lbl
            if (isTRUE(TRUE %in% dpl) == TRUE) {
                eq <- vector(mode = "list", length = nrow(unique(tmpo)))
                names(eq) <- rownames(unique(tmpo))
                rownames(tmpo) <- gener
                for (i in which(duplicated(tmpo))) {
                  for (j in which(!(duplicated(tmpo)))) {
                    if (isTRUE(all(tmpo[i, ] == tmpo[j, ]) == 
                      TRUE)) {
                      eq[[which(attr(eq, "names") == rownames(tmpo[j, 
                        ]))]] <- append(eq[[which(attr(eq, "names") == 
                        rownames(tmpo[j, ]))]], rownames(tmpo)[i])
                    }
                  }
                  rm(j)
                }
                rm(i)
                for (i in seq_len(length(eq))) {
                  if (isTRUE(is.null(eq[[i]])) == FALSE) {
                    luq[[which(names(eq)[i] == names(luq))]] <- append(luq[[which(names(eq)[i] == 
                      names(luq))]], eq[[i]])
                  }
                  else {
                    NA
                  }
                }
                rm(i)
            }
            for (j in seq_len(nrow(unq))) {
                if (all(vce == unq[j, ]) == TRUE) {
                  lid[[1]] <- append(lid[[1]], rownames(unq)[j])
                  break
                }
            }
            rm(j)
            if (k > 1L) {
                if (length(gn) > 1L) {
                  eq2 <- vector()
                  for (i in seq_len(length(gn))) {
                    eq2 <- append(eq2, paste(gn[i], gn[i], sep = ""))
                  }
                  rm(i)
                  db <- eq2
                  for (i in seq_len(ncol(utils::combn(gn, 2)))) {
                    if (!(paste(utils::combn(gn, 2)[, i][1], 
                      utils::combn(gn, 2)[, i][2], sep = "") %in% 
                      lbl)) 
                      eq2 <- append(eq2, paste(utils::combn(gn, 
                        2)[, i][1], utils::combn(gn, 2)[, i][2], 
                        sep = ""))
                    if (!(paste(utils::combn(gn, 2)[, i][2], 
                      utils::combn(gn, 2)[, i][1], sep = "") %in% 
                      lbl)) 
                      eq2 <- append(eq2, paste(utils::combn(gn, 
                        2)[, i][2], utils::combn(gn, 2)[, i][1], 
                        sep = ""))
                  }
                  rm(i)
                  eq2 <- unique(eq2)
                  if (length(eq2) != 0L) {
                    dbl <- data.frame(matrix(ncol = (dim(w)[1] * 
                      dim(w)[2]), nrow = 0L))
                    for (i in seq_len(length(eq2))) {
                      dbl[(nrow(dbl) + 1), ] <- as.vector(dichot(x[, 
                        , which(dimnames(x)[[3]] == strsplit(eq2[i], 
                          "")[[1]][1])] %*% x[, , which(dimnames(x)[[3]] == 
                        strsplit(eq2[i], "")[[1]][2])]))
                    }
                    rm(i)
                    rownames(dbl) <- eq2
                    for (j in 2:nrow(dbl)) {
                      if (all(vce == dbl[j, ]) == TRUE) {
                        lid[[1]] <- append(lid[[1]], rownames(dbl)[j])
                        break
                      }
                    }
                    rm(j)
                    for (i in seq_len(nrow(dbl))) {
                      if (isTRUE(eq2[i] %in% rownames(unq)) == 
                        FALSE) {
                        luq[[which(duplicated(rbind(dbl[i, ], 
                          unq))) - 1L]] <- append(luq[[which(duplicated(rbind(dbl[i, 
                          ], unq))) - 1L]], eq2[i])
                      }
                    }
                    rm(i)
                  }
                }
            }
            if (k > 2L) {
                eq3 <- vector()
                for (i in seq_len(length(gn))) {
                  eq3 <- append(eq3, paste(db, gn[i], sep = ""))
                  eq3 <- append(eq3, paste(gn[i], db, sep = ""))
                }
                rm(i)
                for (i in seq_len(length(gn))) {
                  for (j in seq_len(length(gn))) {
                    eq3 <- append(eq3, paste(strsplit(db[j], 
                      "")[[1]][1], gn[i], strsplit(db[j], "")[[1]][2], 
                      sep = ""))
                  }
                  rm(j)
                }
                rm(i)
                tp <- eq3
                if (length(gn) > 2) {
                  for (i in seq_len(ncol(utils::combn(gn, 3)))) {
                    if (!(paste(utils::combn(gn, 3)[, i][1], 
                      utils::combn(gn, 3)[, i][2], utils::combn(gn, 
                        3)[, i][3], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][1], utils::combn(gn, 3)[, i][2], 
                        utils::combn(gn, 3)[, i][3], sep = ""))
                    if (!(paste(utils::combn(gn, 3)[, i][1], 
                      utils::combn(gn, 3)[, i][3], utils::combn(gn, 
                        3)[, i][2], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][1], utils::combn(gn, 3)[, i][3], 
                        utils::combn(gn, 3)[, i][2], sep = ""))
                    if (!(paste(utils::combn(gn, 3)[, i][2], 
                      utils::combn(gn, 3)[, i][1], utils::combn(gn, 
                        3)[, i][3], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][2], utils::combn(gn, 3)[, i][1], 
                        utils::combn(gn, 3)[, i][3], sep = ""))
                    if (!(paste(utils::combn(gn, 3)[, i][2], 
                      utils::combn(gn, 3)[, i][3], utils::combn(gn, 
                        3)[, i][1], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][2], utils::combn(gn, 3)[, i][3], 
                        utils::combn(gn, 3)[, i][1], sep = ""))
                    if (!(paste(utils::combn(gn, 3)[, i][3], 
                      utils::combn(gn, 3)[, i][1], utils::combn(gn, 
                        3)[, i][2], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][3], utils::combn(gn, 3)[, i][1], 
                        utils::combn(gn, 3)[, i][2], sep = ""))
                    if (!(paste(utils::combn(gn, 3)[, i][3], 
                      utils::combn(gn, 3)[, i][2], utils::combn(gn, 
                        3)[, i][1], sep = "") %in% lbl)) 
                      eq3 <- append(eq3, paste(utils::combn(gn, 
                        3)[, i][3], utils::combn(gn, 3)[, i][2], 
                        utils::combn(gn, 3)[, i][1], sep = ""))
                  }
                  rm(i)
                }
                eq3 <- unique(eq3)
                if (length(eq3) != 0L) {
                  tpl <- data.frame(matrix(ncol = (dim(w)[1] * 
                    dim(w)[2]), nrow = 0L))
                  for (i in seq_len(length(eq3))) {
                    tpl[(nrow(tpl) + 1L), ] <- as.vector(dichot(x[, 
                      , which(dimnames(x)[[3]] == strsplit(eq3[i], 
                        "")[[1]][1])] %*% x[, , which(dimnames(x)[[3]] == 
                      strsplit(eq3[i], "")[[1]][2])] %*% x[, 
                      , which(dimnames(x)[[3]] == strsplit(eq3[i], 
                        "")[[1]][3])]))
                  }
                  rm(i)
                  rownames(tpl) <- eq3
                  for (j in seq_len(nrow(tpl))) {
                    if (all(vce == tpl[j, ]) == TRUE) {
                      lid[[1]] <- append(lid[[1]], rownames(tpl)[j])
                      break
                    }
                  }
                  rm(j)
                  for (i in seq_len(nrow(tpl))) {
                    if (isTRUE(eq3[i] %in% rownames(unq)) == 
                      FALSE) {
                      luq[[which(duplicated(rbind(tpl[i, ], unq))) - 
                        1L]] <- append(luq[[which(duplicated(rbind(tpl[i, 
                        ], unq))) - 1L]], eq3[i])
                    }
                  }
                  rm(i)
                }
            }
            rm(w)
            if (k > 3L) {
                eq4 <- vector()
                for (i in seq_len(length(gn))) {
                  eq4 <- append(eq4, paste(tp, gn[i], sep = ""))
                  eq4 <- append(eq4, paste(gn[i], tp, sep = ""))
                }
                rm(i)
                ct <- eq4
                for (i in seq_len(length(gn))) {
                  for (j in seq_len(length(gn))) {
                    eq4 <- append(eq4, paste(strsplit(tp[j], 
                      "")[[1]][1], gn[i], strsplit(tp[j], "")[[1]][2], 
                      strsplit(tp[j], "")[[1]][3], sep = ""))
                    eq4 <- append(eq4, paste(strsplit(tp[j], 
                      "")[[1]][1], strsplit(tp[j], "")[[1]][2], 
                      gn[i], strsplit(tp[j], "")[[1]][3], sep = ""))
                    eq4 <- append(eq4, paste(strsplit(tp[j], 
                      "")[[1]][1], strsplit(tp[j], "")[[1]][2], 
                      strsplit(tp[j], "")[[1]][3], gn[i], sep = ""))
                  }
                  rm(j)
                }
                rm(i)
                for (i in seq_along(lbl)) {
                  ifelse(isTRUE(length(dhc(lbl[i], sep = "")) == 
                    2) == TRUE, eq4 <- append(eq4, paste(lbl[i], 
                    lbl[i], sep = "")), NA)
                }
                rm(i)
                if (length(gn) > 3) {
                  warning("Just generators up to three letters are supported.", 
                    call. = FALSE)
                }
                else {
                  NA
                }
                eq4 <- unique(eq4)
                if (length(eq4) != 0L) {
                  ctl <- data.frame(matrix(ncol = (dim(x)[1] * 
                    dim(x)[2]), nrow = 0L))
                  for (i in seq_len(length(eq4))) {
                    ctl[(nrow(ctl) + 1L), ] <- as.vector(dichot(x[, 
                      , which(gn == strsplit(eq4[i], "")[[1]][1])] %*% 
                      x[, , which(gn == strsplit(eq4[i], "")[[1]][2])] %*% 
                      x[, , which(gn == strsplit(eq4[i], "")[[1]][3])] %*% 
                      x[, , which(gn == strsplit(eq4[i], "")[[1]][4])]))
                  }
                  rm(i)
                  rownames(ctl) <- eq4
                  for (i in seq_len(nrow(ctl))) {
                    if (isTRUE(eq4[i] %in% rownames(unq)) == 
                      FALSE) {
                      flg <- TRUE
                      for (j in seq_len(nrow(unq))) {
                        if (all(ctl[i, ] == unq[j, ]) == TRUE) {
                          luq[[j]] <- append(luq[[j]], eq4[i])
                          flg <- FALSE
                          break
                        }
                      }
                      rm(j)
                      if (all(ctl[i, ] == vce) == TRUE) {
                        ifelse(isTRUE(flg == TRUE) == TRUE, lid[[1]] <- append(lid[[1]], 
                          rownames(ctl)[i]), lid[[1]] <- append(lid[[1]], 
                          eq4[i]))
                      }
                      else {
                        ifelse(isTRUE(flg == FALSE) == TRUE, 
                          luq[[which(duplicated(rbind(ctl[i, 
                            ], unq))) - 1L]] <- append(luq[[which(duplicated(rbind(ctl[i, 
                            ], unq))) - 1L]], eq4[i]), NA)
                      }
                    }
                  }
                  rm(i)
                }
            }
            lqu <- list()
            lqlb <- vector()
            for (i in seq_len(length(luq))) {
                if (isTRUE(is.null(luq[[i]])) == FALSE) {
                  lqu[[length(lqu) + 1]] <- luq[[i]]
                  lqlb[length(lqlb) + 1] <- attr(luq, "names")[i]
                }
            }
            rm(i)
            names(lqu) <- lqlb
            if (length(lqu) != 0L) {
                for (i in seq_len(length(lqu))) {
                  lqu[[i]] <- c(attr(lqu, "names")[i], lqu[[i]])
                  lqu[[i]] <- unique(lqu[[i]])
                }
                rm(i)
            }
            else if (length(lqu) == 0L) {
                lqu <- paste("No equations were produced in words with length", 
                  k, "or less", sep = " ")
            }
        }
        if (equat == TRUE) {
            lid[[1]] <- unique(lid[[1]])
            if (isTRUE(length(lid[[1]]) > 1) == TRUE) {
                lst <- list(wt = Bx, ord = dim(Bx)[3], st = lbl, 
                  equat = lqu, equate = lid)
            }
            else {
                lst <- list(wt = Bx, ord = dim(Bx)[3], st = lbl, 
                  equat = lqu)
            }
        }
        else if (equat != TRUE) {
            lst <- list(wt = Bx, ord = dim(Bx)[3], st = lbl)
        }
        class(lst) <- "Strings"
        return(lst)
    }
    else {
        Sx <- mxmn(x, type = "numerical", cmps = TRUE, equat = equat)
        if (equat == TRUE) {
            lst <- list(wt = zbind(Sx$gens, Sx$cmps), ord = Sx$ord, 
                st = Sx$st, equat = Sx$equat)
        }
        else {
            lst <- list(wt = zbind(Sx$gens, Sx$cmps), ord = Sx$ord, 
                st = Sx$st)
        }
        class(lst) <- c("Strings", "valued")
        return(lst)
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
read.dl <-
function (file) 
{
    arx <- scan(file, what = "character", nlines = -1, quiet = TRUE)
    if (isTRUE(arx[1] == "DL") == FALSE) 
        stop(paste("Input file must have a ", sQuote("DL"), " format.", 
            sep = ""))
    if (any(arx == "FULLMATRIX") == FALSE) 
        warning(paste("Support for a ", sQuote("FULLMATRIX"), 
            " format only.", sep = ""), call. = FALSE)
    tip <- dhc(arx[2:3], sep = "=")
    if (isTRUE(tip[1] == "N") == TRUE) {
        if (any(tip == "NM") == TRUE) {
            arr <- array(NA, dim = c(as.numeric(rep(tip[2], 2)), 
                as.numeric(tip[4])))
            if (isTRUE(length(which(arx == "ROW")) > 0) == TRUE) {
                dimnames(arr)[[1]] <- arx[(which(arx == "ROW")[1] + 
                  2L):(which(arx == "ROW")[1] + 1L + dim(arr)[1])]
            }
            else {
                NA
            }
            if (isTRUE(length(which(arx == "COLUMN")) > 0) == 
                TRUE) {
                dimnames(arr)[[2]] <- arx[(which(arx == "COLUMN")[1] + 
                  2L):(which(arx == "COLUMN")[1] + 1L + dim(arr)[2])]
            }
            else {
                NA
            }
            if (isTRUE(length(which(arx == "ROW")) > 0) == TRUE && 
                isTRUE(length(which(arx == "COLUMN")) > 0) == 
                  TRUE) {
                dimnames(arr)[[3]] <- arx[(which(arx == "LABELS:")[3] + 
                  1L):(which(arx == "LABELS:")[3] + dim(arr)[3])]
            }
            else {
                dimnames(arr)[[3]] <- arx[(which(arx == "LABELS:")[1] + 
                  1L):(which(arx == "LABELS:")[1] + dim(arr)[3])]
            }
            lnch <- which(arx == "DATA:")
            lgtv <- dim(arr)[1]^2L
            arrt <- arr
            for (k in seq_len(dim(arr)[3])) {
                arrt[, , k] <- as.numeric(arx[(lnch + 1):(lgtv + 
                  lnch)])
                arr[, , k] <- t(arrt[, , k])
                lnch <- (lgtv + lnch)
            }
            rm(k, arrt, lnch, lgtv)
        }
        else if (any(tip == "NM") == FALSE) {
            if (any(tip == "EDGELIST1") == TRUE) {
                stop(paste(sQuote("EDGELIST"), " option in ", 
                  sQuote("DL"), " is not yet supported for reading.", 
                  sep = ""))
            }
            else {
                arrt <- array(as.numeric(arx[(which(arx == "DATA:") + 
                  1L):length(arx)]), dim = c(as.numeric(rep(tip[2], 
                  2))))
                arr <- t(arrt)
                dimnames(arr)[[1]] <- dimnames(arr)[[2]] <- arx[(which(arx == 
                  "LABELS:")[1] + 1L):(which(arx == "LABELS:")[1] + 
                  as.numeric(tip[2]))]
            }
        }
        else {
            NA
        }
    }
    else if (isTRUE(tip[1] == "NR") == TRUE) {
        tip <- dhc(tip, ",")
        arrt <- data.frame(matrix(as.numeric(arx[(which(arx == 
            "DATA:") + 1L):length(arx)]), ncol = as.numeric(tip[which(tip == 
            "NR") + 1]), nrow = as.numeric(tip[which(tip == "NC") + 
            1])))
        arr <- t(arrt)
        if (isTRUE(length(which(arx == "COLUMN")) > 0) == TRUE) {
            colnames(arr) <- arx[(which(arx == "COLUMN") + 2L):((which(arx == 
                "COLUMN") + 1L + ncol(arr)))]
        }
        else {
            NA
        }
        if (isTRUE(length(which(arx == "ROW")) > 0) == TRUE) {
            rownames(arr) <- arx[(which(arx == "ROW") + 2L):((which(arx == 
                "ROW") + 1L + nrow(arr)))]
        }
        else {
            NA
        }
    }
    else {
        stop("Format not supported.")
    }
    arr
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
mmp <-
function (x1, x2, valued = TRUE) 
{
    if (isTRUE(valued == TRUE) == TRUE) {
        mat <- matrix(NA, nrow = dim(x1)[1], ncol = dim(x1)[2], 
            byrow = TRUE, dimnames = list(dimnames(x1)[[1]], 
                dimnames(x1)[[2]]))
        for (i in seq_len(dim(x1)[1])) {
            for (j in seq_len(dim(x2)[2])) {
                tmp1 <- x1[i, ]
                tmp2 <- x2[, j]
                mintmp <- vector()
                for (m in seq_len(length(tmp1))) {
                  mintmp <- append(mintmp, min(tmp1[m], tmp2[m]))
                }
                rm(m)
                mat[i, j] <- max(mintmp)
            }
            rm(j)
        }
        rm(i)
    }
    else {
        mat <- replace(x1 %*% x2, x1 %*% x2 >= 1, 1)
    }
    mat
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
signed <-
function (P, N = NULL, lbs) 
{
    if (is.array(P) == FALSE) 
        stop("Data must be an array")
    if (is.null(N) == FALSE) {
        if (is.na(dim(N)[3]) == FALSE) {
            N <- N[, , 1]
            warning("Take the 1st dim. in 'N' only.")
        }
    }
    else if (is.null(N) == TRUE) {
        if (is.na(dim(P)[3]) == TRUE) {
            N <- dichot(P, c = max(P) + 1L)
            warning("No negative ties are provided.")
            Po <- P
        }
        else {
            N <- P[, , 2]
            Po <- P <- P[, , 1]
        }
    }
    P <- dichot(P, c = 1L)
    N <- dichot(N, c = 1L)
    sm <- P + N
    if (isTRUE(any((sm) > 1L)) == TRUE) {
        ambs <- which(sm == 2L)
        sm[which(P == 1L)] <- "p"
        sm[which(N == 1L)] <- "n"
        sm[ambs] <- "a"
        sm[which(suppressWarnings(as.numeric(sm) == 0))] <- "o"
    }
    else {
        sm[which(N == 1L)] <- -1L
    }
    if (missing(lbs) == FALSE && isTRUE(length(lbs) == dim(sm)[1]) == 
        TRUE) {
        rownames(sm) <- colnames(sm) <- lbs
    }
    else if (is.null(dimnames(P)[1]) == FALSE) {
        rownames(sm) <- colnames(sm) <- dimnames(P)[[1]]
    }
    else {
        rownames(sm) <- colnames(sm) <- 1:dim(sm)[1]
    }
    val <- levels(factor(sm))
    lst <- list(val = noquote(val[length(val):1]), s = noquote(sm))
    class(lst) <- "Signed"
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
men <-
function (y, sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    mn <- vector()
    if (isTRUE(length(y) > 0) == TRUE) 
        for (i in 1:length(y)) if (isTRUE(strsplit(y[i], sep)[[1]][1] < 
            strsplit(y[i], sep)[[1]][2]) == TRUE) 
            mn <- append(mn, y[i])
    rm(i)
    return(mn)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
sprt <-
function (x, k, l) 
{
    if (isTRUE(is.matrix(x)) == FALSE) 
        x <- as.matrix(x)
    pr <- vector()
    pr <- append(pr, paste(x[k, k], x[l, k], sep = ", "))
    pr <- append(pr, paste(x[k, l], x[l, l], sep = ", "))
    pr <- transl(pr)
    if (length(pr) == 2 && (is.na(strsplit(pr[1], ", ")[[1]][2]) & 
        is.na(strsplit(pr[2], ", ")[[1]][2]))) {
        pr <- jnt(pr)
    }
    clu <- rep(0, nrow(x))
    for (i in seq_len(length(pr))) {
        clu[as.numeric(strsplit(levels(factor(pr[i])), ", ")[[1]])] <- i
    }
    rm(i)
    clu[which(clu == 0)] <- max(clu) + 1
    X <- suppressWarnings(as.semigroup(x, numerical = FALSE))
    if (isTRUE(any(is.na(reducs(X, clu)))) == FALSE) {
        return(clu)
    }
    else {
        if (length(pr) == 1) {
            pr <- paste(pr, pr, sep = ", ")
        }
        for (i in seq_len(length(pr))) {
            ifelse(is.na(strsplit(pr[i], ", ")[[1]][2]), pr[i] <- paste(pr[i], 
                pr[i], sep = ", "), NA)
        }
        rm(i)
        for (i in seq_len(length(pr))) {
            pr <- append(pr, paste(x[(as.numeric(strsplit(pr[i], 
                ", ")[[1]][1])), k], x[(as.numeric(strsplit(pr[i], 
                ", ")[[1]][2])), k], sep = ", "))
            for (j in seq_len(length(pr))) {
                pr <- append(pr, paste(x[(as.numeric(strsplit(pr[i], 
                  ", ")[[1]][1])), (as.numeric(strsplit(pr[j], 
                  ", ")[[1]][1]))], x[(as.numeric(strsplit(pr[i], 
                  ", ")[[1]][1])), (as.numeric(strsplit(pr[j], 
                  ", ")[[1]][2]))], sep = ", "))
                pr <- append(pr, paste(x[(as.numeric(strsplit(pr[i], 
                  ", ")[[1]][2])), (as.numeric(strsplit(pr[j], 
                  ", ")[[1]][1]))], x[(as.numeric(strsplit(pr[i], 
                  ", ")[[1]][2])), (as.numeric(strsplit(pr[j], 
                  ", ")[[1]][2]))], sep = ", "))
            }
            rm(j)
            pr <- append(pr, paste(x[(as.numeric(strsplit(pr[i], 
                ", ")[[1]][1])), (as.numeric(strsplit(pr[i], 
                ", ")[[1]][2]))], x[(as.numeric(strsplit(pr[i], 
                ", ")[[1]][2])), (as.numeric(strsplit(pr[i], 
                ", ")[[1]][1]))], sep = ", "))
        }
        rm(i)
        tpr <- transl(pr)
        clu <- rep(0, nrow(x))
        for (i in seq_len(length(tpr))) {
            clu[as.numeric(strsplit(levels(factor(tpr[i])), ", ")[[1]])] <- i
        }
        rm(i)
        flt <- which(clu == 0)
        ifelse(isTRUE(length(flt) == 0) == FALSE, NA, return(clu))
        clu[which(clu == 0)] <- max(clu) + 1L
        if (isTRUE(any(is.na(reducs(X, clu)))) == FALSE && isTRUE(sum(clu) == 
            ncol(x)) == FALSE) {
            return(clu)
        }
        else {
            xf <- x[flt, flt]
            tmp <- vector()
            for (i in seq_len(length(diag(xf)))) {
                tmp <- append(tmp, paste(attr(diag(xf)[i], "names"), 
                  diag(xf)[i], sep = ", "))
            }
            rm(i)
            ttpr <- transl(c(tmp, tpr))
            clu <- rep(0, nrow(x))
            for (i in seq_len(length(ttpr))) {
                clu[as.numeric(strsplit(levels(factor(ttpr[i])), 
                  ", ")[[1]])] <- i
            }
            rm(i)
            clu[which(clu == 0)] <- max(clu) + 1L
            Sfr <- reducs(X, clu)
            if (isTRUE(any(is.na(Sfr))) == FALSE) {
                return(clu)
            }
            else {
                ftt <- which(is.na(Sfr), arr.ind = TRUE)
                vect <- vector()
                for (i in seq_len(nrow(ftt))) {
                  vect <- append(vect, (c(ttpr, jnt(levels(factor(x[which(clu == 
                    ftt[i, 1]), which(clu == ftt[i, 2])]))))))
                }
                rm(i)
                vect <- transl(vect)
                clu <- rep(0, nrow(x))
                for (i in seq_len(length(vect))) {
                  clu[as.numeric(strsplit(levels(factor(vect[i])), 
                    ", ")[[1]])] <- i
                }
                rm(i)
                clu[which(clu == 0)] <- max(clu) + 1L
                while (isTRUE(any(is.na(eval(Sfr2 <- reducs(X, 
                  clu))))) == TRUE) {
                  ftt2 <- which(is.na(Sfr2), arr.ind = TRUE)
                  if (isTRUE(nrow(ftt2) > 0) == TRUE) {
                    vect2 <- vector()
                    for (i in seq_len(nrow(ftt2))) {
                      vect2 <- append(vect2, (c(vect, jnt(levels(factor(x[which(clu == 
                        ftt2[i, 1]), which(clu == ftt2[i, 2])]))))))
                    }
                    rm(i)
                    vect2 <- transl(vect2)
                    clu <- rep(0, nrow(x))
                    for (i in seq_len(length(vect2))) {
                      clu[as.numeric(strsplit(levels(factor(vect2[i])), 
                        ", ")[[1]])] <- i
                    }
                    rm(i)
                    clu[which(clu == 0)] <- max(clu) + 1L
                  }
                }
                return(clu)
            }
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
zbind <-
function (..., sort, force) 
{
    ifelse(missing(force) == FALSE && isTRUE(force == TRUE) == 
        TRUE, force <- TRUE, force <- FALSE)
    ifelse(missing(sort) == FALSE && isTRUE(sort == TRUE) == 
        TRUE, sort <- TRUE, sort <- FALSE)
    argl <- list(...)
    if (any(unlist(lapply(lapply(argl, dim), length)) < 2L) == 
        TRUE) 
        stop("Input objects must be arrays or data frames.")
    lapply(argl, function(z) {
        ifelse(all(dimnames(z)[[1]] == dimnames(z)[[2]]) == TRUE, 
            invisible(NA), stop(paste(sQuote("x"), ", ", sQuote("y"), 
                " must be square arrays; dimensions not equal.", 
                sep = "")))
    })
    ifelse(isTRUE(dim(argl[[1]])[3] > 1L) == TRUE, pvt0 <- argl[[1]][, 
        , 1], pvt0 <- argl[[1]])
    if (is.null(dimnames(pvt0)[[1]]) == TRUE) {
        warning("Dimnames NULL detected, bind first two arrays.", 
            call. = FALSE)
        return(zbnd(...))
    }
    if (isTRUE(length(argl) < 2L) == TRUE) {
        if (isTRUE(sort == TRUE) == TRUE) {
            return(perm(..., sort = TRUE))
        }
        else {
            return(argl)
        }
    }
    dmnl <- lapply(argl, function(z) dimnames(z)[[1]])
    pvtlbs <- unique(unlist(lapply(argl, function(z) {
        dimnames(z)[[1]]
    })))
    if (isTRUE(length(unique(unlist(lapply(dmnl, length)))) == 
        1L)) {
        flgx <- FALSE
        if (isTRUE(length(unique(unlist(lapply(argl, function(z) dimnames(z)[[1]])))) == 
            unique(unlist(lapply(lapply(argl, function(z) dimnames(z)[[1]]), 
                length)))) == TRUE) {
            if (isTRUE(nrow(unique(as.data.frame(do.call(rbind, 
                dmnl)))) == 1L) == FALSE) {
                for (k in 2:length(argl)) {
                  tmplbs <- dmnl[[k]]
                  vec <- vector()
                  for (i in seq_len(length(tmplbs))) {
                    vec <- append(vec, which(pvtlbs %in% tmplbs[i]))
                  }
                  rm(i)
                  argl[[k]] <- perm(argl[[k]], clu = vec)
                }
                rm(k)
                rm(vec, tmplbs)
            }
            else {
                invisible(NA)
            }
        }
        else {
            if (isTRUE(force == TRUE) == FALSE) 
                stop(paste("Arrays have different labeling; set ", 
                  sQuote("force"), " to TRUE.", sep = ""), call. = FALSE)
            flgx <- TRUE
        }
    }
    else {
        if (isTRUE(force == TRUE) == FALSE) 
            stop(paste("Arrays have different dimensions; set ", 
                sQuote("force"), " to TRUE.", sep = ""), call. = FALSE)
        flgx <- TRUE
    }
    if (isTRUE(flgx == FALSE) == TRUE) {
        argdf <- data.frame(matrix(ncol = (dim(pvt0)[1] * dim(pvt0)[2]), 
            nrow = 0L))
        for (i in seq_along(argl)) {
            ifelse(isTRUE(i < length(argl)) == TRUE, k <- 1L, 
                k <- 0)
            if (all(all.equal(dmnl[i], dmnl[i + k]) == TRUE) == 
                FALSE) {
                ifelse(isTRUE(dim(argl[[i + k]])[3] > 1) == TRUE, 
                  NA, argl[[i + k]] <- trnf(argl[[i + k]], tolist = FALSE, 
                    ord = length(pvtlbs), lbs = pvtlbs))
            }
            if (all.equal(pvtlbs, dimnames(argl[[i]])[[2]]) == 
                TRUE) {
                argdf <- rbind(argdf, matrix(as.vector(argl[[i]]), 
                  ncol = ncol(argdf), byrow = TRUE))
            }
            else {
                tempargdf <- matrix(nrow = dim(pvt0)[1], ncol = dim(pvt0)[2], 
                  dimnames = list(pvtlbs, pvtlbs))
                if (isTRUE(i < length(argl)) == TRUE) {
                  tempargdf <- array(dim = c(dim(pvt0)[1], dim(pvt0)[2], 
                    dim(argl[[i + k]])[3]), dimnames = list(pvtlbs, 
                    pvtlbs))
                }
                tempargdf[which(pvtlbs %in% dimnames(argl[[i]])[[1]]), 
                  which(pvtlbs %in% dimnames(argl[[i]])[[1]]), 
                  ] <- argl[[i]]
                argdf <- rbind(argdf, matrix(as.vector(tempargdf), 
                  ncol = ncol(argdf), byrow = TRUE))
            }
        }
        rm(i)
        argdf[sapply(argdf, is.na)] <- 0L
        arr <- array(dim = c(dim(pvt0)[1], dim(pvt0)[2], nrow(argdf)), 
            dimnames = list(pvtlbs, pvtlbs))
        for (i in seq_len(nrow(argdf))) {
            arr[, , i][seq_len((dim(pvt0)[1] * dim(pvt0)[2]))] <- as.numeric(argdf[i, 
                ])
        }
        rm(i)
        if (any(unlist(lapply(lapply(argl, dim), length)) != 
            3L) == FALSE) {
            pdim <- unlist(lapply(argl, function(z) {
                dimnames(z)[[3]]
            }))
            ifelse(isTRUE(length(pdim) == dim(arr)[3]) == TRUE, 
                dimnames(arr)[[3]] <- pdim, NA)
            rm(pdim)
        }
        if (isTRUE(sort == TRUE) == TRUE) {
            return(perm(arr, sort = TRUE))
        }
        else {
            return(arr)
        }
    }
    else {
        message("An(some) array(s) is(are) extended.")
    }
    if (isTRUE(flgx == TRUE) == TRUE) {
        argdf <- data.frame(matrix(ncol = (length(pvtlbs) * length(pvtlbs)), 
            nrow = 0L))
        if (is.na(dim(argl[[1]])[3]) == TRUE) {
            if (all(pvtlbs %in% dimnames(pvt0)[[1]]) == TRUE) {
                argdf <- rbind(argdf, matrix(pvt0, ncol = ncol(argdf), 
                  byrow = TRUE))
            }
            else {
                tmp1 <- trnf(pvt0, tolist = FALSE, lbs = pvtlbs, 
                  ord = length(pvtlbs))
                if (identical(dimnames(tmp1)[[1]], pvtlbs) == 
                  TRUE) {
                  argdf <- rbind(argdf, matrix(tmp1, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
                else {
                  tmplbs <- dimnames(tmp1)[[1]]
                  vec <- vector()
                  for (i in seq_len(length(tmplbs))) {
                    vec <- append(vec, which(pvtlbs %in% tmplbs[i]))
                  }
                  rm(i)
                  tmpdf <- perm(tmp1, clu = vec)
                  argdf <- rbind(argdf, matrix(tmpdf, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
            }
        }
        else {
            if (identical(dimnames(argl[[1]])[[1]], pvtlbs) == 
                TRUE) {
                for (j in seq_len(dim(argl[[1]])[3])) {
                  argdf <- rbind(argdf, matrix(argl[[1]][, , 
                    j], ncol = ncol(argdf), byrow = TRUE))
                }
                rm(j)
            }
            else {
                for (j in seq_len(dim(argl[[1]])[3])) {
                  tmp3 <- trnf(argl[[1]][, , j], tolist = FALSE, 
                    , lbs = pvtlbs, ord = length(pvtlbs))
                  argdf <- rbind(argdf, matrix(tmp3, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
                rm(j)
            }
        }
        for (k in 2:length(argl)) {
            if (is.na(dim(argl[[k]])[3]) == TRUE) {
                tmpk <- trnf(argl[[k]], tolist = FALSE, lbs = pvtlbs, 
                  ord = length(pvtlbs))
                if (identical(dimnames(tmpk)[[1]], pvtlbs) == 
                  TRUE) {
                  argdf <- rbind(argdf, matrix(tmpk, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
                else {
                  tmplbs <- dimnames(tmpk)[[1]]
                  vek <- vector()
                  for (i in seq_len(length(tmplbs))) {
                    vek <- append(vek, which(pvtlbs %in% tmplbs[i]))
                  }
                  rm(i)
                  tmpdf <- perm(tmpk, clu = vek)
                  argdf <- rbind(argdf, matrix(tmpdf, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
            }
            else {
                for (j in seq_len(dim(argl[[k]])[3])) {
                  tmpk <- trnf(argl[[k]][, , j], tolist = FALSE, 
                    lbs = pvtlbs, ord = length(pvtlbs))
                  tmplbs <- dimnames(tmpk)[[1]]
                  vec <- vector()
                  for (i in seq_len(length(tmplbs))) {
                    vec <- append(vec, which(pvtlbs %in% tmplbs[i]))
                  }
                  rm(i)
                  tmpdf <- perm(tmpk, clu = vec)
                  argdf <- rbind(argdf, matrix(tmpdf, ncol = ncol(argdf), 
                    byrow = TRUE))
                }
                rm(j)
            }
        }
        rm(k)
        argdf[sapply(argdf, is.na)] <- 0L
        arr <- array(dim = c(length(pvtlbs), length(pvtlbs), 
            nrow(argdf)), dimnames = list(pvtlbs, pvtlbs))
        for (i in seq_len(nrow(argdf))) {
            arr[, , i][seq_len((length(pvtlbs) * length(pvtlbs)))] <- as.numeric(argdf[i, 
                ])
        }
        rm(i)
        if (any(unlist(lapply(lapply(argl, dim), length)) != 
            3L) == FALSE) {
            pdim <- unlist(lapply(argl, function(z) {
                dimnames(z)[[3]]
            }))
            ifelse(isTRUE(length(pdim) == dim(arr)[3]) == TRUE, 
                dimnames(arr)[[3]] <- pdim, NA)
            rm(pdim)
        }
        if (isTRUE(sort == TRUE) == TRUE) {
            return(perm(arr, sort = TRUE))
        }
        else {
            return(arr)
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
flt <-
function (e, PO, rclos = TRUE) 
{
    if (isTRUE(e > nrow(PO)) == TRUE) 
        stop(paste(deparse(substitute(e)), " is greater than size of partial order in ", 
            deparse(substitute(PO)), ".", sep = ""))
    pfl <- vector()
    for (i in seq_len(nrow(PO))) {
        if (isTRUE(PO[e, i] == 1) == TRUE && isTRUE(PO[i, e] == 
            0) == TRUE) {
            pfl <- append(pfl, i)
        }
        else {
            NA
        }
    }
    rm(i)
    if (rclos) {
        pfl <- append(pfl, e)
    }
    return(pfl)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
mxmn <-
function (x, type = c("numerical", "symbolic"), cmps, equat) 
{
    ifelse(missing(cmps) == FALSE && isTRUE(cmps == TRUE) == 
        TRUE, cmps <- TRUE, cmps <- FALSE)
    ifelse(missing(equat) == FALSE && isTRUE(equat == TRUE) == 
        TRUE, equat <- TRUE, equat <- FALSE)
    n <- dim(x)[1]
    z <- dim(x)[3]
    Bx <- x
    cplb <- vector()
    for (k in seq_len(z)) {
        for (l in seq_len(z)) {
            mat <- matrix(NA, nrow = n, ncol = n, byrow = TRUE, 
                dimnames = list(dimnames(x)[[1]], dimnames(x)[[2]]))
            for (i in seq_len(n)) {
                for (j in seq_len(n)) {
                  tmp1 <- x[i, , k]
                  tmp2 <- x[, j, l]
                  mintmp <- vector()
                  for (m in seq_len(length(tmp1))) {
                    mintmp <- append(mintmp, min(tmp1[m], tmp2[m]))
                  }
                  rm(m)
                  mat[i, j] <- max(mintmp)
                }
                rm(j)
            }
            rm(i)
            if (isTRUE(dim(Bx)[3] == z) == TRUE) {
                Bx <- zbind(x, mat)
                cplb <- c(dimnames(x)[[3]], paste0(dimnames(x)[[3]][k], 
                  dimnames(x)[[3]][l]))
            }
            else {
                Bx <- zbind(Bx, mat)
                cplb <- append(cplb, paste0(dimnames(x)[[3]][k], 
                  dimnames(x)[[3]][l]))
            }
        }
        rm(l)
    }
    rm(k)
    dimnames(Bx)[[3]] <- cplb
    dfBx <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
        nrow = 0))
    for (i in seq_len(dim(Bx)[3])) {
        dfBx[i, ] <- as.vector(Bx[, , i])
    }
    rm(i)
    cplb2 <- vector()
    if (any(duplicated(dfBx)) == TRUE) {
        eqlb <- jnt(cplb[as.numeric(rownames(dfBx[duplicated(dfBx) | 
            duplicated(dfBx, fromLast = TRUE), ]))], sep = "=")
        rownames(dfBx) <- cplb
        dfBx <- unique(dfBx)
        cplb2 <- cplb[which(!(cplb %in% rownames(dfBx)))]
        cplb <- rownames(dfBx)
        Bx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(dfBx)))
        for (i in seq_len(nrow(dfBx))) {
            Bx[, , i][seq_len(dim(Bx)[1] * dim(Bx)[2])] <- as.numeric(dfBx[i, 
                ])
        }
        rm(i)
        dimnames(Bx)[[1]] <- dimnames(Bx)[[2]] <- dimnames(x)[[1]]
        dimnames(Bx)[[3]] <- cplb
    }
    else {
        eqlb <- vector()
    }
    z2 <- dim(Bx)[3]
    E <- data.frame(matrix(ncol = z, nrow = z2))
    for (k in seq_len(z)) {
        for (j in seq_len(z2)) {
            tmp <- mmp(Bx[, , j], Bx[, , k])
            for (i in z2:1) {
                if (isTRUE(all.equal(tmp, Bx[, , i]) == TRUE)) 
                  E[j, k] <- i
            }
            rm(i)
        }
        rm(j)
    }
    rm(k)
    dimnames(E)[[1]] <- cplb
    dimnames(E)[[2]] <- dimnames(x)[[3]]
    while (any(is.na(E)) == TRUE) {
        ei <- which(is.na(E), arr.ind = TRUE)
        for (k in seq_len(nrow(ei))) {
            Bx <- zbind(Bx, mmp(Bx[, , which(cplb == rownames(ei)[k])], 
                Bx[, , which(cplb == cplb[ei[k, 2]])]))
            cplb <- append(cplb, paste0(rownames(ei)[k], cplb[ei[k, 
                2]]))
        }
        rm(k)
        dimnames(Bx)[[3]] <- cplb
        dfBx <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
            nrow = 0))
        for (i in seq_len(dim(Bx)[3])) {
            dfBx[i, ] <- as.vector(Bx[, , i])
        }
        rm(i)
        if (any(duplicated(dfBx)) == TRUE) {
            eqlb <- append(eqlb, jnt(cplb[as.numeric(rownames(dfBx[duplicated(dfBx) | 
                duplicated(dfBx, fromLast = TRUE), ]))], sep = "="))
            rownames(dfBx) <- cplb
            dfBx <- unique(dfBx)
            cplb <- rownames(dfBx)
            Bx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(dfBx)))
            for (i in seq_len(nrow(dfBx))) {
                Bx[, , i][seq_len(dim(Bx)[1] * dim(Bx)[2])] <- as.numeric(dfBx[i, 
                  ])
            }
            rm(i)
            dimnames(Bx)[[1]] <- dimnames(Bx)[[2]] <- dimnames(x)[[1]]
            dimnames(Bx)[[3]] <- cplb
        }
        else {
            NA
        }
        z2 <- dim(Bx)[3]
        E <- data.frame(matrix(ncol = z, nrow = z2))
        for (k in seq_len(z)) {
            for (j in seq_len(z2)) {
                tmp <- mmp(Bx[, , j], Bx[, , k])
                for (i in z2:1) {
                  if (isTRUE(all.equal(tmp, Bx[, , i]) == TRUE)) 
                    E[j, k] <- i
                }
                rm(i)
            }
            rm(j)
        }
        rm(k)
        dimnames(E)[[1]] <- cplb
        dimnames(E)[[2]] <- dimnames(x)[[3]]
    }
    switch(match.arg(type), numerical = S <- cbind(E, data.frame(matrix(ncol = (nrow(E) - 
        ncol(E)), nrow = nrow(E)))), symbolic = {
        e <- E
        for (i in seq_len(nrow(E))) {
            for (j in seq_len(ncol(E))) {
                e[i, j] <- dimnames(Bx)[[3]][as.matrix(E[i, j])]
            }
            rm(j)
        }
        rm(i)
        S <- cbind(as.data.frame(e), data.frame(matrix(ncol = (nrow(E) - 
            ncol(E)), nrow = nrow(E))))
        rm(e)
    })
    if (ncol(S) != ncol(E)) {
        for (j in (ncol(E) + 1L):nrow(E)) {
            for (i in seq_len(nrow(E))) {
                tmp <- mmp(Bx[, , i], mmp(Bx[, , as.numeric(which(E == 
                  j, arr.ind = TRUE)[1, ][1])], Bx[, , as.numeric(which(E == 
                  j, arr.ind = TRUE)[1, ][2])]))
                for (k in seq_len(dim(Bx)[3])) {
                  if (isTRUE(all.equal(Bx[, , k], tmp)) == TRUE) {
                    switch(match.arg(type), numerical = S[i, 
                      j] <- k, symbolic = S[i, j] <- dimnames(Bx)[[3]][k])
                    break
                  }
                }
                rm(k)
            }
            rm(i)
        }
        rm(j)
        rm(tmp)
    }
    else {
        NA
    }
    if (match.arg(type) == "symbolic") {
        colnames(S) <- rownames(S) <- dimnames(Bx)[[3]]
    }
    else {
        colnames(S) <- rownames(S) <- seq_len(nrow(S))
    }
    if (equat == TRUE) {
        lst <- list(dim = dim(x)[1], gens = x, cmps = Bx[, , 
            (z + 1):dim(Bx)[3]], equat = eqlb, ord = nrow(S), 
            st = dimnames(Bx)[[3]], S = S)
    }
    else {
        lst <- list(dim = dim(x)[1], gens = x, cmps = Bx[, , 
            (z + 1):dim(Bx)[3]], ord = nrow(S), st = dimnames(Bx)[[3]], 
            S = S)
    }
    if (isTRUE(cmps == FALSE) == TRUE) {
        lst$cmps <- NULL
    }
    else {
        NA
    }
    class(lst) <- c("Semigroup", match.arg(type), "valued")
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
cscl <-
function (x, cl, scale = c("nominal", "ordinal", "intord", "biord", 
    "dichot"), sep) 
{
    if (is.array(x) == FALSE) 
        stop(paste("Input in ", sQuote(deparse(substitute(x))), 
            " should be a table or an array.", sep = ""))
    if (any(cl %in% unique(x)) == FALSE && is.null(cl) == FALSE) {
        warning(paste("Any value in ", sQuote(deparse(substitute(x))), 
            " correspond to concept-levels in ", sQuote(deparse(substitute(cl))), 
            " and return ", sQuote("x"), ".", sep = ""), call. = FALSE)
        return(x)
    }
    else {
        if (is.null(cl) == TRUE) 
            return(x)
        if (is.vector(cl) == FALSE) 
            stop(paste("Concept-levels in ", sQuote(deparse(substitute(cl))), 
                " should be a list or vector.", sep = ""))
        flgd <- FALSE
        if (is.list(cl) == TRUE) {
            scl <- diag(length(unlist(cl)))
            colnames(scl) <- rownames(scl) <- unlist(cl)
        }
        else {
            if (match.arg(scale) == "dichot") {
                if (isTRUE(length(cl) != 2) == TRUE) 
                  stop("Dichotomic scale requires a vector of conceptual levels with length 2.")
                scl <- diag(2)
                flgd <- TRUE
            }
            else if (match.arg(scale) == "biord") {
                stop("Biordinal scale requires a list of conceptual levels with length 2.")
            }
            else {
                scl <- diag(length(cl))
            }
            colnames(scl) <- rownames(scl) <- cl
        }
        if (isTRUE(flgd == FALSE) == TRUE) {
            switch(match.arg(scale), nominal = {
                NA
            }, ordinal = {
                scl[upper.tri(scl)] <- 1L
            }, intord = {
                scl[seq_len(round(length(cl)/2L)), seq_len(round(length(cl)/2L))][upper.tri(scl[seq_len(round(length(cl)/2L)), 
                  seq_len(round(length(cl)/2L))])] <- 1L
                scl[(round(length(cl)/2L) + 1L):nrow(scl), (round(length(cl)/2L) + 
                  1L):ncol(scl)][lower.tri(scl[(round(length(cl)/2L) + 
                  1L):nrow(scl), (round(length(cl)/2L) + 1L):ncol(scl)])] <- 1L
            }, biord = {
                scl[seq_len(length(cl[[1]])), seq_len(length(cl[[1]]))][upper.tri(scl[seq_len(length(cl[[1]])), 
                  seq_len(length(cl[[1]]))])] <- 1L
                scl[(length(cl[[1]]) + 1):nrow(scl), (length(cl[[1]]) + 
                  1):ncol(scl)][lower.tri(scl[(length(cl[[1]]) + 
                  1):nrow(scl), (length(cl[[1]]) + 1):ncol(scl)])] <- 1L
                ifelse(isTRUE(length(cl) == 2) == TRUE, NA, warning(paste("Biordinal scale ", 
                  dQuote("biord"), " in ", sQuote("scale"), " is for two-dimensional.", 
                  sep = ""), call. = FALSE))
            })
        }
        else {
            NA
        }
        scl <- as.data.frame(scl)
    }
    ifelse(missing(sep) == TRUE, sep <- ".", NA)
    lvl <- attr(scl, "names")
    dx <- data.frame(matrix(NA, ncol = ncol(x) * ncol(scl), nrow = 0))
    for (i in seq_len(nrow(x))) {
        tmp <- vector()
        for (j in seq_len(ncol(x))) {
            tmp <- c(tmp, as.vector(unlist(scl[which(x[i, j] == 
                lvl), ])))
        }
        rm(j)
        dx <- rbind(dx, tmp)
    }
    rm(i)
    rownames(dx) <- rownames(x)
    colnames(dx) <- paste0(rep(colnames(x), each = length(lvl)), 
        sep, lvl)
    attr(dx, "class") <- c(class(dx), "conceptual.scaling", jnt(cl, 
        uniq = TRUE), sep)
    dx
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
trnf <-
function (x, lbs = NULL, lb2lb = FALSE, tolist = FALSE, ord, 
    sep) 
{
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    ifelse(isTRUE(tolist == TRUE) == TRUE && is.na(dim(x)[3]) == 
        TRUE, x <- as.matrix(x), NA)
    if (is.vector(x) == FALSE && is.na(dim(x)[3]) == TRUE) {
        co <- rev(sort(unique(as.vector(as.matrix(x))))[-1])
        lst <- vector(mode = "list", length = dim(x)[1])
        names(lst) <- dimnames(x)[[1]]
        if (isTRUE(suppressWarnings(max(co)) == 1L) == TRUE || 
            isTRUE(length(co) == 0) == TRUE) {
            for (k in seq_len(length(lst))) {
                lst[[k]] <- names(which(x[, k] == 1))
            }
            rm(k)
        }
        else {
            for (i in seq_along(co)) {
                rpvt <- which(x == co[i])%%dim(x)[1]
                rpvt[rpvt == 0] <- dim(x)[2]
                sco <- rownames(x)[rpvt]
                if (isTRUE(length(sco) > 1L) == TRUE) {
                  tmp <- unique(x[rpvt, ])
                  sco <- vector()
                  rco <- vector()
                  for (l in seq_len(nrow(tmp))) {
                    sco <- append(sco, rep(rownames(tmp)[l], 
                      length(which(tmp[l, ] == co[i]))))
                    rco <- append(rco, names(which(tmp[l, ] == 
                      co[i])))
                  }
                  rm(l)
                  for (j in seq_len(length(rco))) {
                    ifelse(is.null(lst[[which(names(lst) == rco[j])]]) == 
                      FALSE, lst[[which(names(lst) == rco[j])]] <- append(lst[[which(names(lst) == 
                      rco[j])]], rep(sco[j], as.numeric(co[i]))), 
                      lst[[which(names(lst) == rco[j])]] <- rep(sco[j], 
                        as.numeric(co[i])))
                  }
                  rm(j)
                }
                else if (isTRUE(length(sco) == 1L) == TRUE) {
                  ifelse(is.null(lst[[which(x[rpvt, ] == co[i])]]) == 
                    FALSE, lst[[which(x[rpvt, ] == co[i])]] <- append(lst[[which(x[rpvt, 
                    ] == co[i])]], rep(names(lst)[rpvt], as.numeric(co[i]))), 
                    lst[[which(x[rpvt, ] == co[i])]] <- rep(names(lst)[rpvt], 
                      as.numeric(co[i])))
                }
            }
            rm(i)
        }
    }
    else {
        if (is.vector(x) == FALSE || isTRUE(class(x) %in% c("matrix", 
            "array")) == FALSE) 
            stop(paste(sQuote(deparse(substitute(x))), " should be a matrix or low-dimensional array.", 
                sep = ""), call. = FALSE)
    }
    if (isTRUE(tolist == TRUE) == TRUE) {
        if (isTRUE(sum(x) > 0L) == FALSE) 
            return(paste(0, 0, sep = sep))
        if (isTRUE(lb2lb == FALSE) == TRUE) {
            sct <- which(!(unlist(lapply(lst, is.null), use.names = FALSE)))
            lst <- lst[sct]
            names(lst) <- sct
            lst <- lapply(lst, function(z) {
                as.vector(factor(z, dimnames(x)[[1]], 1:dim(x)[1]))
            })
        }
        else {
            NA
        }
        llst <- lst
        for (k in seq_len(length(lst))) {
            ifelse(isTRUE(length(lst[[k]]) == 0) == TRUE, NA, 
                llst[[k]] <- paste(lst[[k]], names(lst)[k], sep = sep))
        }
        rm(k)
        return(unlist(llst, use.names = FALSE))
    }
    else {
        if (missing(ord) == TRUE && is.array(x) == FALSE) {
            ord <- length(dhc(jnt(x, sep = sep), sep = sep))
        }
        else {
            ifelse(missing(ord) == FALSE, ord <- as.numeric(ord), 
                ord <- dim(x)[1])
        }
        if (is.vector(x) == FALSE) {
            ifelse(is.array(x) == TRUE && missing(ord) == TRUE, 
                return(x), NA)
            ifelse(is.null(lbs) == TRUE, lbs <- dimnames(x)[[1]], 
                NA)
            ifelse(is.null(lbs) == FALSE, NA, lbs <- lbs[seq_len(ord)])
            mat <- matrix(0L, ncol = ord, nrow = ord, dimnames = list(lbs, 
                lbs))
            for (j in seq_len(length(lst))) {
                if (is.null(lst[[j]]) == FALSE) {
                  for (i in seq_len(length(lst[[j]]))) {
                    mat[which(rownames(mat) == lst[[j]][i]), 
                      which(colnames(mat) == names(lst)[j])] <- mat[which(rownames(mat) == 
                      lst[[j]][i]), which(colnames(mat) == names(lst)[j])] + 
                      1L
                  }
                  rm(i)
                }
            }
            rm(j)
            return(mat)
        }
        else {
            lbs <- unique(dhc(unlist(x), sep = sep))
            if (is.list(x) == TRUE) {
                arr <- array(0L, dim = c(ord, ord, length(x)), 
                  dimnames = list(lbs, lbs, names(x)))
                for (i in seq_len(length(x))) {
                  for (k in seq_len(length(x[[i]]))) {
                    crs <- dhc(x[[i]][k], sep = sep)
                    ifelse(all(suppressWarnings(is.na(as.numeric(crs)))) == 
                      FALSE, arr[which(lbs %in% lbs[as.numeric(crs)][1]), 
                      which(lbs %in% lbs[as.numeric(crs)][2]), 
                      i] <- 1L, arr[which(lbs %in% crs[1]), which(lbs %in% 
                      crs[2]), i] <- 1L)
                  }
                  rm(k)
                }
                rm(i)
                return(arr)
            }
            else {
                mat <- matrix(0L, ncol = ord, nrow = ord, dimnames = list(lbs, 
                  lbs))
                for (k in seq_len(length(x))) {
                  crs <- dhc(x[k], sep = sep)
                  mat[which(lbs %in% crs[1]), which(lbs %in% 
                    crs[2])] <- 1L
                }
                rm(k)
                return(mat)
            }
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
write.gml <-
function (x, file = NULL) 
{
    if (isTRUE(is.na(dim(x)[3]) == TRUE) == FALSE) {
        if (isTRUE(is.null(dimnames(x)[[3]])) == TRUE) 
            dimnames(x)[[3]] <- seq_len(dim(x)[3])
    }
    if (isTRUE(is.null(dimnames(x)[[1]])) == TRUE) 
        dimnames(x)[[1]] <- dimnames(x)[[2]] <- seq_len(dim(x)[1])
    suppressWarnings(file.remove(file = file))
    cat(paste("Creator", "\"multiplex\"", sep = "\t"), file = file, 
        sep = "\n", append = TRUE)
    cat(paste("Version", paste("\"", utils::packageDescription("multiplex")["Version"]$Version, 
        "\"", sep = ""), sep = "\t"), file = file, sep = "\n", 
        append = TRUE)
    cat("graph", file = file, sep = "\n", append = TRUE)
    cat("[", file = file, sep = "\n", append = TRUE)
    cat(paste("", "hierarchic", "1", sep = "\t"), file = file, 
        sep = "\n", append = TRUE)
    cat(paste("", "label", "\"\"", sep = "\t"), file = file, 
        sep = "\n", append = TRUE)
    cat(paste("", "directed", "1", sep = "\t"), file = file, 
        sep = "\n", append = TRUE)
    for (i in seq_len(dim(x)[1])) {
        cat(paste("", "node", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("", "[", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t", "id", i - 1, sep = "\t"), file = file, 
            sep = "\n", append = TRUE)
        cat(paste("\t", "label", paste("\"", dimnames(x)[[1]][i], 
            "\"", sep = ""), sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t", "graphics", sep = "\t"), file = file, 
            sep = "\n", append = TRUE)
        cat(paste("\t", "[", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t\t", "x", stats::runif(1) * 10, sep = "\t"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\t\t", "y", stats::runif(1) * 10, sep = "\t"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\t\t", "type", "\"ellipse\"", sep = "\t"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\t\t", "fill", "\"#3399FF\"", sep = "\t"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\t\t", "outline", "\"#000000\"", sep = "\t"), 
            file = file, sep = "\n", append = TRUE)
        cat(paste("\t", "]", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t", "LabelGraphics", sep = "\t"), file = file, 
            sep = "\n", append = TRUE)
        cat(paste("\t", "[", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t\t", "text", paste("\"", dimnames(x)[[1]][i], 
            "\"", sep = ""), sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("\t", "]", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
        cat(paste("", "]", sep = "\t"), file = file, sep = "\n", 
            append = TRUE)
    }
    pat <- c("dotted", "line", "dashed")
    for (j in seq_len(dim(x)[3])) {
        tmp <- trnf(x[, , j], tolist = TRUE, lb2lb = FALSE, ord = dim(x)[1])
        for (k in seq_len(length(tmp))) {
            cat(paste("", "edge", sep = "\t"), file = file, sep = "\n", 
                append = TRUE)
            cat(paste("", "[", sep = "\t"), file = file, sep = "\n", 
                append = TRUE)
            cat(paste("\t", "source", as.numeric(strsplit(tmp[k], 
                ", ")[[1]])[1] - 1, sep = "\t"), file = file, 
                sep = "\n", append = TRUE)
            cat(paste("\t", "target", as.numeric(strsplit(tmp[k], 
                ", ")[[1]])[2] - 1, sep = "\t"), file = file, 
                sep = "\n", append = TRUE)
            cat(paste("\t", "graphics", sep = "\t"), file = file, 
                sep = "\n", append = TRUE)
            cat(paste("\t", "[", sep = "\t"), file = file, sep = "\n", 
                append = TRUE)
            cat(paste("\t\t", "width", 1, sep = "\t"), file = file, 
                sep = "\n", append = TRUE)
            cat(paste("\t\t", "style", paste("\"", pat[(j%%3) + 
                1], "\"", sep = ""), sep = "\t"), file = file, 
                sep = "\n", append = TRUE)
            cat(paste("\t\t", "fill", "\"#000000\"", sep = "\t"), 
                file = file, sep = "\n", append = TRUE)
            cat(paste("\t\t", "targetArrow", "\"standard\"", 
                sep = "\t"), file = file, sep = "\n", append = TRUE)
            cat(paste("\t", "]", sep = "\t"), file = file, sep = "\n", 
                append = TRUE)
            cat(paste("", "]", sep = "\t"), file = file, sep = "\n", 
                append = TRUE)
        }
    }
    cat("]", file = file, sep = "\n", append = TRUE)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
zbnd <-
function (a, b) 
{
    if (isTRUE(is.na(dim(a)[3]) == FALSE)) {
        if (isTRUE(dim(b)[3] > 1) == TRUE) {
            nx <- array(a, dim = c(dim(a)[1], dim(a)[2], (dim(a)[3] + 
                dim(b)[3])))
            nx[, , (dim(a)[3] + 1):(dim(nx)[3])] <- b
        }
        else {
            nx <- array(a, dim = c(dim(a)[1], dim(a)[2], (dim(a)[3] + 
                1)))
            nx[, , (dim(a)[3] + 1)] <- b
        }
    }
    else {
        if (isTRUE(dim(b)[3] > 1) == TRUE) {
            nx <- array(a, dim = c(dim(a)[1], dim(a)[2], (1 + 
                dim(b)[3])))
            nx[, , 2:(dim(nx)[3])] <- b
        }
        else {
            nx <- array(a, dim = c(dim(a)[1], dim(a)[2], 2))
            nx[, , 2] <- b
        }
    }
    return(nx)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
pi.rels <-
function (x, po.incl, vc, po) 
{
    if (any(c("Induced.inclusions", "Ind.incl", "Pacnet") %in% 
        attr(x, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " should be factorization product with an ", 
            dQuote("Induced.inclusions"), " class or a ", dQuote("Pacnet"), 
            " class object.", sep = ""))
    po <- x$po
    Po <- po[seq_len(nrow(po)), seq_len(ncol(po))]
    if (any(c("Induced.inclusions", "Ind.incl") %in% attr(x, 
        "class")) == TRUE) {
        if (missing(vc) == FALSE) {
            pii <- array(dim = c(nrow(po), ncol(po), length(vc)))
            k <- 1L
            for (i in vc) {
                pii[, , k] <- transf(x$iin[[i]], type = "toarray", 
                  ord = nrow(po), lbs = seq_len(nrow(po))) + 
                  Po
                k <- k + 1L
            }
            rm(i)
            dimnames(pii)[[3]] <- attr(x$iin, "names")[vc]
        }
        else {
            pii <- array(dim = c(nrow(po), ncol(po), length(x$iin)))
            for (i in seq_along(x$iin)) {
                pii[, , i] <- transf(x$iin[[i]], type = "toarray", 
                  ord = nrow(po), lbs = seq_len(nrow(po))) + 
                  Po
            }
            rm(i)
            dimnames(pii)[[3]] <- as.list(attr(x$iin, "names"))
        }
        pat <- array(dim = c(nrow(po), ncol(po), length(x$atm)))
        for (i in seq_along(x$atm)) {
            pat[, , i] <- transf(x$atm[[i]], type = "toarray", 
                ord = nrow(po), lbs = seq_len(nrow(po))) + Po
        }
        rm(i)
        dimnames(pat)[[1]] <- dimnames(pat)[[2]] <- as.list(seq_len(dim(po)[1]))
        if (isTRUE(length(unlist(x$mca)) != 0) == TRUE) {
            pmc <- array(dim = c(nrow(po), ncol(po), length(x$mca)))
            for (i in seq_len(length(x$mca))) {
                pmc[, , i] <- x$mca[[i]]
            }
            rm(i)
            piis <- zbnd(dichot(pii), pmc)
            xmc <- x$mca
        }
        else {
            piis <- dichot(pii)
            warning(paste("There is no meet-complement of the atom in ", 
                sQuote(deparse(substitute(x))), " then use atom itself.", 
                sep = ""), call. = FALSE)
            xmc <- pat
        }
    }
    if (isTRUE("Pacnet" %in% attr(x, "class")) == TRUE) {
        if (missing(po) == TRUE) 
            stop(paste("A partial order in ", sQuote(deparse(substitute(po))), 
                " needed for the ", dQuote("Pacnet"), " class option.", 
                sep = ""))
        ifelse(isTRUE(attr(x, "class")[length(attr(x, "class"))] == 
            "transp") == TRUE, Po <- (po), Po <- t(po))
        pii <- array(dim = c(nrow(po), ncol(po), length(x$ii)))
        for (i in seq_along(x$ii)) {
            pii[, , i] <- transf(x$ii[[i]], type = "toarray", 
                ord = nrow(po), lbs = seq_len(nrow(po))) + Po
        }
        rm(i)
        pat <- array(dim = c(nrow(po), ncol(po), length(x$atm)))
        for (i in seq_along(x$atm)) {
            pat[, , i] <- transf(x$atm[[i]], type = "toarray", 
                ord = nrow(po), lbs = seq_len(nrow(po))) + Po
        }
        rm(i)
        dimnames(pat)[[1]] <- dimnames(pat)[[2]] <- as.list(seq_len(dim(po)[1]))
        pmc <- array(dim = c(nrow(po), ncol(po), dim(x$mca)[3]))
        for (i in seq_len(dim(x$mca)[3])) {
            pmc[, , i] <- x$mca[, , i]
        }
        rm(i)
        piis <- zbnd(pii, zbnd(pat, pmc))
    }
    tmp <- data.frame(matrix(ncol = (nrow(po) * ncol(po)), nrow = 0))
    for (i in seq_len(dim(piis)[3])) {
        ifelse(isTRUE(dim(pii)[3] > 1) == TRUE, tmp[i, ] <- as.vector(piis[, 
            , i]), tmp <- as.vector(piis))
    }
    rm(i)
    if (missing(vc) == FALSE || is.vector(tmp) == TRUE) {
        tmpu <- tmp
    }
    else {
        tmpu <- unique(tmp)
    }
    if (isTRUE(nrow(tmpu) > 0L) == TRUE) {
        pisu <- array(1L, dim = c(dim(piis)[1], dim(piis)[2], 
            nrow(tmpu)))
        for (i in seq_len(nrow(tmpu))) {
            pisu[, , i][seq_len((dim(piis)[1] * dim(piis)[2]))] <- as.numeric(tmpu[i, 
                ])
        }
        rm(i)
        dimnames(pisu)[[3]] <- c(dimnames(pii)[[3]], seq(from = dim(pii)[3] + 
            1L, to = dim(pisu)[3]))[which(duplicated(tmp) == 
            FALSE)]
    }
    else if (isTRUE(nrow(tmpu) > 0) == FALSE) {
        pisu <- piis
    }
    dimnames(pisu)[[1]] <- dimnames(pisu)[[2]] <- as.list(seq_len(dim(po)[1]))
    if (missing(po.incl) == FALSE && isTRUE(po.incl == TRUE) == 
        TRUE) {
        lst <- list(pi = pisu, at = pat, mca = xmc, po = Po)
    }
    else {
        lst <- list(pi = pisu, at = pat, mca = xmc)
    }
    class(lst) <- "Pi.rels"
    lst
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
mnplx <-
function (net, directed = TRUE, valued, diag, clu) 
{
    if (missing(valued) == FALSE && isTRUE(valued == FALSE) == 
        TRUE) {
        flgval <- FALSE
        net <- dichot(net, c = 1L)
    }
    else {
        flgval <- TRUE
    }
    ifelse(missing(diag) == FALSE && isTRUE(diag == FALSE) == 
        TRUE, flgdg <- FALSE, flgdg <- TRUE)
    ifelse(missing(clu) == FALSE && is.vector(clu) == TRUE, net <- perm(net, 
        clu = clu), NA)
    if ((is.na(dim(net)[3]) == TRUE | isTRUE(dim(net)[3] == 1L) == 
        TRUE)) {
        ifelse(isTRUE(dim(net)[3] == 1) == TRUE, net <- net[, 
            , 1], NA)
        ifelse(isTRUE(directed == FALSE) == TRUE, net <- (net + 
            t(net)), NA)
        ifelse(isTRUE(flgdg == FALSE) == TRUE, diag(net) <- 0L, 
            NA)
        ifelse(isTRUE(flgval == FALSE) == TRUE, return(dichot(net, 
            c = 1L)), return(net))
    }
    else {
        mat <- matrix(0L, nrow = dim(net)[1], ncol = dim(net)[2])
        for (k in seq_len(dim(net)[3])) mat <- mat + net[, , 
            k]
        ifelse(isTRUE(directed == TRUE) == TRUE, NA, mat <- mat + 
            t(mat))
        ifelse(isTRUE(flgval == FALSE) == TRUE, mat <- dichot(mat, 
            c = 1L), NA)
        ifelse(isTRUE(flgdg == FALSE) == TRUE, diag(mat) <- 0L, 
            NA)
        mat
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
reduc <-
function (x, clu, lbs, slbs, valued, row, col) 
{
    ifelse(missing(valued) == FALSE && isTRUE(valued == TRUE) == 
        TRUE, valued <- TRUE, valued <- FALSE)
    ifelse(missing(row) == FALSE && isTRUE(row == TRUE) == TRUE, 
        row <- TRUE, row <- FALSE)
    ifelse(missing(col) == FALSE && isTRUE(col == TRUE) == TRUE, 
        col <- TRUE, col <- FALSE)
    if (isTRUE(length(clu) != dim(x)[1]) == TRUE && isTRUE(col == 
        FALSE) == TRUE) 
        stop(paste("Length of ", sQuote("clu"), " does not match the order of ", 
            sQuote("x"), ".", sep = ""))
    if (isTRUE(row == FALSE) == TRUE && isTRUE(col == FALSE) == 
        TRUE) {
        if (isTRUE(is.array(x) == TRUE) == FALSE) 
            stop(paste(sQuote("x"), " should be an array object."))
    }
    if (is.character(clu) == TRUE || is.factor(clu) == TRUE) {
        tmp <- as.vector(clu)
        for (i in seq_len(nlevels(factor(clu)))) {
            tmp[which(levels(factor(clu))[i] == tmp)] <- i
        }
        rm(i)
        clu <- as.numeric(tmp)
        rm(tmp)
    }
    else if (is.character(clu) == FALSE && is.factor(clu) == 
        FALSE) {
        ifelse(isTRUE(0L %in% as.numeric(levels(factor(clu)))) == 
            TRUE, clu <- clu + 1L, NA)
    }
    else {
        NA
    }
    ifelse(NA %in% clu, clu[which(is.na(clu))] <- max(as.numeric(levels(factor(clu)))) + 
        1L, NA)
    lngt <- nlevels(factor(clu))
    or <- list()
    for (i in as.numeric(levels(factor(clu)))) {
        or[[i]] <- which(clu == i)
    }
    rm(i)
    cls <- list()
    length(cls) <- lngt
    k <- 1L
    for (i in seq_len(length(or))) {
        if (isTRUE(is.null(or[[i]])) == FALSE) {
            cls[[k]] <- or[[i]]
            k <- k + 1L
        }
        else {
            NA
        }
    }
    rm(i, k)
    if (isTRUE(is.na(dim(x)[3]) == TRUE)) {
        ifelse(isTRUE(is.null(dimnames(x)[[1]]) == TRUE) == TRUE, 
            dimnames(x)[[1]] <- dimnames(x)[[2]] <- seq_len(nrow(x)), 
            NA)
        if (isTRUE(row == FALSE) == TRUE && isTRUE(col == FALSE) == 
            TRUE) {
            bm <- array(dim = c(lngt, lngt))
            for (i in seq_len(lngt)) {
                for (j in seq_len(lngt)) {
                  bm[i, j] <- sum(x[cls[[i]], cls[[j]]])
                }
            }
            rm(i, j)
            ifelse(missing(lbs) == FALSE && is.vector(lbs) == 
                TRUE, rownames(bm) <- colnames(bm) <- lbs, NA)
        }
        else if (isTRUE(row == TRUE) == TRUE) {
            bm <- array(dim = c(lngt, ncol(x)))
            colnames(bm) <- colnames(x)
            for (i in seq_len(lngt)) {
                bm[i, ] <- colSums(x[cls[[i]], ])
            }
            rm(i)
            ifelse(missing(lbs) == FALSE && is.vector(lbs) == 
                TRUE, rownames(bm) <- lbs, NA)
        }
        else if (isTRUE(col == TRUE) == TRUE) {
            bm <- array(dim = c(nrow(x), lngt))
            rownames(bm) <- rownames(x)
            for (i in seq_len(lngt)) {
                ifelse(isTRUE(length(cls[[i]]) == 1) == TRUE, 
                  bm[, i] <- x[, cls[[i]]], bm[, i] <- rowSums(x[, 
                    cls[[i]]]))
            }
            rm(i)
            ifelse(missing(lbs) == FALSE && is.vector(lbs) == 
                TRUE, colnames(bm) <- lbs, NA)
        }
        else {
            NA
        }
    }
    else if (isTRUE(is.na(dim(x)[3]) == FALSE)) {
        bm <- array(dim = c(lngt, lngt, dim(x)[3]))
        if (is.null(lbs) == FALSE) {
            dimnames(bm)[[1]] <- dimnames(bm)[[2]] <- lbs
        }
        if (missing(slbs) == FALSE && is.vector(slbs) == TRUE) {
            dimnames(bm)[[3]] <- slbs
        }
        else {
            if (is.null(dimnames(x)[[3]]) == FALSE) 
                dimnames(bm)[[3]] <- dimnames(x)[[3]]
        }
        for (k in seq_len(dim(x)[3])) {
            for (i in seq_len(lngt)) {
                for (j in seq_len(lngt)) {
                  bm[i, j, k] <- sum(x[cls[[i]], cls[[j]], k])
                }
                rm(j)
            }
            rm(i)
        }
        rm(k)
    }
    if (isTRUE(valued == TRUE) == TRUE) {
        return(bm)
    }
    else {
        return(dichot(bm, c = 1L))
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
neighb <-
function (x, rs, type = c("und", "inn", "out"), k = 1, inclx = FALSE, 
    expand) 
{
    if (isTRUE("Rel.System" %in% attr(rs, "class")) == FALSE) {
        if (is.array(rs) == FALSE) {
            stop(paste(sQuote(deparse(substitute(x))), " must be at least a stacked array of square matrices.", 
                sep = ""))
        }
        warning(paste(sQuote(deparse(substitute(rs))), " is transformed into a relational system with a ", 
            dQuote("Rel.System"), " class.", sep = ""), call. = FALSE)
        rs <- rel.sys(rs, bonds = "entire")
    }
    if (isTRUE(k < 0L) == TRUE) 
        stop(paste(sQuote("k"), " must not be negative.", sep = ""))
    if (isTRUE(k == 0L) == TRUE) 
        ifelse((inclx), return(x), return(character(0)))
    ifelse(missing(expand) == FALSE && isTRUE(expand == TRUE) == 
        TRUE, expand <- TRUE, expand <- FALSE)
    if (isTRUE(all(x %in% unique(unlist(dhc(as.character(rs$nodes)))))) == 
        TRUE) {
        if (isTRUE(length(rs$Ties) > 0L) == TRUE) {
            rst <- as.list(unlist(rs$Ties))
            srs <- list()
            for (i in seq_len(length(rst))) {
                tmp <- vector()
                if (length(rst[[i]]) > 0L) {
                  for (n in seq_len(length(x))) {
                    for (j in seq_len(length(rst[[i]]))) {
                      if (x[n] %in% c(c(strsplit(rst[[i]][j], 
                        rs$sep)[[1]][1], strsplit(rst[[i]][j], 
                        rs$sep)[[1]][2]))) {
                        tmp <- append(tmp, rst[[i]][j])
                      }
                    }
                    rm(j)
                  }
                  rm(n)
                }
                srs[[i]] <- as.vector(unlist(tmp))
            }
            rm(i)
            attr(srs, "names") <- attr(rst, "names")
            nrs <- vector()
            for (i in seq_len(length(srs))) {
                if (isTRUE(length(srs[[i]]) > 0L) == TRUE) {
                  for (j in seq_len(length(srs[[i]]))) {
                    switch(match.arg(type), und = nrs <- append(nrs, 
                      strsplit(srs[[i]][j], rs$sep)[[1]][1]), 
                      inn = nrs <- append(nrs, strsplit(srs[[i]][j], 
                        rs$sep)[[1]][1]), out = nrs <- append(nrs, 
                        (strsplit(srs[[i]][j], rs$sep)[[1]][2])))
                    switch(match.arg(type), und = nrs <- append(nrs, 
                      strsplit(srs[[i]][j], rs$sep)[[1]][2]), 
                      inn = NA, out = NA)
                  }
                  rm(j)
                }
            }
            rm(i)
            nb <- unique(nrs)
            if (isTRUE(k > 1L) == TRUE) {
                if (isTRUE(expand == FALSE) == TRUE) {
                  for (i in 2:k) {
                    nb <- append(nb, ngbs(nb, rs, type = type))
                  }
                  rm(i)
                }
                else if (isTRUE(expand == TRUE) == TRUE) {
                  nb2 <- nb
                  nbk <- list()
                  if (!(inclx)) {
                    nbk[[1]] <- nb2[which(!(nb2 %in% x))]
                    ink <- 2L
                  }
                  else {
                    nbk[[1]] <- x
                    nbk[[2]] <- nb2[which(!(nb2 %in% x))]
                    ink <- 3
                    k <- k + 1L
                  }
                  for (i in ink:k) {
                    nb2 <- append(nb2, ngbs(nb2, rs, type = type))
                    nbk[[i]] <- nb2[which(!(nb2 %in% c(nb, unlist(nbk))))]
                  }
                  rm(i)
                  ifelse(!(inclx), attr(nbk, "names") <- paste0("k=", 
                    seq_len(k)), attr(nbk, "names") <- paste0("k=", 
                    seq_along((ink - 2L):k) - 1L))
                }
            }
            else {
                NA
            }
        }
        else if (isTRUE(length(rs$Ties) > 0L) == FALSE) {
            nb <- x
        }
        if (isTRUE(expand == FALSE) == TRUE) {
            ifelse(!(inclx), return(nb[which(!(nb %in% x))]), 
                return(nb))
        }
        else if (isTRUE(expand == TRUE) == TRUE) {
            return(nbk)
        }
    }
    else {
        warning(paste(sQuote(deparse(substitute(x))), " is not part of ", 
            sQuote(deparse(substitute(rs))), ".", sep = ""), 
            call. = FALSE)
        x
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
fltr <-
function (x, PO, ideal = FALSE, rclos) 
{
    if (isTRUE("Partial.Order" %in% attr(PO, "class")) == FALSE) 
        stop(paste(sQuote(deparse(substitute(PO))), " must be a ", 
            dQuote("Partial.Order"), " class object.", sep = ""))
    if (is.null(dimnames(PO)[[1]]) == TRUE) 
        stop(paste("Dimnames in ", sQuote(deparse(substitute(PO))), 
            " are NULL.", sep = ""))
    ifelse(missing(rclos) == FALSE && isTRUE(rclos == FALSE) == 
        TRUE, rclos <- FALSE, rclos <- TRUE)
    if (isTRUE(is.character(x) == TRUE) == TRUE) {
        lbs <- dimnames(PO)[[1]]
        ifelse(isTRUE(attr(PO, "class")[3] == ", ") == FALSE, 
            tmp <- jnt(unlist(strsplit(lbs, "}{", fixed = TRUE)), 
                sep = ",, "), tmp <- jnt(unlist(strsplit(lbs, 
                "} {", fixed = TRUE)), sep = ",, "))
        tmp <- sub("{}{", "", dhc(tmp, sep = ",, "), fixed = TRUE)
        tmp <- sub("}{}", "", dhc(tmp, sep = ",, "), fixed = TRUE)
        tmp <- sub("{", "", dhc(tmp, sep = ",, "), fixed = TRUE)
        tmp <- sub("}", "", dhc(tmp, sep = ",, "), fixed = TRUE)
        tmp <- dhc(tmp, sep = attr(PO, "class")[3])
        if (isTRUE(length(tmp) != length(unique(tmp))) == TRUE) 
            stop(paste(sQuote(deparse(substitute(PO))), " must be in a reduced form.", 
                sep = ""))
        ifelse(all(x %in% tmp) == FALSE, x <- x[which(x %in% 
            tmp)], NA)
        X <- vector()
        for (k in seq_len(length(x))) {
            for (i in seq_len(length(lbs))) {
                ifelse(isTRUE(attr(PO, "class")[3] == ", ") == 
                  FALSE, tmplb <- jnt(unlist(strsplit(lbs[i], 
                  "}{", fixed = TRUE)), sep = ",, "), tmplb <- jnt(unlist(strsplit(lbs[i], 
                  "} {", fixed = TRUE)), sep = ",, "))
                tmplb <- sub("{}{", "", dhc(tmplb, sep = ",, "), 
                  fixed = TRUE)
                tmplb <- sub("}{}", "", dhc(tmplb, sep = ",, "), 
                  fixed = TRUE)
                tmplb <- sub("{", "", dhc(tmplb, sep = ",, "), 
                  fixed = TRUE)
                tmplb <- sub("}", "", dhc(tmplb, sep = ",, "), 
                  fixed = TRUE)
                tmplb <- dhc(tmplb, sep = attr(PO, "class")[3])
                if (isTRUE(x[k] %in% tmplb) == TRUE) {
                  X <- append(X, i)
                  break
                }
                else {
                  NA
                }
            }
            rm(i)
        }
        rm(k)
        if (isTRUE(length(X) == 0) == TRUE) 
            stop(paste(sQuote(deparse(substitute(x))), " is not part of ", 
                sQuote(deparse(substitute(PO))), ".", sep = ""), 
                call. = FALSE)
    }
    else {
        if (isTRUE(max(x) > nrow(PO) | min(x) <= 0L) == TRUE) 
            stop(paste("Elements in ", sQuote(deparse(substitute(x))), 
                " must be greater than the size of ", sQuote(deparse(substitute(PO))), 
                ".", sep = ""))
        X <- as.integer(x)
    }
    ifelse(isTRUE(ideal == TRUE) == TRUE, po <- t(PO), po <- PO)
    pfl <- vector()
    for (i in seq_len(nrow(po))) {
        for (k in seq_len(length(X))) {
            ifelse(isTRUE(po[X[k], i] == 1L) == TRUE && isTRUE(po[i, 
                X[k]] == 0L) == TRUE, pfl <- append(pfl, i), 
                NA)
        }
        rm(k)
    }
    rm(i)
    if (isTRUE(rclos == TRUE) == TRUE) {
        pfl <- append(X, pfl)
    }
    else {
        NA
    }
    if (isTRUE(length(pfl) > 0L) == TRUE) {
        pfl <- unique(pfl)
        pfll <- as.list(dimnames(PO)[[1]][pfl])
        attr(pfll, "names") <- pfl
    }
    else {
        pfll <- NULL
    }
    return(pfll)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
wordT <-
function (x) 
{
    if (is.array(x) == FALSE) 
        stop("Data must be a stacked array of square matrices.")
    if (is.na(dim(x)[3]) == TRUE) {
        s0 <- data.frame(matrix(ncol = 1, nrow = 1))
        if (isTRUE(all.equal(replace(x %*% x, x %*% x >= 1, 1), 
            x) == TRUE)) 
            s0[1, 1] <- 1
        Bx <- array(dim = c(dim(x)[1], dim(x)[2], 2))
        Bx[, , 1] <- as.matrix(x)
        Bx[, , 2] <- replace(x %*% x, x %*% x >= 1, 1)
    }
    if (is.na(dim(x)[3]) == FALSE) {
        tmp0 <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
            nrow = 0))
        for (i in seq_len(dim(x)[3])) {
            ifelse(dim(x)[3] > 1, tmp0[i, ] <- as.vector(x[, 
                , i]), tmp0 <- as.vector(x))
        }
        rm(i)
        if (isTRUE(is.null(dim(tmp0)) == FALSE) == TRUE) 
            rownames(tmp0) <- dimnames(x)[[3]]
        if (dim(x)[3] < 2) 
            x <- array(tmp0, c(dim(x)[1], dim(x)[2]))
        if (dim(x)[3] > 1) {
            tmp <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp0))))
            for (i in seq_len(nrow(unique(tmp0)))) {
                tmp[, , i][seq_len(dim(x)[1] * dim(x)[2])] <- as.numeric(unique(tmp0)[i, 
                  ])
            }
            rm(i)
            if (is.null(dimnames(tmp)[[1]]) == FALSE) 
                dimnames(tmp)[[3]] <- rownames(unique(tmp0))
            if (is.null(dimnames(x)[[1]]) == FALSE) 
                dimnames(tmp)[[1]] <- dimnames(tmp)[[2]] <- dimnames(x)[[1]]
            x <- tmp
            dimnames(x)[[3]] <- as.list(rownames(unique(tmp0)))
        }
        s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(x)[3]))
        for (k in seq_len(dim(x)[3])) {
            for (j in seq_len(dim(x)[3])) {
                for (i in rev(seq_len(dim(x)[3]))) {
                  if (isTRUE(all.equal(replace(x[, , j] %*% x[, 
                    , k], x[, , j] %*% x[, , k] >= 1, 1), x[, 
                    , i]) == TRUE)) 
                    s0[j, k] <- i
                }
            }
        }
        rm(i, j, k)
        rm(tmp0, tmp)
        dimnames(s0)[[1]] <- seq_len(dim(x)[3])
        dimnames(s0)[[2]] <- seq_len(dim(x)[3])
        if (sum(as.numeric(is.na(s0))) == 0) 
            Bx <- x
        if (sum(as.numeric(is.na(s0))) > 0) {
            Bx <- array(dim = c(dim(x)[1], dim(x)[2], 0))
            for (i in seq_len(nrow(s0))) {
                for (j in seq_len(length(which(is.na(s0[i, ]))))) {
                  if (length(which(is.na(s0[i, ]))) > 0) 
                    Bx <- zbnd(Bx, (replace(x[, , i] %*% x[, 
                      , which(is.na(s0[i, ]))[j]], x[, , i] %*% 
                      x[, , which(is.na(s0[i, ]))[j]] >= 1, 1)))
                }
            }
            rm(i, j)
            tmp <- data.frame(matrix(ncol = (dim(x)[1] * dim(x)[2]), 
                nrow = 0))
            for (i in seq_len(dim(Bx)[3])) {
                tmp[i, ] <- as.vector(Bx[, , i])
            }
            rm(i)
            xBx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
            for (i in seq_len(nrow(unique(tmp)))) {
                xBx[, , i][seq_len(dim(Bx)[1] * dim(Bx)[2])] <- as.numeric(unique(tmp)[i, 
                  ])
            }
            rm(i)
            if (is.null(dimnames(xBx)) == FALSE) 
                dimnames(xBx)[[3]] <- (dim(x)[3] + 1):(dim(xBx)[3] + 
                  dim(x)[3])
            Bx <- zbnd(x, xBx)
            rm(xBx, tmp)
        }
    }
    while (sum(as.numeric(is.na(s0))) > 0) {
        BBx <- Bx
        for (i in seq_len(nrow(s0))) {
            for (j in seq_len(length(which(is.na(s0[i, ]))))) {
                if (length(which(is.na(s0[i, ]))) > 0) 
                  BBx <- zbnd(BBx, (replace(Bx[, , i] %*% Bx[, 
                    , which(is.na(s0[i, ]))[j]], Bx[, , i] %*% 
                    Bx[, , which(is.na(s0[i, ]))[j]] >= 1, 1)))
            }
        }
        rm(i, j)
        tmp <- data.frame(matrix(ncol = (dim(Bx)[1] * dim(Bx)[2]), 
            nrow = 0))
        for (i in seq_len(dim(BBx)[3])) {
            tmp[i, ] <- as.vector(BBx[, , i])
        }
        rm(i)
        Bx <- array(dim = c(dim(x)[1], dim(x)[2], nrow(unique(tmp))))
        for (i in seq_len(nrow(unique(tmp)))) {
            Bx[, , i][seq_len(dim(BBx)[1] * dim(BBx)[2])] <- as.numeric(unique(tmp)[i, 
                ])
        }
        rm(i)
        rm(tmp, BBx)
        if (is.na(dim(x)[3]) == TRUE) {
            s0 <- data.frame(matrix(ncol = 1, nrow = dim(Bx)[3]))
            for (j in seq_len(dim(Bx)[3])) {
                for (i in rev(seq_len(dim(Bx)[3]))) {
                  if (isTRUE(all.equal(replace(Bx[, , j] %*% 
                    Bx[, , 1], Bx[, , j] %*% Bx[, , 1] >= 1, 
                    1), Bx[, , i]) == TRUE)) 
                    s0[j, 1] <- i
                }
            }
            rm(i, j)
        }
        if (is.na(dim(x)[3]) == FALSE) {
            s0 <- data.frame(matrix(ncol = dim(x)[3], nrow = dim(Bx)[3]))
            for (k in seq_len(dim(x)[3])) {
                for (j in seq_len(dim(Bx)[3])) {
                  for (i in rev(seq_len(dim(Bx)[3]))) {
                    if (isTRUE(all.equal(replace(Bx[, , j] %*% 
                      Bx[, , k], Bx[, , j] %*% Bx[, , k] >= 1, 
                      1), Bx[, , i]) == TRUE)) 
                      s0[j, k] <- i
                  }
                }
            }
            rm(i, j, k)
        }
    }
    ifelse(isTRUE(is.na(dim(x)[3])) == TRUE, dimnames(s0)[[2]] <- 1, 
        dimnames(s0)[[2]] <- seq_len(dim(x)[3]))
    tmp0 <- data.frame(matrix(ncol = (dim(Bx)[1] * dim(Bx)[2]), 
        nrow = 0))
    for (i in seq_len(dim(Bx)[3])) {
        tmp0[i, ] <- as.vector(Bx[, , i])
    }
    rm(i)
    rownames(tmp0) <- dimnames(Bx)[[3]]
    tmp <- array(dim = c(dim(Bx)[1], dim(Bx)[2], nrow(unique(tmp0))))
    for (i in seq_len(nrow(unique(tmp0)))) {
        tmp[, , i][seq_len(dim(Bx)[1] * dim(Bx)[2])] <- as.numeric(unique(tmp0)[i, 
            ])
    }
    rm(i)
    Bx <- tmp
    dimnames(Bx)[[3]] <- as.list(rownames(unique(tmp0)))
    E <- s0
    rm(s0)
    if (dim(Bx)[3] == ncol(E)) {
        W <- rbind(cbind(seq_len(ncol(E)), NA, NA))
        colnames(W) <- c("", "n", "g")
    }
    if (dim(Bx)[3] > ncol(E)) {
        tmp <- (ncol(E) + 1):dim(Bx)[3]
        z <- vector()
        for (i in seq_len(length(tmp))) {
            z[i] <- which(t(E) == tmp[i])[1]
        }
        rm(i)
        g <- vector()
        for (i in seq_len(length(tmp))) {
            ifelse(z[i]%%ncol(E) == 0, g[i] <- ncol(E), g[i] <- z[i]%%ncol(E))
        }
        rm(i)
        n <- vector()
        for (i in seq_len(length(tmp))) {
            ifelse(z[i]%%ncol(E) == 0, n[i] <- (z[i]%/%ncol(E)), 
                n[i] <- ((z[i]%/%ncol(E)) + 1))
        }
        rm(i)
        W <- rbind(cbind(seq_len(ncol(E)), NA, NA), cbind(((ncol(E) + 
            1):nrow(E)), n, g))
        rm(z, n, g)
    }
    rm(tmp)
    wt <- list(gens = x, WT = W)
    class(wt) <- "WordTable"
    return(wt)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
cpath <-
function (x, values = FALSE, collapse = TRUE, directed, bonds, 
    sel, sep, lb2lb) 
{
    if (missing(directed) == FALSE && isTRUE(directed == FALSE) == 
        TRUE) {
        if (is.na(dim(x)[3]) == FALSE) {
            for (i in seq_len(dim(x)[3])) {
                x[, , i] <- mnplx(x[, , i], directed = FALSE)
            }
            rm(i)
        }
        else {
            x <- mnplx(x, directed = FALSE)
        }
    }
    else {
        NA
    }
    ifelse(missing(bonds) == TRUE, bonds <- "entire", NA)
    ifelse(missing(sep) == TRUE, sep <- ",", NA)
    ifelse(missing(sel) == FALSE && isTRUE(sel == "all") == TRUE, 
        sel <- dimnames(x)[[1]], NA)
    ifelse(missing(lb2lb) == FALSE && isTRUE(lb2lb == FALSE) == 
        TRUE, lb2lb <- FALSE, lb2lb <- TRUE)
    netrs <- transf(dichot(x, c = 1L), type = "tolist", lb2lb = lb2lb)
    qn <- list()
    if (is.na(dim(x)[3]) == FALSE) {
        cmp <- vector()
        for (k in seq_len((length(netrs) - 1L))) {
            if (length(netrs[[k]]) > 0) {
                for (i in seq_len(length(netrs[[k]]))) {
                  for (j in seq_len(length(netrs[[k + 1L]]))) {
                    if (isTRUE(any(duplicated(dhc(c(netrs[[k]][i], 
                      netrs[[k + 1]][j]))[seq(2, 3)]))) == TRUE) {
                      cmp <- append(cmp, paste0(attr(netrs[k], 
                        "names"), attr(netrs[k + 1L], "names")))
                      qn[[length(qn) + 1L]] <- as.vector(unique(dhc(c(netrs[[k]][i], 
                        netrs[[k + 1L]][j]))))
                    }
                    else if (isTRUE(any(duplicated(dhc(c(netrs[[k + 
                      1L]][j], netrs[[k]][i]))[seq(2, 3)]))) == 
                      TRUE) {
                      cmp <- append(cmp, paste0(attr(netrs[k + 
                        1L], "names"), attr(netrs[k], "names")))
                      qn[[length(qn) + 1L]] <- as.vector(unique(dhc(c(netrs[[k + 
                        1L]][j], netrs[[k]][i]))))
                    }
                  }
                  rm(j)
                }
                rm(i)
            }
        }
        rm(k)
        ifelse(isTRUE(length(cmp) != 0) == TRUE, attr(qn, "names") <- cmp, 
            NA)
    }
    else if (is.na(dim(x)[3]) == TRUE) {
        NA
    }
    qm <- list()
    cp <- vector()
    if (is.na(dim(x)[3]) == FALSE) {
        for (k in seq_len((length(netrs)))) {
            if (length(netrs[[k]]) > 1) {
                for (i in seq_len(length(netrs[[k]]) - 1L)) {
                  for (j in (i + 1L):length(netrs[[k]])) {
                    if (isTRUE(any(duplicated(dhc(c(netrs[[k]][i], 
                      netrs[[k]][j]))[seq(2, 3)]))) == TRUE) {
                      cp <- append(cp, paste0(attr(netrs[k], 
                        "names"), attr(netrs[k], "names")))
                      qm[[length(qm) + 1L]] <- as.vector(unique(dhc(c(netrs[[k]][i], 
                        netrs[[k]][j]))))
                    }
                  }
                  rm(j)
                }
                rm(i)
                for (i in length(netrs[[k]]):1) {
                  for (j in (i - 1L):1) {
                    if (isTRUE(any(duplicated(dhc(c(netrs[[k]][i], 
                      netrs[[k]][j]))[seq(2, 3)]))) == TRUE) {
                      cp <- append(cp, paste0(attr(netrs[k], 
                        "names"), attr(netrs[k], "names")))
                      qm[[length(qm) + 1L]] <- as.vector(unique(dhc(c(netrs[[k]][i], 
                        netrs[[k]][j]))))
                    }
                  }
                  rm(j)
                }
                rm(i)
            }
        }
        rm(k)
        ifelse(isTRUE(length(cp) != 0) == TRUE, attr(qm, "names") <- cp, 
            NA)
    }
    else if (is.na(dim(x)[3]) == TRUE) {
        for (i in seq_len(length(netrs) - 1L)) {
            for (j in (i + 1L):length(netrs)) {
                if (isTRUE(any(duplicated(dhc(c(netrs[i], netrs[j]))[seq(2, 
                  3)]))) == TRUE) {
                  qm[[length(qm) + 1L]] <- as.vector(unique(dhc(c(netrs[i], 
                    netrs[j]))))
                }
            }
            rm(j)
        }
        rm(i)
        for (i in length(netrs):1) {
            for (j in (i - 1L):1) {
                if (isTRUE(any(duplicated(dhc(c(netrs[i], netrs[j]))[seq(2, 
                  3)]))) == TRUE) {
                  qm[[length(qm) + 1]] <- as.vector(unique(dhc(c(netrs[i], 
                    netrs[j]))))
                }
            }
            rm(j)
        }
        rm(i)
    }
    if (missing(sel) == TRUE) {
        bnd2 <- c(qm, qn)
    }
    else {
        pths <- c(qm, qn)
        bnd2 <- list()
        bnd2s <- list()
        cpsel <- vector()
        for (i in seq_len(length(pths))) {
            if (any(sel %in% pths[[i]]) == TRUE) {
                ifelse(isTRUE(values == TRUE) == TRUE, bnd2s[[length(bnd2s) + 
                  1L]] <- pths[[i]][seq_len(3)], NA)
                bnd2[[length(bnd2) + 1L]] <- pths[[i]]
                cpsel <- append(cpsel, attr(pths, "names")[i])
            }
            else {
                NA
            }
        }
        rm(i)
        ifelse(isTRUE(length(cpsel) == 0) == TRUE, NA, attr(bnd2, 
            "names") <- cpsel)
        if (isTRUE(values == TRUE) == TRUE) {
            vsel <- list()
            length(vsel) <- length(sel)
            for (i in seq_len(length(vsel))) {
                vsel[[i]] <- which(unlist(bnd2s) %in% sel[i])%%3L
            }
            rm(i)
            attr(vsel, "names") <- sel
            rm(bnd2s)
        }
        else {
            NA
        }
    }
    if (isTRUE(length(bnd2) == 0) == TRUE) {
        return(list(0))
    }
    else {
        str2 <- attr(bnd2, "names")
        if (isTRUE(collapse == FALSE) == TRUE) {
            jbnd2 <- jnt(bnd2, sep = sep)
        }
        else if (isTRUE(collapse == TRUE) == TRUE) {
            if (is.null(str2) == FALSE) {
                str2u <- unique(attr(bnd2, "names"))
                jbnd2 <- list()
                length(jbnd2) <- length(str2u)
                for (i in seq_len(length(str2u))) {
                  jbnd2[[i]] <- as.vector(unlist(jnt(bnd2, sep = sep)[which(attr(bnd2, 
                    "names") == str2u[i])]))
                }
                rm(i)
                attr(jbnd2, "names") <- str2u
            }
            else {
                jbnd2 <- unlist(jnt(bnd2, sep = sep))
            }
        }
        if (isTRUE(values == TRUE) == TRUE) {
            if (is.na(dim(x)[3]) == FALSE) {
                str2 <- attr(bnd2, "names")
                lcp <- levels(factor(str2))
                count <- vector()
                for (i in seq_len(length(lcp))) count <- append(count, 
                  sum(str2 == lcp[i]))
                cnt <- t(as.data.frame(count))
                colnames(cnt) <- lcp
                rownames(cnt) <- ""
            }
            else {
                cnt <- length(jbnd2)
            }
            if (missing(sel) == TRUE) {
                return(list(cp = jbnd2, counts = cnt, total = sum(cnt)))
            }
            else {
                cnts <- matrix(0L, nrow = length(vsel), ncol = 3)
                colnames(cnts) <- c("orig", "intr", "trgt")
                rownames(cnts) <- attr(vsel, "names")
                for (i in seq_len(length(vsel))) {
                  cnts[i, 1] <- length(which(vsel[[i]] == 1))
                  cnts[i, 2] <- length(which(vsel[[i]] == 2))
                  cnts[i, 3] <- length(which(vsel[[i]] == 0))
                }
                rm(i)
                return(list(cp = jbnd2, sel = cnts, counts = cnt, 
                  total = sum(cnt)))
            }
        }
        else {
            jbnd2
        }
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
cngr <-
function (S, PO, uniq) 
{
    if (missing(S) == TRUE) 
        stop("Semigroup is missing.")
    if (missing(PO) == TRUE) {
        PO <- NULL
    }
    else {
        class(PO) <- NULL
    }
    if (isTRUE("Semigroup" %in% attr(S, "class")) == FALSE || 
        isTRUE("symbolic" %in% attr(S, "class")) == TRUE) {
        s <- suppressWarnings(as.semigroup(S, numerical = TRUE))
        flgnum <- TRUE
    }
    else {
        s <- S
        flgnum <- FALSE
    }
    ns <- s$ord
    if (isTRUE(ns > 1L) == TRUE) {
        mat <- matrix(0L, nrow = ns, ncol = ns, dimnames = list(seq_len(ns), 
            seq_len(ns)))
        for (i in seq_len(ns)) {
            mat[which(s$S == i)[1]] <- i
        }
        rm(i)
        inc <- levels(factor(trnf(dichot(mat, c = 1), tolist = TRUE, 
            sep = ", ")))
        clus <- data.frame(matrix(ncol = ns, nrow = 0))
        if (isTRUE(nlevels(factor(as.matrix(s$S))) != 1) == TRUE) {
            kual <- as.vector(mat)[which(as.vector(mat) > 0)]
            for (k in kual) {
                for (i in seq_along(inc)) {
                  clus[i, ] <- as.vector(sprt(s$S, as.numeric(dhc(inc[i])[1]), 
                    as.numeric(dhc(inc[i])[2])))
                }
                rm(i)
            }
            rm(k)
            ifelse(missing(uniq) == FALSE && isTRUE(uniq == TRUE) == 
                TRUE, clus <- unique(clus), NA)
            colnames(clus) <- rownames(clus) <- NULL
            cls <- data.matrix(clus)
            cg <- list()
            for (i in seq_len(nrow(cls))) {
                cg[[i]] <- as.vector(cls[i, ])
                if (isTRUE(flgnum == TRUE) == TRUE) {
                  attr(cg[[i]], "names") <- S$st
                }
                else {
                  attr(cg[[i]], "names") <- dimnames(S)[[1]]
                }
            }
            rm(i)
        }
        else {
            cg <- rep(1, s$dim)
        }
        ifelse(isTRUE(flgnum == TRUE) == TRUE, sS <- S$S, sS <- s$S)
        ifelse(isTRUE(is.null(PO)) == FALSE, lst <- list(S = sS, 
            PO = PO, clu = cg), lst <- list(S = sS, clu = cg))
        ifelse(isTRUE(flgnum == TRUE) == TRUE, Sclss <- "symbolic", 
            Sclss <- attr(s, "class")[2])
        ifelse(isTRUE(is.null(PO)) == FALSE, class(lst) <- c("Congruence", 
            "PO.Semigroup", Sclss), class(lst) <- c("Congruence", 
            "A.Semigroup", Sclss))
        return(lst)
    }
    else {
        s
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
transf <-
function (x, type = c("toarray", "tolist", "toarray2", "toedgel"), 
    lbs = NULL, lb2lb, valued, sep, ord, sort, sym, add, adc, 
    rm.isol, na.rm) 
{
    if (is.list(x) == TRUE) {
        if (isTRUE(length(x) == 1L) == TRUE) {
            x <- x[[1]]
        }
        else if (is.null(unlist(x)) == TRUE) {
            return(NULL)
        }
        else {
            NA
        }
    }
    else if (is.array(x) == TRUE && match.arg(type) != "toarray") {
        ifelse(missing(valued) == FALSE && isTRUE(valued == TRUE) == 
            TRUE, NA, x <- dichot(x, c = 1))
    }
    ifelse(missing(na.rm) == FALSE && isTRUE(na.rm == TRUE) == 
        TRUE, na.rm <- TRUE, na.rm <- FALSE)
    ifelse(missing(sort) == FALSE && isTRUE(sort == TRUE) == 
        TRUE, sort <- TRUE, sort <- FALSE)
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    if (match.arg(type) == "toarray") {
        if (is.array(x) == TRUE && missing(add) == TRUE && is.null(lbs) == 
            TRUE) {
            if (missing(rm.isol) == FALSE && isTRUE(rm.isol == 
                TRUE) == TRUE) {
                return(rm.isol(x))
            }
            else {
                message("No transformation.")
                return(x)
            }
        }
        if (is.matrix(x) == TRUE && isTRUE(length(unique(dim(x))) == 
            1) == TRUE) {
            if (is.null(lbs) == TRUE) {
                lbs <- dimnames(x)[[1]]
            }
            else {
                NA
            }
        }
        if (is.data.frame(x) == TRUE || (is.matrix(x) == TRUE && 
            identical(dimnames(x)[[1]], dimnames(x)[[2]]) == 
                FALSE)) {
            mat <- rbind(as.matrix(cbind(array(0L, dim = c(nrow(x), 
                nrow(x))), x)), matrix(0L, nrow = ncol(x), ncol = sum(dim(x))))
            dimnames(mat)[[1]] <- dimnames(mat)[[2]] <- c(rownames(x), 
                colnames(x))
            if (missing(add) == FALSE) {
                warning(paste("Option ", sQuote("add"), " not supported for non-square arrays.", 
                  sep = ""), call. = FALSE)
            }
            else {
                NA
            }
            return(as.data.frame(mat))
        }
        if (missing(add) == FALSE) {
            if (is.list(x) == TRUE) {
                if (is.list(add) == TRUE) {
                  for (i in seq_len(length(add))) {
                    x[[i]] <- append(x[[i]], add[[i]])
                  }
                  rm(i)
                }
                else if (is.vector(add) == TRUE) {
                  for (i in seq_len(length(add))) {
                    x[[i]] <- append(x[[i]], add)
                  }
                  rm(i)
                }
            }
            else if (is.vector(x) == TRUE && is.array(x) == FALSE && 
                is.vector(add) == TRUE) {
                x <- c(x, add)
            }
            else if (is.array(x) == TRUE) {
                lbs <- c(dimnames(x)[[1]], add)
            }
        }
        if ((is.list(x) == TRUE && isTRUE(length(x) > 1L) == 
            TRUE) && is.matrix(x[[1]]) == TRUE) 
            return(x)
        if (missing(ord) == FALSE) {
            ord <- as.numeric(ord)
            if ((is.array(x) == FALSE & is.data.frame(x) == FALSE) && 
                isTRUE(nlevels(factor(unlist(dhc(x, sep = sep)))) > 
                  ord) == TRUE) {
                ord <- nlevels(factor(unlist(dhc(x, sep = sep))))
                warning(paste("Value in ", sQuote("ord"), " is ignored since the number of factor levels in pairwise list is higher.", 
                  sep = ""), call. = FALSE)
            }
            else {
                NA
            }
        }
        else if (missing(ord) == TRUE) {
            if (is.null(lbs) == FALSE) {
                ord <- length(lbs)
            }
            else {
                if (is.vector(x) == TRUE) {
                  if (isTRUE("data.frame" %in% unlist(lapply(x, 
                    is), use.names = FALSE)) == TRUE) {
                    ord <- length(unique(unlist(lapply(x, dimnames), 
                      use.names = FALSE)))
                  }
                  else {
                    ord <- length(unique(dhc(unlist(x, use.names = FALSE))))
                  }
                }
                else {
                  ord <- dim(x)[1]
                }
            }
        }
        if (is.array(x) == TRUE) {
            if (isTRUE(length(unique(dim(x))) > 1) == TRUE) {
                Lbs <- lbs
            }
            else {
                ifelse(is.null(lbs) == TRUE, Lbs <- dimnames(x)[[1]][seq_len(ord)], 
                  Lbs <- lbs[seq_len(ord)])
            }
            if (any(duplicated(Lbs)) == TRUE) {
                Lbs <- unique(Lbs)
                ord <- length(Lbs)
            }
            else {
                NA
            }
        }
        else if (is.array(x) == FALSE) {
            if (is.null(lbs) == FALSE) {
                if (any(unique(unlist(dhc(x))) %in% lbs) == FALSE && 
                  all(suppressWarnings(is.na(as.numeric(unique(unlist(dhc(x))))))) == 
                    FALSE) {
                  Lbs <- seq_len(ord)
                }
                else {
                  Lbs <- lbs[seq_len(ord)]
                }
            }
            else {
                if (isTRUE("data.frame" %in% unlist(lapply(x, 
                  is), use.names = FALSE)) == TRUE) {
                  ifelse(isTRUE(sort == TRUE) == TRUE, Lbs <- sort(unique(unlist(lapply(x, 
                    dimnames), use.names = FALSE))), Lbs <- unique(unlist(lapply(x, 
                    dimnames), use.names = FALSE)))
                }
                else {
                  ifelse(isTRUE(sort == TRUE) == TRUE, Lbs <- sort(unique(unlist(dhc(x, 
                    sep = sep))))[seq_len(ord)], Lbs <- levels(factor(unlist(dhc(x, 
                    sep = sep))))[seq_len(ord)])
                }
            }
        }
        if (is.list(x) == TRUE) {
            arr <- array(0L, dim = c(ord, ord, length(x)), dimnames = list(Lbs, 
                Lbs, names(x)))
            if (isTRUE("data.frame" %in% unlist(lapply(x, methods::is), 
                use.names = FALSE)) == TRUE) {
                for (k in seq_len(length(x))) {
                  lst <- vector(mode = "list", length = length(Lbs))
                  names(lst) <- Lbs
                  sco <- rownames(x[[k]])[which(x[[k]] == 1)%%nrow(x[[k]])]
                  for (i in unique(which(x[[k]] == 1)%%nrow(x[[k]]))) {
                    rco <- colnames(x[[k]])[which(x[[k]][i, ] == 
                      1)]
                    for (j in seq_len(length(rco))) {
                      ifelse(is.null(unlist(lst[which(Lbs %in% 
                        rco[j])])) == FALSE, lst[[which(Lbs %in% 
                        rco[j])]] <- append(as.vector(unlist(lst[which(Lbs %in% 
                        rco[j])])), rownames(x[[k]][i, ])), lst[which(Lbs %in% 
                        rco[j])] <- rownames(x[[k]][i, ]))
                    }
                    rm(j)
                  }
                  rm(i)
                  tmp <- matrix(0L, ncol = as.numeric(ord), nrow = as.numeric(ord), 
                    dimnames = list(Lbs, Lbs))
                  for (j in seq_len(length(lst))) {
                    if (is.null(lst[[j]]) == FALSE) {
                      for (i in seq_len(length(lst[[j]]))) {
                        tmp[which(rownames(tmp) == lst[[j]][i]), 
                          which(colnames(tmp) == names(lst)[j])] <- tmp[which(rownames(tmp) == 
                          lst[[j]][i]), which(colnames(tmp) == 
                          names(lst)[j])] + 1L
                      }
                      rm(i)
                    }
                  }
                  rm(j)
                  arr[, , k] <- tmp
                }
                rm(k)
            }
            else {
                for (i in seq_len(length(x))) {
                  for (k in seq_len(length(x[[i]]))) {
                    crs <- dhc(x[[i]][k], sep = sep)
                    arr[which(Lbs %in% crs[1]), which(Lbs %in% 
                      crs[2]), i] <- 1L
                  }
                  rm(k)
                }
                rm(i)
            }
            if (missing(sym) == FALSE && isTRUE(sym == TRUE) == 
                TRUE) {
                for (i in seq_len(dim(arr)[3])) {
                  arr[, , i] <- arr[, , i] + t(arr[, , i])
                }
                rm(i)
            }
            if (is.null(lbs) == FALSE && isTRUE(length(lbs) == 
                dim(arr)[1]) == TRUE) {
                dimnames(arr)[[1]] <- dimnames(arr)[[2]] <- lbs
            }
            else {
                NA
            }
            if (isTRUE(sort == TRUE) == TRUE) {
                return(perm(arr, sort = TRUE))
            }
            else {
                return(arr)
            }
        }
        else if (is.vector(x) == TRUE && is.array(x) == FALSE) {
            mat <- matrix(0L, ncol = ord, nrow = ord, dimnames = list(Lbs, 
                Lbs))
            for (k in seq_len(length(x))) {
                crs <- dhc(x[k], sep = sep)
                mat[which(Lbs %in% crs[1]), which(Lbs %in% crs[2])] <- 1L
            }
            rm(k)
            ifelse(missing(sym) == FALSE && isTRUE(sym == TRUE) == 
                TRUE, mat <- mat + t(mat), NA)
            if (isTRUE(sort == TRUE) == TRUE) {
                return(perm(mat, sort = TRUE))
            }
            else {
                return(mat)
            }
        }
        else if (is.array(x) == TRUE) {
            ifelse(isTRUE(NA %in% Lbs) == TRUE && is.null(lbs) == 
                FALSE, Lbs <- lbs, NA)
            if (is.na(dim(x)[3]) == TRUE && isTRUE(length(unique(dim(x))) == 
                1) == TRUE) {
                mat <- trnf(x, tolist = FALSE, ord = ord, lbs = Lbs)
            }
            else if (is.na(dim(x)[3]) == FALSE) {
                arr <- array(0L, dim = c(length(Lbs), length(Lbs), 
                  dim(x)[3]), dimnames = list(Lbs, Lbs, dimnames(x)[[3]]))
                for (k in seq_len(dim(x)[3])) {
                  arr[, , k] <- trnf(x[, , k], tolist = FALSE, 
                    lbs = Lbs, ord = ord)
                }
                rm(k)
            }
            else {
                mat <- matrix(0L, ncol = length(Lbs), nrow = length(Lbs), 
                  dimnames = list(Lbs, Lbs))
                for (i in seq_len(nrow(x))) {
                  mat[i, which(colnames(mat) %in% names(which(x[i, 
                    ] > 0)))] <- x[i, which(colnames(x) %in% 
                    names(which(x[i, ] > 0)))]
                }
                rm(i)
            }
        }
        else if (is.null(x) == TRUE) {
            mat <- matrix(0L, nrow = ord, ncol = ord)
        }
        else {
            stop(paste("Input for ", sQuote("toarray"), " must be vector, pairwise list, edge list, or array.", 
                sep = ""))
        }
        if (missing(sym) == FALSE && isTRUE(sym == TRUE) == TRUE) {
            if (is.na(dim(x)[3]) == TRUE) {
                mat <- mat + t(mat)
            }
            else {
                for (i in seq_len(dim(x)[3])) {
                  arr[, , i] <- arr[, , i] + t(arr[, , i])
                }
                rm(i)
            }
        }
        if (is.null(lbs) == FALSE && missing(add) == TRUE) {
            ifelse(is.na(dim(x)[3]) == TRUE, dimnames(mat)[[1]] <- dimnames(mat)[[2]] <- lbs[seq_len(ord)], 
                dimnames(arr)[[2]] <- dimnames(arr)[[2]] <- lbs[seq_len(ord)])
        }
        else {
            NA
        }
        if (isTRUE(sort == TRUE) == TRUE) {
            if (is.na(dim(x)[3]) == TRUE) {
                mat <- perm(mat, sort = TRUE)
            }
            else {
                arr <- perm(arr, sort = TRUE)
            }
        }
        else {
            NA
        }
        if (missing(rm.isol) == FALSE && isTRUE(rm.isol == TRUE) == 
            TRUE) {
            if (is.na(dim(x)[3]) == TRUE) {
                slct <- which((apply(mat, 1, sum) + apply(mat, 
                  2, sum)) > 0)
                return(mat[slct, slct])
            }
            else {
                return(arr[slct, slct, ])
            }
        }
        else {
            if (is.na(dim(x)[3]) == TRUE) {
                return(mat)
            }
            else {
                return(arr)
            }
        }
    }
    if (match.arg(type) == "toedgel") {
        if (is.array(x) == TRUE) {
            return(edgel(x, toarray = FALSE))
        }
        else if (is.data.frame(x) == FALSE) {
            if (isTRUE(na.rm == FALSE) == TRUE) {
                if (any(is.na(x)) == TRUE) 
                  message(paste("Missing information in ", sQuote("x"), 
                    " recorded as ", sQuote("NA"), ".", sep = ""))
                x[is.na(x)] <- "NA"
            }
            else {
                NA
            }
            if (is.list(x) == TRUE) {
                edgl <- data.frame(matrix(nrow = 0, ncol = (2 + 
                  length(x))))
                colnames(edgl) <- c("s", "r", names(x))
                tmps <- lapply(x, function(z) {
                  strsplit(z, sep)
                })
                for (i in seq_len(length(x[[1]]))) {
                  edgl[nrow(edgl) + 1L, ] <- c(tmps[[1]][i][[1]], 
                    1L, rep(0L, length(x) - 1L))
                }
                edgl <- unique(edgl)
                ttmps <- split(edgl[, 1:2], seq(nrow(edgl)))
                tmpss <- lapply(ttmps, function(z) {
                  unlist(z, use.names = FALSE)
                })
                for (k in 2:length(x)) {
                  if (any(tmps[[k]] %in% tmpss) == FALSE) {
                    for (i in seq_len(length(x[[k]]))) {
                      edgl[nrow(edgl) + 1L, ] <- c(tmps[[k]][i][[1]], 
                        rep(0L, length(x)))
                      edgl[nrow(edgl), (2L + k)] <- 1L
                    }
                    rm(i)
                  }
                  else if (any(tmps[[k]] %in% tmpss) == TRUE) {
                    if (all(tmps[[k]] %in% tmpss) == TRUE && 
                      all(tmpss %in% tmps[[k]]) == TRUE) {
                      edgl[, (2L + k)] <- 1L
                    }
                    else {
                      kual <- which(tmpss %in% tmps[[k]])
                      edgl[kual, (2L + k)] <- as.numeric(edgl[kual, 
                        (2L + k)]) + 1L
                      rm(kual)
                      kuals <- which(!(tmps[[k]] %in% tmpss))
                      for (i in kuals) {
                        edgl[nrow(edgl) + 1L, ] <- c(tmps[[k]][i][[1]], 
                          rep(0L, length(x)))
                        edgl[nrow(edgl), (2L + k)] <- 1L
                      }
                      rm(i)
                      rm(kuals)
                    }
                  }
                  ttmps <- split(edgl[, 1:2], seq(nrow(edgl)))
                  tmpss <- lapply(ttmps, function(z) {
                    unlist(z, use.names = FALSE)
                  })
                }
                rm(k)
            }
            else {
                if (any(duplicated(x)) == TRUE) {
                  x0 <- x[which(!(duplicated(x)))]
                  x1 <- x[which(duplicated(x))]
                  flgdp <- TRUE
                }
                else {
                  x0 <- x
                  flgdp <- FALSE
                }
                edgl <- data.frame(matrix(nrow = 0, ncol = 3))
                colnames(edgl) <- c("s", "r", "t")
                for (k in seq_len(length(x0))) {
                  edgl[nrow(edgl) + 1L, ] <- c(strsplit(x0[k], 
                    split = ", ")[[1]], "1")
                }
                rm(k)
                if (isTRUE(flgdp == TRUE) == TRUE) {
                  for (k in seq_len(length(x1))) {
                    tmp <- strsplit(x1[k], split = ", ")[[1]]
                    for (i in seq_len(nrow(edgl))) {
                      if (identical(tmp, as.character(edgl[i, 
                        1:2])) == TRUE) {
                        edgl[i, 3] <- as.numeric(edgl[i, 3]) + 
                          1L
                        break
                      }
                      else {
                        NA
                      }
                    }
                    rm(i)
                  }
                  rm(k)
                }
                else {
                  NA
                }
            }
            rownames(edgl) <- seq_len(nrow(edgl))
            return(edgl)
        }
        else {
            return(x)
        }
    }
    if (match.arg(type) == "tolist") {
        ifelse(missing(lb2lb) == FALSE && isTRUE(lb2lb == TRUE) == 
            TRUE, lb2lb <- TRUE, lb2lb <- FALSE)
        if (is.data.frame(x) == TRUE && all(is.numeric(unlist(x, 
            use.names = FALSE))) == FALSE) {
            return(apply(x, 1, function(w) {
                jnt(unlist(w, use.names = FALSE), uniq = TRUE)
            }))
        }
        if (is.list(x) == TRUE && is.data.frame(x) == FALSE) {
            inc <- list()
            for (k in seq_len(length(x))) {
                inc[[k]] <- trnf(x[[k]], tolist = TRUE, lb2lb = lb2lb, 
                  sep = sep)
            }
            rm(k)
            attr(inc, "names") <- names(x)
            return(inc)
        }
        else {
            if (isTRUE(is.character(x) == TRUE) == TRUE | (is.array(x) == 
                TRUE && is.null(dim(x)) == TRUE)) 
                return(x)
            if ((isTRUE(sum(x) > 0L) == FALSE | isTRUE(max(x) < 
                1L) == TRUE) && is.array(x) == TRUE) 
                return(NULL)
        }
        if (is.na(dim(x)[3]) == TRUE) {
            if (identical(dimnames(x)[[1]], dimnames(x)[[2]]) == 
                TRUE) {
                return(trnf(x, tolist = TRUE, lb2lb = lb2lb, 
                  sep = sep))
            }
            else {
                ifelse(is.matrix(x) == FALSE, x <- as.matrix(x), 
                  NA)
                x0 <- cbind(matrix(0, nrow = nrow(x) + ncol(x), 
                  ncol = nrow(x)), rbind(x, matrix(0, nrow = ncol(x), 
                  ncol = ncol(x))))
                dimnames(x0)[[1]] <- dimnames(x0)[[2]] <- c(rownames(x), 
                  colnames(x))
                return(trnf(x0, tolist = TRUE, lb2lb = lb2lb, 
                  sep = sep))
            }
        }
        else {
            inc <- vector(mode = "list", length = dim(x)[3])
            for (k in seq_len(dim(x)[3])) {
                if (identical(dimnames(x[, , k])[[1]], dimnames(x[, 
                  , k])[[2]]) == TRUE) {
                  inc[[k]] <- trnf(x[, , k], tolist = TRUE, lb2lb = lb2lb, 
                    sep = sep)
                }
                else {
                  ifelse(is.matrix(x[, , k]) == FALSE, x[, , 
                    k] <- as.matrix(x[, , k]), NA)
                  x0k <- cbind(matrix(0, nrow = nrow(x[, , k]) + 
                    ncol(x[, , k]), ncol = nrow(x[, , k])), rbind(x[, 
                    , k], matrix(0, nrow = ncol(x[, , k]), ncol = ncol(x[, 
                    , k]))))
                  dimnames(x0k)[[1]] <- dimnames(x0k)[[2]] <- c(rownames(x[, 
                    , k]), colnames(x[, , k]))
                  inc[[k]] <- trnf(x0k, tolist = TRUE, lb2lb = lb2lb, 
                    sep = sep)
                }
            }
            rm(k)
            attr(inc, "names") <- dimnames(x)[[3]]
            return(inc)
        }
    }
    else {
        ifelse(missing(lb2lb) == FALSE && isTRUE(lb2lb == FALSE) == 
            TRUE, lb2lb <- FALSE, lb2lb <- TRUE)
    }
    if (match.arg(type) == "toarray2") {
        if (is.vector(x) == TRUE) {
            vec <- dhc(x, sep = sep)
            if (missing(add) == FALSE && isTRUE(is.vector(add) == 
                TRUE) == TRUE) {
                if (is.list(vec) == TRUE) {
                  for (k in seq_len(length(vec))) {
                    for (i in seq_len(length(add[[k]]))) {
                      vec[[k]] <- append(vec[[k]], c(add[[k]][i], 
                        NA))
                    }
                    rm(i)
                  }
                  rm(k)
                }
                else if (is.vector(vec) == TRUE) {
                  vec <- append(vec, dhc(paste(add, NA, sep = sep)))
                  vec[which(vec == "NA")] <- NA
                }
                else {
                  NA
                }
            }
            if (missing(adc) == FALSE && isTRUE(is.vector(adc) == 
                TRUE) == TRUE) {
                if (is.list(vec) == TRUE) {
                  for (k in seq_len(length(vec))) {
                    for (i in seq_len(length(adc[[k]]))) {
                      vec[[k]] <- append(vec[[k]], c(NA, adc[[k]][i]))
                    }
                    rm(i)
                  }
                  rm(k)
                }
                else if (is.vector(vec) == TRUE) {
                  vec <- append(vec, dhc(paste(NA, adc, sep = sep)))
                  vec[which(vec == "NA")] <- NA
                }
                else {
                  NA
                }
            }
            if (is.list(vec) == TRUE) {
                dfr <- list()
                vec1 <- list()
                length(vec1) <- length(vec)
                vec2 <- list()
                length(vec2) <- length(vec)
                for (k in seq_len(length(vec))) {
                  vec1[[k]] <- vec[[k]][which(seq_len(length(vec[[k]]))%%2L == 
                    1L)]
                  vec2[[k]] <- vec[[k]][which(seq_len(length(vec[[k]]))%%2L == 
                    0L)]
                  if (is.null(lbs) == FALSE) {
                    if (is.list(lbs) == FALSE) 
                      warning(paste(sQuote("lbs"), " should be a list for ", 
                        sQuote("toarray2"), ".", sep = ""))
                    vc1 <- unique(c(vec1[[k]], lbs[[k]][[1]]))
                    vc2 <- unique(c(vec2[[k]], lbs[[k]][[2]]))
                  }
                  else {
                    vc1 <- as.vector(stats::na.omit(unique(vec1[[k]])))
                    vc2 <- as.vector(stats::na.omit(unique(vec2[[k]])))
                  }
                  if (missing(sort) == FALSE && isTRUE(sort == 
                    TRUE) == TRUE) {
                    vc1 <- sort(vc1)
                    vc2 <- sort(vc2)
                  }
                  else {
                    NA
                  }
                  temp <- data.frame(matrix(0L, ncol = length(vc2), 
                    nrow = length(vc1), dimnames = list(vc1, 
                      vc2)))
                  for (i in seq_len(length(vec1[[k]]))) {
                    temp[which(vc1 == vec1[[k]][i]), which(vc2 == 
                      vec2[[k]][i])] <- 1L
                  }
                  rm(i)
                  dfr[[k]] <- temp
                }
                rm(k)
                attr(dfr, "names") <- attr(x, "names")
            }
            else {
                vec1 <- vec[which(seq_len(length(vec))%%2L == 
                  1L)]
                vec2 <- vec[which(seq_len(length(vec))%%2L == 
                  0L)]
                if (is.null(lbs) == FALSE) {
                  if (is.list(lbs) == FALSE) 
                    warning(paste(sQuote("lbs"), " should be a list for ", 
                      sQuote("toarray2"), ".", sep = ""))
                  vc1 <- unique(c(vec1, lbs[[1]]))
                  vc2 <- unique(c(vec2, lbs[[2]]))
                }
                else {
                  vc1 <- stats::na.omit(unique(vec1))
                  vc2 <- stats::na.omit(unique(vec2))
                }
                if (missing(sort) == FALSE && isTRUE(sort == 
                  TRUE) == TRUE) {
                  vc1 <- sort(vc1)
                  vc2 <- sort(vc2)
                }
                else {
                  NA
                }
                dfr <- data.frame(matrix(0L, ncol = length(vc2), 
                  nrow = length(vc1), dimnames = list(vc1, vc2)))
                for (i in seq_len(length(vec1))) {
                  dfr[which(vc1 == vec1[i]), which(vc2 == vec2[i])] <- 1L
                }
                rm(i)
            }
        }
        else {
            ifelse(is.null(lbs) == TRUE, dfr <- as.data.frame(x), 
                dfr <- trnf(trnf(x, tolist = TRUE, lb2lb = TRUE), 
                  tolist = FALSE, ord = length(lbs), lbs = lbs))
        }
        return(dfr)
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
dichot <-
function (x, c = 1, diag) 
{
    ifelse(missing(diag) == FALSE && isTRUE(diag == FALSE) == 
        TRUE, diag <- FALSE, diag <- TRUE)
    if (isTRUE(diag == TRUE) == FALSE) {
        if (is.na(dim(x)[3]) == TRUE | isTRUE(dim(x)[3] == 1) == 
            TRUE) {
            dg <- diag(x)
        }
        else {
            dg <- list()
            for (i in seq_len(dim(x)[3])) dg[[i]] <- diag(x[, 
                , i])
        }
    }
    else {
        dg <- NULL
    }
    if (isTRUE(0 >= c) == TRUE) {
        x <- replace(x, x >= c, 1L)
        x <- replace(x, x < c, 0L)
    }
    else {
        x <- replace(x, x < c, 0L)
        x <- replace(x, x >= c, 1L)
    }
    if (isTRUE(is.null(dg)) == FALSE) {
        if (is.na(dim(x)[3]) == TRUE | isTRUE(dim(x)[3] == 1) == 
            TRUE) {
            diag(x) <- dg
        }
        else {
            for (i in seq_len(dim(x)[3])) diag(x[, , i]) <- dg[[i]]
        }
        x
    }
    else {
        x
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
jnt <-
function (z, uniq, sep) 
{
    ifelse(missing(uniq) == FALSE && isTRUE(uniq == TRUE) == 
        TRUE, uniq <- TRUE, uniq <- FALSE)
    ifelse(missing(sep) == TRUE, sep <- ", ", NA)
    if (isTRUE(length(z) != 0) == TRUE) {
        if (is.list(z) == TRUE) {
            tj <- list()
            jt <- list()
            length(tj) <- length(jt) <- length(z)
            for (i in seq_len(length(z))) {
                if (isTRUE(length(z[[i]]) != 0) == TRUE) {
                  tmpj <- as.list(z[[i]])
                  for (j in seq_len(length(z[[i]]))) {
                    ifelse(isTRUE("." %in% strsplit(sep, "")[[1]]) == 
                      TRUE, tj[[i]] <- append(tj[[i]], tmpj[[j]]), 
                      tj[[i]] <- append(tj[[i]], strsplit(tmpj[[j]], 
                        sep)[[1]]))
                  }
                  rm(j, tmpj)
                  tj[[i]] <- unique(tj[[i]])
                  if (length(tj[[i]]) == 1) 
                    jt[[i]] <- tj[[i]]
                  if (length(tj[[i]]) > 1) 
                    jt[[i]] <- paste(tj[[i]][1], tj[[i]][2], 
                      sep = sep)
                  if (length(tj[[i]]) > 2) {
                    for (j in 3:length(tj[[i]])) jt[[i]] <- paste(jt[[i]], 
                      tj[[i]][j], sep = sep)
                    rm(j)
                  }
                }
                else {
                  NA
                }
            }
            rm(i)
            ifelse(is.null(attr(z, "names")) == FALSE, attr(jt, 
                "names") <- attr(z, "names"), NA)
        }
        else if (is.vector(z) == TRUE) {
            vec <- vector()
            for (i in seq_len(length(z))) {
                ifelse(is.numeric(z) == TRUE, vec <- append(vec, 
                  strsplit(as.character(z)[i], sep)[[1]]), vec <- append(vec, 
                  strsplit(z[i], sep)[[1]]))
            }
            rm(i)
            if (isTRUE(uniq == TRUE) == TRUE) {
                vec <- unique(vec)
            }
            else {
                vec <- levels(factor(vec))
            }
            if (length(vec) == 1) 
                jt <- vec
            if (length(vec) > 1) 
                jt <- paste(vec[1], vec[2], sep = sep)
            if (length(vec) > 2) {
                for (i in 3:length(vec)) {
                  jt <- paste(jt, vec[i], sep = sep)
                }
                rm(i)
            }
        }
        else {
            stop("Input data must be a list or a vector.")
        }
        return(jt)
    }
    else {
        z
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
as.signed <-
function (x, lbs) 
{
    if (isTRUE("Rel.Q" %in% attr(x, "class")) == TRUE) {
        x <- x$Q
    }
    else if (is.array(x) == FALSE) {
        stop("Data must be an array.")
    }
    else {
        NA
    }
    if (is.na(dim(x)[3]) == FALSE) {
        sm <- x[, , 1]
        message(paste("Take first dimension in ", sQuote("x"), 
            " only.", sep = ""))
    }
    else {
        sm <- x
    }
    if (missing(lbs) == FALSE && isTRUE(length(lbs) == dim(sm)[1]) == 
        TRUE) {
        rownames(sm) <- colnames(sm) <- lbs
    }
    else {
        ifelse(isTRUE(dimnames(x)[[1]]) == TRUE, rownames(sm) <- colnames(sm) <- seq_len(dim(sm)[1]), 
            rownames(sm) <- colnames(sm) <- dimnames(x)[[1]])
    }
    val <- levels(factor(sm))
    lst <- list(val = noquote(levels(stats::reorder(val, length(val):1))), 
        s = sm)
    class(lst) <- "Signed"
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
as.semigroup <-
function (x, gens, lbs, numerical, edgeT) 
{
    ifelse(is.list(x) == TRUE && isTRUE(length(x) == 1L) == TRUE, 
        x <- x[[1]], NA)
    ifelse(missing(numerical) == FALSE && isTRUE(numerical == 
        TRUE) == TRUE, numerical <- TRUE, numerical <- FALSE)
    if (is.array(x) == TRUE && is.na(dim(x)[3]) == FALSE && isTRUE(dim(x)[1] == 
        dim(x)[2]) == TRUE) {
        ifelse(isTRUE(numerical == TRUE) == TRUE, return(semigroup(x, 
            type = "numerical")), return(semigroup(x, type = "symbolic")))
    }
    if (isTRUE("partial.order" %in% tolower(attr(x, "class"))) == 
        TRUE) {
        stop(paste("Class of ", sQuote(deparse(substitute(x))), 
            " not supported.", sep = ""))
    }
    else {
        if (isTRUE("Semigroup" %in% attr(x, "class")) == TRUE) {
            scls <- TRUE
        }
        else {
            if (isTRUE(class(x) == "EdgeTable") == FALSE && is.null(dimnames(x)) == 
                TRUE) 
                stop(paste("Dimnames in ", sQuote(deparse(substitute(x))), 
                  " not found.", sep = ""))
            scls <- FALSE
        }
    }
    if (isTRUE(scls == TRUE) == TRUE) {
        warning(paste("Semigroup in ", sQuote(deparse(substitute(x))), 
            " is a ", dQuote(attr(x, "class")[2]), " type object.", 
            sep = ""), call. = FALSE)
        if (isTRUE(is.array(x$gens) == TRUE) == TRUE) {
            ifelse(missing(gens) == FALSE, NA, gens <- x$st[seq_len(dim(x$gens)[3])])
        }
        else {
            ifelse(missing(gens) == FALSE, NA, gens <- x$gens)
        }
        if (isTRUE(dim(x)[1] != dim(x)[2]) == TRUE) {
            xdim <- NA
        }
        else {
            xdim <- x$dim
        }
    }
    else {
        if ((missing(gens) == FALSE && all(gens %in% unlist(dimnames(x))) == 
            FALSE) && isTRUE("EdgeTable" %in% attr(x, "class")) == 
            FALSE) {
            stop(paste("Generators are not part of ", sQuote(deparse(substitute(x))), 
                ".", sep = ""))
        }
        else {
            if (missing(gens) == TRUE) {
                if (isTRUE(length(which(nchar(rownames(x)) == 
                  1L) > 0)) == TRUE) {
                  gens <- rownames(x)[which(nchar(rownames(x)) == 
                    1L)]
                  warning(paste("No generators provided in semigroup ", 
                    sQuote(deparse(substitute(x))), " and take single character string(s).", 
                    sep = ""), call. = FALSE)
                }
                else {
                  gens <- NA
                  warning(paste("No generators provided in semigroup ", 
                    sQuote(deparse(substitute(x))), ".", sep = ""), 
                    call. = FALSE)
                }
            }
        }
        if (is.null(dimnames(x)) == TRUE && isTRUE(numerical == 
            TRUE) == TRUE && (isTRUE("EdgeTable" %in% attr(x, 
            "class")) == FALSE & isTRUE("Semigroup" %in% attr(x, 
            "class")) == FALSE)) {
            dimnames(x)[[1]] <- seq_len(nrow(x))
            dimnames(x)[[2]] <- seq_len(ncol(x))
        }
        else {
            NA
        }
        if (isTRUE("EdgeTable" %in% attr(x, "class")) == TRUE || 
            isTRUE(dim(x)[1] != dim(x)[2]) == TRUE || is.matrix(x) == 
            TRUE) {
            xdim <- NULL
        }
        else {
            xdim <- dim(x)[1]
        }
    }
    if ((missing(edgeT) == FALSE && isTRUE(edgeT == TRUE) == 
        TRUE) || isTRUE("EdgeTable" %in% attr(x, "class")) == 
        TRUE) {
        ifelse(isTRUE("EdgeTable" %in% attr(x, "class")) == TRUE, 
            x <- edgS(x$ET), x <- edgS(x))
    }
    else if (is.matrix(x) == TRUE && isTRUE(dim(x)[1] != dim(x)[2]) == 
        TRUE) {
        warning(paste("Edge-list is assumed for ", sQuote(deparse(substitute(x))), 
            ".", sep = ""), call. = FALSE)
        x <- edgS(x)
    }
    if (missing(lbs) == TRUE) {
        if (isTRUE(numerical == TRUE) == FALSE) {
            if (isTRUE(scls == TRUE) == TRUE) {
                if (isTRUE("symbolic" %in% attr(x, "class")) == 
                  TRUE) {
                  return(x)
                }
                else if (isTRUE("numerical" %in% attr(x, "class")) == 
                  TRUE) {
                  s <- x$S
                  colnames(s) <- rownames(s) <- x$st
                  for (i in seq_along(dimnames(x$S)[[1]])) {
                    s[s == i] <- x$st[i]
                  }
                  rm(i)
                  lst <- list(ord = length(x$st), st = x$st, 
                    gens = x$gens, S = as.data.frame(s))
                  class(lst) <- c("Semigroup", "symbolic")
                  return(lst)
                }
            }
            else if (isTRUE(scls == FALSE) == TRUE) {
                if (is.null(attr(x, "class")) == TRUE) {
                  ifelse(is.null(dimnames(x)) == TRUE, s <- as.matrix(x), 
                    s <- as.data.frame(x))
                  if (all(rownames(x) %in% levels(unlist(x))) == 
                    TRUE || all(as.character(as.matrix(s)) %in% 
                    unlist(dimnames(s))) == TRUE) {
                    Sst <- rownames(x)
                  }
                  else {
                    ifelse(is.numeric(x) == TRUE, Sst <- unique(c(unlist(x), 
                      unique(c(rownames(x), colnames(x))))), 
                      Sst <- c(unique(unlist(x)), unique(c(rownames(x), 
                        colnames(x)))))
                  }
                  ifelse(is.numeric(gens) == TRUE && any(gens %in% 
                    unique(unlist(dimnames(x)))) == FALSE, gens <- unique(unlist(dimnames(x)))[gens], 
                    NA)
                  ifelse(all(x %in% unique(unlist(dimnames(x)))) == 
                    TRUE, lst <- list(ord = nrow(x), st = unique(unlist(dimnames(x))), 
                    gens = gens, S = s), lst <- list(ord = length(Sst), 
                    st = Sst, gens = gens, S = s))
                  class(lst) <- "Semigroup"
                  ifelse(is.character(lst$st) == TRUE, class(lst) <- c(class(lst), 
                    "symbolic"), class(lst) <- c(class(lst), 
                    "numerical"))
                  return(lst)
                }
                else {
                  lbs <- dimnames(x)[[1]]
                }
            }
        }
        else if (isTRUE(numerical == TRUE) == TRUE) {
            if (isTRUE("numerical" %in% attr(x, "class")) == 
                TRUE) {
                return(x)
            }
            else if (isTRUE(scls == TRUE) == TRUE) {
                lbs <- seq_along(x$st)
            }
            else {
                ifelse(isTRUE(dim(x)[1] == dim(x)[2]) == TRUE, 
                  lbs <- seq_len(dim(x)[1]), lbs <- NULL)
            }
        }
    }
    else if (missing(lbs) == FALSE) {
        if (isTRUE(scls == FALSE) == TRUE) {
            if (is.null(lbs) == FALSE && (any(is.na(gens) == 
                FALSE) == TRUE & is.numeric(gens) == FALSE)) {
                gens <- lbs[which(dimnames(x)[[1]] %in% gens)]
            }
            else if (is.numeric(gens) == TRUE && any(gens %in% 
                lbs) == FALSE) {
                gens <- lbs[gens]
            }
            else {
                NA
            }
        }
    }
    if (isTRUE(scls == TRUE) == TRUE) {
        s <- as.matrix(x$S)
        ord <- x$ord
        if (is.null(lbs) == FALSE && isTRUE(numerical == TRUE) == 
            TRUE) {
            Sst <- lbs
        }
        else if (isTRUE(numerical == FALSE) == TRUE && all(rownames(s) == 
            x$st) == FALSE) {
            Sst <- rownames(s)
        }
        else {
            Sst <- x$st
        }
    }
    else if (isTRUE(scls == TRUE) == FALSE) {
        if (is.array(x) == FALSE && is.data.frame(x) == FALSE) 
            stop(paste("Input data in ", sQuote(deparse(substitute(x))), 
                " must be a square matrix or data frame.", sep = ""))
        s <- as.matrix(x, rownames.force = TRUE)
        if (all(as.character(s) %in% unlist(dimnames(s))) == 
            TRUE || any(is.na(s)) == TRUE) {
            Sst <- rownames(s)
        }
        else {
            if (is.numeric(s) == TRUE) {
                Sst <- unique(c(unlist(x), unique(c(rownames(x), 
                  colnames(x)))))
            }
            else {
                ifelse(is.null(levels(unlist(x))) == TRUE, Sst <- unique(c(rownames(x), 
                  colnames(x))), Sst <- unique(levels(unlist(x)), 
                  unique(c(rownames(x), colnames(x)))))
            }
        }
        ord <- length(Sst)
    }
    if (all(unique(as.vector(s)) %in% Sst) == FALSE && isTRUE(numerical == 
        FALSE) == TRUE) 
        warning(paste("Input data in ", sQuote(deparse(substitute(x))), 
            " is not a closed semigroup.", sep = ""), call. = FALSE)
    if (is.null(dimnames(s)) == TRUE && isTRUE(dim(s)[1] == dim(s)[2]) == 
        TRUE) {
        ifelse(isTRUE(length(Sst) == dim(s)[1]) == TRUE, dimnames(s)[[1]] <- dimnames(s)[[2]] <- seq_along(Sst), 
            NA)
    }
    if (is.null(lbs) == FALSE) {
        z <- vector(length = nrow(s) * ncol(s))
        for (i in seq_along(as.matrix(s))) {
            if (isTRUE(numerical == TRUE) == TRUE && isTRUE(scls == 
                TRUE) == TRUE) {
                ifelse(any(x$st == as.matrix(s)[i]) == FALSE, 
                  z[i] <- NA, z[i] <- lbs[which(x$st == as.matrix(s)[i])])
            }
            else {
                ifelse(any(Sst == as.matrix(s)[i]) == FALSE, 
                  z[i] <- NA, z[i] <- lbs[which(Sst == as.matrix(s)[i])])
            }
        }
        rm(i)
        suppressWarnings(s <- matrix(z, nrow = nrow(s), ncol = ncol(s)))
        rm(z)
    }
    if ((is.null(dimnames(s)) == TRUE && isTRUE(dim(s)[1] == 
        dim(s)[2]) == TRUE) || isTRUE(numerical == TRUE) == TRUE) {
        rownames(s) <- colnames(s) <- lbs
    }
    else if (isTRUE(numerical == FALSE) == TRUE || isTRUE(dim(s)[1] == 
        dim(s)[2]) == FALSE) {
        if (isTRUE(all.equal(lbs, Sst) == TRUE) == TRUE && isTRUE(rownames(x) == 
            colnames(x)) == TRUE) {
            dimnames(s)[[1]] <- dimnames(s)[[2]] <- as.list(lbs)
        }
        else if (isTRUE(all.equal(lbs, Sst) == TRUE) == TRUE && 
            isTRUE(rownames(x) == colnames(x)) == FALSE) {
            rownames(s) <- lbs[(nlevels(factor(s)) + 1L):(nlevels(factor(s)) + 
                nrow(s))]
            colnames(s) <- lbs[((nlevels(factor(s)) + nrow(s) + 
                1L)):(nlevels(factor(s)) + nrow(s) + ncol(s))]
        }
        else {
            if (isTRUE(length(lbs) != length(Sst)) == TRUE) {
                ifelse(all(rownames(x) %in% lbs) == FALSE, rownames(s) <- Sst[(nlevels(factor(s)) + 
                  1L):(nlevels(factor(s)) + nrow(s))], NA)
                ifelse(all(colnames(x) %in% lbs) == FALSE, colnames(s) <- Sst[((nlevels(factor(s)) + 
                  nrow(s) + 1L)):(nlevels(factor(s)) + nrow(s) + 
                  ncol(s))], NA)
            }
            else {
                ifelse(all(rownames(x) %in% lbs) == FALSE, rownames(s) <- lbs[(nlevels(factor(s)) + 
                  1L):(nlevels(factor(s)) + nrow(s))], NA)
                ifelse(all(colnames(x) %in% lbs) == FALSE, colnames(s) <- lbs[((nlevels(factor(s)) + 
                  nrow(s) + 1L)):(nlevels(factor(s)) + nrow(s) + 
                  ncol(s))], NA)
            }
        }
    }
    else {
        NA
    }
    Sdf <- as.data.frame(s)
    if (isTRUE(numerical == TRUE) == TRUE || is.null(dimnames(s)) == 
        TRUE && isTRUE(dim(s)[1] == dim(s)[2]) == TRUE) {
        dimnames(Sdf)[[1]] <- dimnames(Sdf)[[2]] <- lbs
    }
    else {
        NA
    }
    ifelse(isTRUE(numerical == TRUE) == TRUE, lst <- list(dim = xdim, 
        ord = ord, st = as.numeric(unique(unlist(dimnames(Sdf)))), 
        gens = gens, S = Sdf), lst <- list(dim = xdim, ord = ord, 
        st = unique(unlist(dimnames(Sdf))), gens = gens, S = Sdf))
    if ((missing(edgeT) == FALSE && isTRUE(edgeT == TRUE) == 
        TRUE) || isTRUE("EdgeTable" %in% attr(x, "class")) == 
        TRUE || is.matrix(x) == TRUE || is.null(xdim) == TRUE) {
        lst$dim <- NULL
    }
    class(lst) <- "Semigroup"
    ifelse(is.character(lst$st) == TRUE, class(lst) <- c(class(lst), 
        "symbolic"), class(lst) <- c(class(lst), "numerical"))
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
diagram.levels <-
function (x, perm = FALSE) 
{
    po <- x & (1L - t(x))
    diag(po) <- 0L
    for (i in seq_len(ncol(po))) {
        tmp <- outer(po[, i], po[i, ], pmin.int)
        po <- pmin(po, (1L - tmp))
    }
    if (isTRUE(sum(po) > 0L) == TRUE) {
        if (requireNamespace("Rgraphviz", quietly = TRUE)) {
            suppressWarnings(grDevices::pictex())
            X <- Rgraphviz::plot(methods::as(po, "graphNEL"))
            alt <- vector()
            nam <- vector()
            for (i in 1:length(X@AgNode)) {
                alt[length(alt) + 1L] <- X@AgNode[[i]]@center@y
                nam[length(nam) + 1L] <- X@AgNode[[i]]@name
            }
            rm(i)
            cls <- (rbind(nam, rep(0, length(nam))))
            for (i in 1:nlevels(factor(alt))) cls[2, ][which(alt == 
                levels(factor(alt))[i])] <- i
            ord <- vector()
            for (i in 1:length(X@AgEdge)) ord <- append(ord, 
                c(X@AgEdge[[i]]@head, X@AgEdge[[i]]@tail))
            cls[2, ][which(!(cls[1, ] %in% (unique(ord))))] <- as.numeric(max(levels(factor(cls[2, 
                ])))) + 1L
            attr(cls, "dimnames") <- NULL
            colnames(cls) <- cls[2, ]
            cls <- as.data.frame(cls)
            grDevices::dev.off()
            unlink("Rplots.tex")
        }
        else {
            stop(paste("Package ", sQuote("Rgraphviz"), " not found.", 
                sep = ""))
        }
    }
    else {
        cls <- as.data.frame(rbind(as.vector(dimnames(x)[[1]]), 
            rep(1L, ncol(x))))
        attr(cls, "dimnames") <- NULL
        colnames(cls) <- rep(1L, ncol(x))
    }
    if (perm) {
        clu <- as.numeric(as.vector(unlist(cls[2, ])))
        return(list(cls = cls[1, ], clu = clu, perm = perm(x, 
            clu = clu)))
    }
    else {
        dgl <- cls[1, ]
        ulv <- unique(attr(as.list(dgl), "names"))
        lulv <- vector(mode = "list", length = length(ulv))
        for (k in ulv) {
            lulv[[which(ulv %in% k)]] <- unlist(as.list(dgl)[which(attr(as.list(dgl), 
                "names") == k)], use.names = FALSE)
        }
        rm(k)
        attr(lulv, "names") <- ulv
        return(lulv[order(names(lulv))])
    }
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
mlvl <-
function (x, y, type = c("bpn", "cn", "cn2"), symCdm, diag, lbs) 
{
    if (missing(x) == FALSE && match.arg(type) != "cn") {
        if (isTRUE("pathfinder" %in% attr(x, "class")) == TRUE) {
            x <- x$Q
        }
        else {
            if (any(class(x) %in% c("matrix", "array", "list")) == 
                FALSE) 
                stop(paste("Invalid class of ", sQuote(deparse(substitute(x))), 
                  ".", sep = ""))
        }
        if (is.null(dim(x)) == FALSE) {
            ifelse(is.null(dimnames(x)[[1]]) == TRUE, dimnames(x)[[1]] <- seq_len(dim(x)[1]), 
                NA)
            ifelse(is.null(dimnames(x)[[2]]) == TRUE, dimnames(x)[[2]] <- seq_len(dim(x)[2]), 
                NA)
        }
        if (is.null(dim(x)) == TRUE || is.list(x) == TRUE) {
            if (all(lapply(x, class) == "character") == TRUE) {
                xx <- transf(x, type = "toarray")
            }
            else {
                xx <- transf(lapply(x, function(z) {
                  trnf(z, tolist = TRUE, lb2lb = TRUE)
                }), type = "toarray")
            }
        }
        else {
            xx <- x
        }
        ifelse(is.na(dim(xx)[3]) == TRUE, qmd <- "1M", qmd <- rep("1M", 
            dim(xx)[3]))
    }
    else {
        if (missing(y) == TRUE) 
            stop(paste("Missing ", sQuote("x"), " and ", sQuote("y"), 
                ".", sep = ""))
    }
    if (missing(y) == FALSE) {
        if (is.array(y) == TRUE) {
            ifelse(is.null(dimnames(y)[[1]]) == TRUE, dimnames(y)[[1]] <- seq_len(dim(y)[1]), 
                NA)
            ifelse(is.null(dimnames(y)[[2]]) == TRUE, dimnames(y)[[2]] <- seq_len(dim(y)[2]), 
                NA)
        }
        if (match.arg(type) == "bpn" || match.arg(type) == "cn2") {
            if (is.data.frame(y) == TRUE) {
                yy <- transf(y, type = "toarray", lbs = c(rownames(y), 
                  colnames(y)))
            }
            else if (is.list(y) == FALSE) {
                yy <- transf(transf(y, type = "tolist", lb2lb = TRUE), 
                  type = "toarray", lbs = c(rownames(y), colnames(y)))
            }
            else {
                yy <- transf(lapply(y, function(z) {
                  transf(z, type = "tolist", lb2lb = TRUE)
                }), type = "toarray")
            }
            ifelse(is.na(dim(yy)[3]) == TRUE, qmd <- append(qmd, 
                "2M"), qmd <- append(qmd, rep("2M", dim(yy)[3])))
        }
        else {
            if (is.matrix(y) == TRUE || is.array(y) == TRUE || 
                is.data.frame(y) == TRUE) {
                cdmat <- array(0, dim = c(nrow(y), nrow(y)), 
                  dimnames = list(rownames(y), rownames(y)))
                for (k in seq_len(ncol(y))) {
                  af <- which(y[, k] > 0)
                  for (i in af) {
                    for (j in seq_len(length(af))) {
                      cdmat[i, af[j]] <- cdmat[i, af[j]] + 1L
                    }
                    rm(j)
                  }
                  rm(i)
                }
                rm(k)
                ifelse(missing(diag) == FALSE && isTRUE(diag == 
                  TRUE) == TRUE, NA, diag(cdmat) <- 0L)
            }
            else if (is.list(y) == TRUE) {
                cdmat <- lapply(y, function(z) {
                  cdm <- array(0, dim = c(nrow(z), nrow(z)), 
                    dimnames = list(rownames(z), rownames(z)))
                  for (k in seq_len(ncol(z))) {
                    af <- which(z[, k] > 0)
                    for (i in af) {
                      for (j in seq_len(length(af))) {
                        cdm[i, af[j]] <- cdm[i, af[j]] + 1L
                      }
                      rm(j)
                    }
                    rm(i)
                  }
                  rm(k)
                  return(cdm)
                })
            }
            else {
                stop(paste(sQuote("y"), " has invalid format.", 
                  sep = ""))
            }
        }
    }
    if (missing(lbs) == FALSE && (is.list(lbs) == TRUE && isTRUE(length(lbs) == 
        2) == TRUE)) {
        if ((is.matrix(y) == TRUE && all(dimnames(y)[[2]] %in% 
            lbs[[1]]) == FALSE) || (is.data.frame(y) == TRUE && 
            all(rownames(y) %in% lbs[[1]]) == FALSE) || (is.list(y) == 
            TRUE && all(rownames(y[[1]]) %in% lbs[[1]]) == FALSE)) {
            warning(paste("Domain labels for ", sQuote(deparse(substitute(y))), 
                " do not correspond to specified labels in ", 
                sQuote("lbs"), ".", sep = ""), call. = FALSE)
        }
        if ((is.matrix(x) == TRUE && all(dimnames(x)[[1]] %in% 
            lbs[[2]]) == FALSE) || (is.array(x) == TRUE && all(unique(unlist(dimnames(x)[1:2])) %in% 
            lbs[[2]]) == FALSE) || (is.list(x) == TRUE && all(unique(unlist(lapply(x, 
            dimnames), use.names = FALSE)) %in% lbs[[2]]) == 
            FALSE)) {
            warning(paste("Codomain labels for ", sQuote(deparse(substitute(x))), 
                " do not correspond to specified labels in ", 
                sQuote("lbs"), ".", sep = ""), call. = FALSE)
        }
        Lbs <- list(dm = lbs[[1]], cdm = lbs[[2]])
    }
    else if (match.arg(type) != "cn") {
        if (is.matrix(x) == TRUE) {
            dm <- dimnames(x)[[1]]
        }
        else if (is.array(x) == TRUE) {
            dm <- unique(unlist(dimnames(x)[1:2]))
        }
        else if (is.list(x) == TRUE) {
            dm <- unique(unlist(lapply(x, dimnames), use.names = FALSE))
        }
        else {
            dm <- NULL
        }
        if (is.matrix(y) == TRUE) {
            cdm <- dimnames(y)[[2]]
        }
        else if (is.data.frame(y) == TRUE) {
            cdm <- colnames(y)
        }
        else if (is.list(y) == TRUE) {
            cdm <- unique(unlist(lapply(y, dimnames), use.names = FALSE))
        }
        else {
            cdm <- NULL
        }
        if (any(dm %in% cdm) == TRUE) {
            warning(paste("Need domain/codomain labels in ", 
                sQuote("lbs"), " for ", sQuote(deparse(substitute(x))), 
                " and ", sQuote(deparse(substitute(y))), " since `", 
                paste(intersect(dm[which(dm %in% cdm)], cdm[which(cdm %in% 
                  dm)]), collapse = "`,`"), "` appear in both domains.", 
                sep = ""), call. = FALSE)
        }
        Lbs <- list(dm = dm, cdm = cdm)
    }
    else {
        Lbs <- list(dm = rownames(y), cdm = colnames(y))
    }
    if (match.arg(type) == "bpn") {
        if (is.data.frame(yy) == TRUE) {
            bmat <- suppressMessages(zbind(xx, as.matrix(yy), 
                force = TRUE))
        }
        else {
            bmat <- suppressMessages(zbind(xx, yy, force = TRUE))
        }
        if (missing(lbs) == FALSE && (is.list(lbs) == FALSE && 
            isTRUE(length(lbs) == dim(bmat)[3]) == TRUE)) {
            dimnames(bmat)[[3]] <- lbs
        }
        else {
            NA
        }
        if (missing(symCdm) == FALSE && isTRUE(symCdm == TRUE) == 
            TRUE) {
            for (i in which(qmd == "2M")) {
                bmat[, , i] <- bmat[, , i] + t(bmat[, , i])
            }
            rm(i)
        }
        if (is.null(dimnames(bmat)[[3]]) == TRUE) {
            dimnames(bmat)[[3]] <- seq_len(dim(bmat)[3])
            if (is.na(dim(x)[3]) == FALSE && is.null(dimnames(x)[[3]]) == 
                FALSE) {
                dimnames(bmat)[[3]][1:dim(x)[3]] <- dimnames(x)[[3]]
            }
            else {
                NA
            }
            if (is.na(dim(y)[3]) == FALSE && is.null(dimnames(y)[[3]]) == 
                FALSE) {
                dimnames(bmat)[[3]][(dim(xx)[3] + 1):dim(bmat)[3]] <- dimnames(y)[[3]]
            }
            else {
                NA
            }
        }
        else {
            NA
        }
        lst <- list(mlnet = bmat, lbs = Lbs, modes = qmd)
    }
    else {
        if (match.arg(type) == "cn2") {
            if (is.null(y) == FALSE && (is.matrix(y) == TRUE || 
                is.array(y) == TRUE || is.data.frame(y) == TRUE)) {
                cdmat <- array(0, dim = c(nrow(y), nrow(y)), 
                  dimnames = list(rownames(y), rownames(y)))
                for (k in seq_len(ncol(y))) {
                  af <- which(y[, k] > 0)
                  for (i in af) {
                    for (j in seq_len(length(af))) {
                      cdmat[i, af[j]] <- cdmat[i, af[j]] + 1L
                    }
                    rm(j)
                  }
                  rm(i)
                }
                rm(k)
                ifelse(missing(diag) == FALSE && isTRUE(diag == 
                  TRUE) == TRUE, NA, diag(cdmat) <- 0L)
            }
            else {
                stop(paste(sQuote("y"), " is missing or has invalid format.", 
                  sep = ""))
            }
            cdmat <- suppressMessages(zbind(xx, cdmat, force = TRUE))
            if (missing(lbs) == FALSE && isTRUE(length(lbs) == 
                dim(cdmat)[3]) == TRUE) {
                dimnames(cdmat)[[3]] <- lbs
            }
            else {
                if (is.null(dimnames(cdmat)[[3]]) == TRUE) {
                  dimnames(cdmat)[[3]] <- seq_len(dim(cdmat)[3])
                  if (is.na(dim(x)[3]) == FALSE && is.null(dimnames(x)[[3]]) == 
                    FALSE) {
                    dimnames(cdmat)[[3]][1:dim(x)[3]] <- dimnames(x)[[3]]
                  }
                  else {
                    NA
                  }
                  if (is.na(dim(y)[3]) == FALSE && is.null(dimnames(y)[[3]]) == 
                    FALSE) {
                    dimnames(cdmat)[[3]][(dim(xx)[3] + 1):dim(cdmat)[3]] <- dimnames(y)[[3]]
                  }
                  else {
                    NA
                  }
                }
                else {
                  NA
                }
            }
        }
        else if (match.arg(type) == "cn") {
            if (is.null(dim(cdmat)) == TRUE) {
                qmd <- rep("2M", length(cdmat))
            }
            else if (is.na(dim(cdmat)[3]) == FALSE) {
                qmd <- rep("2M", dim(cdmat)[3])
            }
            else {
                qmd <- "2M"
            }
        }
        lst <- list(mlnet = cdmat, lbs = Lbs, modes = qmd)
    }
    class(lst) <- c("Multilevel", match.arg(type))
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
as.strings <-
function (x, lbs) 
{
    if (is.array(x) == FALSE) 
        stop("Data must be an array.")
    ifelse(isTRUE(is.na(dim(x)[3])) == TRUE, ord <- 1, ord <- dim(x)[3])
    ifelse(missing(lbs) == FALSE && is.vector(lbs) == TRUE, lst <- list(wt = x, 
        ord = ord, st = lbs), lst <- list(wt = x, ord = ord))
    class(lst) <- "Strings"
    return(lst)
}

## (GPL-3) Antonio Rivero Ostoic, multiplex@post.com
perm <-
function (x, clu, rev, lbs, sort) 
{
    ifelse(isTRUE(is.list(x) == TRUE) == TRUE && isTRUE(length(x$S) > 
        0) == TRUE, x <- x$S, NA)
    ifelse(isTRUE(is.list(x) == TRUE) == TRUE && isTRUE(length(x$Q) > 
        0) == TRUE, x <- x$Q, NA)
    if (isTRUE(is.array(x) == TRUE) == FALSE && isTRUE(is.data.frame(x) == 
        TRUE) == FALSE && isTRUE(is.matrix(x) == TRUE) == FALSE) 
        stop(paste(sQuote(deparse(substitute(x))), " must be an array, matrix, or a data frame object.", 
            sep = ""))
    if (missing(sort) == FALSE && (missing(clu) == FALSE || missing(rev) == 
        FALSE || missing(lbs) == FALSE)) 
        warning(paste("Values in ", sQuote("clu"), ", ", sQuote("rev"), 
            " and ", sQuote("lbs"), " are ignored for ", sQuote("sort"), 
            " option.", sep = ""), call. = FALSE)
    ifelse(missing(rev) == FALSE && isTRUE(rev == TRUE) == TRUE, 
        rev <- TRUE, rev <- FALSE)
    if (missing(sort) == TRUE && (missing(clu) == TRUE || isTRUE(length(unlist(clu)) != 
        dim(x)[1]) == TRUE)) 
        stop(paste(sQuote("clu"), " is missing or it does not match the order of ", 
            sQuote(deparse(substitute(x))), ".", sep = ""))
    if (missing(sort) == FALSE && is.null(dimnames(x)) == TRUE) 
        return(x)
    if (missing(sort) == FALSE && isTRUE(sort == TRUE) == TRUE && 
        is.null(dimnames(x)) == FALSE) {
        clu <- vector()
        lb <- dimnames(x)[[1]]
        for (i in seq(length(lb))) {
            clu <- append(clu, which(sort(lb) %in% lb[i]))
        }
        rm(i)
        cls <- clu
    }
    else if (missing(sort) == TRUE | is.null(dimnames(x)) == 
        TRUE) {
        if (is.character(clu) == TRUE || is.factor(clu) == TRUE) {
            tmp <- as.vector(clu)
            for (i in seq_len(nlevels(factor(clu)))) {
                tmp[which(levels(factor(clu))[i] == tmp)] <- i
            }
            rm(i)
            cls <- as.numeric(tmp)
            rm(tmp)
        }
        else if (is.numeric(clu) == TRUE) {
            ifelse(isTRUE(0L %in% as.numeric(levels(factor(clu)))) == 
                TRUE, cls <- clu + 1L, cls <- clu)
        }
        else if (is.data.frame(clu) == TRUE || is.list(clu) == 
            TRUE) {
            cls <- as.vector(unlist(clu))
        }
        else {
            cls <- clu
        }
        ifelse(NA %in% cls, cls[which(is.na(cls))] <- max(as.numeric(levels(factor(cls)))) + 
            1L, NA)
    }
    or <- list()
    for (i in as.numeric(unique(cls))) {
        or[[i]] <- which(cls == i)
    }
    rm(i)
    if (isTRUE(any(is.na(unlist(or)))) == TRUE) {
        for (i in seq_len(length(or))) {
            ifelse(isTRUE(is.null(or[[i]])) == TRUE, or[[i]] <- NA, 
                NA)
        }
        rm(i)
        nor <- as.vector(stats::na.omit(unlist(or)))
    }
    else {
        nor <- order(unlist(or))
    }
    if (isTRUE(is.na(dim(x)[3]) == TRUE)) {
        prm <- vector()
        for (i in nor) {
            prm[nor[i]] <- i
        }
        rm(i)
        ifelse(isTRUE(rev == TRUE) == TRUE, px <- x[rev(prm), 
            rev(prm)], px <- x[prm, prm])
        ifelse(missing(lbs) == FALSE && isTRUE(length(lbs) == 
            dim(x)[1]) == TRUE, dimnames(px)[[1]] <- dimnames(px)[[2]] <- lbs, 
            NA)
        return(px)
    }
    else {
        px <- x
        for (k in seq_len(dim(px)[3])) {
            prm <- vector()
            for (i in nor) {
                prm[nor[i]] <- i
            }
            rm(i)
            px[, , k] <- px[prm, prm, k]
        }
        rm(k)
        if (missing(lbs) == FALSE && isTRUE(length(lbs) == dim(x)[1]) == 
            TRUE) {
            dimnames(px)[[1]] <- dimnames(px)[[2]] <- lbs
        }
        else if (is.null(dimnames(x)[[1]]) == FALSE) {
            Lbs <- vector()
            length(Lbs) <- length(clu)
            for (i in seq_len(length(nor))) Lbs[i] <- dimnames(x)[[1]][which(nor == 
                i)]
            dimnames(px)[[1]] <- dimnames(px)[[2]] <- Lbs
        }
        else {
            NA
        }
        ifelse(isTRUE(is.null(dimnames(x)[[3]]) == FALSE), dimnames(px)[[3]] <- dimnames(x)[[3]], 
            NA)
        return(px)
    }
}

%\VignetteIndexEntry{Working with Two-Mode Networks in multiplex}
%\VignetteDepends{multiplex, Rgraphviz, multigraph}
%\VignetteEngine{knitr::knitr}

\documentclass{article}
\usepackage[a4paper,margin=2.5cm]{geometry}
\usepackage[fleqn]{amsmath}
\usepackage{float}
%
\setlength\parindent{0pt}
\setlength{\parskip}{9pt}
\renewcommand{\baselinestretch}{1.2}
%
\renewcommand\abstractname{}
%\lstset{breaklines=true}

\begin{document}
\title{\LARGE Working with Two-Mode Networks in ``multiplex''}
\author{ {\Large Antonio Rivero Ostoic} \\
{\normalsize CESU, \large University of San Sim\'{o}n} }
\maketitle

Social networks are configurations defined by a collection of relationships among collective actors. 
In terms of set theory, a relation is an ordered pair such as $(x, y)$ that refers to a directed linkage from an element $x$ to an element $y$, where $x \in X$ and $y \in Y$ called the ``domain'' and ``codomain'' of the relation. 
The context of a binary relation $R$ is the overall relation set that results from the Cartesian product of the domain and codomain or $X \times Y$ of all ordered pairs $(x, y)$ where $R$ is a subset of the context.

Usually, a social network refers to a domain with a set of relations on such domain, which is the generic term used to name the social entities in the system, and in such a case the system of relations is said to be a one-mode network. 
However, when the domain and the codomain in the system are not equal, there are two sets of entities that describe the entire social configuration, which is known as affiliation, bipartite, or else as a two-mode network. 


%
<<setup, include=FALSE>>=
knitr::opts_chunk$set(size = "footnotesize", background = "#FFFFFF", prompt = TRUE, strip.white = FALSE, comment = NA)
options(width=110)
knitr::knit_hooks$set(small.mar = function(before, options, envir) {
    if (before) par(mar = c(4, 4, .1, .1)) 
})
@
%


\section{Galois representation}
In terms of Formal Concept Analysis, the domain and codomain of a two-mode network are characterized respectively as a set of objects $G$, and a set of attributes $M$. 
A formal context is obtained with an incident relation $I \subseteq G \times M$ between these sets, and this triple is typically represented as a data table.

<<data, echo=-6>>=
# fruits data set with attributes
frt <- data.frame(yellow = c(0,1,0,0,1,0,0,0), green = c(0,0,1,0,0,0,0,1), red = c(1,0,0,1,0,0,0,0), 
                  orange = c(0,0,0,0,0,1,1,0), apple = c(1,1,1,1,0,0,0,0), citrus = c(0,0,0,0,1,1,1,1))
# fruit varieties as objects
rownames(frt) <- c("PinkLady","GrannySmith","GoldenDelicious","RedDelicious","Lemon","Orange","Mandarin","Lime")
frt
@

\newpage


\subsection*{Galois derivations}
The formal concept of a formal context is a pair of sets of objects $A$ and attributes $B$ that is maximally contained on each other. 
A \emph{Galois derivation} between $G$ and $M$ is defined for any subsets $A \subseteq G$ and $B \subseteq M$ by
\begin{equation*}
\begin{aligned}
A^\prime \;=\; { m \in M \;\mid\; (g, m) \in I \quad(\text{for all } g \in A) } \\
B^\prime \;=\; { g \in G \;\mid\; (g, m) \in I \quad(\text{for all } m \in B) }
\end{aligned}
\end{equation*}
where $A$ and $B$ are said to be the extent and intent of the formal concept respectively, whereas $A^\prime$ is the set of attributes common to all the objects in the intent and $B^\prime$ the set of objects possessing the attributes in the extent.

With package \textbf{multiplex}, it is possible to perform an algebraic analysis of two-mode networks with the function \texttt{galois()} to produce Galois derivations between objects and attributes.
This command creates an adjunction between the two sets partially ordered by inclusion, and we obtain the complete list of concepts of the context, which can be assigned into an object with the class named ``\texttt{Galois}'' and ``\texttt{full}.''

<<loadmultiplex>>=
# load package
library("multiplex")
@
\vspace{-10pt}
<<galoisFull>>=
# Galois derivations between fruits and their attributes
galois(frt)
@


\subsubsection*{Reduced labeling of concepts}
It is also possible to condense the labeling of the objects and attributes in the Galois derivations with option \texttt{"reduced"} as argument in \texttt{labeling} of \texttt{galois()} function. 
Below is another Galois representation of the fruits dataset with two domains by using the \textsf{R} native pipe. 

<<galoisReduc, echo=TRUE>>=
# Galois derivation with a reduced labeling
frt |> galois(labeling = "reduced")
@


The class object of the above representation is hidden, and this is since the full labeling is useful for the construction of the hierarchy of concepts.
That is the reason why the whole structure of the $12$ formal concepts given by the Galois derivation is keept in the output.

<<strgaloisReduc, size="scriptsize">>=
# structure of Galois derivation with full labeling
frt |> 
  galois(labeling = "reduced") |> 
  getElement("gc") |> 
  getElement("full") |> 
  str()
@


\subsection*{Partial ordering of formal concepts}

A hierarchy of the concepts is given by the relation subconcept--superconcept 
$$
(A, B) \leq (A_2, B_2) \quad\Leftrightarrow\quad A_1 \subseteq A_2 \qquad (\Leftrightarrow\quad B_1 \subseteq B_2)
$$

For an ordering of concepts in a formal context, function \texttt{partial.order()} has the \texttt{"galois"} option in the \texttt{type} argument where the hierarchy of the concepts is constructed. 
In this case, even though the concepts have the ``reduced'' option, it is the ``full'' labeling of the formal concepts that is the base of the ordering among these concepts that can be designated in different ways.

<<partialorder, echo=-5>>=
# partial ordering of the formal concepts with established labels
pogdc <- frt |> 
  galois(labeling = "reduced") |> 
  partial.order(type = "galois", lbs = paste("c", seq_len(12), sep = ""))
pogdc
@

Object \texttt{pogdc} records the partial order of the concepts with a a customized labeling of the concepts.
The partial order table shows that all concepts are included in concept $12$, whereas concept $7$ is included in the rest of the concepts. 
As a result, these concepts constitute the maxima and the minima elements of a complete lattice that provides for all the formal concepts of the context. 
From the outputs given with the Galois derivation of this context, these concepts correspond to the set of objects and the set of attributes, which are entirely abridged in the reduced formal context.


\subsection*{Concept diagram of the context}

The concept diagram of the formal context is a system of concepts partially ordered where the greatest lower bound of the meet and the least upper bound of the join are defined as
\begin{equation*}
\begin{aligned}
\bigwedge_{t\in T} \quad \bigl(A_t, B_t \bigr) \;=\; \Bigl(\; \bigcap_{t\in T}{A_t}, \;\;\bigl(\bigcup_{t\in T}{B_t} \bigr)^{\prime\prime} \;\Bigr) \\
\bigvee_{t\in T} \quad \bigl(A_t, B_t \bigr) \;=\; \Bigl(\; \bigl(\bigcup_{t\in T}{A_t} \bigr)^{\prime\prime}, \;\;\bigcap_{t\in T}{B_t} \;\Bigr) \\
\end{aligned}
\end{equation*}

To plot this type of concept or lattice diagram with the labeling corresponding to the reduced context.
\vspace{-10pt}
<<diagrampogc, fig.pos="H", fig.width=4.5, fig.height=4.5, fig.align="center", fig.cap="Concept Lattice of fruits and color characteristics", echo=-1, small.mar=TRUE>>=  %
par(mar=c(0,0,0,0))
# plot concept lattice diagram
suppressPackageStartupMessages(require("Rgraphviz", quietly = TRUE))
frt |> galois(labeling = "reduced") |> 
  partial.order(type = "galois") |> 
  diagram(type = "concept", main = "Fruits & Colors", fsize = 17, fcol = "red", col.main = "blue")
@


Since this is a reduced representation of the context, both objects and attributes are only given just once. 
Besides, labels are placed instead of the nodes rather than next to them as the typical representation of formal context. 
Moreover, in case that a concept does not have a label, which happens in most reduced contexts, then the number of the concept is placed as the node.


\section{Diagram levels \& Order Filters}

The construction of the concept diagram of the context allows us to have additional information about the network relational structure. 
One part is concerned with the inclusion levels in the lattice structure, and another aspect deals with downsets and upsets, which are formed from all the lower and greater bounds of an element in the lattice diagram. 
Next, we take a brief look at the suitable functions to get such information.

\subsection*{Levels in the lattice diagram}

Mainly when dealing with large diagrams, it can be difficult to distinguish the different heights in the lattice and the elements belonging to each level. 
Function \texttt{diagram.levels()} allows us to count with such information, and we illustrate this routine with the entry \texttt{pogdc} that represents the partial order of the concepts corresponding to the fruits data set.

<<diaglevels, echo=TRUE>>= 
# diagram levels of partial order
require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)
frt |> 
  galois(labeling = "reduced") |> 
  partial.order(type = "galois") |> 
  diagram.levels() 
@

Hence, concepts $7$ and $12$ make a class of their own, whereas the rest of the concepts belong either to class $2$ or to class $3$.

\bigbreak

By setting \texttt{perm} to \texttt{TRUE}, we obtain the different classes in the lattice structure in a convenient way, and also a permuted partial order table according to the clustering.
Recall that \texttt{pogdc} used in function \texttt{diagram.levels()} records the formal concepts with a customized labeling. 

<<diaglevelsperm, echo=TRUE, message=FALSE, warning=FALSE>>= 
# diagram levels with permutation
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc, perm = TRUE) }
@


\subsection*{Order Filters and Order Ideals}

Implications among objects and attributes in an arbitrary partially ordered set representing context are revealed by subsets in the order structure. 

Let $(P, \leq)$ be an ordered set, and $a$, $b$ are elements in $P$. 

A non-empty subset $U$ [resp. $D$] of $P$ is an upset [resp. downset] called a \emph{order filter} [resp. \emph{order ideal}] if, for all $a \in P$ and $b \in U$ [resp. $D$]
$$
b \leq a \text{\quad implies\quad} a \in U  \qquad\qquad [\;\text{resp.\;\;} a \leq b \text{\quad implies\quad} a \in D\;]
$$

For a particular element $x \in P$, the upset $\uparrow\! x$ formed for all the upper bounds of $x$ is called a \emph{principal order filter} generated by $x$. 
Dually, $\downarrow\! x$ is a \emph{principal order ideal} with all the lower bounds of $x$. Order filters and order ideals not coinciding with $P$ are called \emph{proper}.

To illustrate these concepts, we apply the function \texttt{fltr()} to the third element of the partial order represented by \texttt{pogd} that results in a proper principal order filter for this formal concept with labels.


<<pogc, echo=TRUE>>= 
# first assign the partial order of the reduced context
pogd <- frt |> galois(labeling = "reduced") |> 
  partial.order(type = "galois")
@

<<princfltrlbs, echo=TRUE>>= 
# principal order filter of the third concept 
fltr(3, pogd)
@


We get the same result when introducing the one or more of the names of this concept.
<<princfltrlbs2, echo=TRUE, eval=TRUE>>= 
# principal order filter of the concept with these labels
fltr(c("red", "RedDelicious"), pogd)
@

Or alternatively we combine elements from different concepts to obtain other types of order filters in the concept diagram of the context.
<<filter, echo=TRUE>>= 
# order filter of two concepts
fltr(c("Lemon", "Lime"), pogd)
@



Order ideals and principal order ideals are obtained similarly with this function if the argument \texttt{ideal} is set to \texttt{TRUE}.

<<ideal, echo=TRUE>>= 
# order ideal of two concepts
fltr(c(9, 11), pogd, ideal = TRUE)
@




\section{Bipartite graphs}

Two-mode network are depicted through \emph{bipartite graphs}, where the entities in one set only can relate to the elements placed in the other set. 
To plot network structure, \textbf{multiplex} has a reverse dependence on package \textbf{multigraph} for the visualization of multiple networks, and also for bipartite graphs representing affiliation or two-mode networks. 
Hence, function \texttt{bmgraph()} serves to plot the graph of the \texttt{frt} dataset with the default layout option that is \texttt{"bip"}.

<<bipp, echo=TRUE, eval=TRUE, fig.pos="H", fig.width=3.5, fig.height=3.5, fig.align="center", fig.env="figure", fig.cap="Bipartite graph of fruits with attributes", small.mar=TRUE>>=
# load "multigraph" package and plot bipartite graph
suppressPackageStartupMessages(library("multigraph", quietly = TRUE))
multigraph::bmgraph(frt, pch = 16:15, lwd = 2, fsize = 6)
@


\subsection*{Bipartite graph with a binomial projection}

Another possibility to depict a two-mode network as a ``classic'' bipartite graph is to apply a force-directed layout to the binomial projection of this two-mode data set. 
The plot below is made with arguments in function \texttt{bmgraph()} for changing the aspect of the vertices and to make the graph clock-wise rotated. 

<<binp2, echo=TRUE, eval=FALSE>>= 
# plot proyection of bipartite graph
require(multigraph)
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, lwd = 2, rot = 15)
@
<<binp, fig.pos="H", fig.width=4.4, fig.height=4.4, fig.align="center", fig.env="figure", fig.cap="Bipartite graph of fruit attributes with a force-directed layout", echo=FALSE, small.mar=TRUE>>=
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, lwd = 2, rot = 15)
@


\bigbreak
\medbreak

\renewcommand{\baselinestretch}{1.0}

\begin{thebibliography}{5}
%
\bibitem{Gant-Will96} Ganter, B and Wille R~\emph{Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
\bibitem{rgpahviz} Hansen KD, Gentry J, Long L, Gentleman R, Falcon S, Hahne F and Sarkar D  ~\textbf{Rgraphviz}: \emph{Provides plotting capabilities for R graph objects}. R package v 2.24.0
\bibitem{multiplex} Ostoic, JAR ~\textbf{multiplex}: \emph{Algebraic Tools for the Analysis of Multiple Social Networks}. R package v 3.8-3
\bibitem{multiplex} Ostoic, JAR ~\textbf{multigraph}: \emph{Plot and Manipulate Multigraphs}. R package v 0.99-4
%
\end{thebibliography}


\end{document}

%\VignetteIndexEntry{Affiliation Networks with multiplex}
%\VignetteDepends{multiplex, Rgraphviz, multigraph}
%\VignetteEngine{knitr::knitr}

\documentclass{article}
\usepackage[a4paper,margin=2.5cm]{geometry}
\usepackage[fleqn]{amsmath}
\usepackage{float}
%
\setlength\parindent{0pt}
\setlength{\parskip}{9pt}
\renewcommand{\baselinestretch}{1.2}
%
\renewcommand\abstractname{}
%\lstset{breaklines=true}

\begin{document}
\title{\LARGE Affiliation Networks with `multiplex'}
\author{ {\Large Antonio Rivero Ostoic} \\
{\normalsize CESU} \\{\large University of San Sim\'on} }
\maketitle

Social networks are systems defined by a collection of relationships among collective actors. In terms of set theory, a relation is an ordered pair such as $(x, y)$ that refers to a directed linkage from an element $x$ to an element $y$, where $x \in X$ and $y \in Y$ called the domain and codomain of the relation. The context of a binary relation $R$ is the overall relation set that results from the Cartesian product of the domain and codomain or $X \times Y$ of all ordered pairs $(x, y)$ where $R$ is a subset of the context.

Usually, a social network refers to a domain with a set of relations on such domain, which is the generic term used to name the social entities in the system. In such a case, the system of relations is said to be a one-mode network. However, when the domain and the codomain are not equal, there are two sets of entities that describe the entire social system, which is known as affiliation, bipartite, or else two-mode networks. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
<<setup, include=FALSE>>=
knitr::opts_chunk$set(size = 'footnotesize', background = '#FFFFFF', prompt = TRUE, strip.white = FALSE, comment = NA)
options(width=110)
knitr::knit_hooks$set(small.mar = function(before, options, envir) {
    if (before) par(mar = c(4, 4, .1, .1))  # smaller margin on top and right
})
@
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\section{Galois representation}
In terms of Formal Concept Analysis, the domain and codomain of a two-mode network are characterized respectively as a set of objects $G$, and a set of attributes $M$. A formal context is obtained with an incident relation $I \subseteq G \times M$ between these sets, and this triple is typically represented as a data table.

<<data, echo=-6>>=
# Fruits data set with attributes
frt <- data.frame(yellow = c(0,1,0,0,1,0,0,0), green = c(0,0,1,0,0,0,0,1), red = c(1,0,0,1,0,0,0,0), 
                  orange = c(0,0,0,0,0,1,1,0), apple = c(1,1,1,1,0,0,0,0), citrus = c(0,0,0,0,1,1,1,1))
# Label the objects
rownames(frt) <- c("PinkLady","GrannySmith","GoldenDelicious","RedDelicious","Lemon","Orange","Mandarin","Lime")
frt
@

\newpage


\subsection*{Galois derivations}
The formal concept of a formal context is a pair of sets of objects $A$ and attributes $B$ that is maximally contained on each other. A \emph{Galois derivation} between $G$ and $M$ is defined for any subsets $A \subseteq G$ and $B \subseteq M$ by
\begin{equation*}
\begin{aligned}
A^\prime \;=\; { m \in M \;\mid\; (g, m) \in I \quad(\text{for all } g \in A) } \\
B^\prime \;=\; { g \in G \;\mid\; (g, m) \in I \quad(\text{for all } m \in B) }
\end{aligned}
\end{equation*}
where $A$ and $B$ are said to be the extent and intent of the formal concept respectively, whereas $A^\prime$ is the set of attributes common to all the objects in the intent and $B^\prime$ the set of objects possessing the attributes in the extent.

Starting with version $1.5$ it is possible to perform an algebraic analysis of two-mode networks with the function \texttt{galois()} of \textbf{multiplex} to produce Galois derivations.
This command creates an adjunction between the two sets partially ordered by inclusion, and we obtain the complete list of concepts of the context, which can be assigned into an object with the class named ``\texttt{Galois}'' and ``\texttt{full}.''

<<loadmultiplex>>=
# load package
library("multiplex")
@
\vspace{-10pt}
<<galoisFull>>=
# Galois representation between objects and attributes
galois(frt)
@

It is also possible to condense the labeling of the objects and attributes with the option ``\texttt{reduced}'' in the argument \texttt{labeling} of the \texttt{galois()} function. 

<<galoisReduc, echo=-2>>=
# Galois derivation with a reduced labeling
gd <- galois(frt, labeling = "reduced")
galois(frt, labeling = "reduced")
@


However, the full labeling is useful for the construction of the hierarchy of concepts, and therefore the structure of the output given by the Galois derivation keeps it.

<<strgaloisReduc, size='scriptsize'>>=
str(gd$gc$full)
@


\subsection*{Partial ordering of the concepts}

A hierarchy of the concepts is given by the relation subconcept--superconcept 
$$
(A, B) \leq (A_2, B_2) \quad\Leftrightarrow\quad A_1 \subseteq A_2 \qquad (\Leftrightarrow\quad B_1 \subseteq B_2)
$$

For this, the function \texttt{partial.order()} now supports the ``\texttt{galois}'' option in the \texttt{type} argument where the hierarchy of the concepts is constructed. In this case, even though the concepts have the ``reduced'' option, it is the ``full'' labeling of the formal concepts that is the base of the ordering among these concepts that can be designated in different ways.

<<partialorder, echo=-3>>=
# Partial ordering of the formal concepts with established labels
pogdc <- partial.order(gd, type = "galois", lbs = paste("c", seq_len(length(gd$gc$full)), sep = ""))
pogdc
@

We can see in the partial order table that all concepts are included in concept $12$, whereas concept $7$ is included in the rest of the concepts. As a result, these concepts constitute the maxima and the minima elements of a complete lattice that provides for all the formal concepts of the context. From the outputs given with the Galois derivation of this context, we can see as well that these concepts correspond to the set of objects and the set of attributes, which are entirely abridged in the reduced formal context.


\subsection*{Concept lattice of the context}

The concept lattice of the formal context is a system of concepts partially ordered where the greatest lower bound of the meet and the least upper bound of the join are defined as
\begin{equation*}
\begin{aligned}
\bigwedge_{t\in T} \quad \bigl(A_t, B_t \bigr) \;=\; \Bigl(\; \bigcap_{t\in T}{A_t}, \;\;\bigl(\bigcup_{t\in T}{B_t} \bigr)^{\prime\prime} \;\Bigr) \\
\bigvee_{t\in T} \quad \bigl(A_t, B_t \bigr) \;=\; \Bigl(\; \bigl(\bigcup_{t\in T}{A_t} \bigr)^{\prime\prime}, \;\;\bigcap_{t\in T}{B_t} \;\Bigr) \\
\end{aligned}
\end{equation*}

We plot this type of lattice diagram with the labeling corresponding to the reduced context.
<<pogc>>= 
# Assign partial order of reduced context to 'pogd'
pogd <- partial.order(gd, type = "galois")
@
\vspace{-10pt}
<<diagrampogc, fig.pos='H', fig.width=4.5, fig.height=4.5, fig.align='center', fig.cap='Concept Lattice of fruits and color characteristics', echo=-1, small.mar=TRUE>>=  %
par(mar=c(0,0,0,0))
# Plot the lattice diagram
suppressPackageStartupMessages(library("Rgraphviz", quietly = TRUE))
diagram(pogd, type = "concept", main = "Fruits & Colors", fcol = "red", col.main = "blue")
@


Since this is a reduced representation of the context, both objects and attributes are only given just once. Besides, labels are placed instead of the nodes rather than next to them as the typical representation of formal context. Moreover, in case that a concept does not have a label, which happens in most reduced contexts, then the number of the concept is placed as the node.


\section{Diagram levels \& Order Filters}

The construction of the concept lattice of the context allows us to have additional information about the network relational structure. One part is concerned with the inclusion levels in the lattice structure, and another aspect deals with downsets and upsets, which are formed from all the lower and greater bounds of an element in the lattice diagram. Next, we take a brief look at the suitable functions to get such information.

\subsection*{Levels in the lattice diagram}

Mainly when dealing with large diagrams, it can be difficult to distinguish the different heights in the lattice and the elements belonging to each level. Function \texttt{diagram.levels()} allows us to count with such information, and we illustrate this routine with the entry \texttt{pogdc} that represents the partial order of the concepts corresponding to the fruits data set.

<<diaglevels, echo=TRUE>>= 
# Diagram levels
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc) }
@

Hence concepts $7$ and $12$ make a class of their own, whereas the rest of the concepts belong either to class $2$ or to class $3$.

\bigbreak

By setting \texttt{perm} to \texttt{TRUE}, we obtain the different classes in the lattice structure in a convenient way, and also a permuted partial order table according to the clustering.

<<diaglevelsperm, echo=TRUE, message=FALSE, warning=FALSE>>= 
# Diagram levels with permutation
if( require("Rgraphviz", quietly = TRUE, warn.conflicts = FALSE)) {
diagram.levels(pogdc, perm = TRUE) }
@


\subsection*{Order Filters and Order Ideals}

Implications among objects and attributes in an arbitrary partially ordered set representing context are revealed by subsets in the order structure. 

%\medbreak

Let $(P, \leq)$ be an ordered set, and $a$, $b$ are elements in $P$. 

A non-empty subset $U$ [resp. $D$] of $P$ is an upset [resp. downset] called a \emph{order filter} [resp. \emph{order ideal}] if, for all $a \in P$ and $b \in U$ [resp. $D$]
$$
b \leq a \text{\quad implies\quad} a \in U  \qquad\qquad [\;\text{resp.\;\;} a \leq b \text{\quad implies\quad} a \in D\;]
$$

For a particular element $x \in P$, the upset $\uparrow\! x$ formed for all the upper bounds of $x$ is called a \emph{principal order filter} generated by $x$. Dually, $\downarrow\! x$ is a \emph{principal order ideal} with all the lower bounds of $x$. Order filters and order ideals not coinciding with $P$ are called \emph{proper}.

%\bigbreak

To illustrate these concepts, we apply the function \texttt{fltr()} to the third element of the partial order represented by \texttt{pogd} that results in a proper principal order filter for this formal concept with labels.


<<princfltrlbs, echo=TRUE>>= 
# Principal order filter of the third concept 
fltr(3, pogd)
@


We get the same result when introducing the one or more of the names of this concept.
<<princfltrlbs2, echo=TRUE, eval=FALSE>>= 
# Principal order filter of the concept with these labels
fltr(c("red", "RedDelicious"), pogd)
@

Or alternatively we combine elements from different concepts to obtain other types of order filters in the concept lattice of the context.
<<filter, echo=TRUE>>= 
# Order filter of two concepts
fltr(c("Lemon", "Lime"), pogd)
@


%\newpage

Order ideals and principal order ideals are obtained similarly with this function if the argument \texttt{ideal} is set to \texttt{TRUE}.

<<ideal, echo=TRUE>>= 
# Order ideal of two concepts
fltr(c(9, 11), pogd, ideal = TRUE)
@




\section{Bipartite graphs}

Two-mode network are depicted through \emph{bipartite graphs}, where the entities in one set only can relate to the elements placed in the other set. 
For this, \textbf{multiplex} has a reverse dependence on \textbf{multigraph} for the visualization of multiple networks, and also for bipartite graphs. 
Hence, we use the function \texttt{bmgraph()} to plot the graph of the \texttt{frt} data set with the default layout option.

<<bipp, echo=TRUE, eval=TRUE, fig.pos='H', fig.width=3.0, fig.height=3.0, fig.align='center', fig.env='figure', fig.cap='Bipartite graph', small.mar=TRUE>>=
# Load the "multigraph" package and plot bipartite graph
suppressPackageStartupMessages(library("multigraph", quietly = TRUE))
bmgraph(frt, pch = 16:15, fsize = 6)
@


\subsection*{Multigraph with a binomial projection}


Another possibility is to apply a force-directed layout to the binomial projection of this two-mode data set. Below the plot is made with some arguments for the vertices and the graph clock-wise rotated. 
<<binp2, echo=TRUE, eval=FALSE>>= 
# Plot proyection of bipartite network
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, rot = 25)
@
<<binp, fig.pos='H', fig.width=4.5, fig.height=4.5, fig.align='center', fig.env='figure', fig.cap='Bipartite graph with a force-directed layout', echo=FALSE, small.mar=TRUE>>=
bmgraph(frt, layout = "force", seed = 1, cex = 3, fsize = 7, vcol = 8, pch = 16:15, rot = 25)
@


\bigbreak
\medbreak

\renewcommand{\baselinestretch}{1.0}

\begin{thebibliography}{5}
%
\bibitem{Gant-Will96} Ganter, B. and R. Wille~\emph{ Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
\bibitem{rgpahviz} Hansen KD, Gentry J, Long L, Gentleman R, Falcon S, Hahne F and Sarkar D  ~\textbf{Rgraphviz}: \emph{Provides plotting capabilities for R graph objects}. R package version 2.24.0
\bibitem{multiplex} Ostoic, J.A.R. ~\textbf{multiplex}: \emph{Algebraic Tools for the Analysis of Multiple Social Networks}. R package v 4.0
\bibitem{multiplex} Ostoic, J.A.R. ~\textbf{multigraph}: \emph{Plot and manipulate multigraphs}. R package v 0.99.3
%
\end{thebibliography}


\end{document}

\name{write.dl}
\alias{write.dl}
\title{
Write \code{dl} Format Files
}
\description{
A function to write \code{dl} files representing multiple networks.
}
\usage{
write.dl(x, file = NULL, type = c("nodelist", "fullmat"))
}
\arguments{
  \item{x}{Array or object representing a multiple network structure.}
  \item{file}{Path with filename for output.}
  \item{type}{
  Write data format type: 
  \itemize{ 
    \item \code{nodelist} for \emph{node-list} format
    \item \code{fullmat} for \emph{fullmat} format
  }}
}
\details{
Files with \code{dl} format serve to represent multiple networks, and it is one used in \pkg{NetDraw}, which is a component of the \pkg{Ucinet} program.
}
\value{
A file in path with the data with a \code{.dl} format.
}
\references{
Borgatti, S.P., \pkg{NetDraw} \emph{Software for Network Visualization}. Analytic Technologies. 2002. \cr
Borgatti, S.P., Everett, M.G. and Freeman, L.C. \pkg{Ucinet for Windows}: \emph{Software for Social Network Analysis}. Analytic Technologies. 2002.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{read.dl}}, \code{\link{write.gml}}, \code{\link{write.edgel}}, \code{\link{write.dat}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file }

\name{galois}
\alias{galois}
\title{
Galois Derivations
}
\description{
Function to compute Galois derivations between partially ordered subsets.
}
\usage{
galois(x, labeling = c("full", "reduced"), sep)
}
\arguments{\item{x}{An incidence matrix with objects and attributes.}
  \item{labeling}{Type of labeling for the Galois derivations: 
   \itemize{ 
    \item \code{full}
    \item \code{reduced}
   }
  }
  \item{sep}{(optional) Pair separator for the pairwise relations, default \dQuote{comma-space}.}
}
\details{
A \emph{Galois derivation}, or Galois connection, between the power sets of \eqn{G} and \eqn{M} is defined 
for subsets \eqn{A \subseteq G} and \eqn{B \subseteq M} by the set of attributes common to all objects in \eqn{A}, 
or \eqn{A^\prime}, and the set of objects having all attributes in \eqn{B}, or \eqn{B^\prime}.

An inclusion with the \code{"full"} labeling in the output implies first objects and then attributes in the 
Galois connection, whereas with the \code{"reduced"} option the output assumes inclusions of attributes first and then the objects. 

Notice that for \emph{many-valued} formal contexts the structure is derived from a concept scaling through function \code{\link{cscl}} 
where is possible to define a pair separator between attributes and their values. A warning message is produced when there is a 
conflict between such separators and the pair separator chosen in \code{sep} for extents and intents. 
}
\value{
A list of \dQuote{\code{Galois}} class object with Galois derivations of objects and attributes as list labels:
  \item{sep}{pair separator}
  \item{gc}{galois connections of pairs }
Notice that the object attribute class only is printed for \code{"full"} labeling, which is an intrinsic
part of the outcome for a \code{"reduced"} labeling.
}
\references{
Ganter, B. and R. Wille  \emph{Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
}
%\author{} ~
%\note{}
%\section{Warning }{....} ~
\seealso{
\code{\link{partial.order}}, \code{\link{cscl}}, \code{\link{diagram}}, \code{\link{fltr}}.
}
\examples{
# incidence matrix as a data frame
dfr <- data.frame(x=1:3, y=5:7)

# compute galois derivations 
galois(dfr)
}
\keyword{algebra}
\keyword{math}

\name{bundles}
\alias{bundles}
\title{
Bundle Class Patterns
}
\description{
Classify bundle class patterns in a system of multiple relations.
}
\usage{
bundles(x, loops = FALSE, smpl = FALSE, lb2lb = TRUE, collapse = FALSE, sep)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{An array representing multiple relations.}
  \item{loops}{(logical) Also include loops pattern?}
  \item{smpl}{(logical) Simplify the strings of relations?}
  \item{lb2lb}{(logical) Should labels of the nodes be included in the output?}
  \item{collapse}{(logical) Collapse the distinct levels of relations in the network?}
  \item{sep}{(optional) Separator for the pairwise relations.}
}
\details{
A \emph{bundle} is a particular type of pattern made of relations at different levels that is binding a pair of nodes or actors in a network of relationships. 
A bundle class is a dyadic configuration resulting from the mixture of the direction and the types of ties between the nodes or actors. 
There are in total seven dyadic configuration classes, which are \emph{null}, \emph{asymmetric}, \emph{reciprocal}, \emph{tie entrainment}, \emph{tie exchange}, \emph{mixed}, and the \emph{full} bundle pattern. 
This function provides detailed information about the bundle class patterns in multiple networks as lists of pair relations among the nodes or actors, except for the \dQuote{\emph{null}} pattern.

In case that the nodes are not labeled, then an identification number will be assigned according to the location of the nodes in the array representation and as well when the \code{lb2lb} option is set to \code{FALSE}. 
This function assumes that the network is directed, and self ties are also considered in the output.
Long string labels are simplified with \code{smpl}, whereas the \code{collapse} option blurs the levels in the strings. 

The input array for this function is always dichotomized, and it is possible to obtain the total number of occurrences in each bundle class pattern with the \code{\link{bundle.census}} function.
}
\value{
An object of \dQuote{\code{Rel.Bundles}} class with the distinct bundle class patterns.
  \item{asym }{Asymmetric ties}
  \item{recp }{Reciprocal ties}
  \item{tent }{Tie Entrainment}
  \item{txch }{Tie Exchange}
  \item{mixed}{Mixed}
  \item{full }{Full}
  \item{loops}{Loops (if chosen)}
}
\references{
Ostoic, J.A.R. \dQuote{Dyadic Patterns in Multiple Networks,} \emph{Advances in Social Networks Analysis and Mining, International Conference on}, 475-481. 2011.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{bundle.census}}, \code{\link{summaryBundles}}, \code{\link{transf}}.
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.8, 3 ) )

# look at bundle patterns
bundles(arr)
}
\keyword{list}
\keyword{data}
\keyword{attribute}
\keyword{math}

\name{hierar}
\alias{hierar}
\title{
Person and Relation Hierarchy
}
\description{
Function to establish either the Person or the Relation Hierarchy in a multiple network.
}
\usage{
hierar(W, x, type = c("person", "relation"))
}
\arguments{
  \item{W}{An object of the \dQuote{\code{Rel.Box}} class.}
  \item{x}{( or character) Actor of reference, either by the label or by an integer with its location in array \code{w} (cf. \code{\link{rbox}}).}
  \item{type}{Type of hierarchy with respect to network in \dQuote{\code{w}}: 
   \itemize{ 
    \item \code{person} for Person Hierarchy.
    \item \code{relation} for Relation Hierarchy.
   }
  }
}
\details{
The set of row inclusions in the Relation Plane of a Relation-Box \code{W} defines a partial order: the ego's \emph{Relation Hierarchy}. 
Similarly, the ego's or person's inclusions define another partial order: the ego's \emph{Person Hierarchy}. 
In other words, the Person Hierarchy captures inclusion relations among actors, whereas the Relation Hierarchy captures inclusion relations among ties. 
Both hierarchies are defined from the perspective of a selected reference actor in the network.

Notice that the Relation Plane is an outcome from \code{\link{rbox}}, whereas the cumulative person hierarchy is obtained through the \code{\link{cph}} function.
}
\value{
A list with an array that represents the partial order structure either of the Person Hierarchy in \code{ph} 
or of the Relation Hierarchy in \code{rh}. Both include the reference ego in \code{pers}.
}
\references{
Breiger, R.L. and P.E. Pattison, \dQuote{Cumulated social roles: The duality of persons and their algebras,} \emph{Social Networks}, 8, 215-256. 1986.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{rbox}}, \code{\link{cph}}, \code{\link{partial.order}}, \code{\link{diagram}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# compute person hierarchy of a random actor from relation box
arr |> 
  rbox(k=1) |> 
  hierar(ceiling(runif(1, min=0, max=dim(arr)[2])), type="person")
}
\keyword{algebra}
\keyword{math}

\name{zbind}
\alias{zbind}
\title{
Bind Matrices and Multidimensional Arrays
}
\description{
A function to combine or bind matrices and multidimensional arrays.
}
\usage{
zbind(..., sort, force)
}
\arguments{
  \item{\dots}{One or more arrays having two or three dimensions.}
  \item{sort}{(optional and logical) Sort array in output according to labels?}
  \item{force}{(optional and logical) Force binding arrays with different dimensions?}
}
\details{
Function \code{zbind} is for stacking for instance two-dimensional arrays into a single three-dimensional object to represent a multivariate system structure. 
Both square and rectangular arrays are supported provided that the dimensions in the input are equal, and data frames should be transformed into arrays for the binding. 

The \code{dimnames} in the array output correspond to the names of the first array in the input, and a \code{warning} message is given when the dimnames are \code{NULL}. 

Argument \code{force} must be set to \code{TRUE} for matrices and arrays with different dimensions, and a \code{message} is given.
}
\value{
Mostly a three dimensional array.
}
%\references{} ~
%\author{} ~
%\note{} ~
\section{Warning}{
Arrays without dimnames are not fully supported.
}
\seealso{
\code{\link{mnplx}}, \code{\link{dichot}}, \code{\link{strings}}
}
\examples{
# create two sets with two binary relations among three elements
arr1 <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
        c(3, 3, 2) ) > .9, 3 ) )

arr2 <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
        c(3, 3, 2) ) > .5, 3 ) )

# bind sets of data
zbind(arr1, arr2)
}
\keyword{manip}
\keyword{array}

\name{incubs}
\docType{data}
\alias{incubs}
\alias{incubA}
\alias{incubB}
\alias{incubC}
\alias{incubD}
\alias{incA}
\alias{incB}
\alias{incC}
\alias{incD}
\title{
Incubator networks dataset
}
\description{
These are four data sets collected in the year 2010 (see `source' for the details) of multiple relations between entrepreneurial firms working in business incubators in Denmark.

Each data set contains the adjacency matrices of the three social relations, coded as \code{C}, \code{F}, and \code{K} for working collaboration, informal friendship, and perceived competition among the firms. There are also a pair of actor attributes corresponding to the adoption of two Web innovations in the year 2010 by the firms where \code{A} stands for Linkedin and \code{B} for Facebook.

In addition, there is a blockmodel attached to each data set that is a product of Compositional Equivalence (cf. \code{\link{cph}}) with transposes for each type of social tie labelled with the following letter in the Latin alphabet; i.e. \code{D} for collaboration, \code{G} for friendship, and \code{L} for perceived competition.
}
\usage{
data("incubs")
data("incubA")
data("incubB")
data("incubC")
data("incubD")
data("incA")
data("incB")
data("incC")
data("incD")
}
\format{
Each data set is a list with a pair of three-dimensional arrays.

For \code{incubA}, the dimensions of \code{net} are \eqn{26 \times 26 \times 5}, and of \code{IM} are \eqn{4 \times 4 \times 7} (the two attributes led to the identity matrix).

For \code{incubB}, the dimensions of \code{net} are \eqn{18 \times 18 \times 5}, and of \code{IM} are \eqn{4 \times 4 \times 8}.

For \code{incubC}, the dimensions of \code{net} are \eqn{22 \times 22 \times 5}, and of \code{IM} are \eqn{3 \times 3 \times 8}.

For \code{incubD}, the dimensions of \code{net} are \eqn{15 \times 15 \times 5}, and of \code{IM} are \eqn{4 \times 4 \times 6}.

All four networks are together in \code{incubs}.

To plot automatically actor attributes in the graph with function \code{\link[multigraph:multigraph]{multigraph}}, another version of these data sets are given in \code{incA}, \code{incB}, \code{incC}, and \code{incD}, which  are \code{"Data.Set"} objects class having:

  -- \code{net} for the network data

  -- \code{atnet} a vector that indicates whether or not the arrays in \code{'net'} is attribute data

  -- \code{IM} for the Image Matrices of the reduced network data

  -- \code{atIM} a vector that indicates whether or not the array in \code{'IM'} is attribute data

  -- \code{cite} relational content of the ties


}
\source{
Ostoic, J.A.R.  `Algebraic methods for the analysis of multiple social networks and actors attributes'' PhD Thesis. University of Southern Denmark. 2013.
}
%\references{
%}
\keyword{datasets}

\name{hasse}
\alias{hasse}
\title{
Hasse Diagram of Set of Ordered Relations
}
\description{
A function to plot the Hasse Diagram of partially ordered relations.
}
\usage{
hasse(x, concept, attrs = NULL, main = NULL, incmp, shape = c("rectangle", 
    "circle", "box", "ellipse"), col, col0, fcol, ecol, lty, 
    lbs, ffamily, fstyle, fsize, cex.main, col.main, bg, mar, 
    sep, ...)
}
\arguments{
  \item{x}{An object of the \dQuote{\code{Partial.Order}} class or a matrix representing ordered relations.}
  \item{concept}{(optional and logical) Plot a concept diagram?}
  \item{attrs}{(optional) Attributes for diagram.}
  \item{main}{(optional) Title of diagram.}
  \item{incmp}{(optional and logical) Include incomparable elements Hasse diagram?}
  \item{shape}{Shape of diagram vertices, otherwise \dQuote{\code{rectangle}}:
   \itemize{ 
       \item \code{rectangle}
       \item \code{circle}
       \item \code{box}
       \item \code{ellipse}
   }
  }
  \item{col}{(optional) Colour of diagram vertices.}
  \item{col0}{(optional) Colour of vertices contour.}
  \item{fcol}{(optional) Font colour in vertices.}
  \item{ecol}{(optional) Edges colour in diagram.}
  \item{lty}{(optional) Edges shape in diagram.}
  \item{lbs}{(optional) Assign labels to elements in \code{x}.}
  \item{ffamily}{(optional) Font family of vertex labels.}
  \item{fstyle}{(optional) Font style of vertex labels: 
   \itemize{ 
       \item \code{bold}
       \item \code{italic}
       \item \code{bolditalic}
   }
  }
  \item{fsize}{(optional) Font size of vertex labels.}
  \item{cex.main}{(optional) Font size of main title.}
  \item{col.main}{(optional) Font colour of main title.}
  \item{bg}{(optional) Background colour.}
  \item{mar}{(optional) Margins of diagram plot.}
  \item{sep}{(optional, for concept lattice) Pair separator for pairwise relations inside intents and extents.}
  \item{\dots}{(optional) Additional graphical items.}
}
\details{
A Hasse diagram is a pictorical device to represent systems of partially ordered relations where the \code{hasse} function provides arguments for visual manipulation of the diagram.
An example of a partially ordered system is the partial order table that is the outcome of the \sQuote{\code{strings}} option in the \code{\link{partial.order}} function. 

Roman numerals are given for elements when the partial order table is not labelled.
}
\value{
A plot of a Hasse diagram with specified settings for a partial or a linear order of relations. 
}
%\references{} ~
%\author{} ~
\note{
This function requires \pkg{Rgraphviz} package installed.
}
%\section{Warning }{....} ~
\seealso{
\code{\link{diagram}}, \code{\link{partial.order}}, \code{\link{strings}}, \code{\link{galois}}, 
\code{\link{green.rel}}, \code{\link{diagram.levels}}, \code{\link{as.strings}}.
}
\examples{
# load a dataset
data("incubA")

# a partial order of strings from dataset image matrix
po <- incubA |> getElement("IM") |> 
  as.strings() |> 
  partial.order(type="strings")

# plot the order relation as a Hasse diagram
\dontrun{if(require(Rgraphviz)) {
plot(hasse(po))
}}
}
\keyword{graphs}

\name{diagram}
\alias{diagram}
\title{
Plot Diagrams of Ordered or Linked Relations
}
\description{
A function to plot and manipulate Hasse and Concept diagrams of
ordered relations, or the Egg-box of a semigroup structure.
}
\usage{
diagram(x, type = c("hasse", "concept", "egg-box"), attrs = NULL, main = NULL, 
        incmp, shape = c("rectangle", "circle", "box", "ellipse"), col, col0, 
        fcol, ecol, lty, lbs, ffamily, fstyle, fsize, cex.main, col.main, bg, 
        mar, sep, ...)
}
\arguments{
  \item{x}{Matrix representing ordered relations.}
  \item{type}{Type of diagram:
    \itemize{ 
       \item \code{hasse} Hasse diagram of partially ordered relations.
       \item \code{concept} Concept lattice of a formal context.
       \item \code{egg-box} Egg-box diagram of an abstract semigroup.
     }}
  For \code{"egg-box"} type diagram, the following arguments are ignored: 
  %\itemize{
    \item{attrs}{(optional) a list of lists with diagram attributes for \code{node}, \code{edge}, and \code{graph}.}
    \item{main}{(optional) Main title of the plot diagram.}
    \item{incmp}{(optional and logical) Should incomparable elements be included in the lattice diagram?}
    \item{shape}{(optional) Shape of diagram vertices: \code{"rectangle"}, \code{"circle"}, \code{"box"}, \code{"ellipse"}.}
    \item{col}{(optional) Colourr of diagram vertices.}
    \item{col0}{(optional) Colour of contour in diagram vertices.}
    \item{fcol}{(optional) Font colour of text in diagram vertices.}
    \item{ecol}{(optional) Edge colour of diagram edges.}
    \item{lty}{(optional) Integer for the shape of diagram edges.}
    \item{lbs}{(optional) Labels of elements in \code{x} partially ordered set.}
    \item{ffamily}{(optional) Font family of vertex labels in diagram.}
    \item{fstyle}{(optional) Font style of vertex labels in diagram with options: \code{bold}, \code{italic}, \code{bolditalic}.}
    \item{fsize}{(optional) Font size of vertex labels in diagram.}
    \item{cex.main}{(optional) Font size of title in plot diagram.}
    \item{col.main}{(optional) Font colour of title in plot diagram.}
    \item{bg}{(optional) Background colour of plot diagram.}
    \item{mar}{(optional) Margins of plot vindue.}
    \item{sep}{(optional only for \code{concept}) Pair separator for pairwise relations inside intents and extents.}
    \item{\dots}{(optional) Additional graphical items.}
  %}
}
\details{
\code{diagram} is a wrapper function for plotting and manipulating \dQuote{Hasse}, \dQuote{Concept}, and \dQuote{Egg-box} diagrams. 

The first two diagram types represent systems of ordered relations and are displayed as partial or linear order diagrams. 
For example, the partial order table produced by the \sQuote{\code{strings}} option in the \code{\link{partial.order}} function can be plotted as a Hasse diagram. 
Another example comes from Galois derivations in Formal Concept Analysis, where a Concept diagram shows the ordering of formal concepts defined by intents and extents.
Roman numerals are rendered for diagram elements when the partial order table in \code{x} is not labelled.

On the other hand, the Egg-box \dQuote{diagram} represents equivalence classes in an abstract semigroup without a partial order structure, 
and such representation is in the Console, not on the Graphic Device as the other representations.
}
\value{
Depending on the \code{type} diagram: 
  \item{hasse}{a Hasse diagram of partially ordered relations}
  \item{concept}{a Concept diagram of formal concepts in a formal context}
  \item{egg-box}{an Egg-box of an abstract semigroup}
}
%\references{} ~
%\author{} ~
\note{
This function requires \pkg{Rgraphviz} package installed.
}
%\section{Warning }{....} ~
\seealso{
\code{\link{hasse}}, \code{\link{partial.order}}, \code{\link{strings}}, \code{\link{galois}}, 
\code{\link{green.rel}}, \code{\link{diagram.levels}}, \code{\link{as.strings}}, \code{\link[multigraph:ccgraph]{ccgraph}}.
}
\examples{
# load a dataset
data("incubA")

# a partial order of strings from dataset image matrix
po <- incubA |> getElement("IM") |> 
  as.strings() |> 
  partial.order(type="strings")

# plot the order relation as a Hasse diagram
\dontrun{if(require(Rgraphviz)) {
plot(diagram(po, type="hasse"))
}}
}
\keyword{graphs}
%\keyword{dplot}
%

\name{rm.isol}
\alias{rm.isol}
\title{
Remove Isolates from Network
}
\description{
Function to remove isolate nodes in simple and multiple networks.
}
\usage{
rm.isol(x, diag, diag.incl)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{Matrix or array representing a network.}
  \item{diag}{(optional and logical, for arrays) Include diagonals in transformation?}
  \item{diag.incl}{(optional and logical, for arrays) Include diagonals in output?}
}
\details{
Isolated nodes do not have any edges in the network, and in a multivariate system, there is no edges adjacent to these kinds of nodes at any level.
}
\value{
A matrix or an array representing a multiple network without the isolated actors.
}
%\references{} ~
%\author{} ~
%\note{} ~
%% ~Make other sections like Warning with \section{Warning }{....} ~
\seealso{ 
\code{\link{edgel}}, \code{\link{zbind}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
         c(3, 3, 2) ) > .5, 3 ) )

# remove isolates (if exist)
rm.isol(arr)
}
\keyword{manip}
\keyword{array}

\name{summaryBundles}
\alias{summaryBundles}
\title{
Summary of Bundle Classes
}
\description{
Function for pretty printing of bundle class patterns results.
}
\usage{
summaryBundles(x, file = NULL, latex = FALSE, byties)
}
\arguments{
  \item{x}{A \sQuote{\code{Rel.Bundles}} class object.}
  \item{file}{(optional) Path where to place output file.}
  \item{latex}{(optional and logical) Latex format for output?}
  \item{byties}{(optional and logical) Expand tie patterns and collapse tie labels?}
}
\details{
This function prints the bundle census patterns existing in the network with an option to export such information in a friendly format. 
The dyadic bundle patterns are provided by the function \code{\link{bundles}}; however, the outcome of this function provides a list of pair lists for 
each bundle with the involved types of relations and nodes in the network. 
This form for presentation, although is convenient for further computation, it is not always easy to read for the human eye. 
The pair separator used to print the bundle occurrences is taken from the output of the \code{\link{bundles}} function.

If \code{latex} is set to \code{TRUE}, then the path file is activated to obtain a \code{tex} file with the different bundle class patterns. 
Finally, the optional argument \code{byties} provide more precise information about the patterned ties disregarding the relational content.
}
\value{
The distinct bundle class patterns with a user friendly format.
}
\references{
Ostoic, J. A. R. \dQuote{Dyadic Patterns in Multiple Networks,} \emph{Advances in Social Networks Analysis and Mining, International Conference on}, 475-481. 2011.
}
%\author{} ~
%\note{} ~
\section{Warning}{
Files with identical path and name to \code{file} will be overwritten.
}
\seealso{
\code{\link{bundles}}, \code{\link{bundle.census}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# print different relational bundles in 'arr'
arr |> 
  bundles() |> 
  summaryBundles()
}
\keyword{print}
\keyword{IO}

\name{neighb}
\alias{neighb}
\title{
Actor or Group Neighborhood in Relational System
}
\description{
A function to find with a customized distance the neighbourhood of an actor or group of actors 
in a relational system representing a simple or multiple network.
}
\usage{
neighb(x, rs, type = c("und", "inn", "out"), k = 1, inclx = FALSE, expand)
}
\arguments{
  \item{x}{A reference actor labeled in \code{rs} or a vector with a group of actors.}
  \item{rs}{Relational system of the network.}
  \item{type}{Type of system: 
  \itemize{ 
    \item \code{und} for \emph{undirected} (default)
    \item \code{inn} for \emph{incoming} node's ties to \code{x}
    \item \code{out} for \emph{outgoing} arcs from \code{x}
  }
}
  \item{k}{The \dQuote{distance} of the neighbour nodes to \code{x} where \eqn{k=1} is for adjacent nodes.}
  \item{inclx}{(logical) Include the reference actor in the output?}
  \item{expand}{(optional and logical) Should the output be given by \code{k}, for \eqn{k>1}.}
}
\details{
The relational system in \code{rs} represents either the full multiple network of actors or the subset of relational bundles that are mutual or asymmetric. 
Accordingly, this function identifies the nodes adjacent to \sQuote{\code{x}} within the specified relational system, as well as neighbouring nodes at a user-defined path length. 
Once the longest path or chain has been reached, increasing \code{k} will not add further nodes to the graph. 
The \code{inn} and \code{out} options apply to directed networks.

Notice that the output does not differentiate in case the chosen reference actors are in different components of the relational system. 
}
\value{
Depending on \code{expand}, the output is either a vector or a list with the neighbour nodes to the reference actor(s). 
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{expos}}, \code{\link{rel.sys}}, \code{\link{bundles}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# establish the system of strong bonds
rs <- rel.sys(arr, bonds = "strong")

# obtain inmediate neighbourhood of the first node
neighb(1, rs)
}
\keyword{models}
\keyword{manip}

\name{pfvn}
\alias{pfvn}
\title{
Pathfinder Valued Networks and Triangle Inequality
}
\description{
A function to produce the skeleton of a valued network with the pathfinder algorithm and triangle inequality.
}
\usage{
pfvn(x, r, q)
}
\arguments{
  \item{x}{Network data, typically a valued array.}
  \item{r}{Distance parameter.}
  \item{q}{Parameter with the minimum distance between actors in the proximity matrix.}
}
\details{
Pathfinder analysis is based on a symmetric adjacency matrix or array in \code{x} representing valued networks where 
the values reflect the \dQuote{proximity} between pairs of network members. 
This function depends heavily on internal function \code{\link{cpath}} where the aim is to produce the skeleton or the salient structure of \code{x}.
The pathfinder structure is for undirected networks, whereas for directed network structures the triangle inequality principle is applied. 

Parameter \eqn{q} represents the length of all walks computed over the semiring in the produced dissimilarity matrix, 
while \eqn{r} is a distance measure computed by the \emph{Minkowski operation}.
}
\value{
  \item{max}{\eqn{\max} value of the network with the Frobenius norm}
  \item{r}{parameter \eqn{r}}
  \item{q}{parameter \eqn{q}}
  \item{Q}{salient structure of \code{x}}
  \item{Note}{A note when triangle inequality is used}
}
\references{
Schvaneveldt, R., Durso, F. and Dearholt, D., \dQuote{Network structures in proximity data,} in G. Bower, ed., \emph{The Psychology of Learning and Motivation: Advances in Research & Theory}, vol. 24, Academic Press, pp. 249-284. 1989. \cr
Batagelj, V., Doreian, P., Ferligoj, A. and Kejzar, N., \emph{Understanding Large Temporal Networks and Spatial Networks: Exploration, Pattern Searching, Visualization and Network Evolution}, Wiley. 2014.
}
%
\seealso{
\code{\link{galois}}, \code{\link{cscl}}, \code{\link[multigraph:multigraph]{multigraph}}.
}
\examples{
# create valued network data
arr <- round( array(runif(18), c(3,3,2)), array(runif(18), c(3,3,2)) ) * 10L

# pathfinder valued network of 'arr'
\dontrun{
pfvn(arr)
}
}
\keyword{models}
\keyword{manip}

\name{cph}
\alias{cph}
\title{
Cumulated Person Hierarchy
}
\description{
A function to calculate the Cumulated Person Hierarchy in networks of multiple relations. 
}
\usage{
cph(W, lbs)
}
\arguments{
  \item{W}{An object of the \dQuote{\code{Rel.Box}} class.}
  \item{lbs}{(optional) Labels of the relational system.}
}
\details{
Uses the cumulated person hierarchy to determine \emph{partial structural equivalence} among actors in a multiple network. 
Two nodes are considered partially structurally equivalent only if they have identical role sets.
Output is determined by the properties of the Relation-Box product of function \code{\link{rbox}}, and 
in case that the length of the labels differs from the order of the relational system, then labels will be ignored.
}
\value{
An object of \dQuote{\code{Partial.Order}} class with an array representing the cumulated person hierarchy.
}
\references{
Breiger, R.L. and P.E. Pattison, \dQuote{Cumulated social roles: The duality of persons and their algebras,} \emph{Social Networks}, 8, 215-256. 1986. \cr
Mandel, M.J. \dQuote{Roles and networks: A local approach.} B.A. Honours thesis, Harvard University. 1978.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{rbox}}, \code{\link{semigroup}}, \code{\link{diagram}}
}
\examples{
# load a dataset
data("incubA")

# construct the Relation Box of the dataset image matrices and
# compute its cumulated person hierarchy
incubA |> getElement("IM") |> 
  rbox() |> cph()
}
\keyword{algebra}
\keyword{math}
\keyword{array}

\name{partial.order}
\alias{partial.order}
\title{
Partial Order of String Relations or of Galois Derivations
}
\description{
Construct the partial order table of unique relations of the semigroup, or else of the concepts produced by Galois derivations.
}
\usage{
partial.order(x, type = c("strings", "galois", "pi.rels"), lbs, sel, po.incl, valued)
}
\arguments{
  \item{x}{A \sQuote{\code{Strings}} or a \sQuote{\code{Galois}} class object.}
  \item{type}{Type of partial order:
  \itemize{ 
    \item \code{strings} for string relations
    \item \code{galois} for Galois derivations
    \item \code{pi.rels} for \eqn{\pi}-relations
  }}
  \item{lbs}{(optional) Labels of the unique relations.}
  \item{sel}{(optional) Selected elements in \code{x} for the partial order.}
  \item{po.incl}{(optional, only for \code{pi.rels}) Include the partial order in the \eqn{\pi}-relations?}
  \item{valued}{(optional and logical) Treat string relations in \code{x} as valued?}
}
\details{
To get the partial order of an entire semigroup, both generators and compound relations must be considered. 
This information and the labels of the unique relations are given by the \code{\link{strings}} function. 
cf. \code{\link{semigroup}} to see how the \code{x} should be specified properly.

Galois derivations are now possible to be partially ordered as well, and this option is based on the 
output given by the \code{\link{galois}} function.
}
\value{
An object of \sQuote{\code{Partial.Order}} class with the partial order table in a matrix format.
}
\references{
Pattison, P.E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993. \cr
Ganter, B. and R. Wille  \emph{Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{as.strings}}, \code{\link{strings}}, \code{\link{galois}}, \code{\link{perm}}, \code{\link{diagram}}, \code{\link{fltr}}.
}
\examples{
# load a dataset 
data("incubA")

# strings in structure and partial order
strings(incubA$IM) |> 
  partial.order()
}
\keyword{algebra}
\keyword{math}

\name{read.dl}
\alias{read.dl}
\title{
Read \code{dl} Files
}
\description{
A function to read files with the Ucinet \code{dl} format.
}
\usage{
read.dl(file)
}
\arguments{
  \item{file}{Character vector containing a file name or path of the data representing the network.}
}
\details{
Ucinet \code{dl} format is to represent multiple and two-mode network structures. 
It is used in \pkg{NetDraw}, which is a component of the \pkg{Ucinet} program. 
Besides multiple networks, this function can read two-mode structures as well but 
the \sQuote{\code{EDGELIST}} option in \code{DL} is not yet supported for reading.
}
\value{
A data frame for two-mode networks, or an array representing the multiple networks with one set of actors.
}
\references{
Borgatti, S.P., \pkg{NetDraw} \emph{Software for Network Visualization}. Analytic Technologies. 2002. \cr
Borgatti, S.P., Everett, M.G. and Freeman, L.C. \pkg{Ucinet for Windows}: \emph{Software for Social Network Analysis}. Analytic Technologies. 2002.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{write.dl}}, \code{\link{edgel}}, \code{\link{read.gml}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file}

\name{edgel}
\alias{edgel}
\alias{read.srt}
\title{
Read and Transform Edge-Lists
}
\description{
A function to read edge lists as objects or files with a \sQuote{sender-receiver-tie} 
format representing multiplex networks and to transform edge-lists into three-dimensional arrays.
}
\usage{
edgel(x, toarray = TRUE, header = TRUE, sep = "\t", valued = FALSE, inc = FALSE, 
      rownames = TRUE, add = NULL, na.rm)
}
\arguments{
  \item{x}{Object or file representing network data.}
  \item{toarray}{(logical) Transform edge-list in \code{x} into an array?}
  \item{header}{(optional and logical) Does edge-list in file \code{x} has a header?}
  \item{sep}{(default horizontal tab) Separator between edge-list columns.}
  \item{valued}{(logical, for \code{toarray}) Return a transformation of \code{x} as a valued network?}
  \item{inc}{(optional and logical) Is \code{x} an incidence matrix?}
  \item{rownames}{(optional and logical, for \code{inc}) Treat \sQuote{rownames} in \code{x} as actors/objects names? See details.}
  \item{add}{(optional) Vector with isolate labels to add to the output.}
  \item{na.rm}{(optional and logical) Remove \code{NA}s from \code{x} in the output?}
}
\details{
The \code{edgel} function reads edge lists in \sQuote{sender-receiver-tie} format as a data frame 
with at least two columns for sender and receiver, plus one column for each relation type in a multiplex network. 
For simple networks, two columns for sender and receiver are sufficient. 
The input in \code{x} may also be a file containing tabular data, where the separator and header are specified with \code{sep} and \code{header}.

The \code{inc}  option is used for \emph{incidence} matrices with actors or objects and self-ties in data frames, 
which are relevant for two-mode data and analyses such as Galois transformations between partite sets. 
Incidence matrices can be converted into diagonal matrices for further analysis. 
When \code{toarray} is set to \code{FALSE}, argument \code{rownames} can be used to move labels between row names and the first column.

Additional options make it possible to remove missing values with \code{na.rm}, add isolated nodes with \code{add}, 
and choose between dichotomizing or preserving values in networks with \code{valued}.
}
\value{
By default the outcome is an array that for multiple networks is a three dimensions of stacked matrices where the relation types are placed. 
However, if \code{toarray} is set to \code{FALSE}, then the edge-list with a data frame format is returned.
\code{warning} messages for missing information, with the tranformation type, and when \sQuote{one type of relation assumed} in \code{x}.
}
%\references{} ~
%\author{} ~
\note{
For backwards compatibility, an alias for this fuction is \code{read.srt}.
}
%\section{Warning }{....} ~
\seealso{
\code{\link{write.edgel}}, \code{\link{galois}}, \code{\link{read.gml}}, \code{\link{read.dl}}
}
%\examples{
%}
\keyword{IO}
\keyword{manip}
\keyword{data}

\name{rbox}
\alias{rbox}
\title{
Construct the Relation-Box of Multiple Network
}
\description{
Function to construct the Relation-Box of a multiple network.
}
\usage{
rbox(w, transp = FALSE, smpl = FALSE, k = 3, tlbs)
}
\arguments{
  \item{w}{Array with three dimensions of stacked matrices with generating relations.}
  \item{transp}{(optional and logical) Include matrix transpose in \eqn{w}?
}
  \item{smpl}{(optional and logical) Simplify strings of relations?}
  \item{k}{Length of Relation-Box (in \eqn{z}).}
  \item{tlbs}{(optional) Vector with labels for transpose relations.}
}
\details{
If \code{transp = TRUE} the labels of the transpose are toggle case of the labels of the original matrices, and in such case, it is advised to simplify the strings of relations. 
To prevent a transposed structure for a certain array of \code{w}, use \code{NA} in the vector the transpose labels \code{tlbs} corresponding to the respective matrix.

Values of \code{k} until \eqn{9} are supported. 
}
\value{
An object of the \sQuote{\code{Rel.Box}} class.
  \item{w}{Primitive relations in Relation-Box}
  \item{W}{Structure of Relation-Box}
  \item{lbs}{Labels in relational system}
  \item{Note}{(optional) Notes indicating the particularities in the input}
  \item{Orels}{Original labels of relations}
  \item{Srels}{(optional) Simplified labels of relations}
  \item{Trels}{(optional) Transposed relation labels}
  \item{k}{Maximal length of the word}
  \item{z}{Length of the Relation-Box in the \eqn{z} dimension}
}
\references{
Winship, C. and M.J. Mandel \dQuote{Roles and positions: A critique and extension of the blockmodelling approach,} \emph{Sociological Methodology}, 314-344. 1983.
}
%\author{} ~
%\note{} ~
\section{Warning}{
May take a long time of computation with many types of relations and when the order of the multiplex network is high, and turning \code{k} to more than three.
}
\seealso{
 \code{\link{cph}}, \code{\link{semigroup}}, \code{\link{hierar}}
}
\examples{
# load the data
data("incubA")

# relation box of image matrices in dataset
\dontrun{
incubA |> getElement("IM") |> 
  rbox()
}
}
%
\keyword{algebra}
%\keyword{math}
\keyword{array}

\name{edgeT}
\alias{edgeT}
\title{
Edge Table Generator
}
\description{
Produce the Edge Table of multiple relations.
}
\usage{
edgeT(x, semigroupClass)
}
\arguments{
  \item{x}{An array, usually with three dimensions of stacked matrices where the multiple relations are placed.}
  \item{semigroupClass}{(optional and logical) Return a \dQuote{\code{Semigroup}} class object?}
}
\details{
Function \code{edgeT} is to produce the \emph{Edge Table} of multiple relations in a network, which is a complete 
right multiplication table of the semigroup having its elements for each of its generators, 
}
\value{
A list of \dQuote{\code{EdgeTable}} class object. 
  \item{gens}{generator relations}
  \item{ET}{Edge Table}
}
\references{
Cannon, J.J. \dQuote{Computing the ideal structure of finite semigroup,} \emph{Numerische Mathematik}, 18, 254-266. 1971. \cr
Pattison, P.E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{wordT}}, \code{\link{semigroup}}.
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# obtain its edge table
edgeT(arr)
}
\keyword{algebra}

\name{expos}
\alias{expos}
\title{
Network Exposure for Multiple Networks
}
\description{
Function to measure the network exposure of the nodes according to a chosen relational system representing the multiple network.
}
\usage{
expos(rs, classes = FALSE, allClasses = FALSE, allNodes = TRUE)
}
\arguments{
  \item{rs}{An object of \dQuote{\code{Rel.System}}, typically with node attributes.}
  \item{classes}{(optional and logical) Should categories of adopters be included in the output?}
  \item{allClasses}{(optional and logical, only for \code{classes}) Include empty classes within the categories of adopters?}
  \item{allNodes}{(optional and logical, only for \code{classes}) Include all actors in the network regardless they are in the chosen system?}
}
\details{
This function generalises the measure of network exposure for multiple networks based on the characteristics of the selected relational system. 
Such a system may represent the entire network or a configuration of strong or weak ties among the actors. 
It is also possible to specify different behaviours of the nodes representing social actors, expressed through the relational system. 
The network exposure measure is calculated on the basis of the immediate neighbours of the reference actor.
}
\value{
\item{Classes}{when \code{classes} is set to \code{TRUE}, the adoption membership for the type of relational system chosen, including isolated actors in the system}
\item{Bonds}{type of bonds of the relational system (cf. \code{\link{rel.sys}})}
\item{Exposure}{the exposure to the attribute(s) for acquisition through immediate neighbour relations}
}
\references{
Ostoic, J.A.R. \dQuote{Creating context for social influence processes in multiplex networks.} \emph{Network Science}, 5(1), 1-29. \cr
Valente, T. W. \emph{Social networks and health}. Oxford University Press. 2010. \cr
Rogers, E. \emph{The Diffusion of Innovations}. 5th ed. (1st ed. 1964) The Free Press. 2003.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{rel.sys}}, \code{\link{neighb}}, \code{\link{bundles}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# compute the exposure measure first array in 'arr' is for attributes with adopter categories
arr |> 
  rel.sys(att = 1) |> 
  expos(classes = TRUE)
}
\keyword{attribute}
\keyword{models}

\name{pi.rels}
\alias{pi.rels}
\title{
\eqn{\pi}-Relations
}
\description{
A function to produce the \eqn{\pi}-relations of a partially ordered structure.
}
\usage{
pi.rels(x, po.incl, vc, po)
}
\arguments{
  \item{x}{An object of a \dQuote{\code{Ind.incl}} or \dQuote{\code{Pacnet}} class.}
  \item{po.incl}{(optional and logical) Include partial order in outcome?}
  \item{vc}{(optional) Vector with induced inclusions to compute.}
  \item{po}{(optional) Matrix with partial order associated to induced inclusions.}
}
\details{
The totality of \eqn{\pi}-relations are represented with an array format, and the arrangement of meet-complements in 
this array are congruences that serve for the decomposition of a partially ordered semigroup structure.

Induced inclusions to the partial order in \code{x} as a \dQuote{\code{Ind.incl}} class object are produced by the \code{\link{fact}} function, 
while induced inclusions as a \dQuote{\code{Pacnet}} class object comes from the outcome of a \proglang{Pacnet} log-report. 
With either case, \eqn{\pi}-relations are derived from the induced inclusions in a factorization process of a partially ordered semigroup.

A visualization of the \eqn{\pi}-relations partial order arrangement with function \code{\link{diagram}} is feasible provided that 
the resulted \dQuote{\code{Pi.rels}} class object computes a \dQuote{\code{Pi.rels}} class with the \code{type} option \code{"pi.rels"} in function \code{\link{partial.order}}. 
In such case, including the partial order with \code{po.incl} and a addition in \code{po} is a good idea since the partial order is the minimal element of the lattice of congruence relations. 

Producing the partial order structure of a set of \eqn{\pi}-relations can be resource consuming and for exploring and other purposes, with \code{vc} option 
one can limit the amount of induced inclusions to compute.
}
\value{
An object of the \dQuote{\code{Pi.rels}} class with:
  \item{pi}{\eqn{\pi}-relations, eventually with partial order}
  \item{at}{atoms}
  \item{mca}{meet-complements of atoms}
  \item{po}{partial order (if included)}
}
\references{
Pattison, Philippa E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{fact}}, \code{\link{decomp}}, \code{\link{partial.order}}, \code{\link{diagram}}, \code{\link{semigroup}}, \code{\link{pacnet}}
}
%\examples{
%}
%
\keyword{algebra}
\keyword{math}

\name{write.dat}
\alias{write.dat}
\title{
Write \code{dat} Files
}
\description{
A function to write \code{dat} files.
}
\usage{
write.dat(x, path)
}
\arguments{
  \item{x}{Array representing a multiple network structure.}
  \item{path}{Path with filename for output.}
}
\details{
\dQuote{\code{dat}} files are the format used in the \pkg{Pacnet} program inside \pkg{StOCNET}. 
In case that the input data represents a multiple network then a separate file will be produced, 
each file representing a single type of relationship in the system. 
The name of the output files depends on the object title.
}
\value{
File(s) output with adjacency matrices with a \code{.dat} format.

In case that a directory in path for output does not exist then the folder is created.
}
\references{
\pkg{StOCNET} \emph{An open software system for the advanced statistical analysis of social networks}. 
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{pacnet}}, \code{\link{write.gml}}, \code{\link{write.dl}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file }

\name{as.strings}
\alias{as.strings}
\title{
Coerce Object into a Strings Class
}
\description{
A generic function for coercing an \R object into a \dQuote{\code{Strings}} class.
}
\usage{
as.strings(x, lbs)
}
\arguments{
  \item{x}{An array, usually with three dimensions of stacked matrices where the multiple relations are placed.}
  \item{lbs}{(optional) Labels of strings.}
}
\details{
Use this function to prepare an object for establishing the partial order of relation strings by converting it to class \dQuote{\code{Strings}}. 
It returns as well the number of unique relations in the semigroup represented by the dimensions in \code{x}.
}
\value{
The input array in \code{x} as an object of \dQuote{\code{Strings}} class
  \item{wt}{word tables}
  \item{ord}{dimension in \code{x}}
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{strings}}, \code{\link{partial.order}}, \code{\link{zbind}}
}
\examples{
# create the data: two sets with a pair of binary relations among 
# three elements
arr1 <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
        c(3,3,2))>.5, 3 ) )

arr2 <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
        c(3,3,2))>.5, 3 ) )

# bind the data sets
arrs <- zbind(arr1, arr2)

# make the data a strings object
as.strings(arrs)
}
\keyword{manip}
\keyword{classes}
\keyword{misc}

\name{pacnet}
\alias{pacnet}
\title{
Import Log-Report from Pacnet
}
\description{
A function to read output files and import from the \pkg{Pacnet} program with full factorization option.
}
\usage{
pacnet(file, toarray = FALSE, uniq = FALSE, transp = FALSE, sep)
}
\arguments{
  \item{file}{Path with filename of Log-Report.}
  \item{toarray}{(logical) Transform induced inclusions into arrays?}
  \item{uniq}{(logical) Consider only unique induced inclusions?}
  \item{transp}{(logical) Transpose partial order tables?}
  \item{sep}{(optional) Pair separator in pairwise relations.}
}
\details{
This function is used to read the output file from the \pkg{Pacnet} program, which typically has the \code{.out} extension. 
By default the result is given in a list format, but it is possible to transform the pair lists into arrays. 

Note that the options in the \pkg{Pacnet} program should include the full factorization in the output; otherwise the object will be \code{NULL}.
Also note that only partial order structures of order 36 and less are currently supported.
}
\value{
A \sQuote{\code{Pacnet}} class object with items:
  \item{ii}{: Induced inclusions}
  \item{at}{: Atoms}
  \item{mc}{: Meet complements}
}
\references{
Pattison, P, S Wasserman, G Robins and AM Kanfer \dQuote{Statistical Evaluation of Algebraic Constraints for Social Networks,} \emph{Journal of Mathematical Psychology}, 44, 536-568. 2000
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{pi.rels}}, \code{\link{cngr}}, \code{\link{decomp}}, \code{\link{write.dat}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file}

\name{write.gml}
\alias{write.gml}
\title{
Write \code{gml} Files
}
\description{
A function to write files with a graph modelling language (\code{gml}) format.
}
\usage{
write.gml(x, file = NULL)
}
\arguments{
  \item{x}{Array or object representing a multiple network structure.}
  \item{file}{(optional) Path with filename for output.}
}
\details{
The \code{gml} format, an acronym for \emph{graph modelling language}, provides capabilities to represent multiple networks and add arguments to both the nodes and the edges for visualization purposes. 
}
\value{
A graph with modelling language format in a file with path or an object.
}
%\references{} ~
%\author{} ~
%\note{} ~
\section{Warning}{
Files with identical path and name to \code{file} will be overwritten.
}
\seealso{
\code{\link{read.gml}}, \code{\link{write.dl}}, \code{\link{write.dat}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file }

\name{reduc}
\alias{reduc}
\title{
Reduce Matrices or Arrays
}
\description{
Function to reduce a matrix or an array with a given clustering vector.
}
\usage{
reduc(x, clu, lbs, slbs, valued, row, col)
}
\arguments{
  \item{x}{Matrix or a three-dimensional array to be reduced.}
  \item{clu}{Vector with class membership in \code{x}.}
  \item{lbs}{(optional) Vector with labels for the reduced structure.}
  \item{slbs}{(optional) Vector with string labels in the reduced structure.}
  \item{valued}{(optional and logical) Should the reduction preserve valued data?}
  \item{row}{(optional and logical) Reduction by rows.}
  \item{col}{(optional and logical) Reduction by columns.}
}
\details{
Given a partition, this function serves to reduce either a matrix representing e.g. a partial order structure. 
However, the reduction is also generalized to three-dimensional arrays representing multiple relations or 
affiliation networks with either \code{row} or \code{col}. 

Notice that the \dQuote{reduction} of a semigroup of \code{x} is made through a decomposition process that is computed 
with function \code{\link{decomp}}.
}
\value{
A reduced matrix or a reduced three-dimensional array of the input data according to the clustering information.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{cngr}}, \code{\link{rbox}}, \code{\link{decomp}}
}
\examples{
# scan the multiplication table data
s <- matrix(data=c(1, 1, 1, 3, 3, 3, 3, 3, 3), nrow=3, ncol=3, byrow=TRUE)

# reduce the multiplication table
s |> reduc(clu=c(1,2,2))
}
\keyword{manip}
\keyword{array}
\keyword{cluster}

\name{as.signed}
\alias{as.signed}
\title{
Coerce into a Signed Object
}
\description{
A generic function for coercing a matrix into a \dQuote{\code{Signed}} class object.
}
\usage{
as.signed(x, lbs)
}
\arguments{
  \item{x}{A matrix representing the signed network.}
  \item{lbs}{(optional) Labels for the signed matrix.}
}
\details{
Use this function to convert an array representing a signed network into an \R object of 
class \dQuote{\code{Signed}}, as required by function \code{\link{semiring}}.

The array in \code{x} itself can be also a \dQuote{\code{Semiring}} class object represented as 
\sQuote{\code{Rel.Q}} attribute for the semiring relational structure. 
}
\value{
The input array in \code{x} as a \dQuote{\code{Signed}} class.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{signed}}, \code{\link{semiring}}
}
\examples{
# load a network dataset
data("incubA")

# coerce parts of the signed matrix with two types of relations
signed(incubA$IM)$s[1:2,1:2] |> 
  as.signed()
}
\keyword{manip}
\keyword{classes}
\keyword{misc}

\name{multiplex-package}
\alias{multiplex-package}
\alias{multiplex}
\docType{package}
\title{
\packageTitle{multiplex}
}
\description{
\packageDescription{multiplex}
}
\details{
\tabular{ll}{
    Package: \tab multiplex \cr
    Type: \tab Package \cr
    Version: \tab 4.0 \cr
    Date: \tab 29 July 2026 \cr
    License: \tab GPL-3 \cr
}
One aim of the \pkg{multiplex} package is to provide an analytical tool specifically designed for social networks with relationships at multiple levels. 
It includes functions for modelling local role algebras based on the simple and compound relations present in the network. 
\pkg{multiplex} also supports the construction and analysis of signed networks through semiring structures. 
In addition, it can identify dyadic relational patterns that may support further analysis using a range of structural theories.
The package can also incorporate actor attributes into the analysis of multiple networks in different ways. 
For example, it can assess the network exposure of actors in a multiplex context or embed attribute information directly into the resulting algebraic structures.

A typical workflow starts with function \code{\link{semigroup}}, which constructs a semigroup from an array of multiple binary relations. 
The resulting structure can be described with functions \code{\link{wordT}} and \code{\link{edgeT}}. 
Unique relations and associated equations are returned by \code{\link{strings}} function together with the set of equations with strings of length \eqn{k}. 
Ordering among string elements is defined by function \code{\link{partial.order}}, and the corresponding lattice can be displayed with functions \code{\link{hasse}} or \code{\link{diagram}}. 

Further semigroup analysis is available through function \code{\link{green.rel}} for equivalence classes and \code{\link{diagram}} function again for \dQuote{egg-box} visualization. 
Structure reduction of semigroup objects is supported through decomposition based on congruence relations or \eqn{\pi}-relations using functions \code{\link{pi.rels}}, \code{\link{cngr}}, and \code{\link{decomp}}.

Signed networks can be created with function \code{\link{signed}} and analysed with function \code{\link{semiring}} for balance or cluster semiring structures. 

General network analysis utilities in \pkg{multiplex} include function \code{\link{dichot}} for dichotomization of matrices and arrays, 
\code{\link{rm.isol}} for removing isolates, \code{\link{perm}} for permutation operation, and function \code{\link{zbind}} for building three-dimensional arrays.

The package \pkg{multiplex} also provides function \code{\link{rbox}} for Relation-Box construction and function \code{\link{cph}} for Cumulated Person Hierarchy in the network. 
Bundle analysis is supported by functions \code{\link{bundles}}, \code{\link{transf}}, \code{\link{bundle.census}}, and \code{\link{summaryBundles}}. 
Network exposure and relational-system analysis are available through functions \code{\link{rel.sys}} and \code{\link{expos}}, while \code{\link{galois}} supports algebraic analysis of two-mode networks.
Multivariate network data can be imported from send-receive-ties edge lists with function \code{\link{edgel}} and from formats such as \pkg{UCINET} \code{dl} and \pkg{Visone} \code{gml}. 
Multiple network structures can be visualized further with the related package \pkg{multigraph}.
}
\author{
J. Antonio Rivero Ostoic

Maintainer: \packageMaintainer{multiplex}
}
\references{
Pattison, P.E. \emph{Algebraic Models for Social Networks}. Structural Analysis in the Social Sciences. Cambridge University Press. 1993. \cr 
Boyd, J.P. \emph{Social Semigroups. A unified theory of scaling and blockmodelling as applied to social networks}. George Mason University Press. 1991. \cr 
Lorrain, F. and H.C. White, \dQuote{Structural Equivalence of Individuals in Social Networks.} \emph{Journal of Mathematical Sociology}, 1, 49-80. 1971. \cr 
Boorman, S.A. and H.C. White, \dQuote{Social Structure from Multiple Networks. II. Role Structures.} \emph{American Journal of Sociology}, 81 (6), 1384-1446. 1976. \cr 
Ostoic, J.A.R. \emph{Algebraic Analysis of Social Networks}. Wiley Series in Computational and Quantitative Social Sciences. Wiley. 2021. \cr 
}

%% Uncomment below to imitate parts of library(help = multiplex)
%\section{The \file{DESCRIPTION} File}{\packageDESCRIPTION{multiplex}}
%\section{Documentation Index}{\packageIndices{multiplex}}

\seealso{
\code{\link[multigraph:multigraph]{multigraph}}, \code{\link[multigraph:bmgraph]{bmgraph}}, \code{\link[multigraph:ccgraph]{ccgraph}}.
}
\examples{
# create a three-dimensional array
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 3 ) )

# dichotomize array with customized cutoff value
dichot(arr, c = 3)

# construct the semigroup structure and look at its Green relations
semigroup(arr) |> 
  green.rel()

# look at string relations
strings(arr)
}
\keyword{package}
\keyword{models}
\keyword{attribute}
\keyword{manip}
\keyword{IO}
\keyword{datasets}
\keyword{file}
\keyword{misc}

\name{transf}
\alias{transf}
\title{
Transform Data from-to Matrix-List Formats
}
\description{
Function to transform data from/to matrix/list formats or edge list representing a network.
}
\usage{
transf(x, type = c("toarray", "tolist", "toarray2", "toedgel"), lbs = NULL, lb2lb, valued, 
       sep, ord, sort, sym, add, adc, rm.isol, na.rm)
}
\arguments{
  \item{x}{An array or a list of pair relations.}
  \item{type}{Type of transformation:
   \itemize{ 
    \item \code{toarray} from a list of pair relations to an array format
    \item \code{tolist} from a matrix to a list of pair relations
    \item \code{toarray2} from a list of pair relations to a square array
    \item \code{toedgel} from arrays to edge list
   }}
  \item{lbs}{(optional) Labels in the transformation.}
  \item{lb2lb}{(optional and logical) Is the transformation \dQuote{label-to-label}?}
  \item{valued}{(optional and logical) Treat \code{x} as valued?}
  \item{sep}{(optional) Pair separator used for the pairwise relations.}
  \item{ord}{(optional, for \code{"toarray"}) Order of the transformed array structure.}
  \item{sort}{(optional and logical) Sort the arrays in the output?}
  \item{sym}{(optional and logical, for \code{"toarray"}) Symmetrize the arrays?}
  \item{add}{(optional) Added elements in the array's \emph{domain}.}
  \item{adc}{(optional) Added elements in the array's \emph{codomain}.}
  \item{rm.isol}{(optional and logical) Remove isolates in \code{x}?}
  \item{na.rm}{(optional and logical) Remove missing data or \code{NA}s?}
}
\details{
Option \code{"tolist"} is for transforming a matrix or an array to a list of pair elements. 
In case that the \code{lb2lb} is enabled in this type of transformation, then \code{lbs} 
must be provided, whereas the pair separator is optional. 
Notice that the default of \code{lb2lb} is \code{TRUE} for \code{"toarray"}, while is \code{FALSE} for \code{"tolist"}.

Option type \code{"toarray"} will produce a matrix from a list of pair elements, and in this case is advisable to specify the order of the structure. 
Three dimensional structures are supported in the transformations with all options.

Data frames are also accepted for the \code{"tolist"} option; however, in case that this information 
is given as a list of pair relations the output will be a square matrix.

When the transformation option is \code{"edgel"}, the output is a data frame with the first two 
columns for the sending and receiving ties. For simple networks, these two columns are enough and for 
multiplex networks additional columns are for the types of tie, one for each (cf. function \code{\link{edgel}}).

Notice that for high dimensional arrays, the \code{\link{rel.sys}} function provides additional information 
other than the list of pair relations of the entire structure.
}
\value{
Depending on the input data, the result is either a list of pair relations or a matrix of relations.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{edgel}}, \code{\link{bundles}}, \code{\link{reduc}}, \code{\link{rel.sys}}
}
\examples{
# scan the multiplication table data
s <- matrix(data=c(1, 1, 1, 3, 3, 3, 3, 3, 3), nrow=3, ncol=3, byrow=TRUE)

# transform the matrix to a list format
s |> transf(lb2lb = TRUE, lbs = c("n","m","u"))
}
\keyword{manip}
\keyword{array}

\name{cngr}
\alias{cngr}
\title{
Congruence Relations
}
\description{
Find the congruence relations of a given abstract semigroup or a partially ordered semigroup.
}
\usage{
cngr(S, PO, uniq)
}
\arguments{
  \item{S}{A \dQuote{\code{Semigroup}} class object.}
  \item{PO}{(optional) A partial order table.}
  \item{uniq}{(optional and logical) Return unique congruence relations?}
}
\details{
\emph{Congruencies} are equivalence relations that preserve the operation between the correspondent classes in the algebraic structure 
where the different congruence classes are based on the substitution property of the semigroup object. 

In case that the partial order is supplied in \code{PO} the computation of the congruence classes is slightly faster than for an abstract semigroup.
}
\value{
A \dQuote{\code{Congruence}} class list object with:
  \item{S}{Semigroup of relations}
  \item{PO}{Partial order table (if specified)}
  \item{clu}{Congruence classes}
}
\references{
Hartmanis, J. and R.E. Stearns \emph{Algebraic Structure Theory of Sequential Machines}. Prentice-Hall. 1966.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{decomp}}, \code{\link{fact}}, \code{\link{pacnet}} 
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# abstract semigroup of 'arr'
S <- arr |> semigroup()

# look at the congruences in S
cngr(S)
}
%
\keyword{algebra}
\keyword{math}
\keyword{cluster}

\name{strings}
\alias{strings}
\title{
Strings of Relations
}
\description{
Function to obtain labels of unique relations, and generators and compound relations of a complete semigroup structure.
}
\usage{
strings(x, equat = FALSE, k = 2, smpl, valued)
}
\arguments{
  \item{x}{Array with three dimensions of stacked matrices with generating relations.}
  \item{equat}{(logical) Include equations in output?}
  \item{k}{Length of strings in equations.}
  \item{smpl}{(optional and logical) Simplify string relations for output?}
  \item{valued}{(optional and logical) Valued format in strings?}
}
\details{
The strings are the unique relations, which constitute the elements of the complete semigroup. 
These are both the generators and the compound relations after applying the Axiom of Quality, which means that even some generators can be disregarded.

This function is especially useful to construct the partial order of relations and to establish the set of equations in the relational structure.

The maximum length of the strings in the equations is currently \eqn{4}.
}
\value{
An object of \sQuote{\code{Strings}} class.
  \item{wt}{Generators and compound relations}
  \item{ord}{Order of structure}
  \item{st}{Labels of unique relations}
  \item{equat}{Equations among strings relations}
}
\references{
Boorman, S.A. and H.C. White, \dQuote{Social Structure from Multiple Networks. II. Role Structures.} \emph{American Journal of Sociology}, 81 (6), 1384-1446. 1976.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{partial.order}}, \code{\link{semigroup}}.
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# get string relations
strings(arr)
}
\keyword{algebra}
\keyword{array}

\name{rel.sys}
\alias{rel.sys}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Relational System of Network
}
\description{
Function to create a Relational System of a multiple network.
}
\usage{
rel.sys(x, type = c("tolist", "toarray"), bonds = c("entire", "strong", "weak", 
        "asym", "recp", "txch", "tent", "mixd", "full"), loops = FALSE, 
        sel = NULL, att = NULL, sep)
}
\arguments{
  \item{x}{Array with three dimensions of stacked matrices with generating relations.}
  \item{type}{Is the transformation about: 
  \itemize{ 
    \item \code{tolist} (Array of) matrices into lists of pairwise relations.
    \item \code{toarray} Lists of pairwise relations into (array of) matrices.
  } }
  \item{bonds}{
   the type of bonds to be used in the creation of the relational system 
  \itemize{ 
    \item \code{entire} The \dQuote{entire} network (default, same as \code{full})
    \item \code{strong} Strong bonds
    \item \code{weak} Weak bonds
    \item \code{asym} Asymmetric ties
    \item \code{recp} Reciprocal ties
    \item \code{txch} Tie exchange bundles
    \item \code{tent} Tie entrainment bundles
    \item \code{mixd} Mixed bundles
    \item \code{full} Whole network (same as \code{entire})
  } }
  \item{loops}{(optional and logical) Include loops in relational system.}
  \item{sel}{(optional) Vector with set of actors to select.}
  \item{att}{(optional) Arrays in \code{x} corresponding to attributes.}
  \item{sep}{(optional) Pair separator for pairwise relations.}
}
\details{
A relational system of network \code{x} is a configuration with a particular pattern like the bond type among members. 
For instance, when the type of bonds chosen is \code{entire} then the nodes with ties are considered in the relational system without isolated nodes. 
Besides, \code{strong} bonds are relational bundles with a mutual character, whereas \code{weak} bonds are those patterns exclusively without mutual character. 

It is also possible to select the network members having or *not* having the attribute that is specified in the \code{Attrs} output by using in argument \code{sel}. 
This is possible when choosing from a list with actor attributes. 
}
\value{
For \code{type = "tolist"} (default) option, an object of \sQuote{\code{Rel.System}} class  
where items are:
   \item{ord}{order of network relational system}
   \item{nodes}{nodes in relational system}
   \item{sel}{selected set of actors}
   \item{sys.ord}{order of relational system with chosen bond type}
   \item{incl}{nodes included relational system with chosen bond type}
   \item{excl}{nodes excluded relational system with chosen bond type}
   \item{bond.type}{type of bonds used in relational system creation}
   \item{size}{number of ties in relational system}
   \item{Note}{(if needed) a note}
   \item{sep}{pairwise separator of relational system}
   \item{Ties}{ties in relational system}
   \item{Attrs.ord}{if \code{att} is not \code{NULL}, number of nodes with chosen attribute(s) }
   \item{Attrs}{if \code{att} is not \code{NULL}, actors with chosen attribute(s)}

For \code{type = "toarray"}, the output is a two or three dimensional dichotomous array recording the relations among the actors in the network.
}
\references{
Ostoic, J.A.R. \dQuote{Creating context for social influence processes in multiplex networks.} \emph{Network Science}, 5(1), 1-29.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{expos}}, \code{\link{bundles}}, \code{\link{neighb}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# establish system of strong bonds
arr |> rel.sys(bonds = "strong")

# first array is for attributes
arr |> rel.sys(att = 1)

# select first node
arr |> rel.sys(sel = 1)
}
\keyword{models}
\keyword{attribute}

\name{fltr}
\alias{fltr}
\title{
Principal Order Filters
}
\description{
A function to find principal order filters and order ideals in a partial order structure.
}
\usage{
fltr(x, PO, ideal = FALSE, rclos)
}
\arguments{
  \item{x}{(integer or character) Reference element in the partial order.}
  \item{PO}{An array for the partial order or a \dQuote{\code{Partial.Order}} class object.}
  \item{ideal}{(logical) Is the \dQuote{filter} an order ideal?}
  \item{rclos}{(optional and logical) Apply reflexive closure to the outcome?}
}
\details{
This function identifies the principal order filter or principal order ideal of an element in a partial order. 
The input is typically either a concept, an object, or an attribute, together with the corresponding partial order 
of concepts derived from Galois derivations. If the reference element is a concept, specify it as a positive 
integer representing the concept label. Alternatively, an object or attribute may be given by its character name, 
provided it appears among the dimension labels of the partially labelled order table. 
When the reference element is an object or attribute, principal order filters with full labelling are not supported, 
and in that case use the corresponding concept number instead.
}
\value{
Returns a named list containing the elements in the upset or downset of the principal order filter or order ideal 
associated with the reference element in the partial order.
}
\references{
Ganter, B. and R. Wille \emph{Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{galois}}, \code{\link{partial.order}}, \code{\link{diagram}}.
}
\examples{
# create a data frame
dfr <- data.frame(x=1:3, y=5:7)

# partial ordering of concepts
PO <- dfr |> 
  galois() |> 
  partial.order(type="galois")

# order filter for the first element
fltr(1, PO, rclos=TRUE)
}
\keyword{algebra}
\keyword{math}

\name{semiring}
\alias{semiring}
\title{
Semiring Structures for Balance Theory
}
\description{
A function to construct semiring structures for the analysis of Structural Balance theory.
}
\usage{
semiring(x, type = c("balance", "cluster"), symclos = TRUE, 
         transclos = TRUE, k = 2, lbs)
}
\arguments{
  \item{x}{A \sQuote{\code{Signed}} class object.}
  \item{type}{  
  \itemize{ 
   Semiring type: 
    \item \code{balance} semiring (default)
    \item \code{cluster} semiring
  }}
  \item{symclos}{(logical) Apply symmetric closure?}
  \item{transclos}{(logical) Apply transitive closure?}
  \item{k}{Length of cycle or semicycle.}
  \item{lbs}{(optional) Labels for semiring to return.}
}
\details{
Semiring structures are based on signed networks, and this function provides the capabilities to handle either the balance semiring or the cluster semiring within the Structural Balance theory.

A semiring combines two different kinds of operations with a single underlying set, and it can be seen as an abstract semigroup with identity under multiplication and a commutative monoid under addition. 
Semirings are useful to determine whether a given signed network is balanced or clusterable. 
The symmetric closure evaluates the assessment by looking at semicycles in the system; otherwise, the evaluation is through closed paths. 
}
\value{
A \sQuote{\code{Semiring}} class object with items:
  \item{val}{Valences in the semiring}
  \item{s}{Original semiring structure}
  \item{Q}{Resulted semiring structure}
  \item{k}{Number of cycles or semicycles}
}
\references{
Harary, F, Z. Norman, and D. Cartwright  \emph{Structural Models: An Introduction to the Theory of Directed Graphs}. Wiley. 1965. \cr
Doreian, P., V. Batagelj and A. Ferligoj  \emph{Generalized Blockmodeling}. Cambridge University Press. 2004. \cr
Ostoic, J.A.R. \dQuote{Creating context for social influence processes in multiplex networks.} \emph{Network Science}, 5(1), 1-29.
}
%\author{} ~
%\note{} ~
\section{Warning}{
Disabling transitive closure should be made with good substantial reasons.
}
\seealso{
\code{\link{signed}}, \code{\link{as.signed}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# create signed matrix with the two types of relations
# and establish the semiring structure
signed(arr) |> 
  semiring()
}
\keyword{algebra}
\keyword{math}
\keyword{models}

\name{diagram.levels}
\alias{diagram.levels}
\title{
Levels in Lattice Diagram
}
\description{
A function to represent a textual interpretation of the levels in a given lattice diagram.
}
\usage{
diagram.levels(x, perm = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{A matrix representing partial order relations.}
  \item{perm}{optional and logical) Return automorphism of a permuted structure?}
}
\details{
This function provides a textual interpretation of the different levels in the lattice diagram of the partial order structure among actors and ties in the network.

When reducing a multiple network, the partial order structure may define different classes of elements based on their inclusion relations. 
The illustration produced by the \code{\link{diagram}} function typically shows these levels of ordered relations, which this routine then interprets.
}
\value{
A named list with components of the \dQuote{levels} in the concept diagram produced by \code{\link{diagram}}.

If \code{perm} is specified, the function returns a data frame containing the elements of the partial order structure, with column names indicating the element classes. 
It also returns a vector of levels and a matrix of the permuted structure.
}
%\references{} ~
%\author{} ~
\note{
This function requires that the \pkg{Rgraphviz} package is installed. 
Since function \code{grDevices::pictex()} inside this routine is for historical interest only since \proglang{R} \code{4.4.0}, 
the warning message has been suppressed before its future replacement.
}
%\section{Warning }{....} ~
\seealso{
\code{\link{partial.order}}, \code{\link{diagram}}, \code{\link{perm}}
}
\examples{
# load the data
data("incubA")

# given e.g. a partial order table in the object 'po'
po <- incubA |> getElement("IM") |> 
  as.strings() |> 
  partial.order(type="strings")

# find the levels in the lattice diagram
\dontrun{
diagram.levels(po)
}
}
\keyword{algebra}
\keyword{manip}

\name{semigroup}
\alias{semigroup}
\title{
Semigroup of Relations for Multiple Networks
}
\description{
Function to create the complete semigroup of multiple relations, where the multiplication table can be specified with either a numerical or a symbolic form.
}
\usage{
semigroup(x, type = c("numerical", "symbolic"), cmps, smpl, valued)
}
\arguments{
  \item{x}{Array with three dimensions of stacked matrices with generating relations.}
  \item{type}{
   Semigroup multiplication table to return: 
  \itemize{ 
    \item \code{numerical} format (default)
    \item \code{symbolic} format
  }}
  \item{cmps}{(optional and logical) Include composite matrices in output?}
  \item{smpl}{(optional and logical) Simplify strings of relations?}
  \item{valued}{(optional and logical) Is the semigroup of a valued format?}
}
\details{
A multiple relation can be defined by square matrices of \code{0}s and \code{1}s indicating the presence and absence of ties among a set of actors. 
If there is more than one relation type, the matrices must preserve the label ordering of its elements and stacked into an object array in order to be effectively applied to this function.

The semigroup, which is an algebraic structure having a set with an associative operation on it, is calculated considering binary matrices only. 
This means that if the provided matrices are valued, the function will dichotomise the input data automatically.
Values higher or equal to a unit are converted to one; otherwise they are set to zero. 
For other values use function \code{\link{dichot}} to specify a cutoff value for the dichotomization. 

Semigroup structures for valued relations apply the max min operation in the composition of generators and strings, and depend on function \code{\link{cscl}}. 
}
\value{
A \sQuote{\code{Semigroup}} class object with items:
  \item{gens}{Array with generator relations}
  \item{cmps}{Array with the unique compound relations}
  \item{ord}{Dimension of the semigroup}
  \item{st}{Vector of unique string relations}
  \item{S}{Multiplication matrix with semigroup of relations (numerical or symbolic)}
If the specified type is \code{numerical}, then a matrix of semigroup values is given; otherwise the values is returned as a data frame with the strings of the semigroup.
}
\references{
Boorman, S.A. and H.C. White, \dQuote{Social Structure from Multiple Networks. II. Role Structures.} \emph{American Journal of Sociology}, 81 (6), 1384-1446. 1976. \cr
Boyd, J.P. \emph{Social Semigroups. A unified theory of scaling and blockmodelling as applied to social networks}. George Mason University Press. 1991. \cr
Pattison, P.E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993.
}
%\author{} ~
%\note{} ~
\section{Warning}{
Computing for the semigroup construction can take very long time for medium size or bigger sets (e.g. having more than 4 relation types).
}
\seealso{
\code{\link{green.rel}}, \code{\link{strings}}, \code{\link{edgeT}}, \code{\link{wordT}}, \code{\link{cngr}}, \code{\link{cscl}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# optionally put labels
dimnames(arr)[[3]] <- list("n", "m")

# look at the semigroup with numerical format
semigroup(arr)
}
\keyword{algebra}
\keyword{math}

\name{read.gml}
\alias{read.gml}
\title{
Read \code{gml} Files
}
\description{
A function to read files with the \code{gml} format.
}
\usage{
read.gml(file, as = c("edgel", "array"), directed = TRUE, coords = FALSE)
}
\arguments{
  \item{file}{Character vector containing a file name or path of the data representing the network.}
  \item{as}{Data format for output: 
  \itemize{ 
    \item \code{edgel} Edge list with send/receive/ties format
    \item \code{array} Two- or three-dimensional array
  }}
  \item{directed}{(logical) Is the graph directed?}
  \item{coords}{(optional and logical) Include coordenates in \code{gml} file?}
}
\details{
The \code{gml} format, an acronym for \emph{graph modelling language}, provides capabilities to represent multiple networks and 
add arguments both to the nodes and the edges for visualization purposes.

For the multiplexity in the ties the \code{gml} file distinguishes \dQuote{graphics} arguments inside \dQuote{edge}. 
Both \dQuote{style} and \dQuote{fill} are supported here and the former has priority over the latter in case the two are given; 
otherwise when these arguments are absent, the function separates up to a couple of relational levels when several pairwise ties are specified.

Node attributes can be retrieved as well when coordinates in \code{coords} are chosen.
}
\value{
Depending the option chosen, the output is either a data frame or an array representing the multigraph. 
If the coordenates are chosen then these are part of the obejct structure, but they are not visible.
}
\references{
\pkg{visone}: \emph{Software for the analysis and visualization of social networks}. \url{http://visone.info}
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{write.gml}}, \code{\link{edgel}}, \code{\link{read.dl}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file }

\name{decomp}
\alias{decomp}
\title{
Decomposition of a Semigroup Structure
}
\description{
A function to perform the decomposition of a semigroup structure.
}
\usage{
decomp(S, pr, type = c("mca", "pi", "at", "cc"), reduc, fac)
}
\arguments{
  \item{S}{A \dQuote{\code{Semigroup}} class object.}
  \item{pr}{Either an object of a \dQuote{\code{Congruence}} class or an object of a \dQuote{\code{Pi.rels}} class.}
  \item{type}{Type of decomposition on \code{S} where the reduction is based on: 
  \itemize{ 
    \item \code{mca} meet-complements of atoms in the \dQuote{\code{Pi.rels}} class
    \item \code{pi} \eqn{\pi}-relations in the \dQuote{\code{Pi.rels}} class
    \item \code{at} atoms
    \item \code{cc} congruence classes.
  }}
  \item{reduc}{(optional and logical) Should the returned list include the reduced structures?}
  \item{fac}{(optional) Factor subject to decomposition.}
}
\details{
The \code{decomp} function reduces an algebraic structure, such as a semigroup, to determine which class members in the system are congruent. 
The resulting object consists of congruent elements that belong to the lattice of congruence classes in the structure. 
If the input data comes from the \proglang{Pacnet} program, these elements take the form of \eqn{\pi}-relations or meet-complements of atoms; 
otherwise, they are equivalent elements that satisfy the substitution property.

A \dQuote{\code{Semigroup}} class object may contain unavailable values in its multiplication table, typically when it is produced as an image by the \code{\link{fact}} function. 
In such cases, the semigroup can be reduced with the \code{force} option, which adds equations to the string relations to eliminate \code{NA} values in the semigroup data.

Use the \code{\link{reduc}} function to reduce the partial order table.
}
\value{
A list object of \dQuote{\code{Decomp}} class having:
  \item{clu }{vector with class membership}
  \item{eq }{equations in decomposition}
  \item{IM }{(optional) image matrices}
  \item{PO }{(optional) partial order table}
  \item{ord}{(optional) vector with order of image matrices}
}
\references{
Pattison, Philippa E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993. \cr
Hartmanis, J. and R.E. Stearns \emph{Algebraic Structure Theory of Sequential Machines}. Prentice-Hall. 1966.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{fact}}, \code{\link{cngr}}, \code{\link{reduc}}, \code{\link{pi.rels}}, 
\code{\link{semigroup}}, \code{\link{partial.order}}, \code{\link{green.rel}}.
}
%\examples{} ~
\keyword{algebra}
\keyword{math}
\keyword{array}
\keyword{cluster}

\name{signed}
\alias{signed}
\title{
Signed Network
}
\description{
Construct the signed network of a system made of contrasting relations.
}
\usage{
signed(P, N = NULL, lbs)
}
\arguments{
  \item{P}{Array with positive ties and eventually with negative ties (see \sQuote{details}).}
  \item{N}{(optional) Array with the negative ties.}
  \item{lbs}{(optional) Labels for returned signed matrix.}
}
\details{
This function coerces an array(s) to become a \sQuote{\code{Signed}} object. 
Positive ties are always in the first argument, and in case that this array has three dimensions, 
the second dimension is considered as the negative ties, provided that \code{N} is still \code{NULL}. 

If ambivalent ties are present in the structure then the signed matrix represent positive, negative, ambivalent, and null ties 
as \code{p}, \code{n}, \code{a}, and \code{o} respectively; otherwise, the values are \code{1}, \code{-1}, and \code{0}.
}
\value{
A \sQuote{\code{Signed}} class object with items: 
  \item{val}{Valences in \code{s}}
  \item{s}{Signed matrix}
%
A warning message is shown when the \code{N} argument has more than two dimensions.
}
\references{
Doreian, P., V. Batagelj and A. Ferligoj  \emph{Generalized Blockmodeling}. Cambridge University Press. 2004.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~

\seealso{
\code{\link{semiring}}, \code{\link{as.signed}}
}
\examples{
# load a dataset
data("incubA")

# make signed matrix of image matrix in dataset
incubA |> getElement("IM") |> signed()
}
\keyword{models}
\keyword{array}

\name{mnplx}
\alias{mnplx}
\title{
Make Multiple Networks as Monoplex Structures
}
\description{
A function to transform multiple networks into a monoplex structure.
}
\usage{
mnplx(net, directed = TRUE, valued, diag, clu)
}
\arguments{
  \item{net}{A three-dimensional array to be transformed into a matrix.}
  \item{directed}{(optional and logical) Make symmetric the matrix?}
  \item{valued}{(optional and logical) Dichotomize the matrix?}
  \item{diag}{(optional and logical) Include diagonals?}
  \item{clu}{(optional) Vector with a cluster for permutation.}
}
\details{
This function is to collapse multiple types of tie of a network \code{net} recorded in an array into a matrix representation with monoplex relations. 
Other transformations on \code{net} are dichotomizing a valued network, and convert directed networks into undirected systems having or not self-relations 
depending on the value of \code{diag}. 
Moreover, the resulted matrix can be permuted with a clustering information in a vector in \code{clu} as with \code{\link{perm}}.
}
\value{
A matrix of monoplex relations.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{perm}}, \code{\link{zbind}}, \code{\link{dichot}}, \code{\link{reduc}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.8, 3 ) )

# make array monoplex
mnplx(arr)
}
\keyword{manip}
\keyword{array}

\name{wordT}
\alias{wordT}
\title{
Word Table of Relations
}
\description{
Function to produce the \emph{Word Table} of multiple relations as representation form of a semigroup of relations.
}
\usage{
wordT(x)
}
\arguments{
  \item{x}{Array with three dimensions of stacked matrices with generating relations.}
}
\details{
The Word Table is a consequence of the Edge Table (cf. \code{\link{edgeT}}) and the function gives a list of indexed elements in the complete semigroup. 

In terms of the Cayley graph of the semigroup (cf. \code{\link[multigraph:ccgraph]{ccgraph}}, the collection of unique relations 
(both compound and generators) are represented by nodes. 
On the other hand, the generators are edges that record the result of post-multiplying the compound relations by the generators.

The labels for the elements can be retrieved by the \code{\link{strings}} function. 

The generators do not have values in neither the \dQuote{node} nor the \dQuote{generator} of the Word table since they are not 
a product of any other element in the semigroup (cf. \sQuote{details} for the rest of the values).
}
\value{
A \sQuote{\code{WordTable}} class object with items:
  \item{gens}{Generator relations}
  \item{WT}{ Word Table where \dQuote{\code{n}} stands for \emph{node} and \dQuote{\code{g}} stands for \emph{generator}}
}
\references{
Cannon, J.J. \dQuote{Computing the ideal structure of finite semigroup,} \emph{Numerische Mathematik}, 18, 254-266. 1971. \cr
Pattison, P.E. \emph{Algebraic Models for Social Networks}. Cambridge University Press. 1993.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{edgeT}}, \code{\link{semigroup}}, \code{\link{strings}}, \code{\link[multigraph:ccgraph]{ccgraph}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array( runif(18), c(3 ,3, 2) ), array( runif(18),
       c(3, 3, 2) ) > .9, 3 ) )

# obtain word table
wordT(arr)
}
\keyword{algebra}

\name{comps}
\alias{comps}
\title{
Find Components in Multiple Networks
}
\description{
Function to find different components and isolated nodes in the multiple networks.
}
\usage{
comps(x, bonds = c("entire", "strong", "weak"), sort)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{An array representing a given network.}
  \item{bonds}{Type of bonds for components creation: 
  \itemize{
    \item \code{"entire"}: all bundle patterns
    \item \code{"strong"}: mutual bundles (reciprocal, exchange, and mixed)
    \item \code{"weak"}: asymmetrical bundles (and entraiment)
  }}
  \item{sort}{(optional and logical, default \code{FALSE}) Sort components by size?}
}
\details{
Components and isolates in network \code{x} are derived from the transitive closure of bundle ties. 
By default, the computation takes the \emph{entire} system, but the \code{bonds} option lets 
the selection of other types of relational bundles for the resulted components. 

The \code{sort} argument outputs components length in ascending size, such as dyads, triads, and 
larger groups when present. Changing the order of the existing components may have consequences in 
the layout of the graph when plotting it with function \code{\link[multigraph:multigraph]{multigraph}}.
}
\value{
A \code{list} object of length two with the \code{bonds} type in the class attribute:
  \item{com}{List or vector with network components}
  \item{isol}{Vector with network isolates}
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{bundles}}, \code{\link{summaryBundles}}, \code{\link{bundle.census}}, \code{\link{rel.sys}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# find the components and isolates
comps(arr)
}
\keyword{models}
\keyword{cluster}

\name{mlvl}
\alias{mlvl}
\title{
Construct Multilevel Networks
}
\description{
Function to construct multilevel networks from multimodal structures.
}
\usage{
mlvl(x, y, type = c("bpn", "cn", "cn2"), symCdm, diag, lbs)
}
\arguments{
  \item{x}{Array or matrix with domain data.}
  \item{y}{(optional for \code{"cn"}) Dataframe or list of dataframes with codomain data associated to \code{x}.}
  \item{type}{
    Type of multilevel system to construct: 
   \itemize{ 
    \item \code{bpn} for a binomial projection
    \item \code{cn} for a common membership network
    \item \code{cn2} for a co-affiliation of network members
   }
  }
  \item{symCdm}{(optional and logical) Symmetrize codomains in binomial projection?}
  \item{diag}{(optional and logical) Include entries of the diagonal in matrices?}
  \item{lbs}{(optional) Either a list of length two with domain and codomain element labels or a vector with relation names in multilevel system.}
}
\details{
The inputs in \code{x} and \code{y} accept multiplex networks and an affiliation network that is high dimensional. 

The default multilevel system is a binomial projection \code{bpn} that requires data for the two domains, and 
where the projection is on the system codomain as a directed structure. 
Making symmetric the codomain structure with \code{symCdm} can be convenient for the visualization of 
multilevel graphs as with \code{\link[multigraph:mlgraph]{mlgraph}}, and for similar practical reasons, 
self-relations can be removed from the multilevel structure by disabling \code{diag}.

A co-affiliation of network members with option \code{cn2} requires both inputs as well, and the codomain structure 
in this case is symmetric. However, a common membership network with option \code{cn} does not need input in \dQuote{\code{x}} 
since it returns only the co-affiliation of network members from the codomain structure in \code{y} as in \code{cn2}. 

Since these are different components in the multilevel system for co-affiliation of network members, 
it is possible to specify the domain and codomain labels in \code{lbs} as a list object of length two. 
Option \code{lbs} as a vector can serve instead to label the relation types in the multilevel structure, 
which may be needed when the codomain in \code{y} is just a data frame.
}
\value{
A list object of \sQuote{\code{Multilevel}} class with the chosen type in attribute.
  \item{mlnet}{multilevel network with domain (unless \code{cn}) and projected codomain}
  \item{lbs}{(list) domain and codomain labels}
  \item{modes}{vector with either \code{1M} for domain or \code{2M} for codomain in \code{mlnet}}
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link[multigraph:mlgraph]{mlgraph}}, \code{\link[multigraph:multigraph]{multigraph}}
}
\examples{
# array for the domain
arr1 <- round( replace( array(runif(18), c(3,3,2)), array(runif(18), c(3,3,2))>.9, 3 ) )

# rectangle array for the co-domain
arr2 <- round( replace( array(runif(12), c(3,2,2)), array(runif(12), c(3,2,2))>.9, 3 ) )

# multilevel system with default type
mlvl(arr1, arr2)
}
\keyword{models}
\keyword{data}

\name{write.edgel}
\alias{write.edgel}
\title{
Write edge-list files
}
\description{
A function to write edge-list files having columns for sender, receiver, and ties in multiplex networks.
}
\usage{
write.edgel(x, file = NULL, sep = "\t", header = TRUE)
}
\arguments{
  \item{x}{Array or object representing a multiple network structure.}
  \item{file}{(optional) Path with filename for output.}
  \item{sep}{(optional, default tabular) Separator between columns.}
  \item{header}{(logical) Include header in edge-list file?}
}
\details{
Write edge-list files with a \emph{s}end, \emph{r}eceive, and \emph{t}ies, which is a data frame with at least two columns for the sender and receiver, 
and the different types of tie for multiplex networks, one column for each type of relation.
}
\value{
A data frame having an edge-list format in a file with path or an object.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{edgel}}, , \code{\link{write.dl}}
}
%\examples{
%}
\keyword{IO}
\keyword{data}
\keyword{file }

\name{bundle.census}
\alias{bundle.census}
\title{
Bundle Census of Multiple Networks
}
\description{
A function to perform the bundle census in multiple networks.
}
\usage{
bundle.census(x, loops = FALSE)
}
\arguments{
  \item{x}{An array representing multiple relations.}
  \item{loops}{(logical) Also include loops in the census?}
}
\details{
A \emph{bundle} is a particular type of pattern made of relations at different levels that is binding a pair of nodes or actors, 
and this function calculates the number of occurrences for each bundle class pattern in a given multiple network in \code{x}. 
The different types of relations in the network are typically recorded in a three dimensional array of stacked matrices, and
edge-list and pairwise-list of relations need to be transformed first into arrays with for example function \code{\link{transf}}.

Depending on the direction and occurrence of each possible tie, then it is possible to count with seven dyadic configuration 
classes in the census given in the output where fFunctions \code{\link{bundles}} and \code{\link{summaryBundles}} provide 
bundle class occurrences in the network with a more detailed information.
}
\value{
A table with the number occurrences in the distinct bundle class patterns occuring in \code{x}:
  \itemize{
   \item{BUNDLES} Total number of bundles in \code{x}, excluding the \emph{Null} pattern.
   \item{NULL} \emph{Null}
   \item{ASYMM} \emph{Asymmetric}
   \item{RECIP} \emph{Reciprocal}
   \item{T.ENTR} \emph{Tie Entrainment}
   \item{T.EXCH} \emph{Tie Exchange}
   \item{MIXED} \emph{Mixed} pattern
   \item{FULL} \emph{Full}
   \item{LOOP} \emph{Loops} (if \code{TRUE})
  }
}
\references{
Ostoic, J.A.R. \dQuote{Dyadic Patterns in Multiple Networks,} \emph{Advances in Social Networks Analysis and Mining, International Conference on}, 475-481. 2011.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{bundles}}, \code{\link{summaryBundles}}, \code{\link{transf}}
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.8, 3 ) )

# compute the bundle census
bundle.census(arr)
}
\keyword{data}

\name{green.rel}
\alias{green.rel}
\title{
Green's Relations of Abstract Semigroups
}
\description{
A function to produce the Green's relations of a semigroup object. 
}
\usage{
green.rel(x)
}
\arguments{
  \item{x}{A \dQuote{\code{Semigroup}} class object.}
}
\details{
Function \code{green.rel} produces the \emph{egg-box diagram} (Green, 1951) of an abstract semigroup \eqn{S}, 
which is the union of the left compatible \eqn{R} equivalence and 
the right compatible \eqn{L} equivalence classes that makes the \eqn{D}-class on \eqn{S}. 
Notice that some systems have the \eqn{D}-class equal to \eqn{S}.
}
\value{
A list object of \dQuote{\code{Green.Rels}} and \dQuote{\code{Semigroup}} class having:
  \item{S}{multiplication matrix of the abstract semigroup}
  \item{gens}{generator relations of \eqn{S}}
  \item{dim}{dimension of semigroup generators}
  \item{ord}{order of \eqn{S}}
  \item{st}{unique string relations}
  \item{clu}{list of vectors with clustering information of equivalence classes \eqn{R} and \eqn{L}}
  \item{R}{\eqn{R} equivalence classes}
  \item{L}{\eqn{L} equivalence classes}
  \item{D}{\eqn{D} equivalence classes}
}
\references{
Green, J. \dQuote{On the structure of semigroups,} \emph{Annals of Mathematics} 54(1), 163--172, 1951. \cr
Ostoic, JAR  \dQuote{Relational systems of transport network and provinces in ancient Rome,} in 
       \emph{Mathematics for social sciences and arts -- algebraic modeling}. Springer Nature. 2023.
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{semigroup}}, \code{\link{diagram}}, \code{\link{as.semigroup}}, 
\code{\link{edgeT}}, \code{\link{wordT}}, \code{\link{fact}}, \code{\link{cngr}}, \code{\link{decomp}}  
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )
# optional string labels
dimnames(arr)[[3]] <- list("n", "m")

# look at the Green's relations of its semigroup
semigroup(arr) |> 
  green.rel()
}
\keyword{algebra}
\keyword{math}

\name{perm}
\alias{perm}
\title{
Array Permutation
}
\description{
Function to permutate a given array of relations.
}
\usage{
perm(x, clu, rev, lbs, sort)
}
\arguments{
  \item{x}{Matrix or array to permute.}
  \item{clu}{Vector of cluster for permutation.}
  \item{rev}{(optional and logical) Revert order in \code{clu}?}
  \item{lbs}{(optional) Vector of labels after permutation.}
  \item{sort}{(optional and logical) Sort array according to labels?}
}
\details{
This function performs a permutation of a given array or matrix representing relations according to a clustering vector of membership.
}
\value{
A permuted matrix or array
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{cph}}, \code{\link{partial.order}}
}
\examples{
# scan the multiplication table data
s <- matrix(data=c(1, 1, 1, 3, 3, 3, 3, 3, 3), nrow=3, ncol=3, byrow=TRUE)

# the permutation as an endomorphism
perm(s, clu = c(1,2,3))
}
\keyword{algebra}
\keyword{math}
\keyword{array}
\keyword{cluster}
\keyword{manip}

\name{dichot}
\alias{dichot}
\title{
Dichotomize Data with a Cutoff Value
}
\description{
Function to dichotomize the input data for the semigroup construction with a cutoff value.
}
\usage{
dichot(x, c = 1, diag)
}
\arguments{
  \item{x}{An array, matrix or other data in a numeric form.}
  \item{c}{A cutoff value to perform the dichotomization in \code{x}.}
  \item{diag}{(optional and logical, default \code{TRUE}) Should diagonals be included in output?}
}
\details{
This is a wrapper of the \code{\link[base:replace]{replace}} base function where in this case 
is aimed to specify a cutoff value for the dichotomization of the data. 
Values equal or higher to the cutoff are hence converted to \code{1}, while the others are set to \code{0}. 
Notice that the cutoff value in \code{c} can be any real number, and labels are preserved after the dichotomization..
}
\value{
Binary values of the input data with the same format as \code{x}.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link[base:replace]{replace}}, \code{\link{mnplx}}, \code{\link{semigroup}}.
}
\examples{
# create two binary relations among three elements
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 3 ) )

# dichotomize it with a cutoff value of two
dichot(arr, c = 2)
}
\keyword{manip}

\name{as.semigroup}
\alias{as.semigroup}
\title{
Coerce into a Semigroup Object
}
\description{
A generic function for coercing a relational system into a \dQuote{\code{Semigroup}} class object.
}
\usage{
as.semigroup(x, gens, lbs, numerical, edgeT)
}
\arguments{
  \item{x}{An array representing the semigroup.}
  \item{gens}{Aarray or vector representing the semigroup generators.}
  \item{lbs}{(optional) Label strings for the semigroup.}
  \item{numerical}{(optional and logical) Should the semigroup have numerical format?}
  \item{edgeT}{(optional and logical) Is the input in \sQuote{\code{x}} an edge table?}
}
\details{
Use this function to convert an array representing a semigroup structure into an \R object of class \dQuote{\code{Semigroup}} 
as some routines in \pkg{multiplex} require.
}
\value{
A list object of class \dQuote{\code{Semigroup}} that is either \sQuote{\code{symbolic}} or \sQuote{\code{numerical}}.
  \item{ord}{an integer with the dimension of the semigroup}
  \item{st}{a vector of the semigroup unique relations or the string-relations}
  \item{gens}{a vector with the generators of the semigroup}
  \item{S}{multiplication table with the semigroup structure.}
  Class attribute, and a \code{warning} message when no generators are provided.
}
%\references{} ~
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{semigroup}}, \code{\link{green.rel}}
}
\examples{
# create a labeled multiplication table data
s <- matrix(data=c(1, 1, 1, 3, 3, 3, 3, 3, 3), nrow=3, ncol=3, byrow=TRUE)

# set attributes to object
attr(s, "dimnames") <- list(1:3, 1:3)

# make 's' a semigroup object
as.semigroup(s)
}
\keyword{manip}
\keyword{classes}
\keyword{misc}

\name{fact}
\alias{fact}
\title{
Factorize Partially Ordered Semigroups
}
\description{
A function to factorize partially ordered semigroup structures by induced inclusions.
}
\usage{
fact(S, P, uniq = TRUE, fac, atoms, mca, atmc, patm, k)
}
\arguments{
  \item{S}{A \dQuote{\code{Semigroup}} class object.}
  \item{P}{A \dQuote{\code{Partial.Order}} \dQuote{\code{strings}} class object associated to \code{S}.}
  \item{uniq}{(logical) Should the factorization include unique induced inclusions?}
  \item{fac}{(optional) The \sQuote{factor} to be factorized for partially ordered structures.}
  \item{atoms}{(optional and logical) Short for including \code{"mca"} and \code{"atmc"} in the output.}
  \item{mca}{(optional and logical) Include pairs of meet-complements of pair of atoms in output?}
  \item{atmc}{(optional and logical) Include meet-complements of pair of atoms in output?}
  \item{patm}{(optional and logical) Include potential atoms in output?}
  \item{k}{(optional) Integer with length of induced inclusion.}
}
\details{
\emph{Factorization} is a subdirect-representation-based decomposition technique for a partially ordered semigroup. 
This procedure decomposes the algebraic structure into simpler components, called \emph{factors}, each of which is 
a semigroup factor representing a specific homomorphic image of the algebra. 

For partially ordered semigroups, these factors are isotone homomorphic images corresponding to maximally independent 
features of the original semigroup of relations. 
The quotient semigroups and the reduced partial order tables together form the factorizing set, which 
is given by the decomposition with \code{\link{decomp}}.
}
\value{
A list of \dQuote{\code{Ind.incl}} class object having:
  \item{po}{partial order table}
  \item{iin}{list of induced inclusions pairwise listed}
  \item{niin}{length of induced inclusions}
  \item{patm}{(for \code{patm}) a vector with potential atoms}
  \item{atm}{vector with atoms}
  \item{atmc}{(for \code{atmc}) array with meet-complements of atoms}
  \item{mc}{array of meet-complements of atoms}
  Class attribute, and a \code{warning} message when no substitution property found in induced inclusions.
}
\references{
Ardu, S. \emph{ASNET -- Algebraic and Statistical Network Analysis. User Manual}. University of Melbourne. 1995. (for the implementation algorithm)
}
%\author{} ~
%\note{} ~
%\section{Warning }{....} ~
\seealso{
\code{\link{decomp}}, \code{\link{cngr}}, \code{\link{pacnet}} 
}
\examples{
# create a partially ordered semigroup
arr <- round( replace( array(runif(18), c(3,3,2)), array(runif(18),
       c(3,3,2))>.5, 1 ) )

# semigroup of relations
S <- semigroup(arr)

# string relations and partial order
P <- strings(arr) |> 
  partial.order()

# perform the factorisation of PO S
fact(S, P)
}
\keyword{algebra}
\keyword{math}

\name{cscl}
\alias{cscl}
\title{
Conceptual Scaling for Many-valued Formal Contexts
}
\description{
A function to interpret a given many-valued formal context through a chosen scaling process. 
}
\usage{
cscl(x, cl, scale = c("nominal", "ordinal", "intord", "biord", "dichot"), sep)
}
\arguments{
  \item{x}{A table or array representing a many-valued formal context.}
  \item{cl}{A vector with the ordered conceptual scaling-levels in \code{x}.}
  \item{scale}{Type of \emph{scaling} in the interpretation of \code{x}: 
   \itemize{ 
    \item \code{nominal}.
    \item \code{ordinal}.
    \item \code{intord} for one-dimensional interordinal.
    \item \code{biord} for biordinal.
    \item \code{dichot} for dichotomic.
   }
  }
  \item{sep}{(optional, default dot) Pair separator among attributes and levels.}
}
\details{
\emph{Conceptual scaling} is a special form of formal context in which each attribute of a many-valued context is interpreted through a scaling procedure. 
More broadly, it converts many-valued data into dichotomous data, producing a derived context according to the selected type of scaling. 
Conceptual scaling is therefore an interpretive method where both the choice of scale and the transformation of values are form part of the analysis, 
rather than following from a mathematically determined procedure. 

The formal context represented in \code{x} must be associated to its conceptual scaling-levels recorded in \code{cl} as an ordered vector with all levels, 
and a type of scaling derives the context into a dichotomous data frame with attribute ordinal values. 
Once the partial order of the Galois derivation among the objects and attributes of the formal concept has been established, 
the resulting derived context with dichotomous data can be represented as a concept lattice.
}
\value{
A data frame with a \dQuote{\code{conceptual.scaling}} class representing a derived many-valued formal context with respect to the conceptual scaling-levels in \code{cl}. 
The ordered conceptual levels and the pair separator are given in the class attribute. 
}
\references{
Ganter, B. and R. Wille  \emph{Formal Concept Analysis -- Mathematical Foundations}. Springer. 1996.
}
%\author{} ~
%\note{}
%\section{Warning }{....} ~
\seealso{
\code{\link{galois}}, \code{\link{partial.order}}, \code{\link{diagram}}.
}
%\examples{
%
%}
\keyword{algebra}
\keyword{math}
